/* TaskList.c generated by valac 0.52.4, the Vala compiler
 * generated from TaskList.vala, do not modify */

/*
* Copyright © 2019 Alain M. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "caldav.h"
#include <libedataserver/libedataserver.h>
#include <libecal/libecal.h>
#include <gtk/gtk.h>
#include "plannercore.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <libical-glib/libical-glib.h>

enum  {
	VIEWS_TASK_LIST_0_PROPERTY,
	VIEWS_TASK_LIST_SOURCE_PROPERTY,
	VIEWS_TASK_LIST_NUM_PROPERTIES
};
static GParamSpec* views_task_list_properties[VIEWS_TASK_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block13Data Block13Data;
typedef struct _Block14Data Block14Data;

struct _ViewsTaskListPrivate {
	ESource* _source;
	ECalClientView* view;
	GtkLabel* name_label;
	WidgetsEntry* name_entry;
	GtkStack* name_stack;
	GtkRevealer* action_revealer;
	GtkListBox* listbox;
	GtkListBox* completed_listbox;
	GtkRevealer* completed_revealer;
	GtkToggleButton* settings_button;
	GtkStack* main_stack;
	WidgetsProjectProgress* project_progress;
	GtkPopover* popover;
	GtkSwitch* show_completed_switch;
	GtkModelButton* show_completed_button;
	gboolean entry_menu_opened;
	GeeCollection* views;
	GRecMutex __lock_views;
	ESourceTaskList* task_list;
};

struct _Block13Data {
	int _ref_count_;
	ViewsTaskList* self;
	GAsyncResult* res;
};

struct _Block14Data {
	int _ref_count_;
	ViewsTaskList* self;
	GtkButton* submit_button;
};

static gint ViewsTaskList_private_offset;
static gpointer views_task_list_parent_class = NULL;
static ServicesTasksStore* views_task_list_task_store;
static ServicesTasksStore* views_task_list_task_store = NULL;
static GType views_task_list_type_id = 0;

static void views_task_list_create_popover (ViewsTaskList* self);
static void __lambda60_ (ViewsTaskList* self);
static void ___lambda60__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void views_task_list_remove_views (ViewsTaskList* self);
static void views_task_list_check_tasklist_placeholder (ViewsTaskList* self);
static void views_task_list_on_tasks_added (ViewsTaskList* self,
                                     GeeCollection* tasks);
static void _views_task_list_on_tasks_added_services_tasks_store_tasks_added_func (GeeCollection* tasks,
                                                                            ESource* task_list,
                                                                            gpointer self);
static void views_task_list_on_tasks_modified (ViewsTaskList* self,
                                        GeeCollection* tasks);
static void _views_task_list_on_tasks_modified_services_tasks_store_tasks_modified_func (GeeCollection* tasks,
                                                                                  gpointer self);
static void views_task_list_on_tasks_removed (ViewsTaskList* self,
                                       GSList* cids);
static void _views_task_list_on_tasks_removed_services_tasks_store_tasks_removed_func (GSList* cids,
                                                                                gpointer self);
static void views_task_list_save (ViewsTaskList* self);
static void __lambda61_ (ViewsTaskList* self,
                  GObject* obj,
                  GAsyncResult* res);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static gboolean __lambda62_ (Block13Data* _data13_);
static gboolean ___lambda62__gsource_func (gpointer self);
static void ___lambda61__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda63_ (ViewsTaskList* self,
                  GtkWidget* row);
static void ___lambda63__gtk_callback (GtkWidget* widget,
                                gpointer self);
static GObject * views_task_list_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void _views_task_list___lambda64_ (ViewsTaskList* self);
static void __views_task_list___lambda64__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _views_task_list___lambda65_ (ViewsTaskList* self,
                                   const gchar* uid);
static void __views_task_list___lambda65__services_event_bus_edit_tasklist (ServicesEventBus* _sender,
                                                                     const gchar* uid,
                                                                     gpointer self);
static void _views_task_list___lambda66_ (ViewsTaskList* self);
static void __views_task_list___lambda66__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                              gpointer self);
static void _views_task_list___lambda67_ (ViewsTaskList* self,
                                   GtkListBoxRow* r);
static void __views_task_list___lambda67__gtk_list_box_row_activated (GtkListBox* _sender,
                                                               GtkListBoxRow* row,
                                                               gpointer self);
static void _views_task_list___lambda68_ (ViewsTaskList* self,
                                   GtkListBoxRow* r);
static void __views_task_list___lambda68__gtk_list_box_row_activated (GtkListBox* _sender,
                                                               GtkListBoxRow* row,
                                                               gpointer self);
static void _views_task_list___lambda69_ (ViewsTaskList* self,
                                   gint color);
static void __views_task_list___lambda69__widgets_color_popover_color_changed (WidgetsColorPopover* _sender,
                                                                        gint color,
                                                                        gpointer self);
static void _views_task_list___lambda70_ (ViewsTaskList* self);
static void __views_task_list___lambda70__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static gboolean _views_task_list___lambda71_ (ViewsTaskList* self,
                                       GdkEventKey* key);
static gboolean __views_task_list___lambda71__gtk_widget_key_release_event (GtkWidget* _sender,
                                                                     GdkEventKey* event,
                                                                     gpointer self);
static gboolean _views_task_list___lambda72_ (ViewsTaskList* self);
static gboolean __views_task_list___lambda72__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                   GdkEventFocus* event,
                                                                   gpointer self);
static void _views_task_list___lambda73_ (ViewsTaskList* self,
                                   GtkMenu* menu);
static void __lambda74_ (ViewsTaskList* self);
static void ___lambda74__gtk_widget_hide (GtkWidget* _sender,
                                   gpointer self);
static void __views_task_list___lambda73__gtk_entry_populate_popup (GtkEntry* _sender,
                                                             GtkMenu* popup,
                                                             gpointer self);
static gboolean _views_task_list___lambda75_ (ViewsTaskList* self,
                                       GdkEvent* event);
static gboolean __views_task_list___lambda75__gtk_widget_event (GtkWidget* _sender,
                                                         GdkEvent* event,
                                                         gpointer self);
static void _views_task_list___lambda76_ (Block14Data* _data14_);
static void __views_task_list___lambda76__gtk_editable_changed (GtkEditable* _sender,
                                                         gpointer self);
static void _views_task_list___lambda77_ (ViewsTaskList* self);
static void __views_task_list___lambda77__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _views_task_list___lambda78_ (ViewsTaskList* self);
static void __views_task_list___lambda78__gtk_entry_activate (GtkEntry* _sender,
                                                       gpointer self);
static void _views_task_list___lambda79_ (ViewsTaskList* self);
static void __views_task_list___lambda79__widgets_magic_button_clicked (WidgetsMagicButton* _sender,
                                                                 gpointer self);
static void _views_task_list___lambda80_ (ViewsTaskList* self,
                                   ESource* s);
static void __views_task_list___lambda80__services_tasks_store_task_list_modified (ServicesTasksStore* _sender,
                                                                            ESource* task_list,
                                                                            gpointer self);
static void views_task_list_finalize (GObject * obj);
static void _vala_views_task_list_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_views_task_list_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
views_task_list_get_instance_private (ViewsTaskList* self)
{
	return G_STRUCT_MEMBER_P (self, ViewsTaskList_private_offset);
}

static void
__lambda60_ (ViewsTaskList* self)
{
	GtkPopover* _tmp0_;
	GraniteMessageDialog* message_dialog = NULL;
	Utils* _tmp1_;
	ESource* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GraniteMessageDialog* _tmp9_;
	GraniteMessageDialog* _tmp10_;
	GtkButton* remove_button = NULL;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GraniteMessageDialog* _tmp14_;
	GtkButton* _tmp15_;
	GraniteMessageDialog* _tmp16_;
	GraniteMessageDialog* _tmp17_;
	GraniteMessageDialog* _tmp22_;
	_tmp0_ = self->priv->popover;
	gtk_popover_popdown (_tmp0_);
	_tmp1_ = planner_utils;
	_tmp2_ = self->priv->_source;
	_tmp3_ = e_source_get_display_name (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = utils_get_dialog_text (_tmp1_, _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strdup_printf ("Are you sure you want to delete <b>%s</b>?", _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Delete project"), _ (_tmp8_), "user-trash-full", GTK_BUTTONS_CANCEL);
	g_object_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	message_dialog = _tmp10_;
	_tmp11_ = (GtkButton*) gtk_button_new_with_label (_ ("Delete"));
	g_object_ref_sink (_tmp11_);
	remove_button = _tmp11_;
	_tmp12_ = remove_button;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_add_class (_tmp13_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
	_tmp14_ = message_dialog;
	_tmp15_ = remove_button;
	gtk_dialog_add_action_widget ((GtkDialog*) _tmp14_, (GtkWidget*) _tmp15_, (gint) GTK_RESPONSE_ACCEPT);
	_tmp16_ = message_dialog;
	gtk_widget_show_all ((GtkWidget*) _tmp16_);
	_tmp17_ = message_dialog;
	if (gtk_dialog_run ((GtkDialog*) _tmp17_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		ESource* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
		_tmp18_ = self->priv->_source;
		_tmp19_ = e_source_get_removable (_tmp18_);
		_tmp20_ = _tmp19_;
		if (_tmp20_) {
			ESource* _tmp21_;
			_tmp21_ = self->priv->_source;
			e_source_remove (_tmp21_, NULL, NULL, NULL);
		} else {
			gdk_beep ();
		}
	}
	_tmp22_ = message_dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp22_);
	_g_object_unref0 (remove_button);
	_g_object_unref0 (message_dialog);
}

static void
___lambda60__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda60_ ((ViewsTaskList*) self);
}

static void
views_task_list_create_popover (ViewsTaskList* self)
{
	GtkToggleButton* _tmp0_;
	GtkPopover* _tmp1_;
	GtkPopover* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkPopover* _tmp4_;
	WidgetsModelButton* delete_menu = NULL;
	WidgetsModelButton* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkImage* show_completed_image = NULL;
	GtkImage* _tmp7_;
	GThemedIcon* _tmp8_;
	GThemedIcon* _tmp9_;
	GtkLabel* show_completed_label = NULL;
	GtkLabel* _tmp10_;
	GtkSwitch* _tmp11_;
	GtkSwitch* _tmp12_;
	GtkSwitch* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkGrid* show_completed_grid = NULL;
	GtkGrid* _tmp15_;
	GtkSwitch* _tmp16_;
	GtkModelButton* _tmp17_;
	GtkModelButton* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkModelButton* _tmp20_;
	GtkWidget* _tmp21_;
	GtkModelButton* _tmp22_;
	GtkGrid* popover_grid = NULL;
	GtkGrid* _tmp23_;
	GtkModelButton* _tmp24_;
	GtkSeparator* _tmp25_ = NULL;
	GtkSeparator* _tmp26_;
	GtkPopover* _tmp27_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings_button;
	_tmp1_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) _tmp0_);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp1_;
	_tmp2_ = self->priv->popover;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, "popover-background");
	_tmp4_ = self->priv->popover;
	gtk_popover_set_position (_tmp4_, GTK_POS_BOTTOM);
	_tmp5_ = widgets_model_button_new (_ ("Delete"), "user-trash-symbolic", "", FALSE);
	g_object_ref_sink (_tmp5_);
	delete_menu = _tmp5_;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) delete_menu);
	gtk_style_context_add_class (_tmp6_, "menu-danger");
	_tmp7_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp7_);
	show_completed_image = _tmp7_;
	_tmp8_ = (GThemedIcon*) g_themed_icon_new ("emblem-default-symbolic");
	_tmp9_ = _tmp8_;
	g_object_set (show_completed_image, "gicon", (GIcon*) _tmp9_, NULL);
	_g_object_unref0 (_tmp9_);
	gtk_widget_set_valign ((GtkWidget*) show_completed_image, GTK_ALIGN_START);
	gtk_image_set_pixel_size (show_completed_image, 16);
	_tmp10_ = (GtkLabel*) gtk_label_new (_ ("Show Completed"));
	g_object_ref_sink (_tmp10_);
	show_completed_label = _tmp10_;
	gtk_widget_set_hexpand ((GtkWidget*) show_completed_label, TRUE);
	gtk_widget_set_valign ((GtkWidget*) show_completed_label, GTK_ALIGN_START);
	gtk_label_set_xalign (show_completed_label, (gfloat) 0);
	gtk_widget_set_margin_start ((GtkWidget*) show_completed_label, 9);
	_tmp11_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->show_completed_switch);
	self->priv->show_completed_switch = _tmp11_;
	_tmp12_ = self->priv->show_completed_switch;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp12_, 12);
	_tmp13_ = self->priv->show_completed_switch;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, "planner-switch");
	_tmp15_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp15_);
	show_completed_grid = _tmp15_;
	gtk_container_add ((GtkContainer*) show_completed_grid, (GtkWidget*) show_completed_image);
	gtk_container_add ((GtkContainer*) show_completed_grid, (GtkWidget*) show_completed_label);
	_tmp16_ = self->priv->show_completed_switch;
	gtk_container_add ((GtkContainer*) show_completed_grid, (GtkWidget*) _tmp16_);
	_tmp17_ = (GtkModelButton*) gtk_model_button_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->show_completed_button);
	self->priv->show_completed_button = _tmp17_;
	_tmp18_ = self->priv->show_completed_button;
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
	gtk_style_context_add_class (_tmp19_, "popover-model-button");
	_tmp20_ = self->priv->show_completed_button;
	_tmp21_ = gtk_bin_get_child ((GtkBin*) _tmp20_);
	gtk_widget_destroy (_tmp21_);
	_tmp22_ = self->priv->show_completed_button;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) show_completed_grid);
	_tmp23_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp23_);
	popover_grid = _tmp23_;
	gtk_orientable_set_orientation ((GtkOrientable*) popover_grid, GTK_ORIENTATION_VERTICAL);
	gtk_widget_set_margin_top ((GtkWidget*) popover_grid, 3);
	gtk_widget_set_margin_bottom ((GtkWidget*) popover_grid, 3);
	_tmp24_ = self->priv->show_completed_button;
	gtk_container_add ((GtkContainer*) popover_grid, (GtkWidget*) _tmp24_);
	_tmp25_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp25_, 3);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp25_, 3);
	g_object_ref_sink (_tmp25_);
	_tmp26_ = _tmp25_;
	gtk_container_add ((GtkContainer*) popover_grid, (GtkWidget*) _tmp26_);
	_g_object_unref0 (_tmp26_);
	gtk_container_add ((GtkContainer*) popover_grid, (GtkWidget*) delete_menu);
	_tmp27_ = self->priv->popover;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) popover_grid);
	g_signal_connect_object ((GtkButton*) delete_menu, "clicked", (GCallback) ___lambda60__gtk_button_clicked, self, 0);
	_g_object_unref0 (popover_grid);
	_g_object_unref0 (show_completed_grid);
	_g_object_unref0 (show_completed_label);
	_g_object_unref0 (show_completed_image);
	_g_object_unref0 (delete_menu);
}

static void
views_task_list_remove_views (ViewsTaskList* self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->items_completed_added;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	_tmp1_ = self->items_uncompleted_added;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
	{
		GeeCollection* _tmp2_;
		_tmp2_ = self->priv->views;
		g_rec_mutex_lock (&self->priv->__lock_views);
		{
			GeeCollection* _tmp10_;
			{
				GeeIterator* _view_it = NULL;
				GeeCollection* _tmp3_;
				GeeIterator* _tmp4_;
				_tmp3_ = self->priv->views;
				_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
				_view_it = _tmp4_;
				while (TRUE) {
					GeeIterator* _tmp5_;
					ECalClientView* view = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					ServicesTasksStore* _tmp8_;
					ECalClientView* _tmp9_;
					_tmp5_ = _view_it;
					if (!gee_iterator_next (_tmp5_)) {
						break;
					}
					_tmp6_ = _view_it;
					_tmp7_ = gee_iterator_get (_tmp6_);
					view = (ECalClientView*) _tmp7_;
					_tmp8_ = views_task_list_task_store;
					_tmp9_ = view;
					services_tasks_store_destroy_task_list_view (_tmp8_, _tmp9_);
					_g_object_unref0 (view);
				}
				_g_object_unref0 (_view_it);
			}
			_tmp10_ = self->priv->views;
			gee_collection_clear (_tmp10_);
		}
		__finally0:
		{
			GeeCollection* _tmp11_;
			_tmp11_ = self->priv->views;
			g_rec_mutex_unlock (&self->priv->__lock_views);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	views_task_list_check_tasklist_placeholder (self);
}

static void
_views_task_list_on_tasks_added_services_tasks_store_tasks_added_func (GeeCollection* tasks,
                                                                       ESource* task_list,
                                                                       gpointer self)
{
	views_task_list_on_tasks_added ((ViewsTaskList*) self, tasks);
}

static void
_views_task_list_on_tasks_modified_services_tasks_store_tasks_modified_func (GeeCollection* tasks,
                                                                             gpointer self)
{
	views_task_list_on_tasks_modified ((ViewsTaskList*) self, tasks);
}

static void
_views_task_list_on_tasks_removed_services_tasks_store_tasks_removed_func (GSList* cids,
                                                                           gpointer self)
{
	views_task_list_on_tasks_removed ((ViewsTaskList*) self, cids);
}

void
views_task_list_add_view (ViewsTaskList* self,
                          ESource* task_list,
                          const gchar* query)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (task_list != NULL);
	g_return_if_fail (query != NULL);
	{
		ECalClientView* view = NULL;
		ServicesTasksStore* _tmp0_;
		ECalClientView* _tmp1_;
		_tmp0_ = views_task_list_task_store;
		_tmp1_ = services_tasks_store_create_task_list_view (_tmp0_, task_list, query, _views_task_list_on_tasks_added_services_tasks_store_tasks_added_func, self, _views_task_list_on_tasks_modified_services_tasks_store_tasks_modified_func, self, _views_task_list_on_tasks_removed_services_tasks_store_tasks_removed_func, self, &_inner_error0_);
		view = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		{
			GeeCollection* _tmp2_;
			_tmp2_ = self->priv->views;
			g_rec_mutex_lock (&self->priv->__lock_views);
			{
				GeeCollection* _tmp3_;
				ECalClientView* _tmp4_;
				_tmp3_ = self->priv->views;
				_tmp4_ = view;
				gee_collection_add (_tmp3_, _tmp4_);
			}
			__finally1:
			{
				GeeCollection* _tmp5_;
				_tmp5_ = self->priv->views;
				g_rec_mutex_unlock (&self->priv->__lock_views);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (view);
				goto __catch0_g_error;
			}
		}
		_g_object_unref0 (view);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_critical ("TaskList.vala:422: %s", _tmp7_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
views_task_list_add_new_task (ViewsTaskList* self,
                              gint index)
{
	GtkStack* _tmp0_;
	WidgetsTaskRow* new_task = NULL;
	ESource* _tmp1_;
	WidgetsTaskRow* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->main_stack;
	gtk_stack_set_visible_child_name (_tmp0_, "tasklist");
	_tmp1_ = self->priv->_source;
	_tmp2_ = widgets_task_row_new_for_source (_tmp1_);
	g_object_ref_sink (_tmp2_);
	new_task = _tmp2_;
	_tmp3_ = self->priv->listbox;
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) new_task);
	_tmp4_ = self->priv->listbox;
	gtk_widget_show_all ((GtkWidget*) _tmp4_);
	_g_object_unref0 (new_task);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
	g_atomic_int_inc (&_data13_->_ref_count_);
	return _data13_;
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
		ViewsTaskList* self;
		self = _data13_->self;
		_g_object_unref0 (_data13_->res);
		_g_object_unref0 (self);
		g_slice_free (Block13Data, _data13_);
	}
}

static gboolean
__lambda62_ (Block13Data* _data13_)
{
	ViewsTaskList* self;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	self = _data13_->self;
	{
		ServicesTasksStore* _tmp0_;
		GtkRevealer* _tmp1_;
		GtkStack* _tmp2_;
		ESource* _tmp3_;
		WidgetsEntry* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp0_ = views_task_list_task_store;
		services_tasks_store_update_task_list_display_name_finish (_tmp0_, _data13_->res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp1_ = self->priv->action_revealer;
		gtk_revealer_set_reveal_child (_tmp1_, FALSE);
		_tmp2_ = self->priv->name_stack;
		gtk_stack_set_visible_child_name (_tmp2_, "name_label");
		_tmp3_ = self->priv->_source;
		_tmp4_ = self->priv->name_entry;
		_tmp5_ = gtk_entry_get_text ((GtkEntry*) _tmp4_);
		_tmp6_ = _tmp5_;
		e_source_set_display_name (_tmp3_, _tmp6_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		WidgetsEntry* _tmp7_;
		ESource* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		GtkLabel* _tmp11_;
		ESource* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		GtkRevealer* _tmp15_;
		GtkStack* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = self->priv->name_entry;
		_tmp8_ = self->priv->_source;
		_tmp9_ = e_source_get_display_name (_tmp8_);
		_tmp10_ = _tmp9_;
		gtk_entry_set_text ((GtkEntry*) _tmp7_, _tmp10_);
		_tmp11_ = self->priv->name_label;
		_tmp12_ = self->priv->_source;
		_tmp13_ = e_source_get_display_name (_tmp12_);
		_tmp14_ = _tmp13_;
		gtk_label_set_label (_tmp11_, _tmp14_);
		_tmp15_ = self->priv->action_revealer;
		gtk_revealer_set_reveal_child (_tmp15_, FALSE);
		_tmp16_ = self->priv->name_stack;
		gtk_stack_set_visible_child_name (_tmp16_, "name_label");
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		_tmp19_ = g_strdup_printf ("Error: %s\n", _tmp18_);
		_tmp20_ = _tmp19_;
		g_print ("%s", _tmp20_);
		_g_free0 (_tmp20_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp21_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp21_;
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda62__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda62_ (self);
	return result;
}

static void
__lambda61_ (ViewsTaskList* self,
             GObject* obj,
             GAsyncResult* res)
{
	Block13Data* _data13_;
	GAsyncResult* _tmp0_;
	g_return_if_fail (res != NULL);
	_data13_ = g_slice_new0 (Block13Data);
	_data13_->_ref_count_ = 1;
	_data13_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (res);
	_g_object_unref0 (_data13_->res);
	_data13_->res = _tmp0_;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda62__gsource_func, block13_data_ref (_data13_), block13_data_unref);
	block13_data_unref (_data13_);
	_data13_ = NULL;
}

static void
___lambda61__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda61_ ((ViewsTaskList*) self, source_object, res);
	g_object_unref (self);
}

static void
views_task_list_save (ViewsTaskList* self)
{
	ServicesTasksStore* _tmp0_;
	ESource* _tmp1_;
	WidgetsEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = views_task_list_task_store;
	_tmp1_ = self->priv->_source;
	_tmp2_ = self->priv->name_entry;
	_tmp3_ = gtk_entry_get_text ((GtkEntry*) _tmp2_);
	_tmp4_ = _tmp3_;
	services_tasks_store_update_task_list_display_name (_tmp0_, _tmp1_, _tmp4_, ___lambda61__gasync_ready_callback, g_object_ref (self));
}

static void
views_task_list_on_tasks_added (ViewsTaskList* self,
                                GeeCollection* tasks)
{
	GtkListBox* _tmp35_;
	GtkListBox* _tmp36_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tasks != NULL);
	{
		GeeIterator* _task_it = NULL;
		GeeIterator* _tmp0_;
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) tasks);
		_task_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_;
			ECalComponent* task = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ICalComponent* ical_task = NULL;
			ECalComponent* _tmp4_;
			ICalComponent* _tmp5_;
			ICalComponent* _tmp6_;
			_tmp1_ = _task_it;
			if (!gee_iterator_next (_tmp1_)) {
				break;
			}
			_tmp2_ = _task_it;
			_tmp3_ = gee_iterator_get (_tmp2_);
			task = (ECalComponent*) _tmp3_;
			_tmp4_ = task;
			_tmp5_ = e_cal_component_get_icalcomponent (_tmp4_);
			ical_task = _tmp5_;
			_tmp6_ = ical_task;
			if (i_cal_component_get_status (_tmp6_) == I_CAL_STATUS_COMPLETED) {
				GeeHashMap* _tmp7_;
				ECalComponent* _tmp8_;
				ICalComponent* _tmp9_;
				const gchar* _tmp10_;
				_tmp7_ = self->items_completed_added;
				_tmp8_ = task;
				_tmp9_ = e_cal_component_get_icalcomponent (_tmp8_);
				_tmp10_ = i_cal_component_get_uid (_tmp9_);
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp7_, _tmp10_)) {
					WidgetsTaskRow* row = NULL;
					ECalComponent* _tmp11_;
					ESource* _tmp12_;
					WidgetsTaskRow* _tmp13_;
					GtkListBox* _tmp14_;
					WidgetsTaskRow* _tmp15_;
					GeeHashMap* _tmp16_;
					ECalComponent* _tmp17_;
					ICalComponent* _tmp18_;
					const gchar* _tmp19_;
					WidgetsTaskRow* _tmp20_;
					_tmp11_ = task;
					_tmp12_ = self->priv->_source;
					_tmp13_ = widgets_task_row_new_for_component (_tmp11_, _tmp12_);
					g_object_ref_sink (_tmp13_);
					row = _tmp13_;
					_tmp14_ = self->priv->completed_listbox;
					_tmp15_ = row;
					gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
					_tmp16_ = self->items_completed_added;
					_tmp17_ = task;
					_tmp18_ = e_cal_component_get_icalcomponent (_tmp17_);
					_tmp19_ = i_cal_component_get_uid (_tmp18_);
					_tmp20_ = row;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, _tmp19_, _tmp20_);
					_g_object_unref0 (row);
				}
			} else {
				GeeHashMap* _tmp21_;
				ECalComponent* _tmp22_;
				ICalComponent* _tmp23_;
				const gchar* _tmp24_;
				_tmp21_ = self->items_uncompleted_added;
				_tmp22_ = task;
				_tmp23_ = e_cal_component_get_icalcomponent (_tmp22_);
				_tmp24_ = i_cal_component_get_uid (_tmp23_);
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp21_, _tmp24_)) {
					WidgetsTaskRow* row = NULL;
					ECalComponent* _tmp25_;
					ESource* _tmp26_;
					WidgetsTaskRow* _tmp27_;
					GtkListBox* _tmp28_;
					WidgetsTaskRow* _tmp29_;
					GeeHashMap* _tmp30_;
					ECalComponent* _tmp31_;
					ICalComponent* _tmp32_;
					const gchar* _tmp33_;
					WidgetsTaskRow* _tmp34_;
					_tmp25_ = task;
					_tmp26_ = self->priv->_source;
					_tmp27_ = widgets_task_row_new_for_component (_tmp25_, _tmp26_);
					g_object_ref_sink (_tmp27_);
					row = _tmp27_;
					_tmp28_ = self->priv->listbox;
					_tmp29_ = row;
					gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
					_tmp30_ = self->items_uncompleted_added;
					_tmp31_ = task;
					_tmp32_ = e_cal_component_get_icalcomponent (_tmp31_);
					_tmp33_ = i_cal_component_get_uid (_tmp32_);
					_tmp34_ = row;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, _tmp33_, _tmp34_);
					_g_object_unref0 (row);
				}
			}
			_g_object_unref0 (task);
		}
		_g_object_unref0 (_task_it);
	}
	_tmp35_ = self->priv->listbox;
	gtk_widget_show_all ((GtkWidget*) _tmp35_);
	_tmp36_ = self->priv->completed_listbox;
	gtk_widget_show_all ((GtkWidget*) _tmp36_);
	views_task_list_check_tasklist_placeholder (self);
}

static void
views_task_list_on_tasks_modified (ViewsTaskList* self,
                                   GeeCollection* tasks)
{
	GtkListBox* _tmp77_;
	GtkListBox* _tmp78_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tasks != NULL);
	{
		GeeIterator* _task_it = NULL;
		GeeIterator* _tmp0_;
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) tasks);
		_task_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_;
			ECalComponent* task = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ICalComponent* ical_task = NULL;
			ECalComponent* _tmp4_;
			ICalComponent* _tmp5_;
			ICalComponent* _tmp6_;
			_tmp1_ = _task_it;
			if (!gee_iterator_next (_tmp1_)) {
				break;
			}
			_tmp2_ = _task_it;
			_tmp3_ = gee_iterator_get (_tmp2_);
			task = (ECalComponent*) _tmp3_;
			_tmp4_ = task;
			_tmp5_ = e_cal_component_get_icalcomponent (_tmp4_);
			ical_task = _tmp5_;
			_tmp6_ = ical_task;
			if (i_cal_component_get_status (_tmp6_) == I_CAL_STATUS_COMPLETED) {
				GeeHashMap* _tmp7_;
				ECalComponent* _tmp8_;
				ICalComponent* _tmp9_;
				const gchar* _tmp10_;
				GeeHashMap* _tmp21_;
				ECalComponent* _tmp22_;
				ICalComponent* _tmp23_;
				const gchar* _tmp24_;
				_tmp7_ = self->items_uncompleted_added;
				_tmp8_ = task;
				_tmp9_ = e_cal_component_get_icalcomponent (_tmp8_);
				_tmp10_ = i_cal_component_get_uid (_tmp9_);
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp7_, _tmp10_)) {
					GeeHashMap* _tmp11_;
					ECalComponent* _tmp12_;
					ICalComponent* _tmp13_;
					const gchar* _tmp14_;
					gpointer _tmp15_;
					WidgetsTaskRow* _tmp16_;
					GeeHashMap* _tmp17_;
					ECalComponent* _tmp18_;
					ICalComponent* _tmp19_;
					const gchar* _tmp20_;
					_tmp11_ = self->items_uncompleted_added;
					_tmp12_ = task;
					_tmp13_ = e_cal_component_get_icalcomponent (_tmp12_);
					_tmp14_ = i_cal_component_get_uid (_tmp13_);
					_tmp15_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp14_);
					_tmp16_ = (WidgetsTaskRow*) _tmp15_;
					widgets_task_row_hide_destroy (_tmp16_);
					_g_object_unref0 (_tmp16_);
					_tmp17_ = self->items_uncompleted_added;
					_tmp18_ = task;
					_tmp19_ = e_cal_component_get_icalcomponent (_tmp18_);
					_tmp20_ = i_cal_component_get_uid (_tmp19_);
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp17_, _tmp20_, NULL);
				}
				_tmp21_ = self->items_completed_added;
				_tmp22_ = task;
				_tmp23_ = e_cal_component_get_icalcomponent (_tmp22_);
				_tmp24_ = i_cal_component_get_uid (_tmp23_);
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp21_, _tmp24_)) {
					WidgetsTaskRow* row = NULL;
					ECalComponent* _tmp25_;
					ESource* _tmp26_;
					WidgetsTaskRow* _tmp27_;
					GtkListBox* _tmp28_;
					WidgetsTaskRow* _tmp29_;
					GeeHashMap* _tmp30_;
					ECalComponent* _tmp31_;
					ICalComponent* _tmp32_;
					const gchar* _tmp33_;
					WidgetsTaskRow* _tmp34_;
					_tmp25_ = task;
					_tmp26_ = self->priv->_source;
					_tmp27_ = widgets_task_row_new_for_component (_tmp25_, _tmp26_);
					g_object_ref_sink (_tmp27_);
					row = _tmp27_;
					_tmp28_ = self->priv->completed_listbox;
					_tmp29_ = row;
					gtk_list_box_insert (_tmp28_, (GtkWidget*) _tmp29_, 0);
					_tmp30_ = self->items_completed_added;
					_tmp31_ = task;
					_tmp32_ = e_cal_component_get_icalcomponent (_tmp31_);
					_tmp33_ = i_cal_component_get_uid (_tmp32_);
					_tmp34_ = row;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, _tmp33_, _tmp34_);
					_g_object_unref0 (row);
				} else {
					GeeHashMap* _tmp35_;
					ECalComponent* _tmp36_;
					ICalComponent* _tmp37_;
					const gchar* _tmp38_;
					gpointer _tmp39_;
					WidgetsTaskRow* _tmp40_;
					ECalComponent* _tmp41_;
					_tmp35_ = self->items_completed_added;
					_tmp36_ = task;
					_tmp37_ = e_cal_component_get_icalcomponent (_tmp36_);
					_tmp38_ = i_cal_component_get_uid (_tmp37_);
					_tmp39_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp35_, _tmp38_);
					_tmp40_ = (WidgetsTaskRow*) _tmp39_;
					_tmp41_ = task;
					widgets_task_row_set_task (_tmp40_, _tmp41_);
					_g_object_unref0 (_tmp40_);
				}
			} else {
				GeeHashMap* _tmp42_;
				ECalComponent* _tmp43_;
				ICalComponent* _tmp44_;
				const gchar* _tmp45_;
				GeeHashMap* _tmp56_;
				ECalComponent* _tmp57_;
				ICalComponent* _tmp58_;
				const gchar* _tmp59_;
				_tmp42_ = self->items_completed_added;
				_tmp43_ = task;
				_tmp44_ = e_cal_component_get_icalcomponent (_tmp43_);
				_tmp45_ = i_cal_component_get_uid (_tmp44_);
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp42_, _tmp45_)) {
					GeeHashMap* _tmp46_;
					ECalComponent* _tmp47_;
					ICalComponent* _tmp48_;
					const gchar* _tmp49_;
					gpointer _tmp50_;
					WidgetsTaskRow* _tmp51_;
					GeeHashMap* _tmp52_;
					ECalComponent* _tmp53_;
					ICalComponent* _tmp54_;
					const gchar* _tmp55_;
					_tmp46_ = self->items_completed_added;
					_tmp47_ = task;
					_tmp48_ = e_cal_component_get_icalcomponent (_tmp47_);
					_tmp49_ = i_cal_component_get_uid (_tmp48_);
					_tmp50_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, _tmp49_);
					_tmp51_ = (WidgetsTaskRow*) _tmp50_;
					widgets_task_row_hide_destroy (_tmp51_);
					_g_object_unref0 (_tmp51_);
					_tmp52_ = self->items_completed_added;
					_tmp53_ = task;
					_tmp54_ = e_cal_component_get_icalcomponent (_tmp53_);
					_tmp55_ = i_cal_component_get_uid (_tmp54_);
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp52_, _tmp55_, NULL);
				}
				_tmp56_ = self->items_uncompleted_added;
				_tmp57_ = task;
				_tmp58_ = e_cal_component_get_icalcomponent (_tmp57_);
				_tmp59_ = i_cal_component_get_uid (_tmp58_);
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp56_, _tmp59_)) {
					WidgetsTaskRow* row = NULL;
					ECalComponent* _tmp60_;
					ESource* _tmp61_;
					WidgetsTaskRow* _tmp62_;
					GtkListBox* _tmp63_;
					WidgetsTaskRow* _tmp64_;
					GeeHashMap* _tmp65_;
					ECalComponent* _tmp66_;
					ICalComponent* _tmp67_;
					const gchar* _tmp68_;
					WidgetsTaskRow* _tmp69_;
					_tmp60_ = task;
					_tmp61_ = self->priv->_source;
					_tmp62_ = widgets_task_row_new_for_component (_tmp60_, _tmp61_);
					g_object_ref_sink (_tmp62_);
					row = _tmp62_;
					_tmp63_ = self->priv->listbox;
					_tmp64_ = row;
					gtk_container_add ((GtkContainer*) _tmp63_, (GtkWidget*) _tmp64_);
					_tmp65_ = self->items_uncompleted_added;
					_tmp66_ = task;
					_tmp67_ = e_cal_component_get_icalcomponent (_tmp66_);
					_tmp68_ = i_cal_component_get_uid (_tmp67_);
					_tmp69_ = row;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp65_, _tmp68_, _tmp69_);
					_g_object_unref0 (row);
				} else {
					GeeHashMap* _tmp70_;
					ECalComponent* _tmp71_;
					ICalComponent* _tmp72_;
					const gchar* _tmp73_;
					gpointer _tmp74_;
					WidgetsTaskRow* _tmp75_;
					ECalComponent* _tmp76_;
					_tmp70_ = self->items_uncompleted_added;
					_tmp71_ = task;
					_tmp72_ = e_cal_component_get_icalcomponent (_tmp71_);
					_tmp73_ = i_cal_component_get_uid (_tmp72_);
					_tmp74_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp70_, _tmp73_);
					_tmp75_ = (WidgetsTaskRow*) _tmp74_;
					_tmp76_ = task;
					widgets_task_row_set_task (_tmp75_, _tmp76_);
					_g_object_unref0 (_tmp75_);
				}
			}
			_g_object_unref0 (task);
		}
		_g_object_unref0 (_task_it);
	}
	_tmp77_ = self->priv->listbox;
	gtk_widget_show_all ((GtkWidget*) _tmp77_);
	_tmp78_ = self->priv->completed_listbox;
	gtk_widget_show_all ((GtkWidget*) _tmp78_);
	views_task_list_check_tasklist_placeholder (self);
}

static void
views_task_list_on_tasks_removed (ViewsTaskList* self,
                                  GSList* cids)
{
	WidgetsTaskRow* task_row = NULL;
	gint row_index = 0;
	g_return_if_fail (self != NULL);
	task_row = NULL;
	row_index = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			GtkListBox* _tmp2_;
			GtkListBoxRow* _tmp3_;
			WidgetsTaskRow* _tmp4_;
			gint _tmp15_;
			if (!_tmp0_) {
				WidgetsTaskRow* _tmp1_;
				_tmp1_ = task_row;
				if (!(_tmp1_ != NULL)) {
					break;
				}
			}
			_tmp0_ = FALSE;
			_tmp2_ = self->priv->listbox;
			_tmp3_ = gtk_list_box_get_row_at_index (_tmp2_, row_index);
			task_row = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, WIDGETS_TYPE_TASK_ROW, WidgetsTaskRow);
			_tmp4_ = task_row;
			if (_tmp4_ != NULL) {
				{
					GSList* cid_collection = NULL;
					GSList* cid_it = NULL;
					cid_collection = cids;
					for (cid_it = cid_collection; cid_it != NULL; cid_it = cid_it->next) {
						ECalComponentId* cid = NULL;
						cid = (ECalComponentId*) cid_it->data;
						{
							ECalComponentId* _tmp5_;
							_tmp5_ = cid;
							if (_tmp5_ == NULL) {
								continue;
							} else {
								ECalComponentId* _tmp6_;
								const gchar* _tmp7_;
								WidgetsTaskRow* _tmp8_;
								ECalComponent* _tmp9_;
								ECalComponent* _tmp10_;
								ICalComponent* _tmp11_;
								const gchar* _tmp12_;
								_tmp6_ = cid;
								_tmp7_ = e_cal_component_id_get_uid (_tmp6_);
								_tmp8_ = task_row;
								_tmp9_ = widgets_task_row_get_task (_tmp8_);
								_tmp10_ = _tmp9_;
								_tmp11_ = e_cal_component_get_icalcomponent (_tmp10_);
								_tmp12_ = i_cal_component_get_uid (_tmp11_);
								if (g_strcmp0 (_tmp7_, _tmp12_) == 0) {
									GtkListBox* _tmp13_;
									WidgetsTaskRow* _tmp14_;
									_tmp13_ = self->priv->listbox;
									_tmp14_ = task_row;
									gtk_container_remove ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
									break;
								}
							}
						}
					}
				}
			}
			_tmp15_ = row_index;
			row_index = _tmp15_ + 1;
		}
	}
	views_task_list_check_tasklist_placeholder (self);
}

static void
__lambda63_ (ViewsTaskList* self,
             GtkWidget* row)
{
	g_return_if_fail (row != NULL);
	if (WIDGETS_IS_TASK_ROW (row)) {
		widgets_task_row_update_request (WIDGETS_IS_TASK_ROW (row) ? ((WidgetsTaskRow*) row) : NULL);
	}
}

static void
___lambda63__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda63_ ((ViewsTaskList*) self, widget);
}

void
views_task_list_update_request (ViewsTaskList* self)
{
	GtkLabel* _tmp0_;
	ESource* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	WidgetsEntry* _tmp4_;
	ESource* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	WidgetsProjectProgress* _tmp8_;
	ESourceTaskList* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkListBox* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->name_label;
	_tmp1_ = self->priv->_source;
	_tmp2_ = e_source_dup_display_name (_tmp1_);
	_tmp3_ = _tmp2_;
	gtk_label_set_label (_tmp0_, _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = self->priv->name_entry;
	_tmp5_ = self->priv->_source;
	_tmp6_ = e_source_dup_display_name (_tmp5_);
	_tmp7_ = _tmp6_;
	gtk_entry_set_text ((GtkEntry*) _tmp4_, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = self->priv->project_progress;
	_tmp9_ = self->priv->task_list;
	_tmp10_ = e_source_selectable_dup_color ((ESourceSelectable*) _tmp9_);
	_tmp11_ = _tmp10_;
	widgets_project_progress_set_progress_fill_color (_tmp8_, _tmp11_);
	_g_free0 (_tmp11_);
	_tmp12_ = self->priv->listbox;
	gtk_container_foreach ((GtkContainer*) _tmp12_, ___lambda63__gtk_callback, self);
}

static void
views_task_list_check_tasklist_placeholder (ViewsTaskList* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->items_uncompleted_added;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ > 0) {
		GtkStack* _tmp3_;
		_tmp3_ = self->priv->main_stack;
		gtk_stack_set_visible_child_name (_tmp3_, "tasklist");
	} else {
		GtkStack* _tmp4_;
		_tmp4_ = self->priv->main_stack;
		gtk_stack_set_visible_child_name (_tmp4_, "placeholder");
	}
}

ViewsTaskList*
views_task_list_construct (GType object_type)
{
	ViewsTaskList * self = NULL;
	self = (ViewsTaskList*) g_object_new (object_type, NULL);
	return self;
}

ViewsTaskList*
views_task_list_new (void)
{
	return views_task_list_construct (VIEWS_TYPE_TASK_LIST);
}

ESource*
views_task_list_get_source (ViewsTaskList* self)
{
	ESource* result;
	ESource* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_source;
	result = _tmp0_;
	return result;
}

void
views_task_list_set_source (ViewsTaskList* self,
                            ESource* value)
{
	ESource* old_value;
	g_return_if_fail (self != NULL);
	old_value = views_task_list_get_source (self);
	if (old_value != value) {
		ESource* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_source);
		self->priv->_source = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, views_task_list_properties[VIEWS_TASK_LIST_SOURCE_PROPERTY]);
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
	g_atomic_int_inc (&_data14_->_ref_count_);
	return _data14_;
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
		ViewsTaskList* self;
		self = _data14_->self;
		_g_object_unref0 (_data14_->submit_button);
		_g_object_unref0 (self);
		g_slice_free (Block14Data, _data14_);
	}
}

static void
_views_task_list___lambda64_ (ViewsTaskList* self)
{
	ESource* _tmp0_;
	ESourceExtension* _tmp1_;
	ESourceTaskList* _tmp2_;
	WidgetsProjectProgress* _tmp3_;
	ESourceTaskList* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkListBox* _tmp7_;
	GList* _tmp8_;
	GtkListBox* _tmp10_;
	GList* _tmp11_;
	ESource* _tmp13_;
	_tmp0_ = self->priv->_source;
	_tmp1_ = e_source_get_extension (_tmp0_, E_SOURCE_EXTENSION_TASK_LIST);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, e_source_task_list_get_type (), ESourceTaskList));
	_g_object_unref0 (self->priv->task_list);
	self->priv->task_list = _tmp2_;
	_tmp3_ = self->priv->project_progress;
	_tmp4_ = self->priv->task_list;
	_tmp5_ = e_source_selectable_dup_color ((ESourceSelectable*) _tmp4_);
	_tmp6_ = _tmp5_;
	widgets_project_progress_set_progress_fill_color (_tmp3_, _tmp6_);
	_g_free0 (_tmp6_);
	views_task_list_remove_views (self);
	_tmp7_ = self->priv->listbox;
	_tmp8_ = gtk_container_get_children ((GtkContainer*) _tmp7_);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp8_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				GtkWidget* _tmp9_;
				_tmp9_ = child;
				gtk_widget_destroy (_tmp9_);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	_tmp10_ = self->priv->completed_listbox;
	_tmp11_ = gtk_container_get_children ((GtkContainer*) _tmp10_);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp11_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				GtkWidget* _tmp12_;
				_tmp12_ = child;
				gtk_widget_destroy (_tmp12_);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	_tmp13_ = self->priv->_source;
	views_task_list_add_view (self, _tmp13_, "(contains? 'any' '')");
	views_task_list_update_request (self);
	gtk_widget_show_all ((GtkWidget*) self);
}

static void
__views_task_list___lambda64__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_views_task_list___lambda64_ ((ViewsTaskList*) self);
}

static void
_views_task_list___lambda65_ (ViewsTaskList* self,
                              const gchar* uid)
{
	ESource* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (uid != NULL);
	_tmp0_ = self->priv->_source;
	_tmp1_ = e_source_get_uid (_tmp0_);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, uid) == 0) {
		GtkRevealer* _tmp3_;
		GtkStack* _tmp4_;
		WidgetsEntry* _tmp5_;
		_tmp3_ = self->priv->action_revealer;
		gtk_revealer_set_reveal_child (_tmp3_, TRUE);
		_tmp4_ = self->priv->name_stack;
		gtk_stack_set_visible_child_name (_tmp4_, "name_entry");
		_tmp5_ = self->priv->name_entry;
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
	}
}

static void
__views_task_list___lambda65__services_event_bus_edit_tasklist (ServicesEventBus* _sender,
                                                                const gchar* uid,
                                                                gpointer self)
{
	_views_task_list___lambda65_ ((ViewsTaskList*) self, uid);
}

static void
_views_task_list___lambda66_ (ViewsTaskList* self)
{
	ServicesEventBus* _tmp0_;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	_tmp0_ = planner_event_bus;
	g_signal_emit_by_name (_tmp0_, "unselect-all");
	_tmp1_ = self->priv->settings_button;
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GtkPopover* _tmp4_;
		GtkPopover* _tmp5_;
		_tmp4_ = self->priv->popover;
		if (_tmp4_ == NULL) {
			views_task_list_create_popover (self);
		}
		_tmp5_ = self->priv->popover;
		gtk_widget_show_all ((GtkWidget*) _tmp5_);
	}
}

static void
__views_task_list___lambda66__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                         gpointer self)
{
	_views_task_list___lambda66_ ((ViewsTaskList*) self);
}

static void
_views_task_list___lambda67_ (ViewsTaskList* self,
                              GtkListBoxRow* r)
{
	WidgetsTaskRow* row = NULL;
	WidgetsTaskRow* _tmp0_;
	WidgetsTaskRow* _tmp1_;
	g_return_if_fail (r != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (r, WIDGETS_TYPE_TASK_ROW, WidgetsTaskRow));
	row = _tmp0_;
	_tmp1_ = row;
	widgets_task_row_set_reveal_child (_tmp1_, TRUE);
	_g_object_unref0 (row);
}

static void
__views_task_list___lambda67__gtk_list_box_row_activated (GtkListBox* _sender,
                                                          GtkListBoxRow* row,
                                                          gpointer self)
{
	_views_task_list___lambda67_ ((ViewsTaskList*) self, row);
}

static void
_views_task_list___lambda68_ (ViewsTaskList* self,
                              GtkListBoxRow* r)
{
	WidgetsTaskRow* row = NULL;
	WidgetsTaskRow* _tmp0_;
	WidgetsTaskRow* _tmp1_;
	g_return_if_fail (r != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (r, WIDGETS_TYPE_TASK_ROW, WidgetsTaskRow));
	row = _tmp0_;
	_tmp1_ = row;
	widgets_task_row_set_reveal_child (_tmp1_, TRUE);
	_g_object_unref0 (row);
}

static void
__views_task_list___lambda68__gtk_list_box_row_activated (GtkListBox* _sender,
                                                          GtkListBoxRow* row,
                                                          gpointer self)
{
	_views_task_list___lambda68_ ((ViewsTaskList*) self, row);
}

static void
_views_task_list___lambda69_ (ViewsTaskList* self,
                              gint color)
{
	ESourceTaskList* _tmp0_;
	Utils* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ESource* _tmp4_;
	_tmp0_ = self->priv->task_list;
	_tmp1_ = planner_utils;
	_tmp2_ = utils_get_color (_tmp1_, color);
	_tmp3_ = _tmp2_;
	e_source_selectable_set_color ((ESourceSelectable*) _tmp0_, _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = self->priv->_source;
	e_source_write (_tmp4_, NULL, NULL, NULL);
}

static void
__views_task_list___lambda69__widgets_color_popover_color_changed (WidgetsColorPopover* _sender,
                                                                   gint color,
                                                                   gpointer self)
{
	_views_task_list___lambda69_ ((ViewsTaskList*) self, color);
}

static void
_views_task_list___lambda70_ (ViewsTaskList* self)
{
	GtkRevealer* _tmp0_;
	GtkStack* _tmp1_;
	WidgetsEntry* _tmp2_;
	ESource* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	_tmp0_ = self->priv->action_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
	_tmp1_ = self->priv->name_stack;
	gtk_stack_set_visible_child_name (_tmp1_, "name_label");
	_tmp2_ = self->priv->name_entry;
	_tmp3_ = self->priv->_source;
	_tmp4_ = e_source_get_display_name (_tmp3_);
	_tmp5_ = _tmp4_;
	gtk_entry_set_text ((GtkEntry*) _tmp2_, _tmp5_);
}

static void
__views_task_list___lambda70__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
	_views_task_list___lambda70_ ((ViewsTaskList*) self);
}

static gboolean
_views_task_list___lambda71_ (ViewsTaskList* self,
                              GdkEventKey* key)
{
	gboolean result = FALSE;
	g_return_val_if_fail (key != NULL, FALSE);
	if (key->keyval == ((guint) 65307)) {
		GtkRevealer* _tmp0_;
		GtkStack* _tmp1_;
		WidgetsEntry* _tmp2_;
		ESource* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		_tmp0_ = self->priv->action_revealer;
		gtk_revealer_set_reveal_child (_tmp0_, FALSE);
		_tmp1_ = self->priv->name_stack;
		gtk_stack_set_visible_child_name (_tmp1_, "name_label");
		_tmp2_ = self->priv->name_entry;
		_tmp3_ = self->priv->_source;
		_tmp4_ = e_source_get_display_name (_tmp3_);
		_tmp5_ = _tmp4_;
		gtk_entry_set_text ((GtkEntry*) _tmp2_, _tmp5_);
	}
	result = FALSE;
	return result;
}

static gboolean
__views_task_list___lambda71__gtk_widget_key_release_event (GtkWidget* _sender,
                                                            GdkEventKey* event,
                                                            gpointer self)
{
	gboolean result;
	result = _views_task_list___lambda71_ ((ViewsTaskList*) self, event);
	return result;
}

static gboolean
_views_task_list___lambda72_ (ViewsTaskList* self)
{
	if (self->priv->entry_menu_opened == FALSE) {
		views_task_list_save (self);
	}
}

static gboolean
__views_task_list___lambda72__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                          GdkEventFocus* event,
                                                          gpointer self)
{
	gboolean result;
	result = _views_task_list___lambda72_ ((ViewsTaskList*) self);
	return result;
}

static void
__lambda74_ (ViewsTaskList* self)
{
	self->priv->entry_menu_opened = FALSE;
}

static void
___lambda74__gtk_widget_hide (GtkWidget* _sender,
                              gpointer self)
{
	__lambda74_ ((ViewsTaskList*) self);
}

static void
_views_task_list___lambda73_ (ViewsTaskList* self,
                              GtkMenu* menu)
{
	g_return_if_fail (menu != NULL);
	self->priv->entry_menu_opened = TRUE;
	g_signal_connect_object ((GtkWidget*) menu, "hide", (GCallback) ___lambda74__gtk_widget_hide, self, 0);
}

static void
__views_task_list___lambda73__gtk_entry_populate_popup (GtkEntry* _sender,
                                                        GtkMenu* popup,
                                                        gpointer self)
{
	_views_task_list___lambda73_ ((ViewsTaskList*) self, popup);
}

static gboolean
_views_task_list___lambda75_ (ViewsTaskList* self,
                              GdkEvent* event)
{
	GdkEventType _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->type;
	if (_tmp0_ == GDK_2BUTTON_PRESS) {
		GtkRevealer* _tmp1_;
		GtkStack* _tmp2_;
		WidgetsEntry* _tmp3_;
		WidgetsEntry* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		WidgetsEntry* _tmp7_;
		guint _tmp8_;
		guint _tmp9_;
		_tmp1_ = self->priv->action_revealer;
		gtk_revealer_set_reveal_child (_tmp1_, TRUE);
		_tmp2_ = self->priv->name_stack;
		gtk_stack_set_visible_child_name (_tmp2_, "name_entry");
		_tmp3_ = self->priv->name_entry;
		gtk_entry_grab_focus_without_selecting ((GtkEntry*) _tmp3_);
		_tmp4_ = self->priv->name_entry;
		g_object_get ((GtkEntry*) _tmp4_, "cursor-position", &_tmp5_, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = self->priv->name_entry;
		_tmp8_ = gtk_entry_get_text_length ((GtkEntry*) _tmp7_);
		_tmp9_ = _tmp8_;
		if (((guint) _tmp6_) < _tmp9_) {
			WidgetsEntry* _tmp10_;
			WidgetsEntry* _tmp11_;
			guint _tmp12_;
			guint _tmp13_;
			_tmp10_ = self->priv->name_entry;
			_tmp11_ = self->priv->name_entry;
			_tmp12_ = gtk_entry_get_text_length ((GtkEntry*) _tmp11_);
			_tmp13_ = _tmp12_;
			g_signal_emit_by_name ((GtkEntry*) _tmp10_, "move-cursor", GTK_MOVEMENT_BUFFER_ENDS, (gint) ((gint32) _tmp13_), FALSE);
		}
	}
	result = FALSE;
	return result;
}

static gboolean
__views_task_list___lambda75__gtk_widget_event (GtkWidget* _sender,
                                                GdkEvent* event,
                                                gpointer self)
{
	gboolean result;
	result = _views_task_list___lambda75_ ((ViewsTaskList*) self, event);
	return result;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
_views_task_list___lambda76_ (Block14Data* _data14_)
{
	ViewsTaskList* self;
	gboolean _tmp0_ = FALSE;
	WidgetsEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	self = _data14_->self;
	_tmp1_ = self->priv->name_entry;
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = string_strip (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strcmp0 (_tmp5_, "") != 0;
	_g_free0 (_tmp5_);
	if (_tmp6_) {
		ESource* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		WidgetsEntry* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		_tmp7_ = self->priv->_source;
		_tmp8_ = e_source_get_display_name (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = self->priv->name_entry;
		_tmp11_ = gtk_entry_get_text ((GtkEntry*) _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp0_ = g_strcmp0 (_tmp9_, _tmp12_) != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkButton* _tmp13_;
		_tmp13_ = _data14_->submit_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
	} else {
		GtkButton* _tmp14_;
		_tmp14_ = _data14_->submit_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
	}
}

static void
__views_task_list___lambda76__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self)
{
	_views_task_list___lambda76_ (self);
}

static void
_views_task_list___lambda77_ (ViewsTaskList* self)
{
	views_task_list_save (self);
}

static void
__views_task_list___lambda77__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
	_views_task_list___lambda77_ ((ViewsTaskList*) self);
}

static void
_views_task_list___lambda78_ (ViewsTaskList* self)
{
	views_task_list_save (self);
}

static void
__views_task_list___lambda78__gtk_entry_activate (GtkEntry* _sender,
                                                  gpointer self)
{
	_views_task_list___lambda78_ ((ViewsTaskList*) self);
}

static void
_views_task_list___lambda79_ (ViewsTaskList* self)
{
	GSettings* _tmp0_;
	_tmp0_ = planner_settings;
	views_task_list_add_new_task (self, g_settings_get_enum (_tmp0_, "new-tasks-position"));
}

static void
__views_task_list___lambda79__widgets_magic_button_clicked (WidgetsMagicButton* _sender,
                                                            gpointer self)
{
	_views_task_list___lambda79_ ((ViewsTaskList*) self);
}

static void
_views_task_list___lambda80_ (ViewsTaskList* self,
                              ESource* s)
{
	ESource* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	g_return_if_fail (s != NULL);
	_tmp0_ = self->priv->_source;
	_tmp1_ = e_source_get_uid (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = e_source_get_uid (s);
	_tmp4_ = _tmp3_;
	if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
		views_task_list_update_request (self);
	}
}

static void
__views_task_list___lambda80__services_tasks_store_task_list_modified (ServicesTasksStore* _sender,
                                                                       ESource* task_list,
                                                                       gpointer self)
{
	_views_task_list___lambda80_ ((ViewsTaskList*) self, task_list);
}

static GObject *
views_task_list_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ViewsTaskList * self;
	Block14Data* _data14_;
	GEqualFunc _tmp0_;
	GeeArrayList* _tmp1_;
	ServicesTasksStore* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	WidgetsColorPopover* color_popover = NULL;
	WidgetsColorPopover* _tmp5_;
	WidgetsProjectProgress* _tmp6_;
	WidgetsProjectProgress* _tmp7_;
	WidgetsProjectProgress* _tmp8_;
	GtkMenuButton* progress_button = NULL;
	GtkMenuButton* _tmp9_;
	GtkMenuButton* _tmp10_;
	GtkMenuButton* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkMenuButton* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkMenuButton* _tmp15_;
	WidgetsProjectProgress* _tmp16_;
	GtkMenuButton* _tmp17_;
	WidgetsColorPopover* _tmp18_;
	GtkMenuButton* _tmp19_;
	GtkMenuButton* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkLabel* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkEventBox* name_eventbox = NULL;
	GtkEventBox* _tmp27_;
	GtkEventBox* _tmp28_;
	GtkEventBox* _tmp29_;
	GtkEventBox* _tmp30_;
	GtkEventBox* _tmp31_;
	GtkLabel* _tmp32_;
	WidgetsEntry* _tmp33_;
	WidgetsEntry* _tmp34_;
	GtkStyleContext* _tmp35_;
	WidgetsEntry* _tmp36_;
	GtkStyleContext* _tmp37_;
	WidgetsEntry* _tmp38_;
	GtkStyleContext* _tmp39_;
	WidgetsEntry* _tmp40_;
	GtkStyleContext* _tmp41_;
	WidgetsEntry* _tmp42_;
	GtkStack* _tmp43_;
	GtkStack* _tmp44_;
	GtkStack* _tmp45_;
	GtkEventBox* _tmp46_;
	GtkStack* _tmp47_;
	WidgetsEntry* _tmp48_;
	GtkButton* _tmp49_;
	GtkButton* _tmp50_;
	GtkButton* _tmp51_;
	GtkStyleContext* _tmp52_;
	GtkButton* cancel_button = NULL;
	GtkButton* _tmp53_;
	GtkButton* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkGrid* action_grid = NULL;
	GtkGrid* _tmp56_;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkGrid* _tmp60_;
	GtkGrid* _tmp61_;
	GtkGrid* _tmp62_;
	GtkButton* _tmp63_;
	GtkGrid* _tmp64_;
	GtkButton* _tmp65_;
	GtkRevealer* _tmp66_;
	GtkRevealer* _tmp67_;
	GtkRevealer* _tmp68_;
	GtkGrid* _tmp69_;
	GtkImage* settings_image = NULL;
	GtkImage* _tmp70_;
	GtkImage* _tmp71_;
	GThemedIcon* _tmp72_;
	GThemedIcon* _tmp73_;
	GtkImage* _tmp74_;
	GtkToggleButton* _tmp75_;
	GtkToggleButton* _tmp76_;
	GtkToggleButton* _tmp77_;
	GtkToggleButton* _tmp78_;
	GtkToggleButton* _tmp79_;
	GtkImage* _tmp80_;
	GtkToggleButton* _tmp81_;
	GtkStyleContext* _tmp82_;
	GtkBox* top_box = NULL;
	GtkBox* _tmp83_;
	GtkBox* _tmp84_;
	GtkBox* _tmp85_;
	GtkBox* _tmp86_;
	GtkBox* _tmp87_;
	GtkBox* _tmp88_;
	GtkBox* _tmp89_;
	GtkMenuButton* _tmp90_;
	GtkBox* _tmp91_;
	GtkStack* _tmp92_;
	GtkBox* _tmp93_;
	GtkToggleButton* _tmp94_;
	GtkListBox* _tmp95_;
	GtkListBox* _tmp96_;
	GtkListBox* _tmp97_;
	GtkListBox* _tmp98_;
	GtkListBox* _tmp99_;
	GtkStyleContext* _tmp100_;
	GtkListBox* _tmp101_;
	GtkListBox* _tmp102_;
	GtkListBox* _tmp103_;
	GtkListBox* _tmp104_;
	GtkListBox* _tmp105_;
	GtkListBox* _tmp106_;
	GtkListBox* _tmp107_;
	GtkListBox* _tmp108_;
	GtkStyleContext* _tmp109_;
	GtkListBox* _tmp110_;
	GtkListBox* _tmp111_;
	GtkListBox* _tmp112_;
	GtkRevealer* _tmp113_;
	GtkRevealer* _tmp114_;
	GtkRevealer* _tmp115_;
	GtkListBox* _tmp116_;
	GtkRevealer* _tmp117_;
	GtkBox* box = NULL;
	GtkBox* _tmp118_;
	GtkBox* _tmp119_;
	GtkBox* _tmp120_;
	GtkListBox* _tmp121_;
	GtkBox* _tmp122_;
	GtkRevealer* _tmp123_;
	GtkScrolledWindow* listbox_scrolled = NULL;
	GtkScrolledWindow* _tmp124_;
	GtkScrolledWindow* _tmp125_;
	GtkScrolledWindow* _tmp126_;
	GtkBox* _tmp127_;
	WidgetsMagicButton* magic_button = NULL;
	WidgetsMagicButton* _tmp128_;
	WidgetsPlaceholder* placeholder_view = NULL;
	WidgetsPlaceholder* _tmp129_;
	WidgetsPlaceholder* _tmp130_;
	WidgetsPlaceholder* _tmp131_;
	GtkStack* _tmp132_;
	GtkStack* _tmp133_;
	GtkStack* _tmp134_;
	GtkStack* _tmp135_;
	WidgetsPlaceholder* _tmp136_;
	GtkStack* _tmp137_;
	GtkScrolledWindow* _tmp138_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp139_;
	GtkBox* _tmp140_;
	GtkBox* _tmp141_;
	GtkBox* _tmp142_;
	GtkBox* _tmp143_;
	GtkRevealer* _tmp144_;
	GtkBox* _tmp145_;
	GtkStack* _tmp146_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp147_;
	GtkOverlay* _tmp148_;
	GtkOverlay* _tmp149_;
	WidgetsMagicButton* _tmp150_;
	GtkOverlay* _tmp151_;
	GtkBox* _tmp152_;
	GtkOverlay* _tmp153_;
	ServicesEventBus* _tmp154_;
	GtkToggleButton* _tmp155_;
	GtkListBox* _tmp156_;
	GtkListBox* _tmp157_;
	WidgetsColorPopover* _tmp158_;
	GtkButton* _tmp159_;
	WidgetsEntry* _tmp160_;
	WidgetsEntry* _tmp161_;
	WidgetsEntry* _tmp162_;
	GtkEventBox* _tmp163_;
	WidgetsEntry* _tmp164_;
	GtkButton* _tmp165_;
	WidgetsEntry* _tmp166_;
	WidgetsMagicButton* _tmp167_;
	ServicesTasksStore* _tmp168_;
	parent_class = G_OBJECT_CLASS (views_task_list_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEWS_TYPE_TASK_LIST, ViewsTaskList);
	_data14_ = g_slice_new0 (Block14Data);
	_data14_->_ref_count_ = 1;
	_data14_->self = g_object_ref (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = gee_array_list_new (e_cal_client_view_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeEqualDataFunc) _tmp0_, NULL, NULL);
	_g_object_unref0 (self->priv->views);
	self->priv->views = (GeeCollection*) _tmp1_;
	_tmp2_ = services_tasks_store_get_default ();
	_g_object_unref0 (views_task_list_task_store);
	views_task_list_task_store = _tmp2_;
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, WIDGETS_TYPE_TASK_ROW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->items_uncompleted_added);
	self->items_uncompleted_added = _tmp3_;
	_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, WIDGETS_TYPE_TASK_ROW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->items_completed_added);
	self->items_completed_added = _tmp4_;
	_tmp5_ = widgets_color_popover_new ();
	g_object_ref_sink (_tmp5_);
	color_popover = _tmp5_;
	_tmp6_ = widgets_project_progress_new (16);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->project_progress);
	self->priv->project_progress = _tmp6_;
	_tmp7_ = self->priv->project_progress;
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
	_tmp8_ = self->priv->project_progress;
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
	_tmp9_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp9_);
	progress_button = _tmp9_;
	_tmp10_ = progress_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
	_tmp11_ = progress_button;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	gtk_style_context_add_class (_tmp12_, "no-padding");
	_tmp13_ = progress_button;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, "flat");
	_tmp15_ = progress_button;
	_tmp16_ = self->priv->project_progress;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = progress_button;
	_tmp18_ = color_popover;
	gtk_menu_button_set_popover (_tmp17_, (GtkPopover*) _tmp18_);
	_tmp19_ = progress_button;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp19_, 6);
	_tmp20_ = progress_button;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp20_, 2);
	_tmp21_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->name_label);
	self->priv->name_label = _tmp21_;
	_tmp22_ = self->priv->name_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_START);
	_tmp23_ = self->priv->name_label;
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) _tmp23_);
	gtk_style_context_add_class (_tmp24_, "title-label");
	_tmp25_ = self->priv->name_label;
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
	gtk_style_context_add_class (_tmp26_, "font-bold");
	_tmp27_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp27_);
	name_eventbox = _tmp27_;
	_tmp28_ = name_eventbox;
	gtk_widget_set_valign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
	_tmp29_ = name_eventbox;
	gtk_widget_add_events ((GtkWidget*) _tmp29_, (gint) (GDK_ENTER_NOTIFY_MASK | GDK_LEAVE_NOTIFY_MASK));
	_tmp30_ = name_eventbox;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp30_, TRUE);
	_tmp31_ = name_eventbox;
	_tmp32_ = self->priv->name_label;
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
	_tmp33_ = widgets_entry_new ();
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->name_entry);
	self->priv->name_entry = _tmp33_;
	_tmp34_ = self->priv->name_entry;
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
	gtk_style_context_add_class (_tmp35_, "font-bold");
	_tmp36_ = self->priv->name_entry;
	_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
	gtk_style_context_add_class (_tmp37_, "flat");
	_tmp38_ = self->priv->name_entry;
	_tmp39_ = gtk_widget_get_style_context ((GtkWidget*) _tmp38_);
	gtk_style_context_add_class (_tmp39_, "title-label");
	_tmp40_ = self->priv->name_entry;
	_tmp41_ = gtk_widget_get_style_context ((GtkWidget*) _tmp40_);
	gtk_style_context_add_class (_tmp41_, "project-name-entry");
	_tmp42_ = self->priv->name_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp42_, TRUE);
	_tmp43_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp43_);
	_g_object_unref0 (self->priv->name_stack);
	self->priv->name_stack = _tmp43_;
	_tmp44_ = self->priv->name_stack;
	gtk_stack_set_transition_type (_tmp44_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	_tmp45_ = self->priv->name_stack;
	_tmp46_ = name_eventbox;
	gtk_stack_add_named (_tmp45_, (GtkWidget*) _tmp46_, "name_label");
	_tmp47_ = self->priv->name_stack;
	_tmp48_ = self->priv->name_entry;
	gtk_stack_add_named (_tmp47_, (GtkWidget*) _tmp48_, "name_entry");
	_tmp49_ = (GtkButton*) gtk_button_new_with_label (_ ("Save"));
	g_object_ref_sink (_tmp49_);
	_data14_->submit_button = _tmp49_;
	_tmp50_ = _data14_->submit_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp50_, FALSE);
	_tmp51_ = _data14_->submit_button;
	_tmp52_ = gtk_widget_get_style_context ((GtkWidget*) _tmp51_);
	gtk_style_context_add_class (_tmp52_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp53_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
	g_object_ref_sink (_tmp53_);
	cancel_button = _tmp53_;
	_tmp54_ = cancel_button;
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
	gtk_style_context_add_class (_tmp55_, "planner-button");
	_tmp56_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp56_);
	action_grid = _tmp56_;
	_tmp57_ = action_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp57_, GTK_ALIGN_START);
	_tmp58_ = action_grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp58_, 6);
	_tmp59_ = action_grid;
	gtk_grid_set_column_homogeneous (_tmp59_, TRUE);
	_tmp60_ = action_grid;
	gtk_grid_set_column_spacing (_tmp60_, 6);
	_tmp61_ = action_grid;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp61_, 42);
	_tmp62_ = action_grid;
	_tmp63_ = cancel_button;
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
	_tmp64_ = action_grid;
	_tmp65_ = _data14_->submit_button;
	gtk_container_add ((GtkContainer*) _tmp64_, (GtkWidget*) _tmp65_);
	_tmp66_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp66_);
	_g_object_unref0 (self->priv->action_revealer);
	self->priv->action_revealer = _tmp66_;
	_tmp67_ = self->priv->action_revealer;
	gtk_revealer_set_transition_type (_tmp67_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp68_ = self->priv->action_revealer;
	_tmp69_ = action_grid;
	gtk_container_add ((GtkContainer*) _tmp68_, (GtkWidget*) _tmp69_);
	_tmp70_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp70_);
	settings_image = _tmp70_;
	_tmp71_ = settings_image;
	_tmp72_ = (GThemedIcon*) g_themed_icon_new ("view-more-symbolic");
	_tmp73_ = _tmp72_;
	g_object_set (_tmp71_, "gicon", (GIcon*) _tmp73_, NULL);
	_g_object_unref0 (_tmp73_);
	_tmp74_ = settings_image;
	gtk_image_set_pixel_size (_tmp74_, 14);
	_tmp75_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp75_);
	_g_object_unref0 (self->priv->settings_button);
	self->priv->settings_button = _tmp75_;
	_tmp76_ = self->priv->settings_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp76_, GTK_ALIGN_CENTER);
	_tmp77_ = self->priv->settings_button;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp77_, FALSE);
	_tmp78_ = self->priv->settings_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp78_, _ ("Project Menu"));
	_tmp79_ = self->priv->settings_button;
	_tmp80_ = settings_image;
	gtk_button_set_image ((GtkButton*) _tmp79_, (GtkWidget*) _tmp80_);
	_tmp81_ = self->priv->settings_button;
	_tmp82_ = gtk_widget_get_style_context ((GtkWidget*) _tmp81_);
	gtk_style_context_add_class (_tmp82_, GTK_STYLE_CLASS_FLAT);
	_tmp83_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	g_object_ref_sink (_tmp83_);
	top_box = _tmp83_;
	_tmp84_ = top_box;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp84_, TRUE);
	_tmp85_ = top_box;
	gtk_widget_set_valign ((GtkWidget*) _tmp85_, GTK_ALIGN_START);
	_tmp86_ = top_box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp86_, 36);
	_tmp87_ = top_box;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp87_, 42);
	_tmp88_ = top_box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp88_, 6);
	_tmp89_ = top_box;
	_tmp90_ = progress_button;
	gtk_box_pack_start (_tmp89_, (GtkWidget*) _tmp90_, FALSE, FALSE, (guint) 0);
	_tmp91_ = top_box;
	_tmp92_ = self->priv->name_stack;
	gtk_box_pack_start (_tmp91_, (GtkWidget*) _tmp92_, FALSE, TRUE, (guint) 0);
	_tmp93_ = top_box;
	_tmp94_ = self->priv->settings_button;
	gtk_box_pack_end (_tmp93_, (GtkWidget*) _tmp94_, FALSE, FALSE, (guint) 0);
	_tmp95_ = (GtkListBox*) gtk_list_box_new ();
	g_object_ref_sink (_tmp95_);
	_g_object_unref0 (self->priv->listbox);
	self->priv->listbox = _tmp95_;
	_tmp96_ = self->priv->listbox;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp96_, 32);
	_tmp97_ = self->priv->listbox;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp97_, 12);
	_tmp98_ = self->priv->listbox;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp98_, 32);
	_tmp99_ = self->priv->listbox;
	_tmp100_ = gtk_widget_get_style_context ((GtkWidget*) _tmp99_);
	gtk_style_context_add_class (_tmp100_, "listbox");
	_tmp101_ = self->priv->listbox;
	gtk_list_box_set_activate_on_single_click (_tmp101_, TRUE);
	_tmp102_ = self->priv->listbox;
	gtk_list_box_set_selection_mode (_tmp102_, GTK_SELECTION_SINGLE);
	_tmp103_ = self->priv->listbox;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp103_, TRUE);
	_tmp104_ = (GtkListBox*) gtk_list_box_new ();
	g_object_ref_sink (_tmp104_);
	_g_object_unref0 (self->priv->completed_listbox);
	self->priv->completed_listbox = _tmp104_;
	_tmp105_ = self->priv->completed_listbox;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp105_, 32);
	_tmp106_ = self->priv->completed_listbox;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp106_, 32);
	_tmp107_ = self->priv->completed_listbox;
	gtk_widget_set_valign ((GtkWidget*) _tmp107_, GTK_ALIGN_START);
	_tmp108_ = self->priv->completed_listbox;
	_tmp109_ = gtk_widget_get_style_context ((GtkWidget*) _tmp108_);
	gtk_style_context_add_class (_tmp109_, "listbox");
	_tmp110_ = self->priv->completed_listbox;
	gtk_list_box_set_activate_on_single_click (_tmp110_, TRUE);
	_tmp111_ = self->priv->completed_listbox;
	gtk_list_box_set_selection_mode (_tmp111_, GTK_SELECTION_SINGLE);
	_tmp112_ = self->priv->completed_listbox;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp112_, TRUE);
	_tmp113_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp113_);
	_g_object_unref0 (self->priv->completed_revealer);
	self->priv->completed_revealer = _tmp113_;
	_tmp114_ = self->priv->completed_revealer;
	gtk_revealer_set_transition_type (_tmp114_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp115_ = self->priv->completed_revealer;
	_tmp116_ = self->priv->completed_listbox;
	gtk_container_add ((GtkContainer*) _tmp115_, (GtkWidget*) _tmp116_);
	_tmp117_ = self->priv->completed_revealer;
	gtk_revealer_set_reveal_child (_tmp117_, TRUE);
	_tmp118_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp118_);
	box = _tmp118_;
	_tmp119_ = box;
	g_object_set ((GtkWidget*) _tmp119_, "expand", TRUE, NULL);
	_tmp120_ = box;
	_tmp121_ = self->priv->listbox;
	gtk_box_pack_start (_tmp120_, (GtkWidget*) _tmp121_, FALSE, FALSE, (guint) 0);
	_tmp122_ = box;
	_tmp123_ = self->priv->completed_revealer;
	gtk_box_pack_start (_tmp122_, (GtkWidget*) _tmp123_, FALSE, FALSE, (guint) 0);
	_tmp124_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp124_);
	listbox_scrolled = _tmp124_;
	_tmp125_ = listbox_scrolled;
	g_object_set (_tmp125_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	_tmp126_ = listbox_scrolled;
	_tmp127_ = box;
	gtk_container_add ((GtkContainer*) _tmp126_, (GtkWidget*) _tmp127_);
	_tmp128_ = widgets_magic_button_new ();
	g_object_ref_sink (_tmp128_);
	magic_button = _tmp128_;
	_tmp129_ = widgets_placeholder_new (_ ("What will you accomplish?"), _ ("Tap + to add a task to this project."), "planner-project-symbolic");
	g_object_ref_sink (_tmp129_);
	placeholder_view = _tmp129_;
	_tmp130_ = placeholder_view;
	gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp130_, TRUE);
	_tmp131_ = placeholder_view;
	gtk_widget_show_all ((GtkWidget*) _tmp131_);
	_tmp132_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp132_);
	_g_object_unref0 (self->priv->main_stack);
	self->priv->main_stack = _tmp132_;
	_tmp133_ = self->priv->main_stack;
	g_object_set ((GtkWidget*) _tmp133_, "expand", TRUE, NULL);
	_tmp134_ = self->priv->main_stack;
	gtk_stack_set_transition_type (_tmp134_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	_tmp135_ = self->priv->main_stack;
	_tmp136_ = placeholder_view;
	gtk_stack_add_named (_tmp135_, (GtkWidget*) _tmp136_, "placeholder");
	_tmp137_ = self->priv->main_stack;
	_tmp138_ = listbox_scrolled;
	gtk_stack_add_named (_tmp137_, (GtkWidget*) _tmp138_, "tasklist");
	_tmp139_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp139_);
	main_box = _tmp139_;
	_tmp140_ = main_box;
	g_object_set ((GtkWidget*) _tmp140_, "expand", TRUE, NULL);
	_tmp141_ = main_box;
	_tmp142_ = top_box;
	gtk_box_pack_start (_tmp141_, (GtkWidget*) _tmp142_, FALSE, FALSE, (guint) 0);
	_tmp143_ = main_box;
	_tmp144_ = self->priv->action_revealer;
	gtk_box_pack_start (_tmp143_, (GtkWidget*) _tmp144_, FALSE, FALSE, (guint) 0);
	_tmp145_ = main_box;
	_tmp146_ = self->priv->main_stack;
	gtk_box_pack_start (_tmp145_, (GtkWidget*) _tmp146_, FALSE, TRUE, (guint) 0);
	_tmp147_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp147_);
	overlay = _tmp147_;
	_tmp148_ = overlay;
	g_object_set ((GtkWidget*) _tmp148_, "expand", TRUE, NULL);
	_tmp149_ = overlay;
	_tmp150_ = magic_button;
	gtk_overlay_add_overlay (_tmp149_, (GtkWidget*) _tmp150_);
	_tmp151_ = overlay;
	_tmp152_ = main_box;
	gtk_container_add ((GtkContainer*) _tmp151_, (GtkWidget*) _tmp152_);
	_tmp153_ = overlay;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp153_);
	g_signal_connect_object ((GObject*) self, "notify::source", (GCallback) __views_task_list___lambda64__g_object_notify, self, 0);
	_tmp154_ = planner_event_bus;
	g_signal_connect_object (_tmp154_, "edit-tasklist", (GCallback) __views_task_list___lambda65__services_event_bus_edit_tasklist, self, 0);
	_tmp155_ = self->priv->settings_button;
	g_signal_connect_object (_tmp155_, "toggled", (GCallback) __views_task_list___lambda66__gtk_toggle_button_toggled, self, 0);
	_tmp156_ = self->priv->listbox;
	g_signal_connect_object (_tmp156_, "row-activated", (GCallback) __views_task_list___lambda67__gtk_list_box_row_activated, self, 0);
	_tmp157_ = self->priv->completed_listbox;
	g_signal_connect_object (_tmp157_, "row-activated", (GCallback) __views_task_list___lambda68__gtk_list_box_row_activated, self, 0);
	_tmp158_ = color_popover;
	g_signal_connect_object (_tmp158_, "color-changed", (GCallback) __views_task_list___lambda69__widgets_color_popover_color_changed, self, 0);
	_tmp159_ = cancel_button;
	g_signal_connect_object (_tmp159_, "clicked", (GCallback) __views_task_list___lambda70__gtk_button_clicked, self, 0);
	_tmp160_ = self->priv->name_entry;
	g_signal_connect_object ((GtkWidget*) _tmp160_, "key-release-event", (GCallback) __views_task_list___lambda71__gtk_widget_key_release_event, self, 0);
	_tmp161_ = self->priv->name_entry;
	g_signal_connect_object ((GtkWidget*) _tmp161_, "focus-out-event", (GCallback) __views_task_list___lambda72__gtk_widget_focus_out_event, self, 0);
	_tmp162_ = self->priv->name_entry;
	g_signal_connect_object ((GtkEntry*) _tmp162_, "populate-popup", (GCallback) __views_task_list___lambda73__gtk_entry_populate_popup, self, 0);
	_tmp163_ = name_eventbox;
	g_signal_connect_object ((GtkWidget*) _tmp163_, "event", (GCallback) __views_task_list___lambda75__gtk_widget_event, self, 0);
	_tmp164_ = self->priv->name_entry;
	g_signal_connect_data ((GtkEditable*) _tmp164_, "changed", (GCallback) __views_task_list___lambda76__gtk_editable_changed, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
	_tmp165_ = _data14_->submit_button;
	g_signal_connect_object (_tmp165_, "clicked", (GCallback) __views_task_list___lambda77__gtk_button_clicked, self, 0);
	_tmp166_ = self->priv->name_entry;
	g_signal_connect_object ((GtkEntry*) _tmp166_, "activate", (GCallback) __views_task_list___lambda78__gtk_entry_activate, self, 0);
	_tmp167_ = magic_button;
	g_signal_connect_object (_tmp167_, "clicked", (GCallback) __views_task_list___lambda79__widgets_magic_button_clicked, self, 0);
	_tmp168_ = views_task_list_task_store;
	g_signal_connect_object (_tmp168_, "task-list-modified", (GCallback) __views_task_list___lambda80__services_tasks_store_task_list_modified, self, 0);
	_g_object_unref0 (overlay);
	_g_object_unref0 (main_box);
	_g_object_unref0 (placeholder_view);
	_g_object_unref0 (magic_button);
	_g_object_unref0 (listbox_scrolled);
	_g_object_unref0 (box);
	_g_object_unref0 (top_box);
	_g_object_unref0 (settings_image);
	_g_object_unref0 (action_grid);
	_g_object_unref0 (cancel_button);
	_g_object_unref0 (name_eventbox);
	_g_object_unref0 (progress_button);
	_g_object_unref0 (color_popover);
	block14_data_unref (_data14_);
	_data14_ = NULL;
	return obj;
}

static void
views_task_list_class_init (ViewsTaskListClass * klass,
                            gpointer klass_data)
{
	views_task_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ViewsTaskList_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_views_task_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_views_task_list_set_property;
	G_OBJECT_CLASS (klass)->constructor = views_task_list_constructor;
	G_OBJECT_CLASS (klass)->finalize = views_task_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VIEWS_TASK_LIST_SOURCE_PROPERTY, views_task_list_properties[VIEWS_TASK_LIST_SOURCE_PROPERTY] = g_param_spec_object ("source", "source", "source", e_source_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
views_task_list_instance_init (ViewsTaskList * self,
                               gpointer klass)
{
	self->priv = views_task_list_get_instance_private (self);
	self->priv->popover = NULL;
	self->priv->entry_menu_opened = FALSE;
	g_rec_mutex_init (&self->priv->__lock_views);
}

static void
views_task_list_finalize (GObject * obj)
{
	ViewsTaskList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEWS_TYPE_TASK_LIST, ViewsTaskList);
	_g_object_unref0 (self->priv->_source);
	_g_object_unref0 (self->priv->view);
	_g_object_unref0 (self->priv->name_label);
	_g_object_unref0 (self->priv->name_entry);
	_g_object_unref0 (self->priv->name_stack);
	_g_object_unref0 (self->priv->action_revealer);
	_g_object_unref0 (self->priv->listbox);
	_g_object_unref0 (self->priv->completed_listbox);
	_g_object_unref0 (self->priv->completed_revealer);
	_g_object_unref0 (self->priv->settings_button);
	_g_object_unref0 (self->priv->main_stack);
	_g_object_unref0 (self->priv->project_progress);
	_g_object_unref0 (self->priv->popover);
	_g_object_unref0 (self->priv->show_completed_switch);
	_g_object_unref0 (self->priv->show_completed_button);
	_g_object_unref0 (self->items_uncompleted_added);
	_g_object_unref0 (self->items_completed_added);
	g_rec_mutex_clear (&self->priv->__lock_views);
	_g_object_unref0 (self->priv->views);
	_g_object_unref0 (self->priv->task_list);
	G_OBJECT_CLASS (views_task_list_parent_class)->finalize (obj);
}

GType
views_task_list_get_type (void)
{
	return views_task_list_type_id;
}

GType
views_task_list_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ViewsTaskListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) views_task_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewsTaskList), 0, (GInstanceInitFunc) views_task_list_instance_init, NULL };
	views_task_list_type_id = g_type_module_register_type (module, gtk_event_box_get_type (), "ViewsTaskList", &g_define_type_info, 0);
	ViewsTaskList_private_offset = sizeof (ViewsTaskListPrivate);
	return views_task_list_type_id;
}

static void
_vala_views_task_list_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ViewsTaskList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VIEWS_TYPE_TASK_LIST, ViewsTaskList);
	switch (property_id) {
		case VIEWS_TASK_LIST_SOURCE_PROPERTY:
		g_value_set_object (value, views_task_list_get_source (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_views_task_list_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ViewsTaskList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VIEWS_TYPE_TASK_LIST, ViewsTaskList);
	switch (property_id) {
		case VIEWS_TASK_LIST_SOURCE_PROPERTY:
		views_task_list_set_source (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

