/* TaskRow.c generated by valac 0.52.4, the Vala compiler
 * generated from TaskRow.vala, do not modify */

/*
* Copyright © 2019 Alain M. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "caldav.h"
#include <libedataserver/libedataserver.h>
#include <libecal/libecal.h>
#include <glib.h>
#include <gtk/gtk.h>
#include "plannercore.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libical-glib/libical-glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gio/gio.h>
#include <gdk/gdk.h>

enum  {
	WIDGETS_TASK_ROW_0_PROPERTY,
	WIDGETS_TASK_ROW_SOURCE_PROPERTY,
	WIDGETS_TASK_ROW_TASK_PROPERTY,
	WIDGETS_TASK_ROW_CREATED_PROPERTY,
	WIDGETS_TASK_ROW_COMPLETED_PROPERTY,
	WIDGETS_TASK_ROW_REVEAL_CHILD_PROPERTY,
	WIDGETS_TASK_ROW_LOADING_PROPERTY,
	WIDGETS_TASK_ROW_NUM_PROPERTIES
};
static GParamSpec* widgets_task_row_properties[WIDGETS_TASK_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _WidgetsTaskRowPrivate {
	ESource* _source;
	ECalComponent* _task;
	gboolean _created;
	gboolean _completed;
	GtkCheckButton* checked_button;
	GtkLabel* content_label;
	GtkBox* top_box;
	GtkButton* hidden_button;
	GtkRevealer* hidden_revealer;
	GtkRevealer* label_revealer;
	WidgetsEntry* content_entry;
	GtkRevealer* entry_revealer;
	WidgetsTextView* note_textview;
	GtkLabel* note_label;
	GtkStack* note_stack;
	GtkRevealer* bottom_revealer;
	GtkRevealer* main_revealer;
	GtkGrid* main_grid;
	GtkGrid* handle_grid;
	GtkMenu* menu;
	GtkImage* menu_image;
	WidgetsScheduleButton* reschedule_button;
	GtkLabel* duedate_preview_label;
	GtkRevealer* duedate_preview_revealer;
	GtkRevealer* preview_revealer;
	GtkBox* preview_box;
	GtkButton* submit_button;
	GtkStack* submit_stack;
	GtkButton* cancel_button;
	ServicesTasksStore* task_store;
	guint focus_timeout;
	guint timeout_id;
	gboolean receive_updates;
	gboolean entry_menu_opened;
};

static gint WidgetsTaskRow_private_offset;
static gpointer widgets_task_row_parent_class = NULL;
static GType widgets_task_row_type_id = 0;

static void widgets_task_row_add_task (WidgetsTaskRow* self);
static void widgets_task_row_activate_menu (WidgetsTaskRow* self,
                                     gboolean visible);
static void widgets_task_row_build_context_menu (WidgetsTaskRow* self);
static void __lambda9_ (WidgetsTaskRow* self);
static void ___lambda9__gtk_widget_hide (GtkWidget* _sender,
                                  gpointer self);
static void __lambda10_ (WidgetsTaskRow* self);
static void ___lambda10__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda11_ (WidgetsTaskRow* self);
static void ___lambda11__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda12_ (WidgetsTaskRow* self);
static void ___lambda12__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda13_ (WidgetsTaskRow* self);
static void ___lambda13__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda14_ (WidgetsTaskRow* self);
static void ___lambda14__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda15_ (WidgetsTaskRow* self);
static void ___lambda15__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda16_ (WidgetsTaskRow* self);
static void ___lambda16__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda17_ (WidgetsTaskRow* self);
static void ___lambda17__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void __lambda18_ (WidgetsTaskRow* self);
static void ___lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static gboolean __lambda20_ (WidgetsTaskRow* self);
static gboolean ___lambda20__gsource_func (gpointer self);
static void widgets_task_row_save_timeout (WidgetsTaskRow* self);
static gboolean __lambda21_ (WidgetsTaskRow* self);
static void widgets_task_row_save_task (WidgetsTaskRow* self,
                                 ECalComponent* task);
static gboolean ___lambda21__gsource_func (gpointer self);
static void widgets_task_row_check_preview_box (WidgetsTaskRow* self);
static gboolean __lambda23_ (WidgetsTaskRow* self);
static gboolean ___lambda23__gsource_func (gpointer self);
static void widgets_task_row_update_note_label (WidgetsTaskRow* self,
                                         const gchar* text);
static void widgets_task_row_set_completed (WidgetsTaskRow* self,
                                     gboolean value);
static void widgets_task_row_update_duedate_style (WidgetsTaskRow* self);
static gboolean ____lambda24_ (WidgetsTaskRow* self);
static gboolean _____lambda24__gsource_func (gpointer self);
static GObject * widgets_task_row_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static gboolean _widgets_task_row___lambda25_ (WidgetsTaskRow* self);
static gboolean __widgets_task_row___lambda25__gsource_func (gpointer self);
static void _widgets_task_row___lambda26_ (WidgetsTaskRow* self);
static void __widgets_task_row___lambda26__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _widgets_task_row___lambda27_ (WidgetsTaskRow* self);
static void __widgets_task_row___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static gboolean _widgets_task_row___lambda28_ (WidgetsTaskRow* self,
                                        GdkEventKey* key);
static gboolean __widgets_task_row___lambda28__gtk_widget_key_release_event (GtkWidget* _sender,
                                                                      GdkEventKey* event,
                                                                      gpointer self);
static gboolean _widgets_task_row___lambda29_ (WidgetsTaskRow* self);
static gboolean __lambda30_ (WidgetsTaskRow* self);
static gboolean ___lambda30__gsource_func (gpointer self);
static gboolean __widgets_task_row___lambda29__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                    GdkEventFocus* event,
                                                                    gpointer self);
static gboolean _widgets_task_row___lambda31_ (WidgetsTaskRow* self);
static gboolean __widgets_task_row___lambda31__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                   GdkEventFocus* event,
                                                                   gpointer self);
static void _widgets_task_row___lambda32_ (WidgetsTaskRow* self,
                                    GtkMenu* menu);
static void __lambda33_ (WidgetsTaskRow* self);
static void ___lambda33__gtk_widget_hide (GtkWidget* _sender,
                                   gpointer self);
static void __widgets_task_row___lambda32__gtk_entry_populate_popup (GtkEntry* _sender,
                                                              GtkMenu* popup,
                                                              gpointer self);
static void _widgets_task_row___lambda34_ (WidgetsTaskRow* self);
static void __widgets_task_row___lambda34__gtk_entry_activate (GtkEntry* _sender,
                                                        gpointer self);
static void _widgets_task_row___lambda35_ (WidgetsTaskRow* self);
static void __widgets_task_row___lambda35__gtk_editable_changed (GtkEditable* _sender,
                                                          gpointer self);
static void _widgets_task_row___lambda36_ (WidgetsTaskRow* self);
static void __widgets_task_row___lambda36__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static gboolean _widgets_task_row___lambda37_ (WidgetsTaskRow* self,
                                        GtkWidget* sender,
                                        GdkEventButton* evt);
static gboolean __widgets_task_row___lambda37__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self);
static gboolean _widgets_task_row___lambda38_ (WidgetsTaskRow* self);
static gboolean __widgets_task_row___lambda38__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                    GdkEventFocus* event,
                                                                    gpointer self);
static gboolean _widgets_task_row___lambda39_ (WidgetsTaskRow* self);
static gboolean __widgets_task_row___lambda39__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                   GdkEventFocus* event,
                                                                   gpointer self);
static void _widgets_task_row___lambda40_ (WidgetsTaskRow* self);
static void __widgets_task_row___lambda40__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                               gpointer self);
static gboolean _widgets_task_row___lambda41_ (WidgetsTaskRow* self,
                                        GtkWidget* sender,
                                        GdkEventButton* evt);
static gboolean __widgets_task_row___lambda41__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self);
static void _widgets_task_row___lambda42_ (WidgetsTaskRow* self);
static void __widgets_task_row___lambda42__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _widgets_task_row_add_task_gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self);
static void _widgets_task_row___lambda43_ (WidgetsTaskRow* self,
                                    gboolean active);
static void __widgets_task_row___lambda43__widgets_schedule_button_popover_opened (WidgetsScheduleButton* _sender,
                                                                            gboolean active,
                                                                            gpointer self);
static void widgets_task_row_finalize (GObject * obj);
static void _vala_widgets_task_row_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_widgets_task_row_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
widgets_task_row_get_instance_private (WidgetsTaskRow* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsTaskRow_private_offset);
}

WidgetsTaskRow*
widgets_task_row_construct_for_source (GType object_type,
                                       ESource* source)
{
	WidgetsTaskRow * self = NULL;
	ECalComponent* task = NULL;
	ECalComponent* _tmp0_;
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = e_cal_component_new ();
	task = _tmp0_;
	e_cal_component_set_new_vtype (task, E_CAL_COMPONENT_TODO);
	self = (WidgetsTaskRow*) g_object_new (object_type, "task", task, "source", source, "created", FALSE, NULL);
	_g_object_unref0 (task);
	return self;
}

WidgetsTaskRow*
widgets_task_row_new_for_source (ESource* source)
{
	return widgets_task_row_construct_for_source (WIDGETS_TYPE_TASK_ROW, source);
}

WidgetsTaskRow*
widgets_task_row_construct_for_component (GType object_type,
                                          ECalComponent* task,
                                          ESource* source)
{
	WidgetsTaskRow * self = NULL;
	g_return_val_if_fail (task != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	self = (WidgetsTaskRow*) g_object_new (object_type, "task", task, "source", source, "created", TRUE, NULL);
	return self;
}

WidgetsTaskRow*
widgets_task_row_new_for_component (ECalComponent* task,
                                    ESource* source)
{
	return widgets_task_row_construct_for_component (WIDGETS_TYPE_TASK_ROW, task, source);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
widgets_task_row_add_task (WidgetsTaskRow* self)
{
	WidgetsEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->content_entry;
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = string_strip (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strcmp0 (_tmp4_, "") != 0;
	_g_free0 (_tmp4_);
	if (_tmp5_) {
		ICalComponent* ical_task = NULL;
		ECalComponent* _tmp6_;
		ICalComponent* _tmp7_;
		WidgetsScheduleButton* _tmp8_;
		gchar* description = NULL;
		WidgetsTextView* _tmp22_;
		GtkTextBuffer* _tmp23_;
		GtkTextBuffer* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gboolean _tmp27_ = FALSE;
		const gchar* _tmp28_;
		ECalComponent* _tmp41_;
		ICalComponent* _tmp42_;
		WidgetsEntry* _tmp43_;
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		ServicesTasksStore* _tmp46_;
		ESource* _tmp47_;
		ECalComponent* _tmp48_;
		widgets_task_row_set_loading (self, TRUE);
		_tmp6_ = self->priv->_task;
		_tmp7_ = e_cal_component_get_icalcomponent (_tmp6_);
		ical_task = _tmp7_;
		_tmp8_ = self->priv->reschedule_button;
		if (widgets_schedule_button_has_datetime (_tmp8_)) {
			ICalTime* due_icaltime = NULL;
			WidgetsScheduleButton* _tmp9_;
			ObjectsDuedate* _tmp10_;
			ObjectsDuedate* _tmp11_;
			ICalTime* _tmp12_;
			ICalComponent* _tmp13_;
			ICalTime* _tmp14_;
			ICalComponent* _tmp15_;
			ICalTime* _tmp16_;
			_tmp9_ = self->priv->reschedule_button;
			_tmp10_ = widgets_schedule_button_get_duedate (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = cal_dav_util_duedate_to_ical (_tmp11_, NULL);
			due_icaltime = _tmp12_;
			_tmp13_ = ical_task;
			_tmp14_ = due_icaltime;
			i_cal_component_set_due (_tmp13_, _tmp14_);
			_tmp15_ = ical_task;
			_tmp16_ = due_icaltime;
			i_cal_component_set_dtstart (_tmp15_, _tmp16_);
			_g_object_unref0 (due_icaltime);
		} else {
			ICalTime* null_icaltime = NULL;
			ICalTime* _tmp17_;
			ICalComponent* _tmp18_;
			ICalTime* _tmp19_;
			ICalComponent* _tmp20_;
			ICalTime* _tmp21_;
			_tmp17_ = i_cal_time_new_null_time ();
			null_icaltime = _tmp17_;
			_tmp18_ = ical_task;
			_tmp19_ = null_icaltime;
			i_cal_component_set_due (_tmp18_, _tmp19_);
			_tmp20_ = ical_task;
			_tmp21_ = null_icaltime;
			i_cal_component_set_dtstart (_tmp20_, _tmp21_);
			_g_object_unref0 (null_icaltime);
		}
		_tmp22_ = self->priv->note_textview;
		_tmp23_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp22_);
		_tmp24_ = _tmp23_;
		g_object_get (_tmp24_, "text", &_tmp25_, NULL);
		_tmp26_ = _tmp25_;
		description = _tmp26_;
		_tmp28_ = description;
		if (_tmp28_ != NULL) {
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gint _tmp32_;
			gint _tmp33_;
			_tmp29_ = description;
			_tmp30_ = string_strip (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp32_ = strlen (_tmp31_);
			_tmp33_ = _tmp32_;
			_tmp27_ = _tmp33_ > 0;
			_g_free0 (_tmp31_);
		} else {
			_tmp27_ = FALSE;
		}
		if (_tmp27_) {
			ICalProperty* property = NULL;
			ICalProperty* _tmp34_;
			ICalProperty* _tmp35_;
			const gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			ICalComponent* _tmp39_;
			ICalProperty* _tmp40_;
			_tmp34_ = i_cal_property_new (I_CAL_DESCRIPTION_PROPERTY);
			property = _tmp34_;
			_tmp35_ = property;
			_tmp36_ = description;
			_tmp37_ = string_strip (_tmp36_);
			_tmp38_ = _tmp37_;
			i_cal_property_set_description (_tmp35_, _tmp38_);
			_g_free0 (_tmp38_);
			_tmp39_ = ical_task;
			_tmp40_ = property;
			i_cal_component_add_property (_tmp39_, _tmp40_);
			_g_object_unref0 (property);
		}
		_tmp41_ = self->priv->_task;
		_tmp42_ = e_cal_component_get_icalcomponent (_tmp41_);
		_tmp43_ = self->priv->content_entry;
		_tmp44_ = gtk_entry_get_text ((GtkEntry*) _tmp43_);
		_tmp45_ = _tmp44_;
		i_cal_component_set_summary (_tmp42_, _tmp45_);
		_tmp46_ = self->priv->task_store;
		_tmp47_ = self->priv->_source;
		_tmp48_ = self->priv->_task;
		services_tasks_store_add_task (_tmp46_, _tmp47_, _tmp48_, self);
		_g_free0 (description);
	}
}

static void
widgets_task_row_activate_menu (WidgetsTaskRow* self,
                                gboolean visible)
{
	GtkMenu* _tmp0_;
	GtkGrid* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkMenu* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->menu;
	if (_tmp0_ == NULL) {
		widgets_task_row_build_context_menu (self);
	}
	_tmp1_ = self->priv->handle_grid;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
	gtk_style_context_add_class (_tmp2_, "highlight");
	_tmp3_ = self->priv->menu;
	gtk_menu_popup_at_pointer (_tmp3_, NULL);
}

static void
__lambda9_ (WidgetsTaskRow* self)
{
	GtkGrid* _tmp0_;
	GtkStyleContext* _tmp1_;
	_tmp0_ = self->priv->handle_grid;
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
	gtk_style_context_remove_class (_tmp1_, "highlight");
}

static void
___lambda9__gtk_widget_hide (GtkWidget* _sender,
                             gpointer self)
{
	__lambda9_ ((WidgetsTaskRow*) self);
}

static void
__lambda10_ (WidgetsTaskRow* self)
{
}

static void
___lambda10__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda10_ ((WidgetsTaskRow*) self);
}

static void
__lambda11_ (WidgetsTaskRow* self)
{
}

static void
___lambda11__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda11_ ((WidgetsTaskRow*) self);
}

static void
__lambda12_ (WidgetsTaskRow* self)
{
}

static void
___lambda12__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda12_ ((WidgetsTaskRow*) self);
}

static void
__lambda13_ (WidgetsTaskRow* self)
{
}

static void
___lambda13__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda13_ ((WidgetsTaskRow*) self);
}

static void
__lambda14_ (WidgetsTaskRow* self)
{
}

static void
___lambda14__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda14_ ((WidgetsTaskRow*) self);
}

static void
__lambda15_ (WidgetsTaskRow* self)
{
}

static void
___lambda15__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda15_ ((WidgetsTaskRow*) self);
}

static void
__lambda16_ (WidgetsTaskRow* self)
{
}

static void
___lambda16__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda16_ ((WidgetsTaskRow*) self);
}

static void
__lambda17_ (WidgetsTaskRow* self)
{
}

static void
___lambda17__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda17_ ((WidgetsTaskRow*) self);
}

static void
__lambda18_ (WidgetsTaskRow* self)
{
	ServicesTasksStore* _tmp0_;
	ESource* _tmp1_;
	ECalComponent* _tmp2_;
	_tmp0_ = self->priv->task_store;
	_tmp1_ = self->priv->_source;
	_tmp2_ = self->priv->_task;
	services_tasks_store_remove_task (_tmp0_, _tmp1_, _tmp2_, E_CAL_OBJ_MOD_ALL);
	widgets_task_row_hide_destroy (self);
}

static void
___lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda18_ ((WidgetsTaskRow*) self);
}

static void
widgets_task_row_build_context_menu (WidgetsTaskRow* self)
{
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	WidgetsImageMenuItem* complete_menu = NULL;
	WidgetsImageMenuItem* _tmp3_;
	WidgetsImageMenuItem* edit_menu = NULL;
	WidgetsImageMenuItem* _tmp4_;
	WidgetsImageMenuItem* today_menu = NULL;
	WidgetsImageMenuItem* _tmp5_;
	GtkImage* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkImage* _tmp8_;
	WidgetsImageMenuItem* tomorrow_menu = NULL;
	WidgetsImageMenuItem* _tmp9_;
	GtkImage* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkImage* _tmp12_;
	WidgetsImageMenuItem* undated_menu = NULL;
	WidgetsImageMenuItem* _tmp13_;
	GtkImage* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkImage* _tmp16_;
	GtkSeparatorMenuItem* date_separator = NULL;
	GtkSeparatorMenuItem* _tmp17_;
	WidgetsImageMenuItem* share_menu = NULL;
	WidgetsImageMenuItem* _tmp18_;
	GtkMenu* share_list_menu = NULL;
	GtkMenu* _tmp19_;
	WidgetsImageMenuItem* share_text_menu = NULL;
	WidgetsImageMenuItem* _tmp20_;
	WidgetsImageMenuItem* share_markdown_menu = NULL;
	WidgetsImageMenuItem* _tmp21_;
	WidgetsImageMenuItem* duplicate_menu = NULL;
	WidgetsImageMenuItem* _tmp22_;
	WidgetsImageMenuItem* delete_menu = NULL;
	WidgetsImageMenuItem* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkMenu* _tmp25_;
	GtkMenu* _tmp26_;
	GtkMenu* _tmp27_;
	GtkSeparatorMenuItem* _tmp28_;
	GtkSeparatorMenuItem* _tmp29_;
	GtkMenu* _tmp30_;
	GtkMenu* _tmp31_;
	GtkMenu* _tmp32_;
	GtkMenu* _tmp33_;
	GtkMenu* _tmp34_;
	GtkMenu* _tmp35_;
	GtkMenu* _tmp36_;
	GtkSeparatorMenuItem* _tmp37_;
	GtkSeparatorMenuItem* _tmp38_;
	GtkMenu* _tmp39_;
	GtkMenu* _tmp40_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->menu);
	self->priv->menu = _tmp0_;
	_tmp1_ = self->priv->menu;
	g_object_set ((GtkWidget*) _tmp1_, "width-request", 235, NULL);
	_tmp2_ = self->priv->menu;
	g_signal_connect_object ((GtkWidget*) _tmp2_, "hide", (GCallback) ___lambda9__gtk_widget_hide, self, 0);
	_tmp3_ = widgets_image_menu_item_new (_ ("Complete"), "emblem-default-symbolic", "");
	g_object_ref_sink (_tmp3_);
	complete_menu = _tmp3_;
	_tmp4_ = widgets_image_menu_item_new (_ ("Edit"), "edit-symbolic", "");
	g_object_ref_sink (_tmp4_);
	edit_menu = _tmp4_;
	_tmp5_ = widgets_image_menu_item_new (_ ("Today"), "help-about-symbolic", "");
	g_object_ref_sink (_tmp5_);
	today_menu = _tmp5_;
	_tmp6_ = today_menu->item_image;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "today-icon");
	_tmp8_ = today_menu->item_image;
	gtk_image_set_pixel_size (_tmp8_, 14);
	_tmp9_ = widgets_image_menu_item_new (_ ("Tomorrow"), "x-office-calendar-symbolic", "");
	g_object_ref_sink (_tmp9_);
	tomorrow_menu = _tmp9_;
	_tmp10_ = tomorrow_menu->item_image;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_add_class (_tmp11_, "upcoming-icon");
	_tmp12_ = tomorrow_menu->item_image;
	gtk_image_set_pixel_size (_tmp12_, 14);
	_tmp13_ = widgets_image_menu_item_new (_ ("Undated"), "window-close-symbolic", "");
	g_object_ref_sink (_tmp13_);
	undated_menu = _tmp13_;
	_tmp14_ = undated_menu->item_image;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_add_class (_tmp15_, "due-clear");
	_tmp16_ = undated_menu->item_image;
	gtk_image_set_pixel_size (_tmp16_, 14);
	_tmp17_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp17_);
	date_separator = _tmp17_;
	_tmp18_ = widgets_image_menu_item_new (_ ("Share"), "emblem-shared-symbolic", "");
	g_object_ref_sink (_tmp18_);
	share_menu = _tmp18_;
	_tmp19_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp19_);
	share_list_menu = _tmp19_;
	gtk_menu_item_set_submenu ((GtkMenuItem*) share_menu, share_list_menu);
	_tmp20_ = widgets_image_menu_item_new (_ ("Text"), "text-x-generic-symbolic", "");
	g_object_ref_sink (_tmp20_);
	share_text_menu = _tmp20_;
	_tmp21_ = widgets_image_menu_item_new (_ ("Markdown"), "planner-markdown-symbolic", "");
	g_object_ref_sink (_tmp21_);
	share_markdown_menu = _tmp21_;
	gtk_container_add ((GtkContainer*) share_list_menu, (GtkWidget*) share_text_menu);
	gtk_container_add ((GtkContainer*) share_list_menu, (GtkWidget*) share_markdown_menu);
	gtk_widget_show_all ((GtkWidget*) share_list_menu);
	_tmp22_ = widgets_image_menu_item_new (_ ("Duplicate"), "edit-copy-symbolic", "");
	g_object_ref_sink (_tmp22_);
	duplicate_menu = _tmp22_;
	_tmp23_ = widgets_image_menu_item_new (_ ("Delete"), "user-trash-symbolic", "");
	g_object_ref_sink (_tmp23_);
	delete_menu = _tmp23_;
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) delete_menu);
	gtk_style_context_add_class (_tmp24_, "menu-danger");
	_tmp25_ = self->priv->menu;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) complete_menu);
	_tmp26_ = self->priv->menu;
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) edit_menu);
	_tmp27_ = self->priv->menu;
	_tmp28_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp28_);
	_tmp29_ = _tmp28_;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp29_);
	_g_object_unref0 (_tmp29_);
	_tmp30_ = self->priv->menu;
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) today_menu);
	_tmp31_ = self->priv->menu;
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) tomorrow_menu);
	_tmp32_ = self->priv->menu;
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) undated_menu);
	_tmp33_ = self->priv->menu;
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) date_separator);
	_tmp34_ = self->priv->menu;
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) share_menu);
	_tmp35_ = self->priv->menu;
	gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) duplicate_menu);
	_tmp36_ = self->priv->menu;
	_tmp37_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp37_);
	_tmp38_ = _tmp37_;
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp38_);
	_g_object_unref0 (_tmp38_);
	_tmp39_ = self->priv->menu;
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) delete_menu);
	_tmp40_ = self->priv->menu;
	gtk_widget_show_all ((GtkWidget*) _tmp40_);
	g_signal_connect_object ((GtkMenuItem*) complete_menu, "activate", (GCallback) ___lambda10__gtk_menu_item_activate, self, 0);
	g_signal_connect_object ((GtkMenuItem*) edit_menu, "activate", (GCallback) ___lambda11__gtk_menu_item_activate, self, 0);
	g_signal_connect_object ((GtkMenuItem*) today_menu, "activate", (GCallback) ___lambda12__gtk_menu_item_activate, self, 0);
	g_signal_connect_object ((GtkMenuItem*) tomorrow_menu, "activate", (GCallback) ___lambda13__gtk_menu_item_activate, self, 0);
	g_signal_connect_object ((GtkMenuItem*) undated_menu, "activate", (GCallback) ___lambda14__gtk_menu_item_activate, self, 0);
	g_signal_connect_object ((GtkMenuItem*) share_text_menu, "activate", (GCallback) ___lambda15__gtk_menu_item_activate, self, 0);
	g_signal_connect_object ((GtkMenuItem*) share_markdown_menu, "activate", (GCallback) ___lambda16__gtk_menu_item_activate, self, 0);
	g_signal_connect_object ((GtkMenuItem*) duplicate_menu, "activate", (GCallback) ___lambda17__gtk_menu_item_activate, self, 0);
	g_signal_connect_object ((GtkMenuItem*) delete_menu, "activate", (GCallback) ___lambda18__gtk_menu_item_activate, self, 0);
	_g_object_unref0 (delete_menu);
	_g_object_unref0 (duplicate_menu);
	_g_object_unref0 (share_markdown_menu);
	_g_object_unref0 (share_text_menu);
	_g_object_unref0 (share_list_menu);
	_g_object_unref0 (share_menu);
	_g_object_unref0 (date_separator);
	_g_object_unref0 (undated_menu);
	_g_object_unref0 (tomorrow_menu);
	_g_object_unref0 (today_menu);
	_g_object_unref0 (edit_menu);
	_g_object_unref0 (complete_menu);
}

static gboolean
__lambda20_ (WidgetsTaskRow* self)
{
	gboolean result = FALSE;
	gtk_widget_destroy ((GtkWidget*) self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda20__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda20_ ((WidgetsTaskRow*) self);
	return result;
}

void
widgets_task_row_hide_destroy (WidgetsTaskRow* self)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->main_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
	_tmp1_ = self->priv->main_revealer;
	_tmp2_ = gtk_revealer_get_transition_duration (_tmp1_);
	_tmp3_ = _tmp2_;
	g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp3_, ___lambda20__gsource_func, g_object_ref (self), g_object_unref);
}

static gboolean
__lambda21_ (WidgetsTaskRow* self)
{
	ECalComponent* _tmp0_;
	gboolean result = FALSE;
	self->priv->timeout_id = (guint) 0;
	self->priv->receive_updates = FALSE;
	_tmp0_ = self->priv->_task;
	widgets_task_row_save_task (self, _tmp0_);
	result = FALSE;
	return result;
}

static gboolean
___lambda21__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda21_ ((WidgetsTaskRow*) self);
	return result;
}

static void
widgets_task_row_save_timeout (WidgetsTaskRow* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->timeout_id != ((guint) 0)) {
		g_source_remove (self->priv->timeout_id);
	}
	self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda21__gsource_func, g_object_ref (self), g_object_unref);
}

static void
widgets_task_row_save_task (WidgetsTaskRow* self,
                            ECalComponent* task)
{
	ICalComponent* ical_task = NULL;
	ICalComponent* _tmp0_;
	gint count = 0;
	ICalComponent* _tmp1_;
	WidgetsScheduleButton* _tmp8_;
	gchar* description = NULL;
	WidgetsTextView* _tmp22_;
	GtkTextBuffer* _tmp23_;
	GtkTextBuffer* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gboolean _tmp27_ = FALSE;
	const gchar* _tmp28_;
	ICalComponent* _tmp41_;
	WidgetsEntry* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	ServicesTasksStore* _tmp45_;
	ESource* _tmp46_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (task != NULL);
	_tmp0_ = e_cal_component_get_icalcomponent (task);
	ical_task = _tmp0_;
	_tmp1_ = ical_task;
	count = i_cal_component_count_properties (_tmp1_, I_CAL_DESCRIPTION_PROPERTY);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				ICalProperty* remove_prop = NULL;
				ICalComponent* _tmp4_;
				ICalProperty* _tmp5_;
				ICalComponent* _tmp6_;
				ICalProperty* _tmp7_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(i < count)) {
					break;
				}
				_tmp4_ = ical_task;
				_tmp5_ = i_cal_component_get_first_property (_tmp4_, I_CAL_DESCRIPTION_PROPERTY);
				_g_object_unref0 (remove_prop);
				remove_prop = _tmp5_;
				_tmp6_ = ical_task;
				_tmp7_ = remove_prop;
				i_cal_component_remove_property (_tmp6_, _tmp7_);
				_g_object_unref0 (remove_prop);
			}
		}
	}
	_tmp8_ = self->priv->reschedule_button;
	if (widgets_schedule_button_has_datetime (_tmp8_)) {
		ICalTime* due_icaltime = NULL;
		WidgetsScheduleButton* _tmp9_;
		ObjectsDuedate* _tmp10_;
		ObjectsDuedate* _tmp11_;
		ICalTime* _tmp12_;
		ICalComponent* _tmp13_;
		ICalTime* _tmp14_;
		ICalComponent* _tmp15_;
		ICalTime* _tmp16_;
		_tmp9_ = self->priv->reschedule_button;
		_tmp10_ = widgets_schedule_button_get_duedate (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = cal_dav_util_duedate_to_ical (_tmp11_, NULL);
		due_icaltime = _tmp12_;
		_tmp13_ = ical_task;
		_tmp14_ = due_icaltime;
		i_cal_component_set_due (_tmp13_, _tmp14_);
		_tmp15_ = ical_task;
		_tmp16_ = due_icaltime;
		i_cal_component_set_dtstart (_tmp15_, _tmp16_);
		_g_object_unref0 (due_icaltime);
	} else {
		ICalTime* null_icaltime = NULL;
		ICalTime* _tmp17_;
		ICalComponent* _tmp18_;
		ICalTime* _tmp19_;
		ICalComponent* _tmp20_;
		ICalTime* _tmp21_;
		_tmp17_ = i_cal_time_new_null_time ();
		null_icaltime = _tmp17_;
		_tmp18_ = ical_task;
		_tmp19_ = null_icaltime;
		i_cal_component_set_due (_tmp18_, _tmp19_);
		_tmp20_ = ical_task;
		_tmp21_ = null_icaltime;
		i_cal_component_set_dtstart (_tmp20_, _tmp21_);
		_g_object_unref0 (null_icaltime);
	}
	_tmp22_ = self->priv->note_textview;
	_tmp23_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp22_);
	_tmp24_ = _tmp23_;
	g_object_get (_tmp24_, "text", &_tmp25_, NULL);
	_tmp26_ = _tmp25_;
	description = _tmp26_;
	_tmp28_ = description;
	if (_tmp28_ != NULL) {
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		_tmp29_ = description;
		_tmp30_ = string_strip (_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = strlen (_tmp31_);
		_tmp33_ = _tmp32_;
		_tmp27_ = _tmp33_ > 0;
		_g_free0 (_tmp31_);
	} else {
		_tmp27_ = FALSE;
	}
	if (_tmp27_) {
		ICalProperty* property = NULL;
		ICalProperty* _tmp34_;
		ICalProperty* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		ICalComponent* _tmp39_;
		ICalProperty* _tmp40_;
		_tmp34_ = i_cal_property_new (I_CAL_DESCRIPTION_PROPERTY);
		property = _tmp34_;
		_tmp35_ = property;
		_tmp36_ = description;
		_tmp37_ = string_strip (_tmp36_);
		_tmp38_ = _tmp37_;
		i_cal_property_set_description (_tmp35_, _tmp38_);
		_g_free0 (_tmp38_);
		_tmp39_ = ical_task;
		_tmp40_ = property;
		i_cal_component_add_property (_tmp39_, _tmp40_);
		_g_object_unref0 (property);
	}
	_tmp41_ = e_cal_component_get_icalcomponent (task);
	_tmp42_ = self->priv->content_entry;
	_tmp43_ = gtk_entry_get_text ((GtkEntry*) _tmp42_);
	_tmp44_ = _tmp43_;
	i_cal_component_set_summary (_tmp41_, _tmp44_);
	_tmp45_ = self->priv->task_store;
	_tmp46_ = self->priv->_source;
	services_tasks_store_update_task (_tmp45_, _tmp46_, task, E_CAL_OBJ_MOD_THIS_AND_FUTURE);
	_g_free0 (description);
}

static gboolean
__lambda23_ (WidgetsTaskRow* self)
{
	gboolean result = FALSE;
	self->priv->timeout_id = (guint) 0;
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, TRUE);
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, TRUE);
	result = FALSE;
	return result;
}

static gboolean
___lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda23_ ((WidgetsTaskRow*) self);
	return result;
}

void
widgets_task_row_hide_item (WidgetsTaskRow* self)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	GtkGrid* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkGrid* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkRevealer* _tmp6_;
	GtkLabel* _tmp7_;
	Utils* _tmp8_;
	WidgetsEntry* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkRevealer* _tmp14_;
	GtkRevealer* _tmp15_;
	GtkRevealer* _tmp16_;
	guint _tmp17_;
	guint _tmp18_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->preview_revealer;
	gtk_revealer_set_transition_duration (_tmp0_, (guint) 150);
	_tmp1_ = self->priv->bottom_revealer;
	gtk_revealer_set_reveal_child (_tmp1_, FALSE);
	_tmp2_ = self->priv->main_grid;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_remove_class (_tmp3_, "item-row-selected");
	_tmp4_ = self->priv->main_grid;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_remove_class (_tmp5_, "popover");
	_tmp6_ = self->priv->entry_revealer;
	gtk_revealer_set_reveal_child (_tmp6_, FALSE);
	_tmp7_ = self->priv->content_label;
	_tmp8_ = planner_utils;
	_tmp9_ = self->priv->content_entry;
	_tmp10_ = gtk_entry_get_text ((GtkEntry*) _tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = utils_get_markup_format (_tmp8_, _tmp11_, 0);
	_tmp13_ = _tmp12_;
	gtk_label_set_label (_tmp7_, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp14_ = self->priv->label_revealer;
	gtk_revealer_set_reveal_child (_tmp14_, TRUE);
	_tmp15_ = self->priv->hidden_revealer;
	gtk_revealer_set_reveal_child (_tmp15_, FALSE);
	widgets_task_row_check_preview_box (self);
	_tmp16_ = self->priv->bottom_revealer;
	_tmp17_ = gtk_revealer_get_transition_duration (_tmp16_);
	_tmp18_ = _tmp17_;
	self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp18_, ___lambda23__gsource_func, g_object_ref (self), g_object_unref);
}

void
widgets_task_row_show_item (WidgetsTaskRow* self)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	GtkGrid* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkGrid* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkRevealer* _tmp6_;
	GtkRevealer* _tmp7_;
	GtkRevealer* _tmp8_;
	GtkRevealer* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->preview_revealer;
	gtk_revealer_set_transition_duration (_tmp0_, (guint) 0);
	_tmp1_ = self->priv->bottom_revealer;
	gtk_revealer_set_reveal_child (_tmp1_, TRUE);
	_tmp2_ = self->priv->main_grid;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, "item-row-selected");
	_tmp4_ = self->priv->main_grid;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, "popover");
	_tmp6_ = self->priv->entry_revealer;
	gtk_revealer_set_reveal_child (_tmp6_, TRUE);
	_tmp7_ = self->priv->label_revealer;
	gtk_revealer_set_reveal_child (_tmp7_, FALSE);
	_tmp8_ = self->priv->preview_revealer;
	gtk_revealer_set_reveal_child (_tmp8_, FALSE);
	_tmp9_ = self->priv->hidden_revealer;
	gtk_revealer_set_reveal_child (_tmp9_, TRUE);
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, FALSE);
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, FALSE);
	widgets_task_row_content_entry_focus (self);
}

void
widgets_task_row_content_entry_focus (WidgetsTaskRow* self)
{
	WidgetsEntry* _tmp0_;
	WidgetsEntry* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	WidgetsEntry* _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->content_entry;
	gtk_entry_grab_focus_without_selecting ((GtkEntry*) _tmp0_);
	_tmp1_ = self->priv->content_entry;
	g_object_get ((GtkEntry*) _tmp1_, "cursor-position", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->content_entry;
	_tmp5_ = gtk_entry_get_text_length ((GtkEntry*) _tmp4_);
	_tmp6_ = _tmp5_;
	if (((guint) _tmp3_) < _tmp6_) {
		WidgetsEntry* _tmp7_;
		WidgetsEntry* _tmp8_;
		guint _tmp9_;
		guint _tmp10_;
		_tmp7_ = self->priv->content_entry;
		_tmp8_ = self->priv->content_entry;
		_tmp9_ = gtk_entry_get_text_length ((GtkEntry*) _tmp8_);
		_tmp10_ = _tmp9_;
		g_signal_emit_by_name ((GtkEntry*) _tmp7_, "move-cursor", GTK_MOVEMENT_BUFFER_ENDS, (gint) ((gint32) _tmp10_), FALSE);
	}
}

static void
widgets_task_row_update_note_label (WidgetsTaskRow* self,
                                    const gchar* text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = string_strip (text);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strcmp0 (_tmp1_, "") == 0;
	_g_free0 (_tmp1_);
	if (_tmp2_) {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		_tmp3_ = self->priv->note_label;
		gtk_label_set_label (_tmp3_, _ ("Note"));
		_tmp4_ = self->priv->note_label;
		gtk_widget_set_opacity ((GtkWidget*) _tmp4_, 0.7);
	} else {
		GtkLabel* _tmp5_;
		Utils* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GtkLabel* _tmp9_;
		_tmp5_ = self->priv->note_label;
		_tmp6_ = planner_utils;
		_tmp7_ = utils_get_markup_format (_tmp6_, text, 0);
		_tmp8_ = _tmp7_;
		gtk_label_set_label (_tmp5_, _tmp8_);
		_g_free0 (_tmp8_);
		_tmp9_ = self->priv->note_label;
		gtk_widget_set_opacity ((GtkWidget*) _tmp9_, 1.0);
	}
}

static gboolean
____lambda24_ (WidgetsTaskRow* self)
{
	gboolean result = FALSE;
	self->priv->receive_updates = TRUE;
	result = FALSE;
	return result;
}

static gboolean
_____lambda24__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda24_ ((WidgetsTaskRow*) self);
	return result;
}

void
widgets_task_row_update_request (WidgetsTaskRow* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_created;
	if (_tmp0_) {
		if (self->priv->receive_updates) {
			WidgetsEntry* _tmp1_;
			GtkStyleContext* _tmp2_;
			WidgetsEntry* _tmp3_;
			GtkStyleContext* _tmp4_;
			ICalComponent* ical_task = NULL;
			ECalComponent* _tmp5_;
			ICalComponent* _tmp6_;
			GtkCheckButton* _tmp7_;
			GtkStyleContext* _tmp8_;
			ICalComponent* _tmp9_;
			GtkCheckButton* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
			const gchar* _tmp19_ = NULL;
			ICalComponent* _tmp20_;
			const gchar* _tmp21_;
			GtkLabel* _tmp24_;
			Utils* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			const gchar* _tmp28_ = NULL;
			ICalComponent* _tmp29_;
			const gchar* _tmp30_;
			WidgetsEntry* _tmp33_;
			ICalComponent* _tmp34_;
			const gchar* _tmp35_;
			ICalComponent* _tmp46_;
			ICalTime* _tmp47_;
			ICalTime* _tmp48_;
			gboolean _tmp49_;
			_tmp1_ = self->priv->content_entry;
			_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
			gtk_style_context_remove_class (_tmp2_, "entry-no-border");
			_tmp3_ = self->priv->content_entry;
			_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
			gtk_style_context_remove_class (_tmp4_, "content-entry");
			_tmp5_ = self->priv->_task;
			_tmp6_ = e_cal_component_get_icalcomponent (_tmp5_);
			ical_task = _tmp6_;
			_tmp7_ = self->priv->checked_button;
			_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
			gtk_style_context_remove_class (_tmp8_, "checklist-completed");
			_tmp9_ = ical_task;
			widgets_task_row_set_completed (self, i_cal_component_get_status (_tmp9_) == I_CAL_STATUS_COMPLETED);
			_tmp10_ = self->priv->checked_button;
			_tmp11_ = self->priv->_completed;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp10_, _tmp11_);
			_tmp12_ = self->priv->_completed;
			if (_tmp12_) {
				GtkCheckButton* _tmp13_;
				GtkStyleContext* _tmp14_;
				WidgetsEntry* _tmp15_;
				GtkStyleContext* _tmp16_;
				_tmp13_ = self->priv->checked_button;
				_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
				gtk_style_context_add_class (_tmp14_, "checklist-completed");
				_tmp15_ = self->priv->content_entry;
				_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
				gtk_style_context_add_class (_tmp16_, "entry-no-border");
			} else {
				WidgetsEntry* _tmp17_;
				GtkStyleContext* _tmp18_;
				_tmp17_ = self->priv->content_entry;
				_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
				gtk_style_context_add_class (_tmp18_, "content-entry");
			}
			_tmp20_ = ical_task;
			_tmp21_ = i_cal_component_get_summary (_tmp20_);
			if (_tmp21_ == NULL) {
				_tmp19_ = "";
			} else {
				ICalComponent* _tmp22_;
				const gchar* _tmp23_;
				_tmp22_ = ical_task;
				_tmp23_ = i_cal_component_get_summary (_tmp22_);
				_tmp19_ = _tmp23_;
			}
			_tmp24_ = self->priv->content_label;
			_tmp25_ = planner_utils;
			_tmp26_ = utils_get_markup_format (_tmp25_, _tmp19_, 0);
			_tmp27_ = _tmp26_;
			gtk_label_set_label (_tmp24_, _tmp27_);
			_g_free0 (_tmp27_);
			_tmp29_ = ical_task;
			_tmp30_ = i_cal_component_get_summary (_tmp29_);
			if (_tmp30_ == NULL) {
				_tmp28_ = "";
			} else {
				ICalComponent* _tmp31_;
				const gchar* _tmp32_;
				_tmp31_ = ical_task;
				_tmp32_ = i_cal_component_get_summary (_tmp31_);
				_tmp28_ = _tmp32_;
			}
			_tmp33_ = self->priv->content_entry;
			gtk_entry_set_text ((GtkEntry*) _tmp33_, _tmp28_);
			_tmp34_ = ical_task;
			_tmp35_ = i_cal_component_get_description (_tmp34_);
			if (_tmp35_ != NULL) {
				WidgetsTextView* _tmp36_;
				GtkTextBuffer* _tmp37_;
				GtkTextBuffer* _tmp38_;
				ICalComponent* _tmp39_;
				const gchar* _tmp40_;
				ICalComponent* _tmp41_;
				const gchar* _tmp42_;
				_tmp36_ = self->priv->note_textview;
				_tmp37_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp36_);
				_tmp38_ = _tmp37_;
				_tmp39_ = ical_task;
				_tmp40_ = i_cal_component_get_description (_tmp39_);
				g_object_set (_tmp38_, "text", _tmp40_, NULL);
				_tmp41_ = ical_task;
				_tmp42_ = i_cal_component_get_description (_tmp41_);
				widgets_task_row_update_note_label (self, _tmp42_);
			} else {
				WidgetsTextView* _tmp43_;
				GtkTextBuffer* _tmp44_;
				GtkTextBuffer* _tmp45_;
				_tmp43_ = self->priv->note_textview;
				_tmp44_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp43_);
				_tmp45_ = _tmp44_;
				g_object_set (_tmp45_, "text", "", NULL);
				widgets_task_row_update_note_label (self, "");
			}
			_tmp46_ = ical_task;
			_tmp47_ = i_cal_component_get_due (_tmp46_);
			_tmp48_ = _tmp47_;
			_tmp49_ = !i_cal_time_is_null_time (_tmp48_);
			_g_object_unref0 (_tmp48_);
			if (_tmp49_) {
				WidgetsScheduleButton* _tmp50_;
				ICalComponent* _tmp51_;
				ICalTime* _tmp52_;
				ICalTime* _tmp53_;
				GDateTime* _tmp54_;
				GDateTime* _tmp55_;
				gboolean _tmp56_;
				_tmp50_ = self->priv->reschedule_button;
				_tmp51_ = ical_task;
				_tmp52_ = i_cal_component_get_due (_tmp51_);
				_tmp53_ = _tmp52_;
				_tmp54_ = cal_dav_util_ical_to_date_time (_tmp53_);
				_tmp55_ = _tmp54_;
				widgets_schedule_button_set_datetime (_tmp50_, _tmp55_);
				_g_date_time_unref0 (_tmp55_);
				_g_object_unref0 (_tmp53_);
				_tmp56_ = self->priv->_completed;
				if (_tmp56_) {
					GtkRevealer* _tmp57_;
					_tmp57_ = self->priv->duedate_preview_revealer;
					gtk_revealer_set_reveal_child (_tmp57_, FALSE);
				} else {
					GtkRevealer* _tmp58_;
					_tmp58_ = self->priv->duedate_preview_revealer;
					gtk_revealer_set_reveal_child (_tmp58_, TRUE);
				}
			} else {
				GtkRevealer* _tmp59_;
				_tmp59_ = self->priv->duedate_preview_revealer;
				gtk_revealer_set_reveal_child (_tmp59_, FALSE);
			}
			widgets_task_row_check_preview_box (self);
			widgets_task_row_update_duedate_style (self);
		} else {
			g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 2500, _____lambda24__gsource_func, g_object_ref (self), g_object_unref);
		}
	}
}

static void
widgets_task_row_update_duedate_style (WidgetsTaskRow* self)
{
	ICalComponent* ical_task = NULL;
	ECalComponent* _tmp0_;
	ICalComponent* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkLabel* _tmp7_;
	GtkStyleContext* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_task;
	_tmp1_ = e_cal_component_get_icalcomponent (_tmp0_);
	ical_task = _tmp1_;
	_tmp2_ = self->priv->duedate_preview_label;
	gtk_label_set_label (_tmp2_, "");
	_tmp3_ = self->priv->duedate_preview_label;
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
	gtk_style_context_remove_class (_tmp4_, "today-label-button");
	_tmp5_ = self->priv->duedate_preview_label;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_remove_class (_tmp6_, "overdue");
	_tmp7_ = self->priv->duedate_preview_label;
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
	gtk_style_context_remove_class (_tmp8_, "upcoming-label-button");
	_tmp10_ = self->priv->_completed;
	if (!_tmp10_) {
		ICalComponent* _tmp11_;
		ICalTime* _tmp12_;
		ICalTime* _tmp13_;
		_tmp11_ = ical_task;
		_tmp12_ = i_cal_component_get_due (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp9_ = !i_cal_time_is_null_time (_tmp13_);
		_g_object_unref0 (_tmp13_);
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		GDateTime* datetime = NULL;
		ICalComponent* _tmp14_;
		ICalTime* _tmp15_;
		ICalTime* _tmp16_;
		GDateTime* _tmp17_;
		GDateTime* _tmp18_;
		gchar* datetime_label = NULL;
		Utils* _tmp19_;
		GDateTime* _tmp20_;
		gchar* _tmp21_;
		Utils* _tmp22_;
		GDateTime* _tmp23_;
		Utils* _tmp34_;
		GDateTime* _tmp35_;
		GtkLabel* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		_tmp14_ = ical_task;
		_tmp15_ = i_cal_component_get_due (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = cal_dav_util_ical_to_date_time (_tmp16_);
		_tmp18_ = _tmp17_;
		_g_object_unref0 (_tmp16_);
		datetime = _tmp18_;
		_tmp19_ = planner_utils;
		_tmp20_ = datetime;
		_tmp21_ = utils_get_relative_date_from_date (_tmp19_, _tmp20_);
		datetime_label = _tmp21_;
		_tmp22_ = planner_utils;
		_tmp23_ = datetime;
		if (utils_has_time (_tmp22_, _tmp23_)) {
			const gchar* _tmp24_;
			GDateTime* _tmp25_;
			Utils* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			_tmp24_ = datetime_label;
			_tmp25_ = datetime;
			_tmp26_ = planner_utils;
			_tmp27_ = utils_get_default_time_format (_tmp26_);
			_tmp28_ = _tmp27_;
			_tmp29_ = g_date_time_format (_tmp25_, _tmp28_);
			_tmp30_ = _tmp29_;
			_tmp31_ = g_strconcat (" ", _tmp30_, NULL);
			_tmp32_ = _tmp31_;
			_tmp33_ = g_strconcat (_tmp24_, _tmp32_, NULL);
			_g_free0 (datetime_label);
			datetime_label = _tmp33_;
			_g_free0 (_tmp32_);
			_g_free0 (_tmp30_);
			_g_free0 (_tmp28_);
		}
		_tmp34_ = planner_utils;
		_tmp35_ = datetime;
		if (utils_is_today (_tmp34_, _tmp35_)) {
			GtkLabel* _tmp36_;
			GtkStyleContext* _tmp37_;
			_tmp36_ = self->priv->duedate_preview_label;
			_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
			gtk_style_context_add_class (_tmp37_, "today-label-button");
		} else {
			Utils* _tmp38_;
			GDateTime* _tmp39_;
			_tmp38_ = planner_utils;
			_tmp39_ = datetime;
			if (utils_is_overdue (_tmp38_, _tmp39_)) {
				GtkLabel* _tmp40_;
				GtkStyleContext* _tmp41_;
				_tmp40_ = self->priv->duedate_preview_label;
				_tmp41_ = gtk_widget_get_style_context ((GtkWidget*) _tmp40_);
				gtk_style_context_add_class (_tmp41_, "overdue");
			} else {
				GtkLabel* _tmp42_;
				GtkStyleContext* _tmp43_;
				_tmp42_ = self->priv->duedate_preview_label;
				_tmp43_ = gtk_widget_get_style_context ((GtkWidget*) _tmp42_);
				gtk_style_context_add_class (_tmp43_, "upcoming-label-button");
			}
		}
		_tmp44_ = self->priv->duedate_preview_label;
		_tmp45_ = datetime_label;
		_tmp46_ = g_strdup_printf ("<small>%s</small>", _tmp45_);
		_tmp47_ = _tmp46_;
		gtk_label_set_label (_tmp44_, _tmp47_);
		_g_free0 (_tmp47_);
		_g_free0 (datetime_label);
		_g_date_time_unref0 (datetime);
	}
}

static void
widgets_task_row_check_preview_box (WidgetsTaskRow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkRevealer* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->bottom_revealer;
	if (NULL != _tmp1_) {
		GtkRevealer* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = self->priv->bottom_revealer;
		_tmp3_ = gtk_revealer_get_reveal_child (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == FALSE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkRevealer* _tmp5_;
		GtkRevealer* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp5_ = self->priv->preview_revealer;
		_tmp6_ = self->priv->duedate_preview_revealer;
		_tmp7_ = gtk_revealer_get_reveal_child (_tmp6_);
		_tmp8_ = _tmp7_;
		gtk_revealer_set_reveal_child (_tmp5_, _tmp8_);
	}
}

WidgetsTaskRow*
widgets_task_row_construct (GType object_type)
{
	WidgetsTaskRow * self = NULL;
	self = (WidgetsTaskRow*) g_object_new (object_type, NULL);
	return self;
}

WidgetsTaskRow*
widgets_task_row_new (void)
{
	return widgets_task_row_construct (WIDGETS_TYPE_TASK_ROW);
}

ESource*
widgets_task_row_get_source (WidgetsTaskRow* self)
{
	ESource* result;
	ESource* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_source;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
widgets_task_row_set_source (WidgetsTaskRow* self,
                             ESource* value)
{
	ESource* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_task_row_get_source (self);
	if (old_value != value) {
		ESource* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_source);
		self->priv->_source = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_task_row_properties[WIDGETS_TASK_ROW_SOURCE_PROPERTY]);
	}
}

ECalComponent*
widgets_task_row_get_task (WidgetsTaskRow* self)
{
	ECalComponent* result;
	ECalComponent* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_task;
	result = _tmp0_;
	return result;
}

void
widgets_task_row_set_task (WidgetsTaskRow* self,
                           ECalComponent* value)
{
	ECalComponent* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_task_row_get_task (self);
	if (old_value != value) {
		ECalComponent* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_task);
		self->priv->_task = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_task_row_properties[WIDGETS_TASK_ROW_TASK_PROPERTY]);
	}
}

gboolean
widgets_task_row_get_created (WidgetsTaskRow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_created;
	return result;
}

static void
widgets_task_row_set_created (WidgetsTaskRow* self,
                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_task_row_get_created (self);
	if (old_value != value) {
		self->priv->_created = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_task_row_properties[WIDGETS_TASK_ROW_CREATED_PROPERTY]);
	}
}

gboolean
widgets_task_row_get_completed (WidgetsTaskRow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_completed;
	return result;
}

static void
widgets_task_row_set_completed (WidgetsTaskRow* self,
                                gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_task_row_get_completed (self);
	if (old_value != value) {
		self->priv->_completed = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_task_row_properties[WIDGETS_TASK_ROW_COMPLETED_PROPERTY]);
	}
}

gboolean
widgets_task_row_get_reveal_child (WidgetsTaskRow* self)
{
	gboolean result;
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->bottom_revealer;
	_tmp1_ = gtk_revealer_get_reveal_child (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
widgets_task_row_set_reveal_child (WidgetsTaskRow* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (value) {
		widgets_task_row_show_item (self);
	}
	g_object_notify_by_pspec ((GObject *) self, widgets_task_row_properties[WIDGETS_TASK_ROW_REVEAL_CHILD_PROPERTY]);
}

void
widgets_task_row_set_loading (WidgetsTaskRow* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	if (value) {
		GtkStack* _tmp0_;
		_tmp0_ = self->priv->submit_stack;
		gtk_stack_set_visible_child_name (_tmp0_, "spinner");
		gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
	} else {
		GtkStack* _tmp1_;
		_tmp1_ = self->priv->submit_stack;
		gtk_stack_set_visible_child_name (_tmp1_, "label");
		gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
	}
	g_object_notify_by_pspec ((GObject *) self, widgets_task_row_properties[WIDGETS_TASK_ROW_LOADING_PROPERTY]);
}

static gboolean
_widgets_task_row___lambda25_ (WidgetsTaskRow* self)
{
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->main_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, TRUE);
	_tmp1_ = self->priv->_created;
	if (!_tmp1_) {
		widgets_task_row_show_item (self);
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
__widgets_task_row___lambda25__gsource_func (gpointer self)
{
	gboolean result;
	result = _widgets_task_row___lambda25_ ((WidgetsTaskRow*) self);
	return result;
}

static void
_widgets_task_row___lambda26_ (WidgetsTaskRow* self)
{
	widgets_task_row_update_request (self);
}

static void
__widgets_task_row___lambda26__g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
	_widgets_task_row___lambda26_ ((WidgetsTaskRow*) self);
}

static void
_widgets_task_row___lambda27_ (WidgetsTaskRow* self)
{
	widgets_task_row_hide_destroy (self);
}

static void
__widgets_task_row___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	_widgets_task_row___lambda27_ ((WidgetsTaskRow*) self);
}

static gboolean
_widgets_task_row___lambda28_ (WidgetsTaskRow* self,
                               GdkEventKey* key)
{
	gboolean result = FALSE;
	g_return_val_if_fail (key != NULL, FALSE);
	if (key->keyval == ((guint) 65307)) {
		gboolean _tmp0_;
		_tmp0_ = self->priv->_created;
		if (_tmp0_) {
			widgets_task_row_hide_item (self);
		} else {
			widgets_task_row_hide_destroy (self);
		}
	}
	result = FALSE;
	return result;
}

static gboolean
__widgets_task_row___lambda28__gtk_widget_key_release_event (GtkWidget* _sender,
                                                             GdkEventKey* event,
                                                             gpointer self)
{
	gboolean result;
	result = _widgets_task_row___lambda28_ ((WidgetsTaskRow*) self, event);
	return result;
}

static gboolean
__lambda30_ (WidgetsTaskRow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean result = FALSE;
	self->priv->focus_timeout = (guint) 0;
	_tmp2_ = self->priv->_created;
	if (!_tmp2_) {
		_tmp1_ = self->priv->entry_menu_opened == FALSE;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		WidgetsEntry* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp3_ = self->priv->content_entry;
		_tmp4_ = gtk_entry_get_text ((GtkEntry*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = string_strip (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp0_ = g_strcmp0 (_tmp7_, "") == 0;
		_g_free0 (_tmp7_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		widgets_task_row_hide_destroy (self);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda30__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda30_ ((WidgetsTaskRow*) self);
	return result;
}

static gboolean
_widgets_task_row___lambda29_ (WidgetsTaskRow* self)
{
	gboolean result = FALSE;
	self->priv->focus_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda30__gsource_func, g_object_ref (self), g_object_unref);
	result = FALSE;
	return result;
}

static gboolean
__widgets_task_row___lambda29__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                           GdkEventFocus* event,
                                                           gpointer self)
{
	gboolean result;
	result = _widgets_task_row___lambda29_ ((WidgetsTaskRow*) self);
	return result;
}

static gboolean
_widgets_task_row___lambda31_ (WidgetsTaskRow* self)
{
	gboolean result = FALSE;
	if (self->priv->focus_timeout != ((guint) 0)) {
		g_source_remove (self->priv->focus_timeout);
	}
	result = FALSE;
	return result;
}

static gboolean
__widgets_task_row___lambda31__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                          GdkEventFocus* event,
                                                          gpointer self)
{
	gboolean result;
	result = _widgets_task_row___lambda31_ ((WidgetsTaskRow*) self);
	return result;
}

static void
__lambda33_ (WidgetsTaskRow* self)
{
	self->priv->entry_menu_opened = FALSE;
}

static void
___lambda33__gtk_widget_hide (GtkWidget* _sender,
                              gpointer self)
{
	__lambda33_ ((WidgetsTaskRow*) self);
}

static void
_widgets_task_row___lambda32_ (WidgetsTaskRow* self,
                               GtkMenu* menu)
{
	g_return_if_fail (menu != NULL);
	self->priv->entry_menu_opened = TRUE;
	g_signal_connect_object ((GtkWidget*) menu, "hide", (GCallback) ___lambda33__gtk_widget_hide, self, 0);
}

static void
__widgets_task_row___lambda32__gtk_entry_populate_popup (GtkEntry* _sender,
                                                         GtkMenu* popup,
                                                         gpointer self)
{
	_widgets_task_row___lambda32_ ((WidgetsTaskRow*) self, popup);
}

static void
_widgets_task_row___lambda34_ (WidgetsTaskRow* self)
{
	gboolean _tmp0_;
	_tmp0_ = self->priv->_created;
	if (_tmp0_) {
		widgets_task_row_hide_item (self);
	} else {
		widgets_task_row_add_task (self);
	}
}

static void
__widgets_task_row___lambda34__gtk_entry_activate (GtkEntry* _sender,
                                                   gpointer self)
{
	_widgets_task_row___lambda34_ ((WidgetsTaskRow*) self);
}

static void
_widgets_task_row___lambda35_ (WidgetsTaskRow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp9_;
	_tmp1_ = self->priv->_created;
	if (!_tmp1_) {
		WidgetsEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp2_ = self->priv->content_entry;
		_tmp3_ = gtk_entry_get_text ((GtkEntry*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = string_strip (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = g_strcmp0 (_tmp6_, "") != 0;
		_g_free0 (_tmp6_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkButton* _tmp7_;
		_tmp7_ = self->priv->submit_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
	} else {
		GtkButton* _tmp8_;
		_tmp8_ = self->priv->submit_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
	}
	_tmp9_ = self->priv->_created;
	if (_tmp9_) {
		widgets_task_row_save_timeout (self);
	}
}

static void
__widgets_task_row___lambda35__gtk_editable_changed (GtkEditable* _sender,
                                                     gpointer self)
{
	_widgets_task_row___lambda35_ ((WidgetsTaskRow*) self);
}

static void
_widgets_task_row___lambda36_ (WidgetsTaskRow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = widgets_task_row_get_reveal_child (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == FALSE) {
		widgets_task_row_show_item (self);
	} else {
		widgets_task_row_hide_item (self);
	}
}

static void
__widgets_task_row___lambda36__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	_widgets_task_row___lambda36_ ((WidgetsTaskRow*) self);
}

static gboolean
_widgets_task_row___lambda37_ (WidgetsTaskRow* self,
                               GtkWidget* sender,
                               GdkEventButton* evt)
{
	GdkEventType _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (sender != NULL, FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp0_ = evt->type;
	if (_tmp0_ == GDK_BUTTON_PRESS) {
		GtkStack* _tmp1_;
		WidgetsTextView* _tmp2_;
		_tmp1_ = self->priv->note_stack;
		gtk_stack_set_visible_child_name (_tmp1_, "textview");
		_tmp2_ = self->priv->note_textview;
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
__widgets_task_row___lambda37__gtk_widget_button_press_event (GtkWidget* _sender,
                                                              GdkEventButton* event,
                                                              gpointer self)
{
	gboolean result;
	result = _widgets_task_row___lambda37_ ((WidgetsTaskRow*) self, _sender, event);
	return result;
}

static gboolean
_widgets_task_row___lambda38_ (WidgetsTaskRow* self)
{
	GtkStack* _tmp0_;
	WidgetsTextView* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->note_stack;
	gtk_stack_set_visible_child_name (_tmp0_, "label");
	_tmp1_ = self->priv->note_textview;
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp1_);
	_tmp3_ = _tmp2_;
	g_object_get (_tmp3_, "text", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	widgets_task_row_update_note_label (self, _tmp6_);
	_g_free0 (_tmp6_);
	widgets_task_row_save_timeout (self);
	result = FALSE;
	return result;
}

static gboolean
__widgets_task_row___lambda38__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                           GdkEventFocus* event,
                                                           gpointer self)
{
	gboolean result;
	result = _widgets_task_row___lambda38_ ((WidgetsTaskRow*) self);
	return result;
}

static gboolean
_widgets_task_row___lambda39_ (WidgetsTaskRow* self)
{
	gboolean result = FALSE;
	if (self->priv->focus_timeout != ((guint) 0)) {
		g_source_remove (self->priv->focus_timeout);
	}
	result = FALSE;
	return result;
}

static gboolean
__widgets_task_row___lambda39__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                          GdkEventFocus* event,
                                                          gpointer self)
{
	gboolean result;
	result = _widgets_task_row___lambda39_ ((WidgetsTaskRow*) self);
	return result;
}

static void
_widgets_task_row___lambda40_ (WidgetsTaskRow* self)
{
	gboolean _tmp0_ = FALSE;
	ECalComponent* _tmp1_;
	GtkRevealer* _tmp3_;
	ServicesTasksStore* _tmp4_;
	ESource* _tmp5_;
	ECalComponent* _tmp6_;
	_tmp1_ = self->priv->_task;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = self->priv->_created;
		_tmp0_ = _tmp2_ == FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp3_ = self->priv->main_revealer;
	gtk_revealer_set_reveal_child (_tmp3_, FALSE);
	_tmp4_ = self->priv->task_store;
	_tmp5_ = self->priv->_source;
	_tmp6_ = self->priv->_task;
	services_tasks_store_complete_task (_tmp4_, _tmp5_, _tmp6_);
}

static void
__widgets_task_row___lambda40__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                          gpointer self)
{
	_widgets_task_row___lambda40_ ((WidgetsTaskRow*) self);
}

static gboolean
_widgets_task_row___lambda41_ (WidgetsTaskRow* self,
                               GtkWidget* sender,
                               GdkEventButton* evt)
{
	gboolean _tmp0_ = FALSE;
	GdkEventType _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (sender != NULL, FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp1_ = evt->type;
	if (_tmp1_ == GDK_BUTTON_PRESS) {
		_tmp0_ = evt->button == ((guint) 3);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkRevealer* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = self->priv->bottom_revealer;
		_tmp3_ = gtk_revealer_get_reveal_child (_tmp2_);
		_tmp4_ = _tmp3_;
		if (_tmp4_ == FALSE) {
			widgets_task_row_activate_menu (self, TRUE);
		}
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
__widgets_task_row___lambda41__gtk_widget_button_press_event (GtkWidget* _sender,
                                                              GdkEventButton* event,
                                                              gpointer self)
{
	gboolean result;
	result = _widgets_task_row___lambda41_ ((WidgetsTaskRow*) self, _sender, event);
	return result;
}

static void
_widgets_task_row___lambda42_ (WidgetsTaskRow* self)
{
	widgets_task_row_activate_menu (self, FALSE);
}

static void
__widgets_task_row___lambda42__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	_widgets_task_row___lambda42_ ((WidgetsTaskRow*) self);
}

static void
_widgets_task_row_add_task_gtk_button_clicked (GtkButton* _sender,
                                               gpointer self)
{
	widgets_task_row_add_task ((WidgetsTaskRow*) self);
}

static void
_widgets_task_row___lambda43_ (WidgetsTaskRow* self,
                               gboolean active)
{
	gboolean _tmp11_;
	self->priv->entry_menu_opened = active;
	if (active == FALSE) {
		WidgetsEntry* _tmp0_;
		WidgetsEntry* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		WidgetsEntry* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
		_tmp0_ = self->priv->content_entry;
		gtk_entry_grab_focus_without_selecting ((GtkEntry*) _tmp0_);
		_tmp1_ = self->priv->content_entry;
		g_object_get ((GtkEntry*) _tmp1_, "cursor-position", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = self->priv->content_entry;
		_tmp5_ = gtk_entry_get_text_length ((GtkEntry*) _tmp4_);
		_tmp6_ = _tmp5_;
		if (((guint) _tmp3_) < _tmp6_) {
			WidgetsEntry* _tmp7_;
			WidgetsEntry* _tmp8_;
			guint _tmp9_;
			guint _tmp10_;
			_tmp7_ = self->priv->content_entry;
			_tmp8_ = self->priv->content_entry;
			_tmp9_ = gtk_entry_get_text_length ((GtkEntry*) _tmp8_);
			_tmp10_ = _tmp9_;
			g_signal_emit_by_name ((GtkEntry*) _tmp7_, "move-cursor", GTK_MOVEMENT_BUFFER_ENDS, (gint) ((gint32) _tmp10_), FALSE);
		}
	}
	_tmp11_ = self->priv->_created;
	if (_tmp11_) {
		ECalComponent* _tmp12_;
		_tmp12_ = self->priv->_task;
		widgets_task_row_save_task (self, _tmp12_);
	}
}

static void
__widgets_task_row___lambda43__widgets_schedule_button_popover_opened (WidgetsScheduleButton* _sender,
                                                                       gboolean active,
                                                                       gpointer self)
{
	_widgets_task_row___lambda43_ ((WidgetsTaskRow*) self, active);
}

static GObject *
widgets_task_row_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsTaskRow * self;
	ServicesTasksStore* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkButton* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkButton* _tmp11_;
	gboolean _tmp12_;
	GtkButton* _tmp13_;
	gboolean _tmp14_;
	GtkRevealer* _tmp15_;
	GtkRevealer* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkRevealer* _tmp18_;
	GtkButton* _tmp19_;
	GtkCheckButton* _tmp20_;
	GtkCheckButton* _tmp21_;
	GtkCheckButton* _tmp22_;
	GtkCheckButton* _tmp23_;
	GtkCheckButton* _tmp24_;
	GtkCheckButton* _tmp25_;
	GtkCheckButton* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkRevealer* _tmp35_;
	GtkRevealer* _tmp36_;
	GtkRevealer* _tmp37_;
	GtkRevealer* _tmp38_;
	GtkRevealer* _tmp39_;
	GtkLabel* _tmp40_;
	GtkRevealer* _tmp41_;
	WidgetsEntry* _tmp42_;
	WidgetsEntry* _tmp43_;
	WidgetsEntry* _tmp44_;
	WidgetsEntry* _tmp45_;
	GtkStyleContext* _tmp46_;
	WidgetsEntry* _tmp47_;
	GtkStyleContext* _tmp48_;
	WidgetsEntry* _tmp49_;
	GtkStyleContext* _tmp50_;
	WidgetsEntry* _tmp51_;
	GtkStyleContext* _tmp52_;
	WidgetsEntry* _tmp53_;
	WidgetsEntry* _tmp54_;
	WidgetsEntry* _tmp55_;
	ECalComponent* _tmp56_;
	ICalComponent* _tmp57_;
	GtkRevealer* _tmp58_;
	GtkRevealer* _tmp59_;
	GtkRevealer* _tmp60_;
	GtkRevealer* _tmp61_;
	GtkRevealer* _tmp62_;
	WidgetsEntry* _tmp63_;
	GtkBox* content_box = NULL;
	GtkBox* _tmp64_;
	GtkBox* _tmp65_;
	GtkBox* _tmp66_;
	GtkRevealer* _tmp67_;
	GtkBox* _tmp68_;
	GtkRevealer* _tmp69_;
	GtkBox* _tmp70_;
	GtkBox* _tmp71_;
	GtkCheckButton* _tmp72_;
	GtkBox* _tmp73_;
	GtkBox* _tmp74_;
	GtkBox* _tmp75_;
	GtkRevealer* _tmp76_;
	WidgetsTextView* _tmp77_;
	WidgetsTextView* _tmp78_;
	WidgetsTextView* _tmp79_;
	WidgetsTextView* _tmp80_;
	WidgetsTextView* _tmp81_;
	WidgetsTextView* _tmp82_;
	GtkStyleContext* _tmp83_;
	GtkLabel* _tmp84_;
	GtkLabel* _tmp85_;
	GtkLabel* _tmp86_;
	GtkLabel* _tmp87_;
	GtkLabel* _tmp88_;
	GtkLabel* _tmp89_;
	GtkLabel* _tmp90_;
	GtkLabel* _tmp91_;
	GtkLabel* _tmp92_;
	GtkEventBox* note_eventbox = NULL;
	GtkEventBox* _tmp93_;
	GtkEventBox* _tmp94_;
	GtkEventBox* _tmp95_;
	GtkLabel* _tmp96_;
	GtkEventBox* _tmp97_;
	ECalComponent* _tmp98_;
	ICalComponent* _tmp99_;
	GtkStack* _tmp100_;
	GtkStack* _tmp101_;
	GtkStack* _tmp102_;
	GtkStack* _tmp103_;
	GtkStack* _tmp104_;
	GtkStack* _tmp105_;
	GtkStack* _tmp106_;
	GtkStack* _tmp107_;
	GtkEventBox* _tmp108_;
	GtkStack* _tmp109_;
	WidgetsTextView* _tmp110_;
	GtkImage* _tmp111_;
	GtkImage* _tmp112_;
	GThemedIcon* _tmp113_;
	GThemedIcon* _tmp114_;
	GtkImage* _tmp115_;
	GtkButton* menu_button = NULL;
	GtkButton* _tmp116_;
	GtkButton* _tmp117_;
	GtkImage* _tmp118_;
	GtkButton* _tmp119_;
	GtkButton* _tmp120_;
	GtkButton* _tmp121_;
	gboolean _tmp122_;
	GtkButton* _tmp123_;
	gboolean _tmp124_;
	GtkButton* _tmp125_;
	GtkButton* _tmp126_;
	GtkStyleContext* _tmp127_;
	GtkButton* _tmp128_;
	GtkStyleContext* _tmp129_;
	WidgetsScheduleButton* _tmp130_;
	GtkBox* action_box = NULL;
	GtkBox* _tmp131_;
	GtkBox* _tmp132_;
	GtkBox* _tmp133_;
	GtkBox* _tmp134_;
	GtkBox* _tmp135_;
	GtkBox* _tmp136_;
	ECalComponent* _tmp137_;
	ICalComponent* _tmp138_;
	GtkBox* _tmp139_;
	WidgetsScheduleButton* _tmp140_;
	GtkBox* _tmp141_;
	GtkButton* _tmp142_;
	GtkBox* bottom_box = NULL;
	GtkBox* _tmp143_;
	GtkBox* _tmp144_;
	GtkStack* _tmp145_;
	GtkBox* _tmp146_;
	GtkBox* _tmp147_;
	GtkRevealer* _tmp148_;
	GtkRevealer* _tmp149_;
	GtkRevealer* _tmp150_;
	GtkRevealer* _tmp151_;
	GtkBox* _tmp152_;
	GtkLabel* _tmp153_;
	GtkLabel* _tmp154_;
	GtkLabel* _tmp155_;
	GtkRevealer* _tmp156_;
	GtkRevealer* _tmp157_;
	GtkRevealer* _tmp158_;
	GtkLabel* _tmp159_;
	GtkBox* _tmp160_;
	GtkBox* _tmp161_;
	GtkBox* _tmp162_;
	GtkBox* _tmp163_;
	GtkBox* _tmp164_;
	GtkRevealer* _tmp165_;
	GtkRevealer* _tmp166_;
	GtkRevealer* _tmp167_;
	GtkRevealer* _tmp168_;
	GtkRevealer* _tmp169_;
	GtkRevealer* _tmp170_;
	GtkBox* _tmp171_;
	GtkGrid* _tmp172_;
	GtkGrid* _tmp173_;
	GtkGrid* _tmp174_;
	GtkGrid* _tmp175_;
	GtkStyleContext* _tmp176_;
	GtkGrid* _tmp177_;
	GtkGrid* _tmp178_;
	GtkBox* _tmp179_;
	GtkGrid* _tmp180_;
	GtkRevealer* _tmp181_;
	GtkGrid* _tmp182_;
	GtkRevealer* _tmp183_;
	GtkButton* _tmp184_;
	GtkButton* _tmp185_;
	GtkButton* _tmp186_;
	GtkStyleContext* _tmp187_;
	GtkSpinner* submit_spinner = NULL;
	GtkSpinner* _tmp188_;
	GtkSpinner* _tmp189_;
	GtkStack* _tmp190_;
	GtkStack* _tmp191_;
	GtkStack* _tmp192_;
	GtkStack* _tmp193_;
	GtkLabel* _tmp194_;
	GtkLabel* _tmp195_;
	GtkStack* _tmp196_;
	GtkSpinner* _tmp197_;
	GtkButton* _tmp198_;
	GtkStack* _tmp199_;
	GtkButton* _tmp200_;
	GtkButton* _tmp201_;
	GtkStyleContext* _tmp202_;
	GtkGrid* action_grid = NULL;
	GtkGrid* _tmp203_;
	GtkGrid* _tmp204_;
	GtkGrid* _tmp205_;
	GtkGrid* _tmp206_;
	GtkGrid* _tmp207_;
	GtkGrid* _tmp208_;
	GtkButton* _tmp209_;
	GtkGrid* _tmp210_;
	GtkButton* _tmp211_;
	GtkGrid* _tmp212_;
	gboolean _tmp213_;
	GtkGrid* _tmp214_;
	gboolean _tmp215_;
	GtkGrid* _tmp216_;
	GtkGrid* _tmp217_;
	GtkGrid* _tmp218_;
	GtkGrid* _tmp219_;
	GtkGrid* _tmp220_;
	GtkGrid* _tmp221_;
	GtkGrid* _tmp222_;
	GtkGrid* _tmp223_;
	GtkGrid* _tmp224_;
	GtkEventBox* handle = NULL;
	GtkEventBox* _tmp225_;
	GtkEventBox* _tmp226_;
	GtkEventBox* _tmp227_;
	GtkEventBox* _tmp228_;
	GtkEventBox* _tmp229_;
	GtkGrid* _tmp230_;
	GtkRevealer* _tmp231_;
	GtkRevealer* _tmp232_;
	GtkRevealer* _tmp233_;
	GtkRevealer* _tmp234_;
	GtkEventBox* _tmp235_;
	GtkRevealer* _tmp236_;
	GtkRevealer* _tmp237_;
	guint _tmp238_;
	guint _tmp239_;
	GtkButton* _tmp240_;
	WidgetsEntry* _tmp241_;
	WidgetsEntry* _tmp242_;
	WidgetsEntry* _tmp243_;
	WidgetsEntry* _tmp244_;
	WidgetsEntry* _tmp245_;
	WidgetsEntry* _tmp246_;
	GtkButton* _tmp247_;
	GtkEventBox* _tmp248_;
	WidgetsTextView* _tmp249_;
	WidgetsTextView* _tmp250_;
	GtkCheckButton* _tmp251_;
	GtkButton* _tmp252_;
	GtkButton* _tmp253_;
	WidgetsScheduleButton* _tmp254_;
	parent_class = G_OBJECT_CLASS (widgets_task_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_TASK_ROW, WidgetsTaskRow);
	_tmp0_ = services_tasks_store_get_default ();
	_g_object_unref0 (self->priv->task_store);
	self->priv->task_store = _tmp0_;
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp1_, "item-row");
	_tmp2_ = (GtkButton*) gtk_button_new_from_icon_name ("view-restore-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->hidden_button);
	self->priv->hidden_button = _tmp2_;
	_tmp3_ = self->priv->hidden_button;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp3_, FALSE);
	_tmp4_ = self->priv->hidden_button;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp4_, 1);
	_tmp5_ = self->priv->hidden_button;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp5_, 3);
	_tmp6_ = self->priv->hidden_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _ ("Hide Details"));
	_tmp7_ = self->priv->hidden_button;
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
	gtk_style_context_add_class (_tmp8_, GTK_STYLE_CLASS_FLAT);
	_tmp9_ = self->priv->hidden_button;
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
	gtk_style_context_add_class (_tmp10_, "hidden-button");
	_tmp11_ = self->priv->hidden_button;
	_tmp12_ = self->priv->_created;
	gtk_widget_set_visible ((GtkWidget*) _tmp11_, _tmp12_);
	_tmp13_ = self->priv->hidden_button;
	_tmp14_ = self->priv->_created;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp13_, !_tmp14_);
	_tmp15_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->hidden_revealer);
	self->priv->hidden_revealer = _tmp15_;
	_tmp16_ = self->priv->hidden_revealer;
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
	_tmp17_ = self->priv->hidden_revealer;
	gtk_revealer_set_transition_type (_tmp17_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
	_tmp18_ = self->priv->hidden_revealer;
	_tmp19_ = self->priv->hidden_button;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = (GtkCheckButton*) gtk_check_button_new ();
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->checked_button);
	self->priv->checked_button = _tmp20_;
	_tmp21_ = self->priv->checked_button;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp21_, FALSE);
	_tmp22_ = self->priv->checked_button;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp22_, 6);
	_tmp23_ = self->priv->checked_button;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp23_, 6);
	_tmp24_ = self->priv->checked_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp24_, GTK_ALIGN_START);
	_tmp25_ = self->priv->checked_button;
	gtk_widget_set_halign ((GtkWidget*) _tmp25_, GTK_ALIGN_BASELINE);
	_tmp26_ = self->priv->checked_button;
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
	gtk_style_context_add_class (_tmp27_, "priority-1");
	_tmp28_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->content_label);
	self->priv->content_label = _tmp28_;
	_tmp29_ = self->priv->content_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp29_, TRUE);
	_tmp30_ = self->priv->content_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp30_, GTK_ALIGN_START);
	_tmp31_ = self->priv->content_label;
	gtk_label_set_xalign (_tmp31_, (gfloat) 0);
	_tmp32_ = self->priv->content_label;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp32_, 5);
	_tmp33_ = self->priv->content_label;
	g_object_set (_tmp33_, "wrap", TRUE, NULL);
	_tmp34_ = self->priv->content_label;
	gtk_label_set_use_markup (_tmp34_, TRUE);
	_tmp35_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (self->priv->label_revealer);
	self->priv->label_revealer = _tmp35_;
	_tmp36_ = self->priv->label_revealer;
	gtk_widget_set_valign ((GtkWidget*) _tmp36_, GTK_ALIGN_START);
	_tmp37_ = self->priv->label_revealer;
	gtk_revealer_set_transition_type (_tmp37_, GTK_REVEALER_TRANSITION_TYPE_NONE);
	_tmp38_ = self->priv->label_revealer;
	gtk_revealer_set_transition_duration (_tmp38_, (guint) 125);
	_tmp39_ = self->priv->label_revealer;
	_tmp40_ = self->priv->content_label;
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
	_tmp41_ = self->priv->label_revealer;
	gtk_revealer_set_reveal_child (_tmp41_, TRUE);
	_tmp42_ = widgets_entry_new ();
	g_object_ref_sink (_tmp42_);
	_g_object_unref0 (self->priv->content_entry);
	self->priv->content_entry = _tmp42_;
	_tmp43_ = self->priv->content_entry;
	gtk_widget_set_valign ((GtkWidget*) _tmp43_, GTK_ALIGN_START);
	_tmp44_ = self->priv->content_entry;
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp44_, _ ("Task name"));
	_tmp45_ = self->priv->content_entry;
	_tmp46_ = gtk_widget_get_style_context ((GtkWidget*) _tmp45_);
	gtk_style_context_add_class (_tmp46_, "flat");
	_tmp47_ = self->priv->content_entry;
	_tmp48_ = gtk_widget_get_style_context ((GtkWidget*) _tmp47_);
	gtk_style_context_add_class (_tmp48_, "content-entry");
	_tmp49_ = self->priv->content_entry;
	_tmp50_ = gtk_widget_get_style_context ((GtkWidget*) _tmp49_);
	gtk_style_context_add_class (_tmp50_, "font-bold");
	_tmp51_ = self->priv->content_entry;
	_tmp52_ = gtk_widget_get_style_context ((GtkWidget*) _tmp51_);
	gtk_style_context_add_class (_tmp52_, "no-padding-left");
	_tmp53_ = self->priv->content_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp53_, TRUE);
	_tmp54_ = self->priv->content_entry;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp54_, 2);
	_tmp55_ = self->priv->content_entry;
	_tmp56_ = self->priv->_task;
	_tmp57_ = e_cal_component_get_icalcomponent (_tmp56_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp55_, i_cal_component_get_status (_tmp57_) != I_CAL_STATUS_COMPLETED);
	_tmp58_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp58_);
	_g_object_unref0 (self->priv->entry_revealer);
	self->priv->entry_revealer = _tmp58_;
	_tmp59_ = self->priv->entry_revealer;
	gtk_widget_set_valign ((GtkWidget*) _tmp59_, GTK_ALIGN_START);
	_tmp60_ = self->priv->entry_revealer;
	gtk_revealer_set_transition_type (_tmp60_, GTK_REVEALER_TRANSITION_TYPE_NONE);
	_tmp61_ = self->priv->entry_revealer;
	gtk_revealer_set_transition_duration (_tmp61_, (guint) 125);
	_tmp62_ = self->priv->entry_revealer;
	_tmp63_ = self->priv->content_entry;
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
	_tmp64_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp64_);
	content_box = _tmp64_;
	_tmp65_ = content_box;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp65_, TRUE);
	_tmp66_ = content_box;
	_tmp67_ = self->priv->entry_revealer;
	gtk_container_add ((GtkContainer*) _tmp66_, (GtkWidget*) _tmp67_);
	_tmp68_ = content_box;
	_tmp69_ = self->priv->label_revealer;
	gtk_container_add ((GtkContainer*) _tmp68_, (GtkWidget*) _tmp69_);
	_tmp70_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp70_);
	_g_object_unref0 (self->priv->top_box);
	self->priv->top_box = _tmp70_;
	_tmp71_ = self->priv->top_box;
	_tmp72_ = self->priv->checked_button;
	gtk_box_pack_start (_tmp71_, (GtkWidget*) _tmp72_, FALSE, FALSE, (guint) 0);
	_tmp73_ = self->priv->top_box;
	_tmp74_ = content_box;
	gtk_box_pack_start (_tmp73_, (GtkWidget*) _tmp74_, FALSE, TRUE, (guint) 8);
	_tmp75_ = self->priv->top_box;
	_tmp76_ = self->priv->hidden_revealer;
	gtk_box_pack_end (_tmp75_, (GtkWidget*) _tmp76_, FALSE, FALSE, (guint) 0);
	_tmp77_ = widgets_text_view_new ();
	g_object_ref_sink (_tmp77_);
	_g_object_unref0 (self->priv->note_textview);
	self->priv->note_textview = _tmp77_;
	_tmp78_ = self->priv->note_textview;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp78_, TRUE);
	_tmp79_ = self->priv->note_textview;
	gtk_widget_set_valign ((GtkWidget*) _tmp79_, GTK_ALIGN_START);
	_tmp80_ = self->priv->note_textview;
	gtk_text_view_set_wrap_mode ((GtkTextView*) _tmp80_, GTK_WRAP_CHAR);
	_tmp81_ = self->priv->note_textview;
	g_object_set ((GtkWidget*) _tmp81_, "height-request", 42, NULL);
	_tmp82_ = self->priv->note_textview;
	_tmp83_ = gtk_widget_get_style_context ((GtkWidget*) _tmp82_);
	gtk_style_context_add_class (_tmp83_, "textview");
	_tmp84_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp84_);
	_g_object_unref0 (self->priv->note_label);
	self->priv->note_label = _tmp84_;
	_tmp85_ = self->priv->note_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp85_, GTK_ALIGN_START);
	_tmp86_ = self->priv->note_label;
	g_object_set ((GtkWidget*) _tmp86_, "height-request", 42, NULL);
	_tmp87_ = self->priv->note_label;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp87_, 3);
	_tmp88_ = self->priv->note_label;
	g_object_set (_tmp88_, "wrap", TRUE, NULL);
	_tmp89_ = self->priv->note_label;
	g_object_set (_tmp89_, "wrap-mode", PANGO_WRAP_CHAR, NULL);
	_tmp90_ = self->priv->note_label;
	gtk_label_set_xalign (_tmp90_, (gfloat) 0);
	_tmp91_ = self->priv->note_label;
	gtk_label_set_yalign (_tmp91_, (gfloat) 0);
	_tmp92_ = self->priv->note_label;
	gtk_label_set_use_markup (_tmp92_, TRUE);
	_tmp93_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp93_);
	note_eventbox = _tmp93_;
	_tmp94_ = note_eventbox;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp94_, TRUE);
	_tmp95_ = note_eventbox;
	_tmp96_ = self->priv->note_label;
	gtk_container_add ((GtkContainer*) _tmp95_, (GtkWidget*) _tmp96_);
	_tmp97_ = note_eventbox;
	_tmp98_ = self->priv->_task;
	_tmp99_ = e_cal_component_get_icalcomponent (_tmp98_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp97_, i_cal_component_get_status (_tmp99_) != I_CAL_STATUS_COMPLETED);
	_tmp100_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp100_);
	_g_object_unref0 (self->priv->note_stack);
	self->priv->note_stack = _tmp100_;
	_tmp101_ = self->priv->note_stack;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp101_, TRUE);
	_tmp102_ = self->priv->note_stack;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp102_, 28);
	_tmp103_ = self->priv->note_stack;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp103_, 12);
	_tmp104_ = self->priv->note_stack;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp104_, 3);
	_tmp105_ = self->priv->note_stack;
	gtk_stack_set_transition_type (_tmp105_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	_tmp106_ = self->priv->note_stack;
	gtk_stack_set_vhomogeneous (_tmp106_, FALSE);
	_tmp107_ = self->priv->note_stack;
	_tmp108_ = note_eventbox;
	gtk_stack_add_named (_tmp107_, (GtkWidget*) _tmp108_, "label");
	_tmp109_ = self->priv->note_stack;
	_tmp110_ = self->priv->note_textview;
	gtk_stack_add_named (_tmp109_, (GtkWidget*) _tmp110_, "textview");
	_tmp111_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp111_);
	_g_object_unref0 (self->priv->menu_image);
	self->priv->menu_image = _tmp111_;
	_tmp112_ = self->priv->menu_image;
	_tmp113_ = (GThemedIcon*) g_themed_icon_new ("view-more-symbolic");
	_tmp114_ = _tmp113_;
	g_object_set (_tmp112_, "gicon", (GIcon*) _tmp114_, NULL);
	_g_object_unref0 (_tmp114_);
	_tmp115_ = self->priv->menu_image;
	gtk_image_set_pixel_size (_tmp115_, 16);
	_tmp116_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp116_);
	menu_button = _tmp116_;
	_tmp117_ = menu_button;
	_tmp118_ = self->priv->menu_image;
	gtk_button_set_image (_tmp117_, (GtkWidget*) _tmp118_);
	_tmp119_ = menu_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp119_, GTK_ALIGN_CENTER);
	_tmp120_ = menu_button;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp120_, FALSE);
	_tmp121_ = menu_button;
	_tmp122_ = self->priv->_created;
	gtk_widget_set_visible ((GtkWidget*) _tmp121_, _tmp122_);
	_tmp123_ = menu_button;
	_tmp124_ = self->priv->_created;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp123_, !_tmp124_);
	_tmp125_ = menu_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp125_, _ ("Task Menu"));
	_tmp126_ = menu_button;
	_tmp127_ = gtk_widget_get_style_context ((GtkWidget*) _tmp126_);
	gtk_style_context_add_class (_tmp127_, "item-action-button");
	_tmp128_ = menu_button;
	_tmp129_ = gtk_widget_get_style_context ((GtkWidget*) _tmp128_);
	gtk_style_context_add_class (_tmp129_, GTK_STYLE_CLASS_FLAT);
	_tmp130_ = widgets_schedule_button_new_new_item ();
	g_object_ref_sink (_tmp130_);
	_g_object_unref0 (self->priv->reschedule_button);
	self->priv->reschedule_button = _tmp130_;
	_tmp131_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp131_);
	action_box = _tmp131_;
	_tmp132_ = action_box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp132_, 3);
	_tmp133_ = action_box;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp133_, 20);
	_tmp134_ = action_box;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp134_, 6);
	_tmp135_ = action_box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp135_, 3);
	_tmp136_ = action_box;
	_tmp137_ = self->priv->_task;
	_tmp138_ = e_cal_component_get_icalcomponent (_tmp137_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp136_, i_cal_component_get_status (_tmp138_) != I_CAL_STATUS_COMPLETED);
	_tmp139_ = action_box;
	_tmp140_ = self->priv->reschedule_button;
	gtk_box_pack_start (_tmp139_, (GtkWidget*) _tmp140_, FALSE, TRUE, (guint) 0);
	_tmp141_ = action_box;
	_tmp142_ = menu_button;
	gtk_box_pack_end (_tmp141_, (GtkWidget*) _tmp142_, FALSE, FALSE, (guint) 0);
	_tmp143_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp143_);
	bottom_box = _tmp143_;
	_tmp144_ = bottom_box;
	_tmp145_ = self->priv->note_stack;
	gtk_box_pack_start (_tmp144_, (GtkWidget*) _tmp145_, FALSE, TRUE, (guint) 0);
	_tmp146_ = bottom_box;
	_tmp147_ = action_box;
	gtk_box_pack_end (_tmp146_, (GtkWidget*) _tmp147_, FALSE, TRUE, (guint) 0);
	_tmp148_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp148_);
	_g_object_unref0 (self->priv->bottom_revealer);
	self->priv->bottom_revealer = _tmp148_;
	_tmp149_ = self->priv->bottom_revealer;
	gtk_widget_set_valign ((GtkWidget*) _tmp149_, GTK_ALIGN_START);
	_tmp150_ = self->priv->bottom_revealer;
	gtk_revealer_set_transition_type (_tmp150_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp151_ = self->priv->bottom_revealer;
	_tmp152_ = bottom_box;
	gtk_container_add ((GtkContainer*) _tmp151_, (GtkWidget*) _tmp152_);
	_tmp153_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp153_);
	_g_object_unref0 (self->priv->duedate_preview_label);
	self->priv->duedate_preview_label = _tmp153_;
	_tmp154_ = self->priv->duedate_preview_label;
	gtk_label_set_use_markup (_tmp154_, TRUE);
	_tmp155_ = self->priv->duedate_preview_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp155_, GTK_ALIGN_CENTER);
	_tmp156_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp156_);
	_g_object_unref0 (self->priv->duedate_preview_revealer);
	self->priv->duedate_preview_revealer = _tmp156_;
	_tmp157_ = self->priv->duedate_preview_revealer;
	gtk_revealer_set_transition_type (_tmp157_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
	_tmp158_ = self->priv->duedate_preview_revealer;
	_tmp159_ = self->priv->duedate_preview_label;
	gtk_container_add ((GtkContainer*) _tmp158_, (GtkWidget*) _tmp159_);
	_tmp160_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp160_);
	_g_object_unref0 (self->priv->preview_box);
	self->priv->preview_box = _tmp160_;
	_tmp161_ = self->priv->preview_box;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp161_, 28);
	_tmp162_ = self->priv->preview_box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp162_, 9);
	_tmp163_ = self->priv->preview_box;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp163_, TRUE);
	_tmp164_ = self->priv->preview_box;
	_tmp165_ = self->priv->duedate_preview_revealer;
	gtk_box_pack_start (_tmp164_, (GtkWidget*) _tmp165_, FALSE, FALSE, (guint) 0);
	_tmp166_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp166_);
	_g_object_unref0 (self->priv->preview_revealer);
	self->priv->preview_revealer = _tmp166_;
	_tmp167_ = self->priv->preview_revealer;
	gtk_revealer_set_transition_type (_tmp167_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP);
	_tmp168_ = self->priv->preview_revealer;
	gtk_revealer_set_transition_duration (_tmp168_, (guint) 150);
	_tmp169_ = self->priv->preview_revealer;
	gtk_revealer_set_reveal_child (_tmp169_, FALSE);
	_tmp170_ = self->priv->preview_revealer;
	_tmp171_ = self->priv->preview_box;
	gtk_container_add ((GtkContainer*) _tmp170_, (GtkWidget*) _tmp171_);
	_tmp172_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp172_);
	_g_object_unref0 (self->priv->main_grid);
	self->priv->main_grid = _tmp172_;
	_tmp173_ = self->priv->main_grid;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp173_, TRUE);
	_tmp174_ = self->priv->main_grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp174_, GTK_ORIENTATION_VERTICAL);
	_tmp175_ = self->priv->main_grid;
	_tmp176_ = gtk_widget_get_style_context ((GtkWidget*) _tmp175_);
	gtk_style_context_add_class (_tmp176_, "transition");
	_tmp177_ = self->priv->main_grid;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp177_, 3);
	_tmp178_ = self->priv->main_grid;
	_tmp179_ = self->priv->top_box;
	gtk_container_add ((GtkContainer*) _tmp178_, (GtkWidget*) _tmp179_);
	_tmp180_ = self->priv->main_grid;
	_tmp181_ = self->priv->preview_revealer;
	gtk_container_add ((GtkContainer*) _tmp180_, (GtkWidget*) _tmp181_);
	_tmp182_ = self->priv->main_grid;
	_tmp183_ = self->priv->bottom_revealer;
	gtk_container_add ((GtkContainer*) _tmp182_, (GtkWidget*) _tmp183_);
	_tmp184_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp184_);
	_g_object_unref0 (self->priv->submit_button);
	self->priv->submit_button = _tmp184_;
	_tmp185_ = self->priv->submit_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp185_, FALSE);
	_tmp186_ = self->priv->submit_button;
	_tmp187_ = gtk_widget_get_style_context ((GtkWidget*) _tmp186_);
	gtk_style_context_add_class (_tmp187_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp188_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp188_);
	submit_spinner = _tmp188_;
	_tmp189_ = submit_spinner;
	gtk_spinner_start (_tmp189_);
	_tmp190_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp190_);
	_g_object_unref0 (self->priv->submit_stack);
	self->priv->submit_stack = _tmp190_;
	_tmp191_ = self->priv->submit_stack;
	g_object_set ((GtkWidget*) _tmp191_, "expand", TRUE, NULL);
	_tmp192_ = self->priv->submit_stack;
	gtk_stack_set_transition_type (_tmp192_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	_tmp193_ = self->priv->submit_stack;
	_tmp194_ = (GtkLabel*) gtk_label_new (_ ("Add Task"));
	g_object_ref_sink (_tmp194_);
	_tmp195_ = _tmp194_;
	gtk_stack_add_named (_tmp193_, (GtkWidget*) _tmp195_, "label");
	_g_object_unref0 (_tmp195_);
	_tmp196_ = self->priv->submit_stack;
	_tmp197_ = submit_spinner;
	gtk_stack_add_named (_tmp196_, (GtkWidget*) _tmp197_, "spinner");
	_tmp198_ = self->priv->submit_button;
	_tmp199_ = self->priv->submit_stack;
	gtk_container_add ((GtkContainer*) _tmp198_, (GtkWidget*) _tmp199_);
	_tmp200_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
	g_object_ref_sink (_tmp200_);
	_g_object_unref0 (self->priv->cancel_button);
	self->priv->cancel_button = _tmp200_;
	_tmp201_ = self->priv->cancel_button;
	_tmp202_ = gtk_widget_get_style_context ((GtkWidget*) _tmp201_);
	gtk_style_context_add_class (_tmp202_, "cancel-button");
	_tmp203_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp203_);
	action_grid = _tmp203_;
	_tmp204_ = action_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp204_, GTK_ALIGN_START);
	_tmp205_ = action_grid;
	gtk_grid_set_column_spacing (_tmp205_, 6);
	_tmp206_ = action_grid;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp206_, 3);
	_tmp207_ = action_grid;
	gtk_grid_set_column_homogeneous (_tmp207_, TRUE);
	_tmp208_ = action_grid;
	_tmp209_ = self->priv->cancel_button;
	gtk_container_add ((GtkContainer*) _tmp208_, (GtkWidget*) _tmp209_);
	_tmp210_ = action_grid;
	_tmp211_ = self->priv->submit_button;
	gtk_container_add ((GtkContainer*) _tmp210_, (GtkWidget*) _tmp211_);
	_tmp212_ = action_grid;
	_tmp213_ = self->priv->_created;
	gtk_widget_set_visible ((GtkWidget*) _tmp212_, !_tmp213_);
	_tmp214_ = action_grid;
	_tmp215_ = self->priv->_created;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp214_, _tmp215_);
	_tmp216_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp216_);
	_g_object_unref0 (self->priv->handle_grid);
	self->priv->handle_grid = _tmp216_;
	_tmp217_ = self->priv->handle_grid;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp217_, TRUE);
	_tmp218_ = self->priv->handle_grid;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp218_, 6);
	_tmp219_ = self->priv->handle_grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp219_, 3);
	_tmp220_ = self->priv->handle_grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp220_, GTK_ORIENTATION_VERTICAL);
	_tmp221_ = self->priv->handle_grid;
	_tmp222_ = self->priv->main_grid;
	gtk_container_add ((GtkContainer*) _tmp221_, (GtkWidget*) _tmp222_);
	_tmp223_ = self->priv->handle_grid;
	_tmp224_ = action_grid;
	gtk_container_add ((GtkContainer*) _tmp223_, (GtkWidget*) _tmp224_);
	_tmp225_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp225_);
	handle = _tmp225_;
	_tmp226_ = handle;
	gtk_widget_add_events ((GtkWidget*) _tmp226_, (gint) (GDK_ENTER_NOTIFY_MASK | GDK_LEAVE_NOTIFY_MASK));
	_tmp227_ = handle;
	g_object_set ((GtkWidget*) _tmp227_, "expand", TRUE, NULL);
	_tmp228_ = handle;
	gtk_event_box_set_above_child (_tmp228_, FALSE);
	_tmp229_ = handle;
	_tmp230_ = self->priv->handle_grid;
	gtk_container_add ((GtkContainer*) _tmp229_, (GtkWidget*) _tmp230_);
	_tmp231_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp231_);
	_g_object_unref0 (self->priv->main_revealer);
	self->priv->main_revealer = _tmp231_;
	_tmp232_ = self->priv->main_revealer;
	gtk_revealer_set_reveal_child (_tmp232_, FALSE);
	_tmp233_ = self->priv->main_revealer;
	gtk_revealer_set_transition_type (_tmp233_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp234_ = self->priv->main_revealer;
	_tmp235_ = handle;
	gtk_container_add ((GtkContainer*) _tmp234_, (GtkWidget*) _tmp235_);
	_tmp236_ = self->priv->main_revealer;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp236_);
	_tmp237_ = self->priv->main_revealer;
	_tmp238_ = gtk_revealer_get_transition_duration (_tmp237_);
	_tmp239_ = _tmp238_;
	g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp239_, __widgets_task_row___lambda25__gsource_func, g_object_ref (self), g_object_unref);
	g_signal_connect_object ((GObject*) self, "notify::task", (GCallback) __widgets_task_row___lambda26__g_object_notify, self, 0);
	widgets_task_row_update_request (self);
	_tmp240_ = self->priv->cancel_button;
	g_signal_connect_object (_tmp240_, "clicked", (GCallback) __widgets_task_row___lambda27__gtk_button_clicked, self, 0);
	_tmp241_ = self->priv->content_entry;
	g_signal_connect_object ((GtkWidget*) _tmp241_, "key-release-event", (GCallback) __widgets_task_row___lambda28__gtk_widget_key_release_event, self, 0);
	_tmp242_ = self->priv->content_entry;
	g_signal_connect_object ((GtkWidget*) _tmp242_, "focus-out-event", (GCallback) __widgets_task_row___lambda29__gtk_widget_focus_out_event, self, 0);
	_tmp243_ = self->priv->content_entry;
	g_signal_connect_object ((GtkWidget*) _tmp243_, "focus-in-event", (GCallback) __widgets_task_row___lambda31__gtk_widget_focus_in_event, self, 0);
	_tmp244_ = self->priv->content_entry;
	g_signal_connect_object ((GtkEntry*) _tmp244_, "populate-popup", (GCallback) __widgets_task_row___lambda32__gtk_entry_populate_popup, self, 0);
	_tmp245_ = self->priv->content_entry;
	g_signal_connect_object ((GtkEntry*) _tmp245_, "activate", (GCallback) __widgets_task_row___lambda34__gtk_entry_activate, self, 0);
	_tmp246_ = self->priv->content_entry;
	g_signal_connect_object ((GtkEditable*) _tmp246_, "changed", (GCallback) __widgets_task_row___lambda35__gtk_editable_changed, self, 0);
	_tmp247_ = self->priv->hidden_button;
	g_signal_connect_object (_tmp247_, "clicked", (GCallback) __widgets_task_row___lambda36__gtk_button_clicked, self, 0);
	_tmp248_ = note_eventbox;
	g_signal_connect_object ((GtkWidget*) _tmp248_, "button-press-event", (GCallback) __widgets_task_row___lambda37__gtk_widget_button_press_event, self, 0);
	_tmp249_ = self->priv->note_textview;
	g_signal_connect_object ((GtkWidget*) _tmp249_, "focus-out-event", (GCallback) __widgets_task_row___lambda38__gtk_widget_focus_out_event, self, 0);
	_tmp250_ = self->priv->note_textview;
	g_signal_connect_object ((GtkWidget*) _tmp250_, "focus-in-event", (GCallback) __widgets_task_row___lambda39__gtk_widget_focus_in_event, self, 0);
	_tmp251_ = self->priv->checked_button;
	g_signal_connect_object ((GtkToggleButton*) _tmp251_, "toggled", (GCallback) __widgets_task_row___lambda40__gtk_toggle_button_toggled, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) __widgets_task_row___lambda41__gtk_widget_button_press_event, self, 0);
	_tmp252_ = menu_button;
	g_signal_connect_object (_tmp252_, "clicked", (GCallback) __widgets_task_row___lambda42__gtk_button_clicked, self, 0);
	_tmp253_ = self->priv->submit_button;
	g_signal_connect_object (_tmp253_, "clicked", (GCallback) _widgets_task_row_add_task_gtk_button_clicked, self, 0);
	_tmp254_ = self->priv->reschedule_button;
	g_signal_connect_object (_tmp254_, "popover-opened", (GCallback) __widgets_task_row___lambda43__widgets_schedule_button_popover_opened, self, 0);
	_g_object_unref0 (handle);
	_g_object_unref0 (action_grid);
	_g_object_unref0 (submit_spinner);
	_g_object_unref0 (bottom_box);
	_g_object_unref0 (action_box);
	_g_object_unref0 (menu_button);
	_g_object_unref0 (note_eventbox);
	_g_object_unref0 (content_box);
	return obj;
}

static void
widgets_task_row_class_init (WidgetsTaskRowClass * klass,
                             gpointer klass_data)
{
	widgets_task_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsTaskRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_task_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_task_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_task_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_task_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_TASK_ROW_SOURCE_PROPERTY, widgets_task_row_properties[WIDGETS_TASK_ROW_SOURCE_PROPERTY] = g_param_spec_object ("source", "source", "source", e_source_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_TASK_ROW_TASK_PROPERTY, widgets_task_row_properties[WIDGETS_TASK_ROW_TASK_PROPERTY] = g_param_spec_object ("task", "task", "task", e_cal_component_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_TASK_ROW_CREATED_PROPERTY, widgets_task_row_properties[WIDGETS_TASK_ROW_CREATED_PROPERTY] = g_param_spec_boolean ("created", "created", "created", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_TASK_ROW_COMPLETED_PROPERTY, widgets_task_row_properties[WIDGETS_TASK_ROW_COMPLETED_PROPERTY] = g_param_spec_boolean ("completed", "completed", "completed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_TASK_ROW_REVEAL_CHILD_PROPERTY, widgets_task_row_properties[WIDGETS_TASK_ROW_REVEAL_CHILD_PROPERTY] = g_param_spec_boolean ("reveal-child", "reveal-child", "reveal-child", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_TASK_ROW_LOADING_PROPERTY, widgets_task_row_properties[WIDGETS_TASK_ROW_LOADING_PROPERTY] = g_param_spec_boolean ("loading", "loading", "loading", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
}

static void
widgets_task_row_instance_init (WidgetsTaskRow * self,
                                gpointer klass)
{
	self->priv = widgets_task_row_get_instance_private (self);
	self->priv->menu = NULL;
	self->priv->focus_timeout = (guint) 0;
	self->priv->timeout_id = (guint) 0;
	self->priv->receive_updates = TRUE;
	self->priv->entry_menu_opened = FALSE;
}

static void
widgets_task_row_finalize (GObject * obj)
{
	WidgetsTaskRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_TASK_ROW, WidgetsTaskRow);
	_g_object_unref0 (self->priv->_source);
	_g_object_unref0 (self->priv->_task);
	_g_object_unref0 (self->priv->checked_button);
	_g_object_unref0 (self->priv->content_label);
	_g_object_unref0 (self->priv->top_box);
	_g_object_unref0 (self->priv->hidden_button);
	_g_object_unref0 (self->priv->hidden_revealer);
	_g_object_unref0 (self->priv->label_revealer);
	_g_object_unref0 (self->priv->content_entry);
	_g_object_unref0 (self->priv->entry_revealer);
	_g_object_unref0 (self->priv->note_textview);
	_g_object_unref0 (self->priv->note_label);
	_g_object_unref0 (self->priv->note_stack);
	_g_object_unref0 (self->priv->bottom_revealer);
	_g_object_unref0 (self->priv->main_revealer);
	_g_object_unref0 (self->priv->main_grid);
	_g_object_unref0 (self->priv->handle_grid);
	_g_object_unref0 (self->priv->menu);
	_g_object_unref0 (self->priv->menu_image);
	_g_object_unref0 (self->priv->reschedule_button);
	_g_object_unref0 (self->priv->duedate_preview_label);
	_g_object_unref0 (self->priv->duedate_preview_revealer);
	_g_object_unref0 (self->priv->preview_revealer);
	_g_object_unref0 (self->priv->preview_box);
	_g_object_unref0 (self->priv->submit_button);
	_g_object_unref0 (self->priv->submit_stack);
	_g_object_unref0 (self->priv->cancel_button);
	_g_object_unref0 (self->priv->task_store);
	G_OBJECT_CLASS (widgets_task_row_parent_class)->finalize (obj);
}

GType
widgets_task_row_get_type (void)
{
	return widgets_task_row_type_id;
}

GType
widgets_task_row_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsTaskRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_task_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsTaskRow), 0, (GInstanceInitFunc) widgets_task_row_instance_init, NULL };
	widgets_task_row_type_id = g_type_module_register_type (module, gtk_list_box_row_get_type (), "WidgetsTaskRow", &g_define_type_info, 0);
	WidgetsTaskRow_private_offset = sizeof (WidgetsTaskRowPrivate);
	return widgets_task_row_type_id;
}

static void
_vala_widgets_task_row_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	WidgetsTaskRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_TASK_ROW, WidgetsTaskRow);
	switch (property_id) {
		case WIDGETS_TASK_ROW_SOURCE_PROPERTY:
		g_value_set_object (value, widgets_task_row_get_source (self));
		break;
		case WIDGETS_TASK_ROW_TASK_PROPERTY:
		g_value_set_object (value, widgets_task_row_get_task (self));
		break;
		case WIDGETS_TASK_ROW_CREATED_PROPERTY:
		g_value_set_boolean (value, widgets_task_row_get_created (self));
		break;
		case WIDGETS_TASK_ROW_COMPLETED_PROPERTY:
		g_value_set_boolean (value, widgets_task_row_get_completed (self));
		break;
		case WIDGETS_TASK_ROW_REVEAL_CHILD_PROPERTY:
		g_value_set_boolean (value, widgets_task_row_get_reveal_child (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_task_row_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	WidgetsTaskRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_TASK_ROW, WidgetsTaskRow);
	switch (property_id) {
		case WIDGETS_TASK_ROW_SOURCE_PROPERTY:
		widgets_task_row_set_source (self, g_value_get_object (value));
		break;
		case WIDGETS_TASK_ROW_TASK_PROPERTY:
		widgets_task_row_set_task (self, g_value_get_object (value));
		break;
		case WIDGETS_TASK_ROW_CREATED_PROPERTY:
		widgets_task_row_set_created (self, g_value_get_boolean (value));
		break;
		case WIDGETS_TASK_ROW_COMPLETED_PROPERTY:
		widgets_task_row_set_completed (self, g_value_get_boolean (value));
		break;
		case WIDGETS_TASK_ROW_REVEAL_CHILD_PROPERTY:
		widgets_task_row_set_reveal_child (self, g_value_get_boolean (value));
		break;
		case WIDGETS_TASK_ROW_LOADING_PROPERTY:
		widgets_task_row_set_loading (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

