/* EventRow.c generated by valac 0.52.4, the Vala compiler
 * generated from EventRow.vala, do not modify */

/*
* Copyright © 2019 Alain M. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <libical-glib/libical-glib.h>
#include <libedataserver/libedataserver.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <gdk/gdk.h>
#include <pango/pango.h>

#define WIDGETS_TYPE_EVENT_ROW (widgets_event_row_get_type ())
#define WIDGETS_EVENT_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow))
#define WIDGETS_EVENT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_EVENT_ROW, WidgetsEventRowClass))
#define WIDGETS_IS_EVENT_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_EVENT_ROW))
#define WIDGETS_IS_EVENT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_EVENT_ROW))
#define WIDGETS_EVENT_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_EVENT_ROW, WidgetsEventRowClass))

typedef struct _WidgetsEventRow WidgetsEventRow;
typedef struct _WidgetsEventRowClass WidgetsEventRowClass;
typedef struct _WidgetsEventRowPrivate WidgetsEventRowPrivate;
enum  {
	WIDGETS_EVENT_ROW_0_PROPERTY,
	WIDGETS_EVENT_ROW_DATE_PROPERTY,
	WIDGETS_EVENT_ROW_COMPONENT_PROPERTY,
	WIDGETS_EVENT_ROW_CAL_PROPERTY,
	WIDGETS_EVENT_ROW_SOURCE_PROPERTY,
	WIDGETS_EVENT_ROW_START_TIME_PROPERTY,
	WIDGETS_EVENT_ROW_END_TIME_PROPERTY,
	WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY,
	WIDGETS_EVENT_ROW_NUM_PROPERTIES
};
static GParamSpec* widgets_event_row_properties[WIDGETS_EVENT_ROW_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WidgetsEventRow {
	GtkListBoxRow parent_instance;
	WidgetsEventRowPrivate * priv;
};

struct _WidgetsEventRowClass {
	GtkListBoxRowClass parent_class;
};

struct _WidgetsEventRowPrivate {
	GDateTime* _date;
	ICalComponent* _component;
	ESourceCalendar* _cal;
	ESource* _source;
	GDateTime* _start_time;
	GDateTime* _end_time;
	gboolean _is_allday;
	GtkRevealer* main_revealer;
	GtkGrid* color_grid;
	GtkLabel* time_label;
};

static gint WidgetsEventRow_private_offset;
static gpointer widgets_event_row_parent_class = NULL;
extern GSettings* planner_settings;

GType widgets_event_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsEventRow, g_object_unref)
WidgetsEventRow* widgets_event_row_new (GDateTime* date,
                                        ICalComponent* component,
                                        ESource* source);
WidgetsEventRow* widgets_event_row_construct (GType object_type,
                                              GDateTime* date,
                                              ICalComponent* component,
                                              ESource* source);
static void widgets_event_row_check_visible (WidgetsEventRow* self);
ESourceCalendar* widgets_event_row_get_cal (WidgetsEventRow* self);
static void widgets_event_row_update_timelabel (WidgetsEventRow* self);
GDateTime* widgets_event_row_get_start_time (WidgetsEventRow* self);
GDateTime* widgets_event_row_get_end_time (WidgetsEventRow* self);
static void widgets_event_row_set_color (WidgetsEventRow* self);
ICalComponent* widgets_event_row_get_component (WidgetsEventRow* self);
GDateTime* widgets_event_row_get_date (WidgetsEventRow* self);
static void widgets_event_row_set_date (WidgetsEventRow* self,
                                 GDateTime* value);
static void widgets_event_row_set_component (WidgetsEventRow* self,
                                      ICalComponent* value);
static void widgets_event_row_set_cal (WidgetsEventRow* self,
                                ESourceCalendar* value);
ESource* widgets_event_row_get_source (WidgetsEventRow* self);
void widgets_event_row_set_source (WidgetsEventRow* self,
                                   ESource* value);
static void widgets_event_row_set_start_time (WidgetsEventRow* self,
                                       GDateTime* value);
static void widgets_event_row_set_end_time (WidgetsEventRow* self,
                                     GDateTime* value);
gboolean widgets_event_row_get_is_allday (WidgetsEventRow* self);
static void widgets_event_row_set_is_allday (WidgetsEventRow* self,
                                      gboolean value);
static GObject * widgets_event_row_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
GDateTime* util_ical_to_date_time (ICalTime* date);
gboolean util_is_the_all_day (GDateTime* dtstart,
                              GDateTime* dtend);
static void _widgets_event_row___lambda910_ (WidgetsEventRow* self,
                                      const gchar* key);
static void __widgets_event_row___lambda910__g_settings_changed (GSettings* _sender,
                                                          const gchar* key,
                                                          gpointer self);
static void widgets_event_row_finalize (GObject * obj);
static GType widgets_event_row_get_type_once (void);
static void _vala_widgets_event_row_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_widgets_event_row_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
widgets_event_row_get_instance_private (WidgetsEventRow* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsEventRow_private_offset);
}

WidgetsEventRow*
widgets_event_row_construct (GType object_type,
                             GDateTime* date,
                             ICalComponent* component,
                             ESource* source)
{
	WidgetsEventRow * self = NULL;
	ESourceExtension* _tmp0_;
	g_return_val_if_fail (date != NULL, NULL);
	g_return_val_if_fail (component != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
	self = (WidgetsEventRow*) g_object_new (object_type, "date", date, "component", component, "cal", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_calendar_get_type (), ESourceCalendar), NULL);
	return self;
}

WidgetsEventRow*
widgets_event_row_new (GDateTime* date,
                       ICalComponent* component,
                       ESource* source)
{
	return widgets_event_row_construct (WIDGETS_TYPE_EVENT_ROW, date, component, source);
}

static void
widgets_event_row_check_visible (WidgetsEventRow* self)
{
	gboolean _visible = FALSE;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	GtkRevealer* _tmp11_;
	g_return_if_fail (self != NULL);
	_visible = TRUE;
	_tmp0_ = planner_settings;
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "calendar-sources-disabled");
	{
		gchar** uid_collection = NULL;
		gint uid_collection_length1 = 0;
		gint _uid_collection_size_ = 0;
		gint uid_it = 0;
		uid_collection = _tmp2_;
		uid_collection_length1 = _vala_array_length (_tmp1_);
		for (uid_it = 0; uid_it < uid_collection_length1; uid_it = uid_it + 1) {
			gchar* _tmp3_;
			gchar* uid = NULL;
			_tmp3_ = g_strdup (uid_collection[uid_it]);
			uid = _tmp3_;
			{
				ESourceCalendar* _tmp4_;
				ESource* _tmp5_;
				ESource* _tmp6_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				gboolean _tmp10_;
				_tmp4_ = self->priv->_cal;
				_tmp5_ = e_source_extension_ref_source ((ESourceExtension*) _tmp4_);
				_tmp6_ = _tmp5_;
				_tmp7_ = e_source_get_uid (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = uid;
				_tmp10_ = g_strcmp0 (_tmp8_, _tmp9_) == 0;
				_g_object_unref0 (_tmp6_);
				if (_tmp10_) {
					_visible = FALSE;
				}
				_g_free0 (uid);
			}
		}
		uid_collection = (_vala_array_free (uid_collection, uid_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp11_ = self->priv->main_revealer;
	gtk_revealer_set_reveal_child (_tmp11_, _visible);
}

static void
widgets_event_row_update_timelabel (WidgetsEventRow* self)
{
	gchar* time_format = NULL;
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GDateTime* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_date_time_get_default_time_format (TRUE, FALSE);
	time_format = _tmp0_;
	_tmp1_ = self->priv->time_label;
	_tmp2_ = self->priv->_start_time;
	_tmp3_ = g_date_time_format (_tmp2_, time_format);
	_tmp4_ = _tmp3_;
	_tmp5_ = self->priv->_end_time;
	_tmp6_ = g_date_time_format (_tmp5_, time_format);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strdup_printf ("<small>%s – %s</small>", _tmp4_, _tmp7_);
	_tmp9_ = _tmp8_;
	gtk_label_set_label (_tmp1_, _tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp4_);
	_g_free0 (time_format);
}

static void
widgets_event_row_set_color (WidgetsEventRow* self)
{
	gchar* color = NULL;
	ESourceCalendar* _tmp0_;
	gchar* _tmp1_;
	gchar* color_css = NULL;
	gchar* _tmp2_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp3_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_cal;
	_tmp1_ = e_source_selectable_dup_color ((ESourceSelectable*) _tmp0_);
	color = _tmp1_;
	_tmp2_ = g_strdup ("\n" \
"            .event-%s {\n" \
"                background-color: %s;\n" \
"                border-radius: 1px;\n" \
"            }\n" \
"        ");
	color_css = _tmp2_;
	_tmp3_ = gtk_css_provider_new ();
	provider = _tmp3_;
	{
		gchar* colored_css = NULL;
		const gchar* _tmp4_;
		ICalComponent* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		GtkCssProvider* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		GdkScreen* _tmp14_;
		GtkCssProvider* _tmp15_;
		_tmp4_ = color_css;
		_tmp5_ = self->priv->_component;
		_tmp6_ = i_cal_component_get_uid (_tmp5_);
		_tmp7_ = color;
		_tmp8_ = g_strdup_printf (_tmp4_, _tmp6_, _tmp7_);
		colored_css = _tmp8_;
		_tmp9_ = provider;
		_tmp10_ = colored_css;
		_tmp11_ = colored_css;
		_tmp12_ = strlen (_tmp11_);
		_tmp13_ = _tmp12_;
		gtk_css_provider_load_from_data (_tmp9_, _tmp10_, (gssize) _tmp13_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (colored_css);
			goto __catch0_g_error;
		}
		_tmp14_ = gdk_screen_get_default ();
		_tmp15_ = provider;
		gtk_style_context_add_provider_for_screen (_tmp14_, (GtkStyleProvider*) _tmp15_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
		_g_free0 (colored_css);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		_g_object_unref0 (provider);
		_g_free0 (color_css);
		_g_free0 (color);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (provider);
		_g_free0 (color_css);
		_g_free0 (color);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (provider);
	_g_free0 (color_css);
	_g_free0 (color);
}

GDateTime*
widgets_event_row_get_date (WidgetsEventRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date;
	result = _tmp0_;
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

static void
widgets_event_row_set_date (WidgetsEventRow* self,
                            GDateTime* value)
{
	GDateTime* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_date (self);
	if (old_value != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_date);
		self->priv->_date = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_DATE_PROPERTY]);
	}
}

ICalComponent*
widgets_event_row_get_component (WidgetsEventRow* self)
{
	ICalComponent* result;
	ICalComponent* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_component;
	result = _tmp0_;
	return result;
}

static void
widgets_event_row_set_component (WidgetsEventRow* self,
                                 ICalComponent* value)
{
	ICalComponent* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_component (self);
	if (old_value != value) {
		self->priv->_component = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_COMPONENT_PROPERTY]);
	}
}

ESourceCalendar*
widgets_event_row_get_cal (WidgetsEventRow* self)
{
	ESourceCalendar* result;
	ESourceCalendar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cal;
	result = _tmp0_;
	return result;
}

static void
widgets_event_row_set_cal (WidgetsEventRow* self,
                           ESourceCalendar* value)
{
	ESourceCalendar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_cal (self);
	if (old_value != value) {
		self->priv->_cal = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_CAL_PROPERTY]);
	}
}

ESource*
widgets_event_row_get_source (WidgetsEventRow* self)
{
	ESource* result;
	ESource* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_source;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
widgets_event_row_set_source (WidgetsEventRow* self,
                              ESource* value)
{
	ESource* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_source (self);
	if (old_value != value) {
		ESource* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_source);
		self->priv->_source = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_SOURCE_PROPERTY]);
	}
}

GDateTime*
widgets_event_row_get_start_time (WidgetsEventRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_start_time;
	result = _tmp0_;
	return result;
}

static void
widgets_event_row_set_start_time (WidgetsEventRow* self,
                                  GDateTime* value)
{
	GDateTime* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_start_time (self);
	if (old_value != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_start_time);
		self->priv->_start_time = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_START_TIME_PROPERTY]);
	}
}

GDateTime*
widgets_event_row_get_end_time (WidgetsEventRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_end_time;
	result = _tmp0_;
	return result;
}

static void
widgets_event_row_set_end_time (WidgetsEventRow* self,
                                GDateTime* value)
{
	GDateTime* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_end_time (self);
	if (old_value != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_end_time);
		self->priv->_end_time = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_END_TIME_PROPERTY]);
	}
}

gboolean
widgets_event_row_get_is_allday (WidgetsEventRow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_allday;
	return result;
}

static void
widgets_event_row_set_is_allday (WidgetsEventRow* self,
                                 gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_is_allday (self);
	if (old_value != value) {
		self->priv->_is_allday = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY]);
	}
}

static void
_widgets_event_row___lambda910_ (WidgetsEventRow* self,
                                 const gchar* key)
{
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "calendar-sources-disabled") == 0) {
		widgets_event_row_check_visible (self);
	}
}

static void
__widgets_event_row___lambda910__g_settings_changed (GSettings* _sender,
                                                     const gchar* key,
                                                     gpointer self)
{
	_widgets_event_row___lambda910_ ((WidgetsEventRow*) self, key);
}

static GObject *
widgets_event_row_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsEventRow * self;
	GtkStyleContext* _tmp0_;
	ICalTime* dt_start = NULL;
	ICalComponent* _tmp1_;
	ICalTime* _tmp2_;
	ICalComponent* _tmp3_;
	ICalTime* _tmp4_;
	ICalTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	ICalTime* _tmp8_;
	ICalTime* dt_end = NULL;
	ICalComponent* _tmp17_;
	ICalTime* _tmp18_;
	ICalTime* _tmp19_;
	gboolean _tmp28_ = FALSE;
	GDateTime* _tmp29_;
	GtkGrid* _tmp32_;
	GtkGrid* _tmp33_;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkGrid* _tmp36_;
	GtkGrid* _tmp37_;
	GtkStyleContext* _tmp38_;
	ICalComponent* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	GtkLabel* _tmp43_;
	GtkLabel* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkStyleContext* _tmp47_;
	GtkLabel* name_label = NULL;
	ICalComponent* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkLabel* _tmp56_;
	GtkStyleContext* _tmp57_;
	GtkLabel* _tmp58_;
	GtkLabel* _tmp59_;
	GtkLabel* _tmp60_;
	GtkLabel* _tmp61_;
	GtkLabel* _tmp62_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp63_;
	GtkGrid* _tmp64_;
	GtkGrid* _tmp65_;
	GtkGrid* _tmp66_;
	GtkGrid* _tmp67_;
	GtkGrid* _tmp68_;
	gboolean _tmp69_;
	GtkGrid* _tmp72_;
	GtkLabel* _tmp73_;
	GtkRevealer* _tmp74_;
	GtkRevealer* _tmp75_;
	GtkRevealer* _tmp76_;
	GtkGrid* _tmp77_;
	GtkRevealer* _tmp78_;
	GtkRevealer* _tmp79_;
	GSettings* _tmp80_;
	parent_class = G_OBJECT_CLASS (widgets_event_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "item-row");
	_tmp1_ = self->priv->_component;
	_tmp2_ = i_cal_component_get_dtstart (_tmp1_);
	dt_start = _tmp2_;
	_tmp3_ = self->priv->_component;
	_tmp4_ = i_cal_component_get_dtend (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = util_ical_to_date_time (_tmp5_);
	_tmp7_ = _tmp6_;
	widgets_event_row_set_end_time (self, _tmp7_);
	_g_date_time_unref0 (_tmp7_);
	_g_object_unref0 (_tmp5_);
	_tmp8_ = dt_start;
	if (i_cal_time_is_date (_tmp8_)) {
		ICalTime* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		_tmp9_ = dt_start;
		_tmp10_ = util_ical_to_date_time (_tmp9_);
		_tmp11_ = _tmp10_;
		widgets_event_row_set_start_time (self, _tmp11_);
		_g_date_time_unref0 (_tmp11_);
	} else {
		ICalTime* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
		GDateTime* _tmp15_;
		GDateTime* _tmp16_;
		_tmp12_ = dt_start;
		_tmp13_ = util_ical_to_date_time (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_date_time_to_local (_tmp14_);
		_tmp16_ = _tmp15_;
		widgets_event_row_set_start_time (self, _tmp16_);
		_g_date_time_unref0 (_tmp16_);
		_g_date_time_unref0 (_tmp14_);
	}
	_tmp17_ = self->priv->_component;
	_tmp18_ = i_cal_component_get_dtend (_tmp17_);
	dt_end = _tmp18_;
	_tmp19_ = dt_end;
	if (i_cal_time_is_date (_tmp19_)) {
		ICalTime* _tmp20_;
		GDateTime* _tmp21_;
		GDateTime* _tmp22_;
		_tmp20_ = dt_end;
		_tmp21_ = util_ical_to_date_time (_tmp20_);
		_tmp22_ = _tmp21_;
		widgets_event_row_set_end_time (self, _tmp22_);
		_g_date_time_unref0 (_tmp22_);
	} else {
		ICalTime* _tmp23_;
		GDateTime* _tmp24_;
		GDateTime* _tmp25_;
		GDateTime* _tmp26_;
		GDateTime* _tmp27_;
		_tmp23_ = dt_end;
		_tmp24_ = util_ical_to_date_time (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = g_date_time_to_local (_tmp25_);
		_tmp27_ = _tmp26_;
		widgets_event_row_set_end_time (self, _tmp27_);
		_g_date_time_unref0 (_tmp27_);
		_g_date_time_unref0 (_tmp25_);
	}
	_tmp29_ = self->priv->_end_time;
	if (_tmp29_ != NULL) {
		GDateTime* _tmp30_;
		GDateTime* _tmp31_;
		_tmp30_ = self->priv->_start_time;
		_tmp31_ = self->priv->_end_time;
		_tmp28_ = util_is_the_all_day (_tmp30_, _tmp31_);
	} else {
		_tmp28_ = FALSE;
	}
	if (_tmp28_) {
		widgets_event_row_set_is_allday (self, TRUE);
	}
	_tmp32_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->priv->color_grid);
	self->priv->color_grid = _tmp32_;
	_tmp33_ = self->priv->color_grid;
	g_object_set ((GtkWidget*) _tmp33_, "width-request", 3, NULL);
	_tmp34_ = self->priv->color_grid;
	g_object_set ((GtkWidget*) _tmp34_, "height-request", 12, NULL);
	_tmp35_ = self->priv->color_grid;
	gtk_widget_set_valign ((GtkWidget*) _tmp35_, GTK_ALIGN_CENTER);
	_tmp36_ = self->priv->color_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp36_, GTK_ALIGN_CENTER);
	_tmp37_ = self->priv->color_grid;
	_tmp38_ = gtk_widget_get_style_context ((GtkWidget*) _tmp37_);
	_tmp39_ = self->priv->_component;
	_tmp40_ = i_cal_component_get_uid (_tmp39_);
	_tmp41_ = g_strdup_printf ("event-%s", _tmp40_);
	_tmp42_ = _tmp41_;
	gtk_style_context_add_class (_tmp38_, _tmp42_);
	_g_free0 (_tmp42_);
	_tmp43_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp43_);
	_g_object_unref0 (self->priv->time_label);
	self->priv->time_label = _tmp43_;
	_tmp44_ = self->priv->time_label;
	gtk_label_set_use_markup (_tmp44_, TRUE);
	_tmp45_ = self->priv->time_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp45_, GTK_ALIGN_CENTER);
	_tmp46_ = self->priv->time_label;
	_tmp47_ = gtk_widget_get_style_context ((GtkWidget*) _tmp46_);
	gtk_style_context_add_class (_tmp47_, "dim-label");
	_tmp48_ = self->priv->_component;
	_tmp49_ = i_cal_component_get_summary (_tmp48_);
	_tmp50_ = g_strdup_printf ("<small>%s</small>", _tmp49_);
	_tmp51_ = _tmp50_;
	_tmp52_ = (GtkLabel*) gtk_label_new (_tmp51_);
	g_object_ref_sink (_tmp52_);
	_tmp53_ = _tmp52_;
	_g_free0 (_tmp51_);
	name_label = _tmp53_;
	_tmp54_ = name_label;
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
	gtk_style_context_add_class (_tmp55_, "font-bold");
	_tmp56_ = name_label;
	_tmp57_ = gtk_widget_get_style_context ((GtkWidget*) _tmp56_);
	gtk_style_context_add_class (_tmp57_, "dim-label");
	_tmp58_ = name_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp58_, GTK_ALIGN_CENTER);
	_tmp59_ = name_label;
	gtk_label_set_ellipsize (_tmp59_, PANGO_ELLIPSIZE_END);
	_tmp60_ = name_label;
	g_object_set (_tmp60_, "wrap", TRUE, NULL);
	_tmp61_ = name_label;
	gtk_label_set_use_markup (_tmp61_, TRUE);
	_tmp62_ = name_label;
	g_object_set (_tmp62_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
	_tmp63_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp63_);
	grid = _tmp63_;
	_tmp64_ = grid;
	gtk_grid_set_column_spacing (_tmp64_, 6);
	_tmp65_ = grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp65_, 3);
	_tmp66_ = grid;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp66_, 3);
	_tmp67_ = grid;
	_tmp68_ = self->priv->color_grid;
	gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
	_tmp69_ = self->priv->_is_allday;
	if (!_tmp69_) {
		GtkGrid* _tmp70_;
		GtkLabel* _tmp71_;
		_tmp70_ = grid;
		_tmp71_ = self->priv->time_label;
		gtk_container_add ((GtkContainer*) _tmp70_, (GtkWidget*) _tmp71_);
	}
	_tmp72_ = grid;
	_tmp73_ = name_label;
	gtk_container_add ((GtkContainer*) _tmp72_, (GtkWidget*) _tmp73_);
	_tmp74_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp74_);
	_g_object_unref0 (self->priv->main_revealer);
	self->priv->main_revealer = _tmp74_;
	_tmp75_ = self->priv->main_revealer;
	gtk_revealer_set_transition_type (_tmp75_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp76_ = self->priv->main_revealer;
	_tmp77_ = grid;
	gtk_container_add ((GtkContainer*) _tmp76_, (GtkWidget*) _tmp77_);
	_tmp78_ = self->priv->main_revealer;
	gtk_revealer_set_reveal_child (_tmp78_, FALSE);
	_tmp79_ = self->priv->main_revealer;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp79_);
	widgets_event_row_set_color (self);
	widgets_event_row_update_timelabel (self);
	widgets_event_row_check_visible (self);
	_tmp80_ = planner_settings;
	g_signal_connect_object (_tmp80_, "changed", (GCallback) __widgets_event_row___lambda910__g_settings_changed, self, 0);
	_g_object_unref0 (grid);
	_g_object_unref0 (name_label);
	_g_object_unref0 (dt_end);
	_g_object_unref0 (dt_start);
	return obj;
}

static void
widgets_event_row_class_init (WidgetsEventRowClass * klass,
                              gpointer klass_data)
{
	widgets_event_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsEventRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_event_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_event_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_event_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_event_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_DATE_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_COMPONENT_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_COMPONENT_PROPERTY] = g_param_spec_object ("component", "component", "component", i_cal_component_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_CAL_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_CAL_PROPERTY] = g_param_spec_object ("cal", "cal", "cal", e_source_calendar_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_SOURCE_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_SOURCE_PROPERTY] = g_param_spec_object ("source", "source", "source", e_source_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_START_TIME_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_START_TIME_PROPERTY] = g_param_spec_boxed ("start-time", "start-time", "start-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_END_TIME_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_END_TIME_PROPERTY] = g_param_spec_boxed ("end-time", "end-time", "end-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY] = g_param_spec_boolean ("is-allday", "is-allday", "is-allday", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
widgets_event_row_instance_init (WidgetsEventRow * self,
                                 gpointer klass)
{
	self->priv = widgets_event_row_get_instance_private (self);
	self->priv->_is_allday = FALSE;
}

static void
widgets_event_row_finalize (GObject * obj)
{
	WidgetsEventRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow);
	_g_date_time_unref0 (self->priv->_date);
	_g_object_unref0 (self->priv->_source);
	_g_date_time_unref0 (self->priv->_start_time);
	_g_date_time_unref0 (self->priv->_end_time);
	_g_object_unref0 (self->priv->main_revealer);
	_g_object_unref0 (self->priv->color_grid);
	_g_object_unref0 (self->priv->time_label);
	G_OBJECT_CLASS (widgets_event_row_parent_class)->finalize (obj);
}

static GType
widgets_event_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsEventRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_event_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsEventRow), 0, (GInstanceInitFunc) widgets_event_row_instance_init, NULL };
	GType widgets_event_row_type_id;
	widgets_event_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "WidgetsEventRow", &g_define_type_info, 0);
	WidgetsEventRow_private_offset = g_type_add_instance_private (widgets_event_row_type_id, sizeof (WidgetsEventRowPrivate));
	return widgets_event_row_type_id;
}

GType
widgets_event_row_get_type (void)
{
	static volatile gsize widgets_event_row_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_event_row_type_id__volatile)) {
		GType widgets_event_row_type_id;
		widgets_event_row_type_id = widgets_event_row_get_type_once ();
		g_once_init_leave (&widgets_event_row_type_id__volatile, widgets_event_row_type_id);
	}
	return widgets_event_row_type_id__volatile;
}

static void
_vala_widgets_event_row_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	WidgetsEventRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow);
	switch (property_id) {
		case WIDGETS_EVENT_ROW_DATE_PROPERTY:
		g_value_set_boxed (value, widgets_event_row_get_date (self));
		break;
		case WIDGETS_EVENT_ROW_COMPONENT_PROPERTY:
		g_value_set_object (value, widgets_event_row_get_component (self));
		break;
		case WIDGETS_EVENT_ROW_CAL_PROPERTY:
		g_value_set_object (value, widgets_event_row_get_cal (self));
		break;
		case WIDGETS_EVENT_ROW_SOURCE_PROPERTY:
		g_value_set_object (value, widgets_event_row_get_source (self));
		break;
		case WIDGETS_EVENT_ROW_START_TIME_PROPERTY:
		g_value_set_boxed (value, widgets_event_row_get_start_time (self));
		break;
		case WIDGETS_EVENT_ROW_END_TIME_PROPERTY:
		g_value_set_boxed (value, widgets_event_row_get_end_time (self));
		break;
		case WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY:
		g_value_set_boolean (value, widgets_event_row_get_is_allday (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_event_row_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	WidgetsEventRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow);
	switch (property_id) {
		case WIDGETS_EVENT_ROW_DATE_PROPERTY:
		widgets_event_row_set_date (self, g_value_get_boxed (value));
		break;
		case WIDGETS_EVENT_ROW_COMPONENT_PROPERTY:
		widgets_event_row_set_component (self, g_value_get_object (value));
		break;
		case WIDGETS_EVENT_ROW_CAL_PROPERTY:
		widgets_event_row_set_cal (self, g_value_get_object (value));
		break;
		case WIDGETS_EVENT_ROW_SOURCE_PROPERTY:
		widgets_event_row_set_source (self, g_value_get_object (value));
		break;
		case WIDGETS_EVENT_ROW_START_TIME_PROPERTY:
		widgets_event_row_set_start_time (self, g_value_get_boxed (value));
		break;
		case WIDGETS_EVENT_ROW_END_TIME_PROPERTY:
		widgets_event_row_set_end_time (self, g_value_get_boxed (value));
		break;
		case WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY:
		widgets_event_row_set_is_allday (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

