/* DatabaseSettings.c generated by valac 0.52.4, the Vala compiler
 * generated from DatabaseSettings.vala, do not modify */

/*
* Copyright © 2020 Roman Schaller. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Roman Schaller. <roman.schaller@gmail.com>
*/

#include "plannercore.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gio/gio.h>
#include <granite.h>

enum  {
	DIALOGS_PREFERENCES_DATABASE_SETTINGS_0_PROPERTY,
	DIALOGS_PREFERENCES_DATABASE_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* dialogs_preferences_database_settings_properties[DIALOGS_PREFERENCES_DATABASE_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DialogsPreferencesDatabaseSettingsPrivate {
	GtkLabel* current_location_content;
	GtkGrid* location_grid;
	GtkMenu* menu;
};

static gint DialogsPreferencesDatabaseSettings_private_offset;
static gpointer dialogs_preferences_database_settings_parent_class = NULL;

static void __lambda1137_ (DialogsPreferencesDatabaseSettings* self);
static void ___lambda1138_ (DialogsPreferencesDatabaseSettings* self);
static void ____lambda1138__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void ___lambda1137__gtk_button_clicked (GtkButton* _sender,
                                        gpointer self);
static void __lambda1139_ (DialogsPreferencesDatabaseSettings* self);
static void dialogs_preferences_database_settings_dialog_response (DialogsPreferencesDatabaseSettings* self,
                                                            GtkDialog* dialog,
                                                            gint response_id);
static void _dialogs_preferences_database_settings_dialog_response_gtk_dialog_response (GtkDialog* _sender,
                                                                                 gint response_id,
                                                                                 gpointer self);
static void ___lambda1139__gtk_button_clicked (GtkButton* _sender,
                                        gpointer self);
static void ____lambda1140_ (DialogsPreferencesDatabaseSettings* self,
                      gint64 current_num_bytes,
                      gint64 total_num_bytes);
static void _____lambda1140__gfile_progress_callback (gint64 current_num_bytes,
                                               gint64 total_num_bytes,
                                               gpointer self);
static void dialogs_preferences_database_settings_finalize (GObject * obj);
static GType dialogs_preferences_database_settings_get_type_once (void);

static inline gpointer
dialogs_preferences_database_settings_get_instance_private (DialogsPreferencesDatabaseSettings* self)
{
	return G_STRUCT_MEMBER_P (self, DialogsPreferencesDatabaseSettings_private_offset);
}

static void
___lambda1138_ (DialogsPreferencesDatabaseSettings* self)
{
	GraniteMessageDialog* message_dialog = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GraniteMessageDialog* _tmp5_;
	GraniteMessageDialog* _tmp6_;
	GtkButton* remove_button = NULL;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkStyleContext* _tmp9_;
	GraniteMessageDialog* _tmp10_;
	GtkButton* _tmp11_;
	GraniteMessageDialog* _tmp12_;
	GraniteMessageDialog* _tmp13_;
	GraniteMessageDialog* _tmp15_;
	_tmp0_ = g_get_user_data_dir ();
	_tmp1_ = g_strconcat (_tmp0_, "/com.github.alainm23.planner/database.db", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf (_ ("The new database location will be: <b>%s</b>"), _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Are you sure you want to restore the database location to default?"), _tmp4_, "dialog-warning", GTK_BUTTONS_CANCEL);
	g_object_ref_sink (_tmp5_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	message_dialog = _tmp6_;
	_tmp7_ = (GtkButton*) gtk_button_new_with_label (_ ("Change"));
	g_object_ref_sink (_tmp7_);
	remove_button = _tmp7_;
	_tmp8_ = remove_button;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	gtk_style_context_add_class (_tmp9_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp10_ = message_dialog;
	_tmp11_ = remove_button;
	gtk_dialog_add_action_widget ((GtkDialog*) _tmp10_, (GtkWidget*) _tmp11_, (gint) GTK_RESPONSE_ACCEPT);
	_tmp12_ = message_dialog;
	gtk_widget_show_all ((GtkWidget*) _tmp12_);
	_tmp13_ = message_dialog;
	if (gtk_dialog_run ((GtkDialog*) _tmp13_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		ServicesDatabase* _tmp14_;
		_tmp14_ = planner_database;
		services_database_reset_database_path_to_default (_tmp14_);
	}
	_tmp15_ = message_dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp15_);
	_g_object_unref0 (remove_button);
	_g_object_unref0 (message_dialog);
}

static void
____lambda1138__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
	___lambda1138_ ((DialogsPreferencesDatabaseSettings*) self);
}

static void
__lambda1137_ (DialogsPreferencesDatabaseSettings* self)
{
	GtkMenu* _tmp0_;
	GtkMenu* _tmp7_;
	_tmp0_ = self->priv->menu;
	if (_tmp0_ == NULL) {
		GtkMenu* _tmp1_;
		GtkMenuItem* reset_default = NULL;
		GtkMenuItem* _tmp2_;
		GtkMenu* _tmp3_;
		GtkMenuItem* _tmp4_;
		GtkMenu* _tmp5_;
		GtkMenuItem* _tmp6_;
		_tmp1_ = (GtkMenu*) gtk_menu_new ();
		g_object_ref_sink (_tmp1_);
		_g_object_unref0 (self->priv->menu);
		self->priv->menu = _tmp1_;
		_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Reset to default"));
		g_object_ref_sink (_tmp2_);
		reset_default = _tmp2_;
		_tmp3_ = self->priv->menu;
		_tmp4_ = reset_default;
		gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
		_tmp5_ = self->priv->menu;
		gtk_widget_show_all ((GtkWidget*) _tmp5_);
		_tmp6_ = reset_default;
		g_signal_connect_object (_tmp6_, "activate", (GCallback) ____lambda1138__gtk_menu_item_activate, self, 0);
		_g_object_unref0 (reset_default);
	}
	_tmp7_ = self->priv->menu;
	gtk_menu_popup_at_pointer (_tmp7_, NULL);
}

static void
___lambda1137__gtk_button_clicked (GtkButton* _sender,
                                   gpointer self)
{
	__lambda1137_ ((DialogsPreferencesDatabaseSettings*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_dialogs_preferences_database_settings_dialog_response_gtk_dialog_response (GtkDialog* _sender,
                                                                            gint response_id,
                                                                            gpointer self)
{
	dialogs_preferences_database_settings_dialog_response ((DialogsPreferencesDatabaseSettings*) self, _sender, response_id);
}

static void
__lambda1139_ (DialogsPreferencesDatabaseSettings* self)
{
	GraniteMessageDialog* message_dialog = NULL;
	GraniteMessageDialog* _tmp0_;
	GtkButton* remove_button = NULL;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GraniteMessageDialog* _tmp4_;
	GtkButton* _tmp5_;
	GraniteMessageDialog* _tmp6_;
	GraniteMessageDialog* _tmp7_;
	GraniteMessageDialog* _tmp25_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Are you sure you want to change the database location?"), _ ("This process will move your database file to the selected location."), "dialog-warning", GTK_BUTTONS_CANCEL);
	g_object_ref_sink (_tmp0_);
	message_dialog = _tmp0_;
	_tmp1_ = (GtkButton*) gtk_button_new_with_label (_ ("Change"));
	g_object_ref_sink (_tmp1_);
	remove_button = _tmp1_;
	_tmp2_ = remove_button;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp4_ = message_dialog;
	_tmp5_ = remove_button;
	gtk_dialog_add_action_widget ((GtkDialog*) _tmp4_, (GtkWidget*) _tmp5_, (gint) GTK_RESPONSE_ACCEPT);
	_tmp6_ = message_dialog;
	gtk_widget_show_all ((GtkWidget*) _tmp6_);
	_tmp7_ = message_dialog;
	if (gtk_dialog_run ((GtkDialog*) _tmp7_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		GtkFileChooserDialog* dialog = NULL;
		GtkFileChooserDialog* _tmp8_;
		GtkFileChooserDialog* _tmp9_;
		GtkFileFilter* filter = NULL;
		GtkFileFilter* _tmp10_;
		GtkFileFilter* _tmp11_;
		GtkFileFilter* _tmp12_;
		GtkFileChooserDialog* _tmp13_;
		GtkFileFilter* _tmp14_;
		GtkFileFilter* _tmp15_;
		GtkFileChooserDialog* _tmp16_;
		GtkFileChooserDialog* _tmp17_;
		ServicesDatabase* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GtkFileChooserDialog* _tmp23_;
		GtkFileChooserDialog* _tmp24_;
		_tmp8_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("database location"), G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_window_get_type ()) ? ((GtkWindow*) self) : NULL, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("_Cancel"), GTK_RESPONSE_CANCEL, _ ("_Open"), GTK_RESPONSE_ACCEPT, NULL);
		g_object_ref_sink (_tmp8_);
		dialog = _tmp8_;
		_tmp9_ = dialog;
		gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp9_, FALSE);
		_tmp10_ = gtk_file_filter_new ();
		g_object_ref_sink (_tmp10_);
		filter = _tmp10_;
		_tmp11_ = filter;
		gtk_file_filter_add_pattern (_tmp11_, "*.db");
		_tmp12_ = filter;
		gtk_file_filter_set_name (_tmp12_, _ ("Planner DB Files (sqlite)"));
		_tmp13_ = dialog;
		_tmp14_ = filter;
		_tmp15_ = _g_object_ref0 (_tmp14_);
		gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp13_, _tmp15_);
		_tmp16_ = dialog;
		gtk_window_set_modal ((GtkWindow*) _tmp16_, TRUE);
		_tmp17_ = dialog;
		_tmp18_ = planner_database;
		_tmp19_ = services_database_get_database_path (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_file_new_for_path (_tmp20_);
		_tmp22_ = _tmp21_;
		gtk_file_chooser_set_file ((GtkFileChooser*) _tmp17_, _tmp22_, &_inner_error0_);
		_g_object_unref0 (_tmp22_);
		_g_free0 (_tmp20_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (filter);
			_g_object_unref0 (dialog);
			_g_object_unref0 (remove_button);
			_g_object_unref0 (message_dialog);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp23_ = dialog;
		g_signal_connect_object ((GtkDialog*) _tmp23_, "response", (GCallback) _dialogs_preferences_database_settings_dialog_response_gtk_dialog_response, self, 0);
		_tmp24_ = dialog;
		gtk_widget_show ((GtkWidget*) _tmp24_);
		_g_object_unref0 (filter);
		_g_object_unref0 (dialog);
	}
	_tmp25_ = message_dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp25_);
	_g_object_unref0 (remove_button);
	_g_object_unref0 (message_dialog);
}

static void
___lambda1139__gtk_button_clicked (GtkButton* _sender,
                                   gpointer self)
{
	__lambda1139_ ((DialogsPreferencesDatabaseSettings*) self);
}

DialogsPreferencesDatabaseSettings*
dialogs_preferences_database_settings_construct (GType object_type)
{
	DialogsPreferencesDatabaseSettings * self = NULL;
	GtkLabel* database_header = NULL;
	GtkLabel* _tmp0_;
	GtkStyleContext* _tmp1_;
	ServicesDatabase* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkGrid* _tmp15_;
	GtkGrid* _tmp16_;
	GtkLabel* _tmp17_;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	ServicesDatabase* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GtkButton* change_button = NULL;
	GtkButton* _tmp25_;
	GtkButton* menu_button = NULL;
	GtkButton* _tmp26_;
	GtkGrid* button_grid = NULL;
	GtkGrid* _tmp27_;
	GtkStyleContext* _tmp28_;
	GtkImage* menu_icon = NULL;
	GtkImage* _tmp29_;
	GThemedIcon* _tmp30_;
	GThemedIcon* _tmp31_;
	GtkBox* current_location_box = NULL;
	GtkBox* _tmp32_;
	GtkGrid* _tmp33_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkSeparator* _tmp36_;
	GtkSeparator* _tmp37_;
	GtkSeparator* _tmp38_;
	GtkSeparator* _tmp39_;
	self = (DialogsPreferencesDatabaseSettings*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Database"));
	g_object_ref_sink (_tmp0_);
	database_header = _tmp0_;
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) database_header);
	gtk_style_context_add_class (_tmp1_, "font-weight-600");
	gtk_widget_set_halign ((GtkWidget*) database_header, GTK_ALIGN_START);
	_tmp2_ = planner_database;
	_tmp3_ = services_database_get_database_path (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup_printf ("<small>%s</small>", _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = (GtkLabel*) gtk_label_new (_tmp6_);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->current_location_content);
	self->priv->current_location_content = _tmp7_;
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_tmp8_ = self->priv->current_location_content;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	gtk_style_context_add_class (_tmp9_, "font-weight-600");
	_tmp10_ = self->priv->current_location_content;
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
	_tmp11_ = self->priv->current_location_content;
	gtk_label_set_use_markup (_tmp11_, TRUE);
	_tmp12_ = self->priv->current_location_content;
	gtk_label_set_ellipsize (_tmp12_, PANGO_ELLIPSIZE_MIDDLE);
	_tmp13_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->location_grid);
	self->priv->location_grid = _tmp13_;
	_tmp14_ = self->priv->location_grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp14_, GTK_ORIENTATION_VERTICAL);
	_tmp15_ = self->priv->location_grid;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) database_header);
	_tmp16_ = self->priv->location_grid;
	_tmp17_ = self->priv->current_location_content;
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = self->priv->location_grid;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp18_, 16);
	_tmp19_ = self->priv->location_grid;
	_tmp20_ = planner_database;
	_tmp21_ = services_database_get_database_path (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_strdup_printf ("Current location: %s", _tmp22_);
	_tmp24_ = _tmp23_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp19_, _ (_tmp24_));
	_g_free0 (_tmp24_);
	_g_free0 (_tmp22_);
	_tmp25_ = (GtkButton*) gtk_button_new_with_label (_ ("Change"));
	g_object_ref_sink (_tmp25_);
	change_button = _tmp25_;
	gtk_widget_set_valign ((GtkWidget*) change_button, GTK_ALIGN_CENTER);
	gtk_widget_set_can_focus ((GtkWidget*) change_button, FALSE);
	_tmp26_ = (GtkButton*) gtk_button_new_from_icon_name ("pan-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp26_);
	menu_button = _tmp26_;
	gtk_widget_set_can_focus ((GtkWidget*) menu_button, FALSE);
	_tmp27_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp27_);
	button_grid = _tmp27_;
	gtk_widget_set_valign ((GtkWidget*) button_grid, GTK_ALIGN_CENTER);
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) button_grid);
	gtk_style_context_add_class (_tmp28_, "grid-linked");
	gtk_container_add ((GtkContainer*) button_grid, (GtkWidget*) change_button);
	gtk_container_add ((GtkContainer*) button_grid, (GtkWidget*) menu_button);
	_tmp29_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp29_);
	menu_icon = _tmp29_;
	_tmp30_ = (GThemedIcon*) g_themed_icon_new ("preferences-system-symbolic");
	_tmp31_ = _tmp30_;
	g_object_set (menu_icon, "gicon", (GIcon*) _tmp31_, NULL);
	_g_object_unref0 (_tmp31_);
	gtk_image_set_pixel_size (menu_icon, 14);
	_tmp32_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp32_);
	current_location_box = _tmp32_;
	gtk_widget_set_margin_start ((GtkWidget*) current_location_box, 12);
	gtk_widget_set_margin_end ((GtkWidget*) current_location_box, 9);
	gtk_widget_set_margin_top ((GtkWidget*) current_location_box, 3);
	gtk_widget_set_margin_bottom ((GtkWidget*) current_location_box, 3);
	gtk_widget_set_hexpand ((GtkWidget*) current_location_box, TRUE);
	_tmp33_ = self->priv->location_grid;
	gtk_box_pack_start (current_location_box, (GtkWidget*) _tmp33_, FALSE, FALSE, (guint) 0);
	gtk_box_pack_end (current_location_box, (GtkWidget*) button_grid, FALSE, FALSE, (guint) 0);
	_tmp34_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp34_);
	main_box = _tmp34_;
	gtk_widget_set_margin_top ((GtkWidget*) main_box, 12);
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) main_box);
	gtk_style_context_add_class (_tmp35_, "view");
	gtk_widget_set_hexpand ((GtkWidget*) main_box, TRUE);
	_tmp36_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp36_);
	_tmp37_ = _tmp36_;
	gtk_box_pack_start (main_box, (GtkWidget*) _tmp37_, FALSE, TRUE, (guint) 0);
	_g_object_unref0 (_tmp37_);
	gtk_box_pack_start (main_box, (GtkWidget*) current_location_box, FALSE, FALSE, (guint) 0);
	_tmp38_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp38_);
	_tmp39_ = _tmp38_;
	gtk_box_pack_start (main_box, (GtkWidget*) _tmp39_, FALSE, TRUE, (guint) 0);
	_g_object_unref0 (_tmp39_);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) main_box);
	g_signal_connect_object (menu_button, "clicked", (GCallback) ___lambda1137__gtk_button_clicked, self, 0);
	g_signal_connect_object (change_button, "clicked", (GCallback) ___lambda1139__gtk_button_clicked, self, 0);
	_g_object_unref0 (main_box);
	_g_object_unref0 (current_location_box);
	_g_object_unref0 (menu_icon);
	_g_object_unref0 (button_grid);
	_g_object_unref0 (menu_button);
	_g_object_unref0 (change_button);
	_g_object_unref0 (database_header);
	return self;
}

DialogsPreferencesDatabaseSettings*
dialogs_preferences_database_settings_new (void)
{
	return dialogs_preferences_database_settings_construct (DIALOGS_PREFERENCES_TYPE_DATABASE_SETTINGS);
}

static void
____lambda1140_ (DialogsPreferencesDatabaseSettings* self,
                 gint64 current_num_bytes,
                 gint64 total_num_bytes)
{
	g_print ("%" G_GINT64_FORMAT " bytes of %" G_GINT64_FORMAT " bytes copied.\n", current_num_bytes, total_num_bytes);
}

static void
_____lambda1140__gfile_progress_callback (gint64 current_num_bytes,
                                          gint64 total_num_bytes,
                                          gpointer self)
{
	____lambda1140_ ((DialogsPreferencesDatabaseSettings*) self, current_num_bytes, total_num_bytes);
}

static void
dialogs_preferences_database_settings_dialog_response (DialogsPreferencesDatabaseSettings* self,
                                                       GtkDialog* dialog,
                                                       gint response_id)
{
	GtkFileChooserDialog* open_dialog = NULL;
	GtkFileChooserDialog* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dialog != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (dialog, gtk_file_chooser_dialog_get_type ()) ? ((GtkFileChooserDialog*) dialog) : NULL);
	open_dialog = _tmp0_;
	switch (response_id) {
		case GTK_RESPONSE_ACCEPT:
		{
			gchar* filename = NULL;
			GtkFileChooserDialog* _tmp1_;
			gchar* _tmp2_;
			GFile* file = NULL;
			const gchar* _tmp3_;
			GFile* _tmp4_;
			GFile* _tmp5_;
			ServicesDatabase* _tmp13_;
			const gchar* _tmp14_;
			GtkLabel* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GtkGrid* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp1_ = open_dialog;
			_tmp2_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp1_);
			filename = _tmp2_;
			_tmp3_ = filename;
			_tmp4_ = g_file_new_for_path (_tmp3_);
			file = _tmp4_;
			_tmp5_ = file;
			if (!g_file_query_exists (_tmp5_, NULL)) {
				GFile* old_file = NULL;
				ServicesDatabase* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				GFile* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				GFile* _tmp12_;
				_tmp6_ = planner_database;
				_tmp7_ = services_database_get_database_path (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = g_file_new_for_path (_tmp8_);
				_tmp10_ = _tmp9_;
				_g_free0 (_tmp8_);
				old_file = _tmp10_;
				_tmp11_ = old_file;
				_tmp12_ = file;
				g_file_copy (_tmp11_, _tmp12_, G_FILE_COPY_ALL_METADATA, NULL, _____lambda1140__gfile_progress_callback, self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (old_file);
					_g_object_unref0 (file);
					_g_free0 (filename);
					_g_object_unref0 (open_dialog);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
				_g_object_unref0 (old_file);
			}
			_tmp13_ = planner_database;
			_tmp14_ = filename;
			services_database_set_database_path (_tmp13_, _tmp14_);
			_tmp15_ = self->priv->current_location_content;
			_tmp16_ = filename;
			_tmp17_ = g_strdup_printf ("<small>%s</small>", _tmp16_);
			_tmp18_ = _tmp17_;
			gtk_label_set_label (_tmp15_, _tmp18_);
			_g_free0 (_tmp18_);
			_tmp19_ = self->priv->location_grid;
			_tmp20_ = filename;
			_tmp21_ = g_strdup_printf ("Current location: %s", _tmp20_);
			_tmp22_ = _tmp21_;
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp19_, _ (_tmp22_));
			_g_free0 (_tmp22_);
			_g_object_unref0 (file);
			_g_free0 (filename);
			break;
		}
		default:
		{
			break;
		}
	}
	gtk_widget_destroy ((GtkWidget*) dialog);
	_g_object_unref0 (open_dialog);
}

static void
dialogs_preferences_database_settings_class_init (DialogsPreferencesDatabaseSettingsClass * klass,
                                                  gpointer klass_data)
{
	dialogs_preferences_database_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DialogsPreferencesDatabaseSettings_private_offset);
	G_OBJECT_CLASS (klass)->finalize = dialogs_preferences_database_settings_finalize;
}

static void
dialogs_preferences_database_settings_instance_init (DialogsPreferencesDatabaseSettings * self,
                                                     gpointer klass)
{
	self->priv = dialogs_preferences_database_settings_get_instance_private (self);
	self->priv->menu = NULL;
}

static void
dialogs_preferences_database_settings_finalize (GObject * obj)
{
	DialogsPreferencesDatabaseSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIALOGS_PREFERENCES_TYPE_DATABASE_SETTINGS, DialogsPreferencesDatabaseSettings);
	_g_object_unref0 (self->priv->current_location_content);
	_g_object_unref0 (self->priv->location_grid);
	_g_object_unref0 (self->priv->menu);
	G_OBJECT_CLASS (dialogs_preferences_database_settings_parent_class)->finalize (obj);
}

static GType
dialogs_preferences_database_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DialogsPreferencesDatabaseSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dialogs_preferences_database_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DialogsPreferencesDatabaseSettings), 0, (GInstanceInitFunc) dialogs_preferences_database_settings_instance_init, NULL };
	GType dialogs_preferences_database_settings_type_id;
	dialogs_preferences_database_settings_type_id = g_type_register_static (gtk_event_box_get_type (), "DialogsPreferencesDatabaseSettings", &g_define_type_info, 0);
	DialogsPreferencesDatabaseSettings_private_offset = g_type_add_instance_private (dialogs_preferences_database_settings_type_id, sizeof (DialogsPreferencesDatabaseSettingsPrivate));
	return dialogs_preferences_database_settings_type_id;
}

GType
dialogs_preferences_database_settings_get_type (void)
{
	static volatile gsize dialogs_preferences_database_settings_type_id__volatile = 0;
	if (g_once_init_enter (&dialogs_preferences_database_settings_type_id__volatile)) {
		GType dialogs_preferences_database_settings_type_id;
		dialogs_preferences_database_settings_type_id = dialogs_preferences_database_settings_get_type_once ();
		g_once_init_leave (&dialogs_preferences_database_settings_type_id__volatile, dialogs_preferences_database_settings_type_id);
	}
	return dialogs_preferences_database_settings_type_id__volatile;
}

