/* Project.c generated by valac 0.52.4, the Vala compiler
 * generated from Project.vala, do not modify */

/*
* Copyright © 2019 Alain M. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "plannercore.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <glib-object.h>

enum  {
	OBJECTS_PROJECT_0_PROPERTY,
	OBJECTS_PROJECT_AREA_ID_PROPERTY,
	OBJECTS_PROJECT_PARENT_ID_PROPERTY,
	OBJECTS_PROJECT_ID_PROPERTY,
	OBJECTS_PROJECT_NAME_PROPERTY,
	OBJECTS_PROJECT_NOTE_PROPERTY,
	OBJECTS_PROJECT_DUE_DATE_PROPERTY,
	OBJECTS_PROJECT_COLOR_PROPERTY,
	OBJECTS_PROJECT_IS_TODOIST_PROPERTY,
	OBJECTS_PROJECT_INBOX_PROJECT_PROPERTY,
	OBJECTS_PROJECT_TEAM_INBOX_PROPERTY,
	OBJECTS_PROJECT_ITEM_ORDER_PROPERTY,
	OBJECTS_PROJECT_IS_DELETED_PROPERTY,
	OBJECTS_PROJECT_IS_ARCHIVED_PROPERTY,
	OBJECTS_PROJECT_IS_FAVORITE_PROPERTY,
	OBJECTS_PROJECT_IS_SYNC_PROPERTY,
	OBJECTS_PROJECT_SHARED_PROPERTY,
	OBJECTS_PROJECT_IS_KANBAN_PROPERTY,
	OBJECTS_PROJECT_SHOW_COMPLETED_PROPERTY,
	OBJECTS_PROJECT_SORT_ORDER_PROPERTY,
	OBJECTS_PROJECT_COLLAPSED_PROPERTY,
	OBJECTS_PROJECT_NUM_PROPERTIES
};
static GParamSpec* objects_project_properties[OBJECTS_PROJECT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block181Data Block181Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ObjectsProjectPrivate {
	gint64 _area_id;
	gint64 _parent_id;
	gint64 _id;
	gchar* _name;
	gchar* _note;
	gchar* _due_date;
	gint _color;
	gint _is_todoist;
	gint _inbox_project;
	gint _team_inbox;
	gint _item_order;
	gint _is_deleted;
	gint _is_archived;
	gint _is_favorite;
	gint64 _is_sync;
	gint _shared;
	gint _is_kanban;
	gint _show_completed;
	gint _sort_order;
	gint _collapsed;
	guint timeout_id;
};

struct _Block181Data {
	int _ref_count_;
	ObjectsProject* self;
	gboolean todoist;
};

static gint ObjectsProject_private_offset;
static gpointer objects_project_parent_class = NULL;

static Block181Data* block181_data_ref (Block181Data* _data181_);
static void block181_data_unref (void * _userdata_);
static gboolean __lambda9_ (Block181Data* _data181_);
static gboolean ___lambda9__gsource_func (gpointer self);
static void _vala_JsonNode_free (JsonNode* self);
static gchar* objects_project_to_markdown (ObjectsProject* self);
static gchar* objects_project_get_format_date (ObjectsProject* self,
                                        const gchar* due_date);
static void objects_project_finalize (GObject * obj);
static GType objects_project_get_type_once (void);
static void _vala_objects_project_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_objects_project_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
objects_project_get_instance_private (ObjectsProject* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsProject_private_offset);
}

static Block181Data*
block181_data_ref (Block181Data* _data181_)
{
	g_atomic_int_inc (&_data181_->_ref_count_);
	return _data181_;
}

static void
block181_data_unref (void * _userdata_)
{
	Block181Data* _data181_;
	_data181_ = (Block181Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data181_->_ref_count_)) {
		ObjectsProject* self;
		self = _data181_->self;
		_g_object_unref0 (self);
		g_slice_free (Block181Data, _data181_);
	}
}

static gboolean
__lambda9_ (Block181Data* _data181_)
{
	ObjectsProject* self;
	ServicesDatabase* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gboolean result = FALSE;
	self = _data181_->self;
	self->priv->timeout_id = (guint) 0;
	_tmp0_ = planner_database;
	services_database_update_project (_tmp0_, self);
	_tmp2_ = self->priv->_is_todoist;
	if (_tmp2_ == 1) {
		_tmp1_ = _data181_->todoist;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		ServicesTodoist* _tmp3_;
		_tmp3_ = planner_todoist;
		services_todoist_update_project (_tmp3_, self);
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda9_ (self);
	return result;
}

void
objects_project_save (ObjectsProject* self,
                      gboolean todoist)
{
	Block181Data* _data181_;
	g_return_if_fail (self != NULL);
	_data181_ = g_slice_new0 (Block181Data);
	_data181_->_ref_count_ = 1;
	_data181_->self = g_object_ref (self);
	_data181_->todoist = todoist;
	if (self->priv->timeout_id != ((guint) 0)) {
		g_source_remove (self->priv->timeout_id);
	}
	self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda9__gsource_func, block181_data_ref (_data181_), block181_data_unref);
	block181_data_unref (_data181_);
	_data181_ = NULL;
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

gchar*
objects_project_to_json (ObjectsProject* self)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	ServicesDatabase* _tmp3_;
	gint64 _tmp4_;
	JsonBuilder* _tmp12_;
	JsonBuilder* _tmp13_;
	const gchar* _tmp14_;
	JsonBuilder* _tmp15_;
	JsonBuilder* _tmp16_;
	gint _tmp17_;
	JsonBuilder* _tmp18_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp19_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp20_;
	JsonNode* _tmp21_;
	gchar* _tmp22_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = json_builder_new ();
	builder = _tmp0_;
	_tmp1_ = builder;
	json_builder_begin_object (_tmp1_);
	_tmp2_ = builder;
	json_builder_set_member_name (_tmp2_, "id");
	_tmp3_ = planner_database;
	_tmp4_ = self->priv->_id;
	if (services_database_curTempIds_exists (_tmp3_, _tmp4_)) {
		JsonBuilder* _tmp5_;
		ServicesDatabase* _tmp6_;
		gint64 _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp5_ = builder;
		_tmp6_ = planner_database;
		_tmp7_ = self->priv->_id;
		_tmp8_ = services_database_get_temp_id (_tmp6_, _tmp7_);
		_tmp9_ = _tmp8_;
		json_builder_add_string_value (_tmp5_, _tmp9_);
		_g_free0 (_tmp9_);
	} else {
		JsonBuilder* _tmp10_;
		gint64 _tmp11_;
		_tmp10_ = builder;
		_tmp11_ = self->priv->_id;
		json_builder_add_int_value (_tmp10_, _tmp11_);
	}
	_tmp12_ = builder;
	json_builder_set_member_name (_tmp12_, "name");
	_tmp13_ = builder;
	_tmp14_ = self->priv->_name;
	json_builder_add_string_value (_tmp13_, _tmp14_);
	_tmp15_ = builder;
	json_builder_set_member_name (_tmp15_, "color");
	_tmp16_ = builder;
	_tmp17_ = self->priv->_color;
	json_builder_add_int_value (_tmp16_, (gint64) _tmp17_);
	_tmp18_ = builder;
	json_builder_end_object (_tmp18_);
	_tmp19_ = json_generator_new ();
	generator = _tmp19_;
	_tmp20_ = builder;
	_tmp21_ = json_builder_get_root (_tmp20_);
	root = _tmp21_;
	json_generator_set_root (generator, root);
	_tmp22_ = json_generator_to_data (generator, NULL);
	result = _tmp22_;
	__vala_JsonNode_free0 (root);
	_g_object_unref0 (generator);
	_g_object_unref0 (builder);
	return result;
}

void
objects_project_share_mail (ObjectsProject* self)
{
	gchar* uri = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("");
	uri = _tmp0_;
	_tmp1_ = uri;
	_tmp2_ = self->priv->_name;
	_tmp3_ = objects_project_to_markdown (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup_printf ("mailto:?subject=%s&body=%s", _tmp2_, _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp1_, _tmp6_, NULL);
	_g_free0 (uri);
	uri = _tmp7_;
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	{
		const gchar* _tmp8_;
		_tmp8_ = uri;
		g_app_info_launch_default_for_uri (_tmp8_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("Project.vala:96: %s\n", _tmp10_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (uri);
}

void
objects_project_share_markdown (ObjectsProject* self)
{
	Planner* _tmp0_;
	Planner* _tmp1_;
	MainWindow* _tmp2_;
	GdkDisplay* _tmp3_;
	GtkClipboard* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	ServicesNotifications* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = planner_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_->main_window;
	_tmp3_ = gtk_widget_get_display ((GtkWidget*) _tmp2_);
	_tmp4_ = gtk_clipboard_get_default (_tmp3_);
	_tmp5_ = objects_project_to_markdown (self);
	_tmp6_ = _tmp5_;
	gtk_clipboard_set_text (_tmp4_, _tmp6_, -1);
	_g_free0 (_tmp6_);
	_tmp7_ = planner_notifications;
	g_signal_emit_by_name (_tmp7_, "send-notification", _ ("The Project was copied to the Clipboard."), NOTIFICATION_STYLE_NORMAL);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gchar*
objects_project_to_markdown (ObjectsProject* self)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	text = _tmp0_;
	_tmp1_ = text;
	_tmp2_ = self->priv->_name;
	_tmp3_ = g_strdup_printf ("# %s\n", _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
	_g_free0 (text);
	text = _tmp5_;
	_g_free0 (_tmp4_);
	_tmp6_ = self->priv->_note;
	if (g_strcmp0 (_tmp6_, "") != 0) {
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp7_ = text;
		_tmp8_ = self->priv->_note;
		_tmp9_ = string_replace (_tmp8_, "\n", " ");
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strdup_printf ("%s\n", _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strconcat (_tmp7_, _tmp12_, NULL);
		_g_free0 (text);
		text = _tmp13_;
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
		_tmp14_ = text;
		_tmp15_ = g_strconcat (_tmp14_, "\n", NULL);
		_g_free0 (text);
		text = _tmp15_;
	}
	{
		GeeArrayList* _item_list = NULL;
		ServicesDatabase* _tmp16_;
		gint64 _tmp17_;
		GeeArrayList* _tmp18_;
		gint _item_size = 0;
		GeeArrayList* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gint _item_index = 0;
		_tmp16_ = planner_database;
		_tmp17_ = self->priv->_id;
		_tmp18_ = services_database_get_all_items_by_project_no_section_no_parent (_tmp16_, _tmp17_);
		_item_list = _tmp18_;
		_tmp19_ = _item_list;
		_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
		_tmp21_ = _tmp20_;
		_item_size = _tmp21_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp22_;
			gint _tmp23_;
			ObjectsItem* item = NULL;
			GeeArrayList* _tmp24_;
			gpointer _tmp25_;
			const gchar* _tmp26_;
			ObjectsItem* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			_item_index = _item_index + 1;
			_tmp22_ = _item_index;
			_tmp23_ = _item_size;
			if (!(_tmp22_ < _tmp23_)) {
				break;
			}
			_tmp24_ = _item_list;
			_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, _item_index);
			item = (ObjectsItem*) _tmp25_;
			_tmp26_ = text;
			_tmp27_ = item;
			_tmp28_ = objects_item_get_content (_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = g_strdup_printf ("- [ ] %s\n", _tmp29_);
			_tmp31_ = _tmp30_;
			_tmp32_ = g_strconcat (_tmp26_, _tmp31_, NULL);
			_g_free0 (text);
			text = _tmp32_;
			_g_free0 (_tmp31_);
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_list);
	}
	{
		GeeArrayList* _section_list = NULL;
		ServicesDatabase* _tmp33_;
		gint64 _tmp34_;
		GeeArrayList* _tmp35_;
		gint _section_size = 0;
		GeeArrayList* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _section_index = 0;
		_tmp33_ = planner_database;
		_tmp34_ = self->priv->_id;
		_tmp35_ = services_database_get_all_sections_by_project (_tmp33_, _tmp34_);
		_section_list = _tmp35_;
		_tmp36_ = _section_list;
		_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
		_tmp38_ = _tmp37_;
		_section_size = _tmp38_;
		_section_index = -1;
		while (TRUE) {
			gint _tmp39_;
			gint _tmp40_;
			ObjectsSection* section = NULL;
			GeeArrayList* _tmp41_;
			gpointer _tmp42_;
			const gchar* _tmp43_;
			gchar* _tmp44_;
			const gchar* _tmp45_;
			ObjectsSection* _tmp46_;
			const gchar* _tmp47_;
			const gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			_section_index = _section_index + 1;
			_tmp39_ = _section_index;
			_tmp40_ = _section_size;
			if (!(_tmp39_ < _tmp40_)) {
				break;
			}
			_tmp41_ = _section_list;
			_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, _section_index);
			section = (ObjectsSection*) _tmp42_;
			_tmp43_ = text;
			_tmp44_ = g_strconcat (_tmp43_, "\n", NULL);
			_g_free0 (text);
			text = _tmp44_;
			_tmp45_ = text;
			_tmp46_ = section;
			_tmp47_ = objects_section_get_name (_tmp46_);
			_tmp48_ = _tmp47_;
			_tmp49_ = g_strdup_printf ("## %s\n", _tmp48_);
			_tmp50_ = _tmp49_;
			_tmp51_ = g_strconcat (_tmp45_, _tmp50_, NULL);
			_g_free0 (text);
			text = _tmp51_;
			_g_free0 (_tmp50_);
			{
				GeeArrayList* _item_list = NULL;
				ServicesDatabase* _tmp52_;
				ObjectsSection* _tmp53_;
				GeeArrayList* _tmp54_;
				gint _item_size = 0;
				GeeArrayList* _tmp55_;
				gint _tmp56_;
				gint _tmp57_;
				gint _item_index = 0;
				_tmp52_ = planner_database;
				_tmp53_ = section;
				_tmp54_ = services_database_get_all_items_by_section_no_parent (_tmp52_, _tmp53_);
				_item_list = _tmp54_;
				_tmp55_ = _item_list;
				_tmp56_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp55_);
				_tmp57_ = _tmp56_;
				_item_size = _tmp57_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp58_;
					gint _tmp59_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp60_;
					gpointer _tmp61_;
					const gchar* _tmp62_;
					ObjectsItem* _tmp63_;
					const gchar* _tmp64_;
					const gchar* _tmp65_;
					gchar* _tmp66_;
					gchar* _tmp67_;
					ObjectsItem* _tmp68_;
					const gchar* _tmp69_;
					const gchar* _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
					_item_index = _item_index + 1;
					_tmp58_ = _item_index;
					_tmp59_ = _item_size;
					if (!(_tmp58_ < _tmp59_)) {
						break;
					}
					_tmp60_ = _item_list;
					_tmp61_ = gee_abstract_list_get ((GeeAbstractList*) _tmp60_, _item_index);
					item = (ObjectsItem*) _tmp61_;
					_tmp62_ = text;
					_tmp63_ = item;
					_tmp64_ = objects_item_get_due_date (_tmp63_);
					_tmp65_ = _tmp64_;
					_tmp66_ = objects_project_get_format_date (self, _tmp65_);
					_tmp67_ = _tmp66_;
					_tmp68_ = item;
					_tmp69_ = objects_item_get_content (_tmp68_);
					_tmp70_ = _tmp69_;
					_tmp71_ = g_strdup_printf ("- [ ]%s%s\n", _tmp67_, _tmp70_);
					_tmp72_ = _tmp71_;
					_tmp73_ = g_strconcat (_tmp62_, _tmp72_, NULL);
					_g_free0 (text);
					text = _tmp73_;
					_g_free0 (_tmp72_);
					_g_free0 (_tmp67_);
					{
						GeeArrayList* _check_list = NULL;
						ServicesDatabase* _tmp74_;
						ObjectsItem* _tmp75_;
						gint64 _tmp76_;
						gint64 _tmp77_;
						GeeArrayList* _tmp78_;
						gint _check_size = 0;
						GeeArrayList* _tmp79_;
						gint _tmp80_;
						gint _tmp81_;
						gint _check_index = 0;
						_tmp74_ = planner_database;
						_tmp75_ = item;
						_tmp76_ = objects_item_get_id (_tmp75_);
						_tmp77_ = _tmp76_;
						_tmp78_ = services_database_get_all_cheks_by_item (_tmp74_, _tmp77_);
						_check_list = _tmp78_;
						_tmp79_ = _check_list;
						_tmp80_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp79_);
						_tmp81_ = _tmp80_;
						_check_size = _tmp81_;
						_check_index = -1;
						while (TRUE) {
							gint _tmp82_;
							gint _tmp83_;
							ObjectsItem* check = NULL;
							GeeArrayList* _tmp84_;
							gpointer _tmp85_;
							const gchar* _tmp86_;
							ObjectsItem* _tmp87_;
							const gchar* _tmp88_;
							const gchar* _tmp89_;
							gchar* _tmp90_;
							gchar* _tmp91_;
							gchar* _tmp92_;
							_check_index = _check_index + 1;
							_tmp82_ = _check_index;
							_tmp83_ = _check_size;
							if (!(_tmp82_ < _tmp83_)) {
								break;
							}
							_tmp84_ = _check_list;
							_tmp85_ = gee_abstract_list_get ((GeeAbstractList*) _tmp84_, _check_index);
							check = (ObjectsItem*) _tmp85_;
							_tmp86_ = text;
							_tmp87_ = check;
							_tmp88_ = objects_item_get_content (_tmp87_);
							_tmp89_ = _tmp88_;
							_tmp90_ = g_strdup_printf ("  - [ ] %s\n", _tmp89_);
							_tmp91_ = _tmp90_;
							_tmp92_ = g_strconcat (_tmp86_, _tmp91_, NULL);
							_g_free0 (text);
							text = _tmp92_;
							_g_free0 (_tmp91_);
							_g_object_unref0 (check);
						}
						_g_object_unref0 (_check_list);
					}
					_g_object_unref0 (item);
				}
				_g_object_unref0 (_item_list);
			}
			_g_object_unref0 (section);
		}
		_g_object_unref0 (_section_list);
	}
	result = text;
	return result;
}

static gchar*
objects_project_get_format_date (ObjectsProject* self,
                                 const gchar* due_date)
{
	Utils* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (due_date != NULL, NULL);
	if (g_strcmp0 (due_date, "") == 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (" ");
		result = _tmp0_;
		return result;
	}
	_tmp1_ = planner_utils;
	_tmp2_ = utils_get_default_date_format_from_string (_tmp1_, due_date);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (" (", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp5_, ") ", NULL);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	result = _tmp7_;
	return result;
}

ObjectsProject*
objects_project_construct (GType object_type)
{
	ObjectsProject * self = NULL;
	self = (ObjectsProject*) g_object_new (object_type, NULL);
	return self;
}

ObjectsProject*
objects_project_new (void)
{
	return objects_project_construct (OBJECTS_TYPE_PROJECT);
}

gint64
objects_project_get_area_id (ObjectsProject* self)
{
	gint64 result;
	g_return_val_if_fail (self != NULL, 0LL);
	result = self->priv->_area_id;
	return result;
}

void
objects_project_set_area_id (ObjectsProject* self,
                             gint64 value)
{
	gint64 old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_area_id (self);
	if (old_value != value) {
		self->priv->_area_id = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_AREA_ID_PROPERTY]);
	}
}

gint64
objects_project_get_parent_id (ObjectsProject* self)
{
	gint64 result;
	g_return_val_if_fail (self != NULL, 0LL);
	result = self->priv->_parent_id;
	return result;
}

void
objects_project_set_parent_id (ObjectsProject* self,
                               gint64 value)
{
	gint64 old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_parent_id (self);
	if (old_value != value) {
		self->priv->_parent_id = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_PARENT_ID_PROPERTY]);
	}
}

gint64
objects_project_get_id (ObjectsProject* self)
{
	gint64 result;
	g_return_val_if_fail (self != NULL, 0LL);
	result = self->priv->_id;
	return result;
}

void
objects_project_set_id (ObjectsProject* self,
                        gint64 value)
{
	gint64 old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_id (self);
	if (old_value != value) {
		self->priv->_id = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_ID_PROPERTY]);
	}
}

const gchar*
objects_project_get_name (ObjectsProject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
objects_project_set_name (ObjectsProject* self,
                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_NAME_PROPERTY]);
	}
}

const gchar*
objects_project_get_note (ObjectsProject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_note;
	result = _tmp0_;
	return result;
}

void
objects_project_set_note (ObjectsProject* self,
                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_note (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_note);
		self->priv->_note = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_NOTE_PROPERTY]);
	}
}

const gchar*
objects_project_get_due_date (ObjectsProject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_due_date;
	result = _tmp0_;
	return result;
}

void
objects_project_set_due_date (ObjectsProject* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_due_date (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_due_date);
		self->priv->_due_date = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_DUE_DATE_PROPERTY]);
	}
}

gint
objects_project_get_color (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_color;
	return result;
}

void
objects_project_set_color (ObjectsProject* self,
                           gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_color (self);
	if (old_value != value) {
		self->priv->_color = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_COLOR_PROPERTY]);
	}
}

gint
objects_project_get_is_todoist (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_is_todoist;
	return result;
}

void
objects_project_set_is_todoist (ObjectsProject* self,
                                gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_is_todoist (self);
	if (old_value != value) {
		self->priv->_is_todoist = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_IS_TODOIST_PROPERTY]);
	}
}

gint
objects_project_get_inbox_project (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_inbox_project;
	return result;
}

void
objects_project_set_inbox_project (ObjectsProject* self,
                                   gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_inbox_project (self);
	if (old_value != value) {
		self->priv->_inbox_project = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_INBOX_PROJECT_PROPERTY]);
	}
}

gint
objects_project_get_team_inbox (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_team_inbox;
	return result;
}

void
objects_project_set_team_inbox (ObjectsProject* self,
                                gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_team_inbox (self);
	if (old_value != value) {
		self->priv->_team_inbox = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_TEAM_INBOX_PROPERTY]);
	}
}

gint
objects_project_get_item_order (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_item_order;
	return result;
}

void
objects_project_set_item_order (ObjectsProject* self,
                                gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_item_order (self);
	if (old_value != value) {
		self->priv->_item_order = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_ITEM_ORDER_PROPERTY]);
	}
}

gint
objects_project_get_is_deleted (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_is_deleted;
	return result;
}

void
objects_project_set_is_deleted (ObjectsProject* self,
                                gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_is_deleted (self);
	if (old_value != value) {
		self->priv->_is_deleted = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_IS_DELETED_PROPERTY]);
	}
}

gint
objects_project_get_is_archived (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_is_archived;
	return result;
}

void
objects_project_set_is_archived (ObjectsProject* self,
                                 gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_is_archived (self);
	if (old_value != value) {
		self->priv->_is_archived = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_IS_ARCHIVED_PROPERTY]);
	}
}

gint
objects_project_get_is_favorite (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_is_favorite;
	return result;
}

void
objects_project_set_is_favorite (ObjectsProject* self,
                                 gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_is_favorite (self);
	if (old_value != value) {
		self->priv->_is_favorite = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_IS_FAVORITE_PROPERTY]);
	}
}

gint64
objects_project_get_is_sync (ObjectsProject* self)
{
	gint64 result;
	g_return_val_if_fail (self != NULL, 0LL);
	result = self->priv->_is_sync;
	return result;
}

void
objects_project_set_is_sync (ObjectsProject* self,
                             gint64 value)
{
	gint64 old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_is_sync (self);
	if (old_value != value) {
		self->priv->_is_sync = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_IS_SYNC_PROPERTY]);
	}
}

gint
objects_project_get_shared (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_shared;
	return result;
}

void
objects_project_set_shared (ObjectsProject* self,
                            gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_shared (self);
	if (old_value != value) {
		self->priv->_shared = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_SHARED_PROPERTY]);
	}
}

gint
objects_project_get_is_kanban (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_is_kanban;
	return result;
}

void
objects_project_set_is_kanban (ObjectsProject* self,
                               gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_is_kanban (self);
	if (old_value != value) {
		self->priv->_is_kanban = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_IS_KANBAN_PROPERTY]);
	}
}

gint
objects_project_get_show_completed (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_show_completed;
	return result;
}

void
objects_project_set_show_completed (ObjectsProject* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_show_completed (self);
	if (old_value != value) {
		self->priv->_show_completed = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_SHOW_COMPLETED_PROPERTY]);
	}
}

gint
objects_project_get_sort_order (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_sort_order;
	return result;
}

void
objects_project_set_sort_order (ObjectsProject* self,
                                gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_sort_order (self);
	if (old_value != value) {
		self->priv->_sort_order = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_SORT_ORDER_PROPERTY]);
	}
}

gint
objects_project_get_collapsed (ObjectsProject* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_collapsed;
	return result;
}

void
objects_project_set_collapsed (ObjectsProject* self,
                               gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_project_get_collapsed (self);
	if (old_value != value) {
		self->priv->_collapsed = value;
		g_object_notify_by_pspec ((GObject *) self, objects_project_properties[OBJECTS_PROJECT_COLLAPSED_PROPERTY]);
	}
}

static void
objects_project_class_init (ObjectsProjectClass * klass,
                            gpointer klass_data)
{
	objects_project_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ObjectsProject_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_project_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_project_set_property;
	G_OBJECT_CLASS (klass)->finalize = objects_project_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_AREA_ID_PROPERTY, objects_project_properties[OBJECTS_PROJECT_AREA_ID_PROPERTY] = g_param_spec_int64 ("area-id", "area-id", "area-id", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_PARENT_ID_PROPERTY, objects_project_properties[OBJECTS_PROJECT_PARENT_ID_PROPERTY] = g_param_spec_int64 ("parent-id", "parent-id", "parent-id", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_ID_PROPERTY, objects_project_properties[OBJECTS_PROJECT_ID_PROPERTY] = g_param_spec_int64 ("id", "id", "id", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_NAME_PROPERTY, objects_project_properties[OBJECTS_PROJECT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_NOTE_PROPERTY, objects_project_properties[OBJECTS_PROJECT_NOTE_PROPERTY] = g_param_spec_string ("note", "note", "note", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_DUE_DATE_PROPERTY, objects_project_properties[OBJECTS_PROJECT_DUE_DATE_PROPERTY] = g_param_spec_string ("due-date", "due-date", "due-date", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_COLOR_PROPERTY, objects_project_properties[OBJECTS_PROJECT_COLOR_PROPERTY] = g_param_spec_int ("color", "color", "color", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_IS_TODOIST_PROPERTY, objects_project_properties[OBJECTS_PROJECT_IS_TODOIST_PROPERTY] = g_param_spec_int ("is-todoist", "is-todoist", "is-todoist", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_INBOX_PROJECT_PROPERTY, objects_project_properties[OBJECTS_PROJECT_INBOX_PROJECT_PROPERTY] = g_param_spec_int ("inbox-project", "inbox-project", "inbox-project", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_TEAM_INBOX_PROPERTY, objects_project_properties[OBJECTS_PROJECT_TEAM_INBOX_PROPERTY] = g_param_spec_int ("team-inbox", "team-inbox", "team-inbox", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_ITEM_ORDER_PROPERTY, objects_project_properties[OBJECTS_PROJECT_ITEM_ORDER_PROPERTY] = g_param_spec_int ("item-order", "item-order", "item-order", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_IS_DELETED_PROPERTY, objects_project_properties[OBJECTS_PROJECT_IS_DELETED_PROPERTY] = g_param_spec_int ("is-deleted", "is-deleted", "is-deleted", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_IS_ARCHIVED_PROPERTY, objects_project_properties[OBJECTS_PROJECT_IS_ARCHIVED_PROPERTY] = g_param_spec_int ("is-archived", "is-archived", "is-archived", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_IS_FAVORITE_PROPERTY, objects_project_properties[OBJECTS_PROJECT_IS_FAVORITE_PROPERTY] = g_param_spec_int ("is-favorite", "is-favorite", "is-favorite", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_IS_SYNC_PROPERTY, objects_project_properties[OBJECTS_PROJECT_IS_SYNC_PROPERTY] = g_param_spec_int64 ("is-sync", "is-sync", "is-sync", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_SHARED_PROPERTY, objects_project_properties[OBJECTS_PROJECT_SHARED_PROPERTY] = g_param_spec_int ("shared", "shared", "shared", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_IS_KANBAN_PROPERTY, objects_project_properties[OBJECTS_PROJECT_IS_KANBAN_PROPERTY] = g_param_spec_int ("is-kanban", "is-kanban", "is-kanban", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_SHOW_COMPLETED_PROPERTY, objects_project_properties[OBJECTS_PROJECT_SHOW_COMPLETED_PROPERTY] = g_param_spec_int ("show-completed", "show-completed", "show-completed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_SORT_ORDER_PROPERTY, objects_project_properties[OBJECTS_PROJECT_SORT_ORDER_PROPERTY] = g_param_spec_int ("sort-order", "sort-order", "sort-order", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_PROJECT_COLLAPSED_PROPERTY, objects_project_properties[OBJECTS_PROJECT_COLLAPSED_PROPERTY] = g_param_spec_int ("collapsed", "collapsed", "collapsed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
objects_project_instance_init (ObjectsProject * self,
                               gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	self->priv = objects_project_get_instance_private (self);
	self->priv->_area_id = (gint64) 0;
	self->priv->_parent_id = (gint64) 0;
	self->priv->_id = (gint64) 0;
	_tmp0_ = g_strdup ("");
	self->priv->_name = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->_note = _tmp1_;
	_tmp2_ = g_strdup ("");
	self->priv->_due_date = _tmp2_;
	self->priv->_color = 0;
	self->priv->_is_todoist = 0;
	self->priv->_inbox_project = 0;
	self->priv->_team_inbox = 0;
	self->priv->_item_order = 0;
	self->priv->_is_deleted = 0;
	self->priv->_is_archived = 0;
	self->priv->_is_favorite = 0;
	self->priv->_is_sync = (gint64) 0;
	self->priv->_shared = 0;
	self->priv->_is_kanban = 0;
	self->priv->_show_completed = 0;
	self->priv->_sort_order = 0;
	self->priv->_collapsed = 0;
	self->priv->timeout_id = (guint) 0;
}

static void
objects_project_finalize (GObject * obj)
{
	ObjectsProject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_PROJECT, ObjectsProject);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_note);
	_g_free0 (self->priv->_due_date);
	G_OBJECT_CLASS (objects_project_parent_class)->finalize (obj);
}

static GType
objects_project_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsProjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_project_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsProject), 0, (GInstanceInitFunc) objects_project_instance_init, NULL };
	GType objects_project_type_id;
	objects_project_type_id = g_type_register_static (G_TYPE_OBJECT, "ObjectsProject", &g_define_type_info, 0);
	ObjectsProject_private_offset = g_type_add_instance_private (objects_project_type_id, sizeof (ObjectsProjectPrivate));
	return objects_project_type_id;
}

GType
objects_project_get_type (void)
{
	static volatile gsize objects_project_type_id__volatile = 0;
	if (g_once_init_enter (&objects_project_type_id__volatile)) {
		GType objects_project_type_id;
		objects_project_type_id = objects_project_get_type_once ();
		g_once_init_leave (&objects_project_type_id__volatile, objects_project_type_id);
	}
	return objects_project_type_id__volatile;
}

static void
_vala_objects_project_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ObjectsProject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_PROJECT, ObjectsProject);
	switch (property_id) {
		case OBJECTS_PROJECT_AREA_ID_PROPERTY:
		g_value_set_int64 (value, objects_project_get_area_id (self));
		break;
		case OBJECTS_PROJECT_PARENT_ID_PROPERTY:
		g_value_set_int64 (value, objects_project_get_parent_id (self));
		break;
		case OBJECTS_PROJECT_ID_PROPERTY:
		g_value_set_int64 (value, objects_project_get_id (self));
		break;
		case OBJECTS_PROJECT_NAME_PROPERTY:
		g_value_set_string (value, objects_project_get_name (self));
		break;
		case OBJECTS_PROJECT_NOTE_PROPERTY:
		g_value_set_string (value, objects_project_get_note (self));
		break;
		case OBJECTS_PROJECT_DUE_DATE_PROPERTY:
		g_value_set_string (value, objects_project_get_due_date (self));
		break;
		case OBJECTS_PROJECT_COLOR_PROPERTY:
		g_value_set_int (value, objects_project_get_color (self));
		break;
		case OBJECTS_PROJECT_IS_TODOIST_PROPERTY:
		g_value_set_int (value, objects_project_get_is_todoist (self));
		break;
		case OBJECTS_PROJECT_INBOX_PROJECT_PROPERTY:
		g_value_set_int (value, objects_project_get_inbox_project (self));
		break;
		case OBJECTS_PROJECT_TEAM_INBOX_PROPERTY:
		g_value_set_int (value, objects_project_get_team_inbox (self));
		break;
		case OBJECTS_PROJECT_ITEM_ORDER_PROPERTY:
		g_value_set_int (value, objects_project_get_item_order (self));
		break;
		case OBJECTS_PROJECT_IS_DELETED_PROPERTY:
		g_value_set_int (value, objects_project_get_is_deleted (self));
		break;
		case OBJECTS_PROJECT_IS_ARCHIVED_PROPERTY:
		g_value_set_int (value, objects_project_get_is_archived (self));
		break;
		case OBJECTS_PROJECT_IS_FAVORITE_PROPERTY:
		g_value_set_int (value, objects_project_get_is_favorite (self));
		break;
		case OBJECTS_PROJECT_IS_SYNC_PROPERTY:
		g_value_set_int64 (value, objects_project_get_is_sync (self));
		break;
		case OBJECTS_PROJECT_SHARED_PROPERTY:
		g_value_set_int (value, objects_project_get_shared (self));
		break;
		case OBJECTS_PROJECT_IS_KANBAN_PROPERTY:
		g_value_set_int (value, objects_project_get_is_kanban (self));
		break;
		case OBJECTS_PROJECT_SHOW_COMPLETED_PROPERTY:
		g_value_set_int (value, objects_project_get_show_completed (self));
		break;
		case OBJECTS_PROJECT_SORT_ORDER_PROPERTY:
		g_value_set_int (value, objects_project_get_sort_order (self));
		break;
		case OBJECTS_PROJECT_COLLAPSED_PROPERTY:
		g_value_set_int (value, objects_project_get_collapsed (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_objects_project_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ObjectsProject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_PROJECT, ObjectsProject);
	switch (property_id) {
		case OBJECTS_PROJECT_AREA_ID_PROPERTY:
		objects_project_set_area_id (self, g_value_get_int64 (value));
		break;
		case OBJECTS_PROJECT_PARENT_ID_PROPERTY:
		objects_project_set_parent_id (self, g_value_get_int64 (value));
		break;
		case OBJECTS_PROJECT_ID_PROPERTY:
		objects_project_set_id (self, g_value_get_int64 (value));
		break;
		case OBJECTS_PROJECT_NAME_PROPERTY:
		objects_project_set_name (self, g_value_get_string (value));
		break;
		case OBJECTS_PROJECT_NOTE_PROPERTY:
		objects_project_set_note (self, g_value_get_string (value));
		break;
		case OBJECTS_PROJECT_DUE_DATE_PROPERTY:
		objects_project_set_due_date (self, g_value_get_string (value));
		break;
		case OBJECTS_PROJECT_COLOR_PROPERTY:
		objects_project_set_color (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_IS_TODOIST_PROPERTY:
		objects_project_set_is_todoist (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_INBOX_PROJECT_PROPERTY:
		objects_project_set_inbox_project (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_TEAM_INBOX_PROPERTY:
		objects_project_set_team_inbox (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_ITEM_ORDER_PROPERTY:
		objects_project_set_item_order (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_IS_DELETED_PROPERTY:
		objects_project_set_is_deleted (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_IS_ARCHIVED_PROPERTY:
		objects_project_set_is_archived (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_IS_FAVORITE_PROPERTY:
		objects_project_set_is_favorite (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_IS_SYNC_PROPERTY:
		objects_project_set_is_sync (self, g_value_get_int64 (value));
		break;
		case OBJECTS_PROJECT_SHARED_PROPERTY:
		objects_project_set_shared (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_IS_KANBAN_PROPERTY:
		objects_project_set_is_kanban (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_SHOW_COMPLETED_PROPERTY:
		objects_project_set_show_completed (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_SORT_ORDER_PROPERTY:
		objects_project_set_sort_order (self, g_value_get_int (value));
		break;
		case OBJECTS_PROJECT_COLLAPSED_PROPERTY:
		objects_project_set_collapsed (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

