/* Notifications.c generated by valac 0.52.4, the Vala compiler
 * generated from Notifications.vala, do not modify */

/*
* Copyright © 2019 Alain M. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "plannercore.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <granite.h>
#include <float.h>
#include <math.h>

enum  {
	SERVICES_NOTIFICATIONS_0_PROPERTY,
	SERVICES_NOTIFICATIONS_NUM_PROPERTIES
};
static GParamSpec* services_notifications_properties[SERVICES_NOTIFICATIONS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block42Data Block42Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block43Data Block43Data;
enum  {
	SERVICES_NOTIFICATIONS_SEND_NOTIFICATION_SIGNAL,
	SERVICES_NOTIFICATIONS_SEND_UNDO_NOTIFICATION_SIGNAL,
	SERVICES_NOTIFICATIONS_NUM_SIGNALS
};
static guint services_notifications_signals[SERVICES_NOTIFICATIONS_NUM_SIGNALS] = {0};

struct _ServicesNotificationsPrivate {
	GeeHashMap* reminders;
	GTimeSpan time;
};

struct _Block42Data {
	int _ref_count_;
	ServicesNotifications* self;
	ObjectsReminder* reminder;
};

struct _Block43Data {
	int _ref_count_;
	Block42Data * _data42_;
	gchar* uid;
};

static gint ServicesNotifications_private_offset;
static gpointer services_notifications_parent_class = NULL;

static GTimeSpan services_notifications_time_until_tomorrow (ServicesNotifications* self);
static void services_notifications_load_today_reminders (ServicesNotifications* self);
static gboolean __lambda18_ (ServicesNotifications* self);
static gboolean ___lambda18__gsource_func (gpointer self);
static void services_notifications_reminder_added (ServicesNotifications* self,
                                            ObjectsReminder* reminder);
static void __lambda16_ (ServicesNotifications* self,
                  ObjectsReminder* reminder);
static void ___lambda16__services_database_reminder_added (ServicesDatabase* _sender,
                                                    ObjectsReminder* reminder,
                                                    gpointer self);
static void __lambda17_ (ServicesNotifications* self,
                  gint64 id);
static void ___lambda17__services_database_reminder_deleted (ServicesDatabase* _sender,
                                                      gint64 id,
                                                      gpointer self);
static Block42Data* block42_data_ref (Block42Data* _data42_);
static void block42_data_unref (void * _userdata_);
static Block43Data* block43_data_ref (Block43Data* _data43_);
static void block43_data_unref (void * _userdata_);
static GTimeSpan services_notifications_time_until_now (ServicesNotifications* self,
                                                 GDateTime* dt);
static gboolean ____lambda15_ (Block43Data* _data43_);
static gboolean _____lambda15__gsource_func (gpointer self);
static void g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void services_notifications_finalize (GObject * obj);
static GType services_notifications_get_type_once (void);

static inline gpointer
services_notifications_get_instance_private (ServicesNotifications* self)
{
	return G_STRUCT_MEMBER_P (self, ServicesNotifications_private_offset);
}

static gboolean
__lambda18_ (ServicesNotifications* self)
{
	ServicesEventBus* _tmp0_;
	GeeHashMap* _tmp1_;
	gboolean result = FALSE;
	self->priv->time = services_notifications_time_until_tomorrow (self);
	_tmp0_ = planner_event_bus;
	g_signal_emit_by_name (_tmp0_, "day-changed");
	_tmp1_ = self->priv->reminders;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
	services_notifications_load_today_reminders (self);
	result = TRUE;
	return result;
}

static gboolean
___lambda18__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda18_ ((ServicesNotifications*) self);
	return result;
}

void
services_notifications_init_server (ServicesNotifications* self)
{
	g_return_if_fail (self != NULL);
	self->priv->time = services_notifications_time_until_tomorrow (self);
	services_notifications_load_today_reminders (self);
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, ((guint) self->priv->time) + 1, ___lambda18__gsource_func, g_object_ref (self), g_object_unref);
}

static void
__lambda16_ (ServicesNotifications* self,
             ObjectsReminder* reminder)
{
	g_return_if_fail (reminder != NULL);
	services_notifications_reminder_added (self, reminder);
}

static void
___lambda16__services_database_reminder_added (ServicesDatabase* _sender,
                                               ObjectsReminder* reminder,
                                               gpointer self)
{
	__lambda16_ ((ServicesNotifications*) self, reminder);
}

static void
__lambda17_ (ServicesNotifications* self,
             gint64 id)
{
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	_tmp0_ = self->priv->reminders;
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		GeeHashMap* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = self->priv->reminders;
		_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
		_tmp6_ = _tmp5_;
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, _tmp6_, NULL);
		_g_free0 (_tmp6_);
	}
}

static void
___lambda17__services_database_reminder_deleted (ServicesDatabase* _sender,
                                                 gint64 id,
                                                 gpointer self)
{
	__lambda17_ ((ServicesNotifications*) self, id);
}

static void
services_notifications_load_today_reminders (ServicesNotifications* self)
{
	GeeHashMap* _tmp0_;
	ServicesDatabase* _tmp11_;
	ServicesDatabase* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->reminders);
	self->priv->reminders = _tmp0_;
	{
		GeeArrayList* _reminder_list = NULL;
		ServicesDatabase* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _reminder_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _reminder_index = 0;
		_tmp1_ = planner_database;
		_tmp2_ = services_database_get_reminders (_tmp1_);
		_reminder_list = _tmp2_;
		_tmp3_ = _reminder_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_reminder_size = _tmp5_;
		_reminder_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			ObjectsReminder* reminder = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			ObjectsReminder* _tmp10_;
			_reminder_index = _reminder_index + 1;
			_tmp6_ = _reminder_index;
			_tmp7_ = _reminder_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _reminder_list;
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _reminder_index);
			reminder = (ObjectsReminder*) _tmp9_;
			_tmp10_ = reminder;
			services_notifications_reminder_added (self, _tmp10_);
			_g_object_unref0 (reminder);
		}
		_g_object_unref0 (_reminder_list);
	}
	_tmp11_ = planner_database;
	g_signal_connect_object (_tmp11_, "reminder-added", (GCallback) ___lambda16__services_database_reminder_added, self, 0);
	_tmp12_ = planner_database;
	g_signal_connect_object (_tmp12_, "reminder-deleted", (GCallback) ___lambda17__services_database_reminder_deleted, self, 0);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block42Data*
block42_data_ref (Block42Data* _data42_)
{
	g_atomic_int_inc (&_data42_->_ref_count_);
	return _data42_;
}

static void
block42_data_unref (void * _userdata_)
{
	Block42Data* _data42_;
	_data42_ = (Block42Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data42_->_ref_count_)) {
		ServicesNotifications* self;
		self = _data42_->self;
		_g_object_unref0 (_data42_->reminder);
		_g_object_unref0 (self);
		g_slice_free (Block42Data, _data42_);
	}
}

static Block43Data*
block43_data_ref (Block43Data* _data43_)
{
	g_atomic_int_inc (&_data43_->_ref_count_);
	return _data43_;
}

static void
block43_data_unref (void * _userdata_)
{
	Block43Data* _data43_;
	_data43_ = (Block43Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data43_->_ref_count_)) {
		ServicesNotifications* self;
		self = _data43_->_data42_->self;
		_g_free0 (_data43_->uid);
		block42_data_unref (_data43_->_data42_);
		_data43_->_data42_ = NULL;
		g_slice_free (Block43Data, _data43_);
	}
}

static gboolean
____lambda15_ (Block43Data* _data43_)
{
	Block42Data* _data42_;
	ServicesNotifications* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	gboolean result = FALSE;
	_data42_ = _data43_->_data42_;
	self = _data42_->self;
	_tmp0_ = objects_reminder_get_id (_data42_->reminder);
	_tmp1_ = _tmp0_;
	_tmp2_ = _data43_->uid;
	services_notifications_queue_reminder_notification (self, _tmp1_, _tmp2_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
_____lambda15__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda15_ (self);
	return result;
}

static void
services_notifications_reminder_added (ServicesNotifications* self,
                                       ObjectsReminder* reminder)
{
	Block42Data* _data42_;
	ObjectsReminder* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (reminder != NULL);
	_data42_ = g_slice_new0 (Block42Data);
	_data42_->_ref_count_ = 1;
	_data42_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (reminder);
	_g_object_unref0 (_data42_->reminder);
	_data42_->reminder = _tmp0_;
	_tmp1_ = objects_reminder_get_datetime (_data42_->reminder);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_date_time_new_now_local ();
	_tmp4_ = _tmp3_;
	_tmp5_ = g_date_time_compare (_tmp2_, _tmp4_) <= 0;
	_g_date_time_unref0 (_tmp4_);
	if (_tmp5_) {
		GNotification* notification = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		GNotification* _tmp8_;
		GNotification* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GNotification* _tmp12_;
		GThemedIcon* _tmp13_;
		GThemedIcon* _tmp14_;
		GNotification* _tmp15_;
		GNotification* _tmp16_;
		gint64 _tmp17_;
		gint64 _tmp18_;
		GVariant* _tmp19_;
		GVariant* _tmp20_;
		Planner* _tmp21_;
		Planner* _tmp22_;
		gint64 _tmp23_;
		gint64 _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GNotification* _tmp27_;
		ServicesDatabase* _tmp28_;
		gint64 _tmp29_;
		gint64 _tmp30_;
		_tmp6_ = objects_reminder_get_project_name (_data42_->reminder);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_notification_new (_tmp7_);
		notification = _tmp8_;
		_tmp9_ = notification;
		_tmp10_ = objects_reminder_get_content (_data42_->reminder);
		_tmp11_ = _tmp10_;
		g_notification_set_body (_tmp9_, _tmp11_);
		_tmp12_ = notification;
		_tmp13_ = (GThemedIcon*) g_themed_icon_new ("com.github.alainm23.planner");
		_tmp14_ = _tmp13_;
		g_notification_set_icon (_tmp12_, (GIcon*) _tmp14_);
		_g_object_unref0 (_tmp14_);
		_tmp15_ = notification;
		g_notification_set_priority (_tmp15_, G_NOTIFICATION_PRIORITY_URGENT);
		_tmp16_ = notification;
		_tmp17_ = objects_reminder_get_item_id (_data42_->reminder);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_variant_new_int64 (_tmp18_);
		g_variant_ref_sink (_tmp19_);
		_tmp20_ = _tmp19_;
		g_notification_set_default_action_and_target_value (_tmp16_, "app.show-item", _tmp20_);
		_g_variant_unref0 (_tmp20_);
		_tmp21_ = planner_get_instance ();
		_tmp22_ = _tmp21_;
		_tmp23_ = objects_reminder_get_id (_data42_->reminder);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = notification;
		g_application_send_notification ((GApplication*) _tmp22_, _tmp26_, _tmp27_);
		_g_free0 (_tmp26_);
		_tmp28_ = planner_database;
		_tmp29_ = objects_reminder_get_id (_data42_->reminder);
		_tmp30_ = _tmp29_;
		services_database_delete_reminder (_tmp28_, _tmp30_);
		_g_object_unref0 (notification);
	} else {
		GDateTime* _tmp31_;
		GDateTime* _tmp32_;
		GDateTime* _tmp33_;
		GDateTime* _tmp34_;
		gboolean _tmp35_;
		_tmp31_ = objects_reminder_get_datetime (_data42_->reminder);
		_tmp32_ = _tmp31_;
		_tmp33_ = g_date_time_new_now_local ();
		_tmp34_ = _tmp33_;
		_tmp35_ = granite_date_time_is_same_day (_tmp32_, _tmp34_);
		_g_date_time_unref0 (_tmp34_);
		if (_tmp35_) {
			Block43Data* _data43_;
			guint interval = 0U;
			GDateTime* _tmp36_;
			GDateTime* _tmp37_;
			gchar* _tmp38_;
			GeeHashMap* _tmp39_;
			gint64 _tmp40_;
			gint64 _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			const gchar* _tmp44_;
			_data43_ = g_slice_new0 (Block43Data);
			_data43_->_ref_count_ = 1;
			_data43_->_data42_ = block42_data_ref (_data42_);
			_tmp36_ = objects_reminder_get_datetime (_data42_->reminder);
			_tmp37_ = _tmp36_;
			interval = (guint) services_notifications_time_until_now (self, _tmp37_);
			_tmp38_ = g_strdup_printf ("%u-%u", interval, (guint) g_random_int ());
			_data43_->uid = _tmp38_;
			_tmp39_ = self->priv->reminders;
			_tmp40_ = objects_reminder_get_id (_data42_->reminder);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp41_);
			_tmp43_ = _tmp42_;
			_tmp44_ = _data43_->uid;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp39_, _tmp43_, _tmp44_);
			_g_free0 (_tmp43_);
			g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, interval, _____lambda15__gsource_func, block43_data_ref (_data43_), block43_data_unref);
			block43_data_unref (_data43_);
			_data43_ = NULL;
		}
	}
	block42_data_unref (_data42_);
	_data42_ = NULL;
}

void
services_notifications_queue_reminder_notification (ServicesNotifications* self,
                                                    gint64 reminder_id,
                                                    const gchar* uid)
{
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_;
	ObjectsReminder* reminder = NULL;
	ServicesDatabase* _tmp5_;
	ObjectsReminder* _tmp6_;
	GNotification* notification = NULL;
	ObjectsReminder* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GNotification* _tmp10_;
	GNotification* _tmp11_;
	ObjectsReminder* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GNotification* _tmp15_;
	GThemedIcon* _tmp16_;
	GThemedIcon* _tmp17_;
	GNotification* _tmp18_;
	GNotification* _tmp19_;
	ObjectsReminder* _tmp20_;
	gint64 _tmp21_;
	gint64 _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	Planner* _tmp25_;
	Planner* _tmp26_;
	GNotification* _tmp27_;
	ServicesDatabase* _tmp28_;
	ObjectsReminder* _tmp29_;
	gint64 _tmp30_;
	gint64 _tmp31_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (uid != NULL);
	_tmp0_ = self->priv->reminders;
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_collection_contains (_tmp3_, uid) == FALSE;
	_g_object_unref0 (_tmp3_);
	if (_tmp4_) {
		return;
	}
	_tmp5_ = planner_database;
	_tmp6_ = services_database_get_reminder_by_id (_tmp5_, reminder_id);
	reminder = _tmp6_;
	_tmp7_ = reminder;
	_tmp8_ = objects_reminder_get_project_name (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_notification_new (_tmp9_);
	notification = _tmp10_;
	_tmp11_ = notification;
	_tmp12_ = reminder;
	_tmp13_ = objects_reminder_get_content (_tmp12_);
	_tmp14_ = _tmp13_;
	g_notification_set_body (_tmp11_, _tmp14_);
	_tmp15_ = notification;
	_tmp16_ = (GThemedIcon*) g_themed_icon_new ("com.github.alainm23.planner");
	_tmp17_ = _tmp16_;
	g_notification_set_icon (_tmp15_, (GIcon*) _tmp17_);
	_g_object_unref0 (_tmp17_);
	_tmp18_ = notification;
	g_notification_set_priority (_tmp18_, G_NOTIFICATION_PRIORITY_URGENT);
	_tmp19_ = notification;
	_tmp20_ = reminder;
	_tmp21_ = objects_reminder_get_item_id (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_variant_new_int64 (_tmp22_);
	g_variant_ref_sink (_tmp23_);
	_tmp24_ = _tmp23_;
	g_notification_set_default_action_and_target_value (_tmp19_, "app.show-item", _tmp24_);
	_g_variant_unref0 (_tmp24_);
	_tmp25_ = planner_get_instance ();
	_tmp26_ = _tmp25_;
	_tmp27_ = notification;
	g_application_send_notification ((GApplication*) _tmp26_, uid, _tmp27_);
	_tmp28_ = planner_database;
	_tmp29_ = reminder;
	_tmp30_ = objects_reminder_get_id (_tmp29_);
	_tmp31_ = _tmp30_;
	services_database_delete_reminder (_tmp28_, _tmp31_);
	_g_object_unref0 (notification);
	_g_object_unref0 (reminder);
}

static GTimeSpan
services_notifications_time_until_now (ServicesNotifications* self,
                                       GDateTime* dt)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan result = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	g_return_val_if_fail (dt != NULL, 0LL);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	result = g_date_time_difference (dt, now) / G_TIME_SPAN_SECOND;
	_g_date_time_unref0 (now);
	return result;
}

static GTimeSpan
services_notifications_time_until_tomorrow (ServicesNotifications* self)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GDateTime* tomorrow = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	GTimeSpan result = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = g_date_time_add_days (now, 1);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_date_time_add_days (now, 1);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_date_time_add_days (now, 1);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_date_time_new_local (g_date_time_get_year (_tmp2_), g_date_time_get_month (_tmp4_), g_date_time_get_day_of_month (_tmp6_), 0, 0, (gdouble) 0);
	_tmp8_ = _tmp7_;
	_g_date_time_unref0 (_tmp6_);
	_g_date_time_unref0 (_tmp4_);
	_g_date_time_unref0 (_tmp2_);
	tomorrow = _tmp8_;
	result = g_date_time_difference (tomorrow, now) / G_TIME_SPAN_SECOND;
	_g_date_time_unref0 (tomorrow);
	_g_date_time_unref0 (now);
	return result;
}

void
services_notifications_send_system_notification (ServicesNotifications* self,
                                                 const gchar* title,
                                                 const gchar* body,
                                                 const gchar* icon_name,
                                                 GNotificationPriority priority)
{
	GNotification* notification = NULL;
	GNotification* _tmp0_;
	GThemedIcon* _tmp1_;
	GThemedIcon* _tmp2_;
	Planner* _tmp3_;
	Planner* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	g_return_if_fail (body != NULL);
	g_return_if_fail (icon_name != NULL);
	_tmp0_ = g_notification_new (title);
	notification = _tmp0_;
	g_notification_set_body (notification, body);
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (icon_name);
	_tmp2_ = _tmp1_;
	g_notification_set_icon (notification, (GIcon*) _tmp2_);
	_g_object_unref0 (_tmp2_);
	g_notification_set_priority (notification, priority);
	_tmp3_ = planner_get_instance ();
	_tmp4_ = _tmp3_;
	g_application_send_notification ((GApplication*) _tmp4_, "com.github.alainm23.planner", notification);
	_g_object_unref0 (notification);
}

ServicesNotifications*
services_notifications_construct (GType object_type)
{
	ServicesNotifications * self = NULL;
	self = (ServicesNotifications*) g_object_new (object_type, NULL);
	return self;
}

ServicesNotifications*
services_notifications_new (void)
{
	return services_notifications_construct (SERVICES_TYPE_NOTIFICATIONS);
}

static void
g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_ENUM) (gpointer data1, const char* arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_enum (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
services_notifications_class_init (ServicesNotificationsClass * klass,
                                   gpointer klass_data)
{
	services_notifications_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ServicesNotifications_private_offset);
	G_OBJECT_CLASS (klass)->finalize = services_notifications_finalize;
	services_notifications_signals[SERVICES_NOTIFICATIONS_SEND_NOTIFICATION_SIGNAL] = g_signal_new ("send-notification", SERVICES_TYPE_NOTIFICATIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_ENUM, G_TYPE_NONE, 2, G_TYPE_STRING, TYPE_NOTIFICATION_STYLE);
	services_notifications_signals[SERVICES_NOTIFICATIONS_SEND_UNDO_NOTIFICATION_SIGNAL] = g_signal_new ("send-undo-notification", SERVICES_TYPE_NOTIFICATIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
}

static void
services_notifications_instance_init (ServicesNotifications * self,
                                      gpointer klass)
{
	self->priv = services_notifications_get_instance_private (self);
}

static void
services_notifications_finalize (GObject * obj)
{
	ServicesNotifications * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_NOTIFICATIONS, ServicesNotifications);
	_g_object_unref0 (self->priv->reminders);
	G_OBJECT_CLASS (services_notifications_parent_class)->finalize (obj);
}

static GType
services_notifications_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServicesNotificationsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_notifications_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesNotifications), 0, (GInstanceInitFunc) services_notifications_instance_init, NULL };
	GType services_notifications_type_id;
	services_notifications_type_id = g_type_register_static (G_TYPE_OBJECT, "ServicesNotifications", &g_define_type_info, 0);
	ServicesNotifications_private_offset = g_type_add_instance_private (services_notifications_type_id, sizeof (ServicesNotificationsPrivate));
	return services_notifications_type_id;
}

GType
services_notifications_get_type (void)
{
	static volatile gsize services_notifications_type_id__volatile = 0;
	if (g_once_init_enter (&services_notifications_type_id__volatile)) {
		GType services_notifications_type_id;
		services_notifications_type_id = services_notifications_get_type_once ();
		g_once_init_leave (&services_notifications_type_id__volatile, services_notifications_type_id);
	}
	return services_notifications_type_id__volatile;
}

