/* Calendar.c generated by valac 0.52.4, the Vala compiler
 * generated from Calendar.vala, do not modify */

/*
* Copyright © 2019 Alain M. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "plannercore.h"
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

enum  {
	WIDGETS_CALENDAR_CALENDAR_0_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_NUM_PROPERTIES
};
static GParamSpec* widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	WIDGETS_CALENDAR_CALENDAR_SELECTION_CHANGED_SIGNAL,
	WIDGETS_CALENDAR_CALENDAR_NUM_SIGNALS
};
static guint widgets_calendar_calendar_signals[WIDGETS_CALENDAR_CALENDAR_NUM_SIGNALS] = {0};

struct _WidgetsCalendarCalendarPrivate {
	WidgetsCalendarCalendarHeader* calendar_header;
	WidgetsCalendarCalendarWeek* calendar_week;
	WidgetsCalendarCalendarView* calendar_view;
	gboolean _block_past_days;
	gint month_nav;
	gint year_nav;
	gint day_nav;
	GDateTime* current_date;
	GDateTime* _date;
};

static gint WidgetsCalendarCalendar_private_offset;
static gpointer widgets_calendar_calendar_parent_class = NULL;

static void widgets_calendar_calendar_today (WidgetsCalendarCalendar* self);
static GObject * widgets_calendar_calendar_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _widgets_calendar_calendar___lambda72_ (WidgetsCalendarCalendar* self);
static void __widgets_calendar_calendar___lambda72__widgets_calendar_calendar_header_left_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                            gpointer self);
static void _widgets_calendar_calendar___lambda73_ (WidgetsCalendarCalendar* self);
static void __widgets_calendar_calendar___lambda73__widgets_calendar_calendar_header_center_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                              gpointer self);
static void _widgets_calendar_calendar___lambda74_ (WidgetsCalendarCalendar* self);
static void __widgets_calendar_calendar___lambda74__widgets_calendar_calendar_header_right_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                             gpointer self);
static void _widgets_calendar_calendar___lambda75_ (WidgetsCalendarCalendar* self,
                                             gint day);
static void __widgets_calendar_calendar___lambda75__widgets_calendar_calendar_view_day_selected (WidgetsCalendarCalendarView* _sender,
                                                                                          gint day,
                                                                                          gpointer self);
static void _widgets_calendar_calendar___lambda76_ (WidgetsCalendarCalendar* self,
                                             const gchar* key);
static void __widgets_calendar_calendar___lambda76__g_settings_changed (GSettings* _sender,
                                                                 const gchar* key,
                                                                 gpointer self);
static void widgets_calendar_calendar_finalize (GObject * obj);
static GType widgets_calendar_calendar_get_type_once (void);
static void _vala_widgets_calendar_calendar_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_widgets_calendar_calendar_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

static inline gpointer
widgets_calendar_calendar_get_instance_private (WidgetsCalendarCalendar* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsCalendarCalendar_private_offset);
}

WidgetsCalendarCalendar*
widgets_calendar_calendar_construct (GType object_type,
                                     gboolean block_past_days)
{
	WidgetsCalendarCalendar * self = NULL;
	self = (WidgetsCalendarCalendar*) g_object_new (object_type, "block-past-days", block_past_days, NULL);
	return self;
}

WidgetsCalendarCalendar*
widgets_calendar_calendar_new (gboolean block_past_days)
{
	return widgets_calendar_calendar_construct (WIDGETS_CALENDAR_TYPE_CALENDAR, block_past_days);
}

void
widgets_calendar_calendar_next_month (WidgetsCalendarCalendar* self)
{
	GDateTime* date = NULL;
	GDateTime* _tmp0_;
	GDateTime* firts_week = NULL;
	GDateTime* _tmp1_;
	gint start_day = 0;
	GSettings* _tmp2_;
	gint max_days = 0;
	Utils* _tmp3_;
	WidgetsCalendarCalendarView* _tmp4_;
	Utils* _tmp5_;
	gboolean _tmp6_;
	WidgetsCalendarCalendarHeader* _tmp7_;
	g_return_if_fail (self != NULL);
	self->priv->month_nav = self->priv->month_nav + 1;
	if (self->priv->month_nav > 12) {
		self->priv->year_nav = self->priv->year_nav + 1;
		self->priv->month_nav = 1;
	}
	_tmp0_ = g_date_time_new_local (self->priv->year_nav, self->priv->month_nav, 1, 0, 0, (gdouble) 0);
	date = _tmp0_;
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), 1, 0, 0, (gdouble) 0);
	firts_week = _tmp1_;
	_tmp2_ = planner_settings;
	start_day = g_date_time_get_day_of_week (firts_week) - g_settings_get_enum (_tmp2_, "start-week");
	_tmp3_ = planner_utils;
	max_days = utils_get_days_of_month (_tmp3_, g_date_time_get_month (date), self->priv->year_nav);
	_tmp4_ = self->priv->calendar_view;
	_tmp5_ = planner_utils;
	_tmp6_ = self->priv->_block_past_days;
	widgets_calendar_calendar_view_fill_grid_days (_tmp4_, start_day, max_days, g_date_time_get_day_of_month (date), utils_is_current_month (_tmp5_, date), _tmp6_, date);
	_tmp7_ = self->priv->calendar_header;
	widgets_calendar_calendar_header_set_date (_tmp7_, date);
	_g_date_time_unref0 (firts_week);
	_g_date_time_unref0 (date);
}

void
widgets_calendar_calendar_previous_month (WidgetsCalendarCalendar* self)
{
	GDateTime* date = NULL;
	GDateTime* _tmp0_;
	GDateTime* firts_week = NULL;
	GDateTime* _tmp1_;
	gint start_day = 0;
	GSettings* _tmp2_;
	gint max_days = 0;
	Utils* _tmp3_;
	WidgetsCalendarCalendarView* _tmp4_;
	Utils* _tmp5_;
	gboolean _tmp6_;
	WidgetsCalendarCalendarHeader* _tmp7_;
	g_return_if_fail (self != NULL);
	self->priv->month_nav = self->priv->month_nav - 1;
	if (self->priv->month_nav < 1) {
		self->priv->year_nav = self->priv->year_nav - 1;
		self->priv->month_nav = 12;
	}
	_tmp0_ = g_date_time_new_local (self->priv->year_nav, self->priv->month_nav, 1, 0, 0, (gdouble) 0);
	date = _tmp0_;
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), 1, 0, 0, (gdouble) 0);
	firts_week = _tmp1_;
	_tmp2_ = planner_settings;
	start_day = g_date_time_get_day_of_week (firts_week) - g_settings_get_enum (_tmp2_, "start-week");
	_tmp3_ = planner_utils;
	max_days = utils_get_days_of_month (_tmp3_, g_date_time_get_month (date), self->priv->year_nav);
	_tmp4_ = self->priv->calendar_view;
	_tmp5_ = planner_utils;
	_tmp6_ = self->priv->_block_past_days;
	widgets_calendar_calendar_view_fill_grid_days (_tmp4_, start_day, max_days, g_date_time_get_day_of_month (date), utils_is_current_month (_tmp5_, date), _tmp6_, date);
	_tmp7_ = self->priv->calendar_header;
	widgets_calendar_calendar_header_set_date (_tmp7_, date);
	_g_date_time_unref0 (firts_week);
	_g_date_time_unref0 (date);
}

static void
widgets_calendar_calendar_today (WidgetsCalendarCalendar* self)
{
	gint year = 0;
	GDateTime* _tmp0_;
	gint month = 0;
	GDateTime* _tmp1_;
	gint day = 0;
	GDateTime* _tmp2_;
	GDateTime* firts_week = NULL;
	GDateTime* _tmp3_;
	gint start_day = 0;
	GSettings* _tmp4_;
	gint max_days = 0;
	Utils* _tmp5_;
	GDateTime* _tmp6_;
	WidgetsCalendarCalendarView* _tmp7_;
	gboolean _tmp8_;
	GDateTime* _tmp9_;
	WidgetsCalendarCalendarHeader* _tmp10_;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->current_date;
	year = g_date_time_get_year (_tmp0_);
	_tmp1_ = self->priv->current_date;
	month = g_date_time_get_month (_tmp1_);
	_tmp2_ = self->priv->current_date;
	day = g_date_time_get_day_of_month (_tmp2_);
	self->priv->month_nav = month;
	self->priv->year_nav = year;
	self->priv->day_nav = day;
	_tmp3_ = g_date_time_new_local (year, month, 1, 0, 0, (gdouble) 0);
	firts_week = _tmp3_;
	_tmp4_ = planner_settings;
	start_day = g_date_time_get_day_of_week (firts_week) - g_settings_get_enum (_tmp4_, "start-week");
	_tmp5_ = planner_utils;
	_tmp6_ = self->priv->current_date;
	max_days = utils_get_days_of_month (_tmp5_, g_date_time_get_month (_tmp6_), self->priv->year_nav);
	_tmp7_ = self->priv->calendar_view;
	_tmp8_ = self->priv->_block_past_days;
	_tmp9_ = self->priv->current_date;
	widgets_calendar_calendar_view_fill_grid_days (_tmp7_, start_day, max_days, day, TRUE, _tmp8_, _tmp9_);
	_tmp10_ = self->priv->calendar_header;
	_tmp11_ = self->priv->current_date;
	widgets_calendar_calendar_header_set_date (_tmp10_, _tmp11_);
	_tmp12_ = g_date_time_new_now_local ();
	_tmp13_ = _tmp12_;
	g_signal_emit (self, widgets_calendar_calendar_signals[WIDGETS_CALENDAR_CALENDAR_SELECTION_CHANGED_SIGNAL], 0, _tmp13_);
	_g_date_time_unref0 (_tmp13_);
	_g_date_time_unref0 (firts_week);
}

gboolean
widgets_calendar_calendar_get_block_past_days (WidgetsCalendarCalendar* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_block_past_days;
	return result;
}

static void
widgets_calendar_calendar_set_block_past_days (WidgetsCalendarCalendar* self,
                                               gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_calendar_calendar_get_block_past_days (self);
	if (old_value != value) {
		self->priv->_block_past_days = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY]);
	}
}

GDateTime*
widgets_calendar_calendar_get_date (WidgetsCalendarCalendar* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_new_local (self->priv->year_nav, self->priv->month_nav, self->priv->day_nav, 0, 0, (gdouble) 0);
	_g_date_time_unref0 (self->priv->_date);
	self->priv->_date = _tmp0_;
	_tmp1_ = self->priv->_date;
	result = _tmp1_;
	return result;
}

static void
_widgets_calendar_calendar___lambda72_ (WidgetsCalendarCalendar* self)
{
	widgets_calendar_calendar_previous_month (self);
}

static void
__widgets_calendar_calendar___lambda72__widgets_calendar_calendar_header_left_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                       gpointer self)
{
	_widgets_calendar_calendar___lambda72_ ((WidgetsCalendarCalendar*) self);
}

static void
_widgets_calendar_calendar___lambda73_ (WidgetsCalendarCalendar* self)
{
	widgets_calendar_calendar_today (self);
}

static void
__widgets_calendar_calendar___lambda73__widgets_calendar_calendar_header_center_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                         gpointer self)
{
	_widgets_calendar_calendar___lambda73_ ((WidgetsCalendarCalendar*) self);
}

static void
_widgets_calendar_calendar___lambda74_ (WidgetsCalendarCalendar* self)
{
	widgets_calendar_calendar_next_month (self);
}

static void
__widgets_calendar_calendar___lambda74__widgets_calendar_calendar_header_right_clicked (WidgetsCalendarCalendarHeader* _sender,
                                                                                        gpointer self)
{
	_widgets_calendar_calendar___lambda74_ ((WidgetsCalendarCalendar*) self);
}

static void
_widgets_calendar_calendar___lambda75_ (WidgetsCalendarCalendar* self,
                                        gint day)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	self->priv->day_nav = day;
	_tmp0_ = g_date_time_new_local (self->priv->year_nav, self->priv->month_nav, self->priv->day_nav, 0, 0, (gdouble) 0);
	_tmp1_ = _tmp0_;
	g_signal_emit (self, widgets_calendar_calendar_signals[WIDGETS_CALENDAR_CALENDAR_SELECTION_CHANGED_SIGNAL], 0, _tmp1_);
	_g_date_time_unref0 (_tmp1_);
}

static void
__widgets_calendar_calendar___lambda75__widgets_calendar_calendar_view_day_selected (WidgetsCalendarCalendarView* _sender,
                                                                                     gint day,
                                                                                     gpointer self)
{
	_widgets_calendar_calendar___lambda75_ ((WidgetsCalendarCalendar*) self, day);
}

static void
_widgets_calendar_calendar___lambda76_ (WidgetsCalendarCalendar* self,
                                        const gchar* key)
{
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "start-week") == 0) {
		WidgetsCalendarCalendarWeek* _tmp0_;
		_tmp0_ = self->priv->calendar_week;
		widgets_calendar_calendar_week_update (_tmp0_);
		widgets_calendar_calendar_today (self);
	}
}

static void
__widgets_calendar_calendar___lambda76__g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self)
{
	_widgets_calendar_calendar___lambda76_ ((WidgetsCalendarCalendar*) self, key);
}

static GObject *
widgets_calendar_calendar_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsCalendarCalendar * self;
	GDateTime* _tmp0_;
	WidgetsCalendarCalendarHeader* _tmp1_;
	WidgetsCalendarCalendarWeek* _tmp2_;
	WidgetsCalendarCalendarView* _tmp3_;
	WidgetsCalendarCalendarHeader* _tmp4_;
	WidgetsCalendarCalendarWeek* _tmp5_;
	WidgetsCalendarCalendarView* _tmp6_;
	WidgetsCalendarCalendarHeader* _tmp7_;
	WidgetsCalendarCalendarHeader* _tmp8_;
	WidgetsCalendarCalendarHeader* _tmp9_;
	WidgetsCalendarCalendarView* _tmp10_;
	GSettings* _tmp11_;
	parent_class = G_OBJECT_CLASS (widgets_calendar_calendar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_CALENDAR_TYPE_CALENDAR, WidgetsCalendarCalendar);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	gtk_widget_set_margin_start ((GtkWidget*) self, 9);
	gtk_widget_set_margin_end ((GtkWidget*) self, 6);
	g_object_set ((GtkWidget*) self, "height-request", 200, NULL);
	_tmp0_ = g_date_time_new_now_local ();
	_g_date_time_unref0 (self->priv->current_date);
	self->priv->current_date = _tmp0_;
	_tmp1_ = widgets_calendar_calendar_header_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->calendar_header);
	self->priv->calendar_header = _tmp1_;
	_tmp2_ = widgets_calendar_calendar_week_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->calendar_week);
	self->priv->calendar_week = _tmp2_;
	_tmp3_ = widgets_calendar_calendar_view_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->calendar_view);
	self->priv->calendar_view = _tmp3_;
	_tmp4_ = self->priv->calendar_header;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp4_, TRUE, TRUE, (guint) 0);
	_tmp5_ = self->priv->calendar_week;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp5_, TRUE, TRUE, (guint) 0);
	_tmp6_ = self->priv->calendar_view;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp6_, TRUE, TRUE, (guint) 0);
	widgets_calendar_calendar_today (self);
	_tmp7_ = self->priv->calendar_header;
	g_signal_connect_object (_tmp7_, "left-clicked", (GCallback) __widgets_calendar_calendar___lambda72__widgets_calendar_calendar_header_left_clicked, self, 0);
	_tmp8_ = self->priv->calendar_header;
	g_signal_connect_object (_tmp8_, "center-clicked", (GCallback) __widgets_calendar_calendar___lambda73__widgets_calendar_calendar_header_center_clicked, self, 0);
	_tmp9_ = self->priv->calendar_header;
	g_signal_connect_object (_tmp9_, "right-clicked", (GCallback) __widgets_calendar_calendar___lambda74__widgets_calendar_calendar_header_right_clicked, self, 0);
	_tmp10_ = self->priv->calendar_view;
	g_signal_connect_object (_tmp10_, "day-selected", (GCallback) __widgets_calendar_calendar___lambda75__widgets_calendar_calendar_view_day_selected, self, 0);
	_tmp11_ = planner_settings;
	g_signal_connect_object (_tmp11_, "changed", (GCallback) __widgets_calendar_calendar___lambda76__g_settings_changed, self, 0);
	return obj;
}

static void
widgets_calendar_calendar_class_init (WidgetsCalendarCalendarClass * klass,
                                      gpointer klass_data)
{
	widgets_calendar_calendar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsCalendarCalendar_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_calendar_calendar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_calendar_calendar_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_calendar_calendar_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_calendar_calendar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY, widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY] = g_param_spec_boolean ("block-past-days", "block-past-days", "block-past-days", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY, widgets_calendar_calendar_properties[WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	widgets_calendar_calendar_signals[WIDGETS_CALENDAR_CALENDAR_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", WIDGETS_CALENDAR_TYPE_CALENDAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, G_TYPE_DATE_TIME);
}

static void
widgets_calendar_calendar_instance_init (WidgetsCalendarCalendar * self,
                                         gpointer klass)
{
	self->priv = widgets_calendar_calendar_get_instance_private (self);
}

static void
widgets_calendar_calendar_finalize (GObject * obj)
{
	WidgetsCalendarCalendar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_CALENDAR_TYPE_CALENDAR, WidgetsCalendarCalendar);
	_g_object_unref0 (self->priv->calendar_header);
	_g_object_unref0 (self->priv->calendar_week);
	_g_object_unref0 (self->priv->calendar_view);
	_g_date_time_unref0 (self->priv->current_date);
	_g_date_time_unref0 (self->priv->_date);
	G_OBJECT_CLASS (widgets_calendar_calendar_parent_class)->finalize (obj);
}

static GType
widgets_calendar_calendar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsCalendarCalendarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_calendar_calendar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsCalendarCalendar), 0, (GInstanceInitFunc) widgets_calendar_calendar_instance_init, NULL };
	GType widgets_calendar_calendar_type_id;
	widgets_calendar_calendar_type_id = g_type_register_static (gtk_box_get_type (), "WidgetsCalendarCalendar", &g_define_type_info, 0);
	WidgetsCalendarCalendar_private_offset = g_type_add_instance_private (widgets_calendar_calendar_type_id, sizeof (WidgetsCalendarCalendarPrivate));
	return widgets_calendar_calendar_type_id;
}

GType
widgets_calendar_calendar_get_type (void)
{
	static volatile gsize widgets_calendar_calendar_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_calendar_calendar_type_id__volatile)) {
		GType widgets_calendar_calendar_type_id;
		widgets_calendar_calendar_type_id = widgets_calendar_calendar_get_type_once ();
		g_once_init_leave (&widgets_calendar_calendar_type_id__volatile, widgets_calendar_calendar_type_id);
	}
	return widgets_calendar_calendar_type_id__volatile;
}

static void
_vala_widgets_calendar_calendar_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	WidgetsCalendarCalendar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_CALENDAR_TYPE_CALENDAR, WidgetsCalendarCalendar);
	switch (property_id) {
		case WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY:
		g_value_set_boolean (value, widgets_calendar_calendar_get_block_past_days (self));
		break;
		case WIDGETS_CALENDAR_CALENDAR_DATE_PROPERTY:
		g_value_set_boxed (value, widgets_calendar_calendar_get_date (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_calendar_calendar_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	WidgetsCalendarCalendar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_CALENDAR_TYPE_CALENDAR, WidgetsCalendarCalendar);
	switch (property_id) {
		case WIDGETS_CALENDAR_CALENDAR_BLOCK_PAST_DAYS_PROPERTY:
		widgets_calendar_calendar_set_block_past_days (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

