/* LabelRow.c generated by valac 0.52.4, the Vala compiler
 * generated from LabelRow.vala, do not modify */

/*
* Copyright © 2019 Alain M. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "plannercore.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

enum  {
	WIDGETS_LABEL_ROW_0_PROPERTY,
	WIDGETS_LABEL_ROW_LABEL_PROPERTY,
	WIDGETS_LABEL_ROW_SCROLLED_PROPERTY,
	WIDGETS_LABEL_ROW_NUM_PROPERTIES
};
static GParamSpec* widgets_label_row_properties[WIDGETS_LABEL_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block114Data Block114Data;

struct _WidgetsLabelRowPrivate {
	ObjectsLabel* _label;
	GtkScrolledWindow* _scrolled;
	GtkEntry* name_entry;
	GtkLabel* name_label;
	GtkStack* name_stack;
	GtkPopover* popover;
	GtkToggleButton* color_button;
	GtkRevealer* buttons_revealer;
	GtkRevealer* motion_revealer;
	GtkSeparator* separator;
	gint color_selected;
	gboolean scroll_up;
	gboolean scrolling;
	gboolean should_scroll;
	gboolean entry_menu_opened;
};

struct _Block114Data {
	int _ref_count_;
	WidgetsLabelRow* self;
	GtkButton* delete_button;
};

static gint WidgetsLabelRow_private_offset;
static gpointer widgets_label_row_parent_class = NULL;

#define WIDGETS_LABEL_ROW_SCROLL_STEP_SIZE 5
#define WIDGETS_LABEL_ROW_SCROLL_DISTANCE 30
#define WIDGETS_LABEL_ROW_SCROLL_DELAY 50
static void widgets_label_row_build_drag_and_drop (WidgetsLabelRow* self);
static void widgets_label_row_on_drag_begin (WidgetsLabelRow* self,
                                      GtkWidget* widget,
                                      GdkDragContext* context);
static void _widgets_label_row_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self);
static void widgets_label_row_on_drag_data_get (WidgetsLabelRow* self,
                                         GtkWidget* widget,
                                         GdkDragContext* context,
                                         GtkSelectionData* selection_data,
                                         guint target_type,
                                         guint time);
static void _widgets_label_row_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   GtkSelectionData* selection_data,
                                                                   guint info,
                                                                   guint time_,
                                                                   gpointer self);
static gboolean _widgets_label_row_on_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   gint x,
                                                                   gint y,
                                                                   guint time_,
                                                                   gpointer self);
static void _widgets_label_row_on_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             guint time_,
                                                             gpointer self);
static void _widgets_label_row_clear_indicator_gtk_widget_drag_end (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self);
static void widgets_label_row_check_scroll (WidgetsLabelRow* self,
                                     gint y);
static gboolean widgets_label_row_scroll (WidgetsLabelRow* self);
static gboolean _widgets_label_row_scroll_gsource_func (gpointer self);
static void widgets_label_row_save (WidgetsLabelRow* self);
static void widgets_label_row_create_popover (WidgetsLabelRow* self);
static void __lambda384_ (WidgetsLabelRow* self);
static void ___lambda384__gtk_popover_closed (GtkPopover* _sender,
                                       gpointer self);
static void __lambda385_ (WidgetsLabelRow* self);
static void ___lambda385__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda386_ (WidgetsLabelRow* self);
static void ___lambda386__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda387_ (WidgetsLabelRow* self);
static void ___lambda387__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda388_ (WidgetsLabelRow* self);
static void ___lambda388__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda389_ (WidgetsLabelRow* self);
static void ___lambda389__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda390_ (WidgetsLabelRow* self);
static void ___lambda390__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda391_ (WidgetsLabelRow* self);
static void ___lambda391__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda392_ (WidgetsLabelRow* self);
static void ___lambda392__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda393_ (WidgetsLabelRow* self);
static void ___lambda393__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda394_ (WidgetsLabelRow* self);
static void ___lambda394__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda395_ (WidgetsLabelRow* self);
static void ___lambda395__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda396_ (WidgetsLabelRow* self);
static void ___lambda396__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda397_ (WidgetsLabelRow* self);
static void ___lambda397__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda398_ (WidgetsLabelRow* self);
static void ___lambda398__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda399_ (WidgetsLabelRow* self);
static void ___lambda399__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda400_ (WidgetsLabelRow* self);
static void ___lambda400__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda401_ (WidgetsLabelRow* self);
static void ___lambda401__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda402_ (WidgetsLabelRow* self);
static void ___lambda402__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda403_ (WidgetsLabelRow* self);
static void ___lambda403__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void __lambda404_ (WidgetsLabelRow* self);
static void ___lambda404__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static GObject * widgets_label_row_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block114Data* block114_data_ref (Block114Data* _data114_);
static void block114_data_unref (void * _userdata_);
static gboolean _widgets_label_row___lambda405_ (Block114Data* _data114_,
                                          GdkEventCrossing* event);
static gboolean __widgets_label_row___lambda405__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                         GdkEventCrossing* event,
                                                                         gpointer self);
static gboolean _widgets_label_row___lambda406_ (Block114Data* _data114_,
                                          GdkEventCrossing* event);
static gboolean __widgets_label_row___lambda406__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                         GdkEventCrossing* event,
                                                                         gpointer self);
static void _widgets_label_row___lambda407_ (WidgetsLabelRow* self);
static void __widgets_label_row___lambda407__gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static void _widgets_label_row___lambda408_ (WidgetsLabelRow* self);
static void __widgets_label_row___lambda408__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                 gpointer self);
static void _widgets_label_row___lambda409_ (WidgetsLabelRow* self);
static void __widgets_label_row___lambda409__gtk_entry_activate (GtkEntry* _sender,
                                                          gpointer self);
static gboolean _widgets_label_row___lambda410_ (WidgetsLabelRow* self);
static gboolean __widgets_label_row___lambda410__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                      GdkEventFocus* event,
                                                                      gpointer self);
static void _widgets_label_row___lambda411_ (WidgetsLabelRow* self,
                                      GtkMenu* menu);
static void __lambda412_ (WidgetsLabelRow* self);
static void ___lambda412__gtk_widget_hide (GtkWidget* _sender,
                                    gpointer self);
static void __widgets_label_row___lambda411__gtk_entry_populate_popup (GtkEntry* _sender,
                                                                GtkMenu* popup,
                                                                gpointer self);
static void _widgets_label_row___lambda413_ (WidgetsLabelRow* self,
                                      gint64 id);
static gboolean ___lambda414_ (WidgetsLabelRow* self);
static gboolean ____lambda414__gsource_func (gpointer self);
static void __widgets_label_row___lambda413__services_database_label_deleted (ServicesDatabase* _sender,
                                                                       gint64 id,
                                                                       gpointer self);
static void widgets_label_row_finalize (GObject * obj);
static GType widgets_label_row_get_type_once (void);
static void _vala_widgets_label_row_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_widgets_label_row_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static const GtkTargetEntry WIDGETS_LABEL_ROW_TARGET_ENTRIES_LABEL[1] = {{"LABELROW", (guint) GTK_TARGET_SAME_APP, (guint) 0}};

static inline gpointer
widgets_label_row_get_instance_private (WidgetsLabelRow* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsLabelRow_private_offset);
}

WidgetsLabelRow*
widgets_label_row_construct (GType object_type,
                             ObjectsLabel* label)
{
	WidgetsLabelRow * self = NULL;
	g_return_val_if_fail (label != NULL, NULL);
	self = (WidgetsLabelRow*) g_object_new (object_type, "label", label, NULL);
	return self;
}

WidgetsLabelRow*
widgets_label_row_new (ObjectsLabel* label)
{
	return widgets_label_row_construct (WIDGETS_TYPE_LABEL_ROW, label);
}

static void
_widgets_label_row_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                        GdkDragContext* context,
                                                        gpointer self)
{
	widgets_label_row_on_drag_begin ((WidgetsLabelRow*) self, _sender, context);
}

static void
_widgets_label_row_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              GtkSelectionData* selection_data,
                                                              guint info,
                                                              guint time_,
                                                              gpointer self)
{
	widgets_label_row_on_drag_data_get ((WidgetsLabelRow*) self, _sender, context, selection_data, info, time_);
}

static gboolean
_widgets_label_row_on_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                          GdkDragContext* context,
                                                          gint x,
                                                          gint y,
                                                          guint time_,
                                                          gpointer self)
{
	gboolean result;
	result = widgets_label_row_on_drag_motion ((WidgetsLabelRow*) self, context, x, y, time_);
	return result;
}

static void
_widgets_label_row_on_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                        GdkDragContext* context,
                                                        guint time_,
                                                        gpointer self)
{
	widgets_label_row_on_drag_leave ((WidgetsLabelRow*) self, context, time_);
}

static void
_widgets_label_row_clear_indicator_gtk_widget_drag_end (GtkWidget* _sender,
                                                        GdkDragContext* context,
                                                        gpointer self)
{
	widgets_label_row_clear_indicator ((WidgetsLabelRow*) self, context);
}

static void
widgets_label_row_build_drag_and_drop (WidgetsLabelRow* self)
{
	g_return_if_fail (self != NULL);
	gtk_drag_source_set ((GtkWidget*) self, GDK_BUTTON1_MASK, WIDGETS_LABEL_ROW_TARGET_ENTRIES_LABEL, (gint) G_N_ELEMENTS (WIDGETS_LABEL_ROW_TARGET_ENTRIES_LABEL), GDK_ACTION_MOVE);
	g_signal_connect_object ((GtkWidget*) self, "drag-begin", (GCallback) _widgets_label_row_on_drag_begin_gtk_widget_drag_begin, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "drag-data-get", (GCallback) _widgets_label_row_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_MOTION, WIDGETS_LABEL_ROW_TARGET_ENTRIES_LABEL, (gint) G_N_ELEMENTS (WIDGETS_LABEL_ROW_TARGET_ENTRIES_LABEL), GDK_ACTION_MOVE);
	g_signal_connect_object ((GtkWidget*) self, "drag-motion", (GCallback) _widgets_label_row_on_drag_motion_gtk_widget_drag_motion, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "drag-leave", (GCallback) _widgets_label_row_on_drag_leave_gtk_widget_drag_leave, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "drag-end", (GCallback) _widgets_label_row_clear_indicator_gtk_widget_drag_end, self, 0);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
widgets_label_row_on_drag_begin (WidgetsLabelRow* self,
                                 GtkWidget* widget,
                                 GdkDragContext* context)
{
	WidgetsLabelRow* row = NULL;
	WidgetsLabelRow* _tmp0_;
	GtkAllocation alloc = {0};
	GtkAllocation _tmp1_ = {0};
	cairo_surface_t* surface = NULL;
	GtkAllocation _tmp2_;
	GtkAllocation _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_t* _tmp5_;
	GtkAllocation _tmp6_;
	GtkAllocation _tmp7_;
	GtkAllocation _tmp8_;
	GtkAllocation _tmp9_;
	GtkAllocation _tmp10_;
	GtkAllocation _tmp11_;
	gboolean _tmp12_ = FALSE;
	GtkRevealer* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, WIDGETS_TYPE_LABEL_ROW, WidgetsLabelRow));
	row = _tmp0_;
	gtk_widget_get_allocation ((GtkWidget*) row, &_tmp1_);
	alloc = _tmp1_;
	_tmp2_ = alloc;
	_tmp3_ = alloc;
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp2_.width, _tmp3_.height);
	surface = _tmp4_;
	_tmp5_ = cairo_create (surface);
	cr = _tmp5_;
	cairo_set_source_rgba (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.3);
	cairo_set_line_width (cr, (gdouble) 1);
	cairo_move_to (cr, (gdouble) 0, (gdouble) 0);
	_tmp6_ = alloc;
	cairo_line_to (cr, (gdouble) _tmp6_.width, (gdouble) 0);
	_tmp7_ = alloc;
	_tmp8_ = alloc;
	cairo_line_to (cr, (gdouble) _tmp7_.width, (gdouble) _tmp8_.height);
	_tmp9_ = alloc;
	cairo_line_to (cr, (gdouble) 0, (gdouble) _tmp9_.height);
	cairo_line_to (cr, (gdouble) 0, (gdouble) 0);
	cairo_stroke (cr);
	cairo_set_source_rgba (cr, (gdouble) 255, (gdouble) 255, (gdouble) 255, 0.5);
	_tmp10_ = alloc;
	_tmp11_ = alloc;
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) _tmp10_.width, (gdouble) _tmp11_.height);
	cairo_fill (cr);
	g_signal_emit_by_name ((GtkWidget*) row, "draw", cr, &_tmp12_);
	gtk_drag_set_icon_surface (context, surface);
	_tmp13_ = self->main_revealer;
	gtk_revealer_set_reveal_child (_tmp13_, FALSE);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (surface);
	_g_object_unref0 (row);
}

static void
widgets_label_row_on_drag_data_get (WidgetsLabelRow* self,
                                    GtkWidget* widget,
                                    GdkDragContext* context,
                                    GtkSelectionData* selection_data,
                                    guint target_type,
                                    guint time)
{
	guchar* data = NULL;
	guchar* _tmp0_;
	gint data_length1;
	gint _data_size_;
	GtkWidget* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	_tmp0_ = g_new0 (guchar, sizeof (WidgetsLabelRow*));
	data = _tmp0_;
	data_length1 = sizeof (WidgetsLabelRow*);
	_data_size_ = data_length1;
	_tmp1_ = _g_object_ref0 (widget);
	_g_object_unref0 (((GtkWidget**) data)[0]);
	((GtkWidget**) data)[0] = _tmp1_;
	gtk_selection_data_set (selection_data, gdk_atom_intern_static_string ("LABELROW"), 32, data, (gint) data_length1);
	data = (g_free (data), NULL);
}

void
widgets_label_row_clear_indicator (WidgetsLabelRow* self,
                                   GdkDragContext* context)
{
	GtkRevealer* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = self->main_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, TRUE);
}

static gboolean
_widgets_label_row_scroll_gsource_func (gpointer self)
{
	gboolean result;
	result = widgets_label_row_scroll ((WidgetsLabelRow*) self);
	return result;
}

gboolean
widgets_label_row_on_drag_motion (WidgetsLabelRow* self,
                                  GdkDragContext* context,
                                  gint x,
                                  gint y,
                                  guint time)
{
	GtkRevealer* _tmp0_;
	GtkSeparator* _tmp1_;
	GtkSeparator* _tmp2_;
	gint index = 0;
	GtkAllocation alloc = {0};
	GtkAllocation _tmp3_ = {0};
	gint real_y = 0;
	GtkAllocation _tmp4_;
	GtkAllocation _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = self->priv->motion_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, TRUE);
	_tmp1_ = self->priv->separator;
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = self->priv->separator;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp2_, FALSE);
	index = gtk_list_box_row_get_index ((GtkListBoxRow*) self);
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp3_);
	alloc = _tmp3_;
	_tmp4_ = alloc;
	_tmp5_ = alloc;
	real_y = ((index * _tmp4_.height) - _tmp5_.height) + y;
	widgets_label_row_check_scroll (self, real_y);
	if (self->priv->should_scroll) {
		_tmp6_ = !self->priv->scrolling;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		self->priv->scrolling = TRUE;
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) WIDGETS_LABEL_ROW_SCROLL_DELAY, _widgets_label_row_scroll_gsource_func, g_object_ref (self), g_object_unref);
	}
	result = TRUE;
	return result;
}

static void
widgets_label_row_check_scroll (WidgetsLabelRow* self,
                                gint y)
{
	GtkScrolledWindow* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
	GtkAdjustment* _tmp4_;
	gdouble vadjustment_min = 0.0;
	GtkAdjustment* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble vadjustment_max = 0.0;
	GtkAdjustment* _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble show_min = 0.0;
	gdouble show_max = 0.0;
	GtkAdjustment* _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_scrolled;
	_tmp1_ = gtk_scrolled_window_get_vadjustment (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->vadjustment);
	self->vadjustment = _tmp3_;
	_tmp4_ = self->vadjustment;
	if (_tmp4_ == NULL) {
		return;
	}
	_tmp5_ = self->vadjustment;
	_tmp6_ = gtk_adjustment_get_value (_tmp5_);
	_tmp7_ = _tmp6_;
	vadjustment_min = _tmp7_;
	_tmp8_ = self->vadjustment;
	_tmp9_ = gtk_adjustment_get_page_size (_tmp8_);
	_tmp10_ = _tmp9_;
	vadjustment_max = _tmp10_ + vadjustment_min;
	show_min = MAX ((gdouble) 0, (gdouble) (y - WIDGETS_LABEL_ROW_SCROLL_DISTANCE));
	_tmp11_ = self->vadjustment;
	_tmp12_ = gtk_adjustment_get_upper (_tmp11_);
	_tmp13_ = _tmp12_;
	show_max = MIN (_tmp13_, (gdouble) (y + WIDGETS_LABEL_ROW_SCROLL_DISTANCE));
	if (vadjustment_min > show_min) {
		self->priv->should_scroll = TRUE;
		self->priv->scroll_up = TRUE;
	} else {
		if (vadjustment_max < show_max) {
			self->priv->should_scroll = TRUE;
			self->priv->scroll_up = FALSE;
		} else {
			self->priv->should_scroll = FALSE;
		}
	}
}

static gboolean
widgets_label_row_scroll (WidgetsLabelRow* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->should_scroll) {
		if (self->priv->scroll_up) {
			GtkAdjustment* _tmp0_;
			GtkAdjustment* _tmp1_;
			gdouble _tmp2_;
			gdouble _tmp3_;
			_tmp0_ = self->vadjustment;
			_tmp1_ = self->vadjustment;
			_tmp2_ = gtk_adjustment_get_value (_tmp1_);
			_tmp3_ = _tmp2_;
			gtk_adjustment_set_value (_tmp1_, _tmp3_ - WIDGETS_LABEL_ROW_SCROLL_STEP_SIZE);
		} else {
			GtkAdjustment* _tmp4_;
			GtkAdjustment* _tmp5_;
			gdouble _tmp6_;
			gdouble _tmp7_;
			_tmp4_ = self->vadjustment;
			_tmp5_ = self->vadjustment;
			_tmp6_ = gtk_adjustment_get_value (_tmp5_);
			_tmp7_ = _tmp6_;
			gtk_adjustment_set_value (_tmp5_, _tmp7_ + WIDGETS_LABEL_ROW_SCROLL_STEP_SIZE);
		}
	} else {
		self->priv->scrolling = FALSE;
	}
	result = self->priv->should_scroll;
	return result;
}

void
widgets_label_row_on_drag_leave (WidgetsLabelRow* self,
                                 GdkDragContext* context,
                                 guint time)
{
	GtkRevealer* _tmp0_;
	GtkSeparator* _tmp1_;
	GtkSeparator* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = self->priv->motion_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
	_tmp1_ = self->priv->separator;
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
	_tmp2_ = self->priv->separator;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp2_, TRUE);
	self->priv->should_scroll = FALSE;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
widgets_label_row_save (WidgetsLabelRow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->name_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = string_strip (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strcmp0 (_tmp4_, "") != 0;
	_g_free0 (_tmp4_);
	if (_tmp5_) {
		ObjectsLabel* _tmp6_;
		GtkEntry* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		ObjectsLabel* _tmp12_;
		GtkLabel* _tmp13_;
		ObjectsLabel* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		ObjectsLabel* _tmp17_;
		GtkEntry* _tmp18_;
		GtkEntry* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		_tmp6_ = self->priv->_label;
		_tmp7_ = self->priv->name_entry;
		_tmp8_ = gtk_entry_get_text (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = string_replace (_tmp9_, " ", "_");
		_tmp11_ = _tmp10_;
		objects_label_set_name (_tmp6_, _tmp11_);
		_g_free0 (_tmp11_);
		_tmp12_ = self->priv->_label;
		objects_label_set_color (_tmp12_, self->priv->color_selected);
		_tmp13_ = self->priv->name_label;
		_tmp14_ = self->priv->_label;
		_tmp15_ = objects_label_get_name (_tmp14_);
		_tmp16_ = _tmp15_;
		gtk_label_set_label (_tmp13_, _tmp16_);
		_tmp17_ = self->priv->_label;
		objects_label_save (_tmp17_);
		_tmp18_ = self->priv->name_entry;
		_tmp19_ = self->priv->name_entry;
		_tmp20_ = gtk_entry_get_text (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = string_replace (_tmp21_, " ", "_");
		_tmp23_ = _tmp22_;
		gtk_entry_set_text (_tmp18_, _tmp23_);
		_g_free0 (_tmp23_);
	}
}

static void
__lambda384_ (WidgetsLabelRow* self)
{
	GtkRevealer* _tmp0_;
	GtkToggleButton* _tmp1_;
	_tmp0_ = self->priv->buttons_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
	_tmp1_ = self->priv->color_button;
	gtk_toggle_button_set_active (_tmp1_, FALSE);
}

static void
___lambda384__gtk_popover_closed (GtkPopover* _sender,
                                  gpointer self)
{
	__lambda384_ ((WidgetsLabelRow*) self);
}

static void
__lambda385_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 30;
	widgets_label_row_save (self);
}

static void
___lambda385__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda385_ ((WidgetsLabelRow*) self);
}

static void
__lambda386_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 31;
	widgets_label_row_save (self);
}

static void
___lambda386__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda386_ ((WidgetsLabelRow*) self);
}

static void
__lambda387_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 32;
	widgets_label_row_save (self);
}

static void
___lambda387__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda387_ ((WidgetsLabelRow*) self);
}

static void
__lambda388_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 33;
	widgets_label_row_save (self);
}

static void
___lambda388__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda388_ ((WidgetsLabelRow*) self);
}

static void
__lambda389_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 34;
	widgets_label_row_save (self);
}

static void
___lambda389__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda389_ ((WidgetsLabelRow*) self);
}

static void
__lambda390_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 35;
	widgets_label_row_save (self);
}

static void
___lambda390__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda390_ ((WidgetsLabelRow*) self);
}

static void
__lambda391_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 36;
	widgets_label_row_save (self);
}

static void
___lambda391__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda391_ ((WidgetsLabelRow*) self);
}

static void
__lambda392_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 37;
	widgets_label_row_save (self);
}

static void
___lambda392__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda392_ ((WidgetsLabelRow*) self);
}

static void
__lambda393_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 38;
	widgets_label_row_save (self);
}

static void
___lambda393__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda393_ ((WidgetsLabelRow*) self);
}

static void
__lambda394_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 39;
	widgets_label_row_save (self);
}

static void
___lambda394__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda394_ ((WidgetsLabelRow*) self);
}

static void
__lambda395_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 40;
	widgets_label_row_save (self);
}

static void
___lambda395__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda395_ ((WidgetsLabelRow*) self);
}

static void
__lambda396_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 41;
	widgets_label_row_save (self);
}

static void
___lambda396__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda396_ ((WidgetsLabelRow*) self);
}

static void
__lambda397_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 42;
	widgets_label_row_save (self);
}

static void
___lambda397__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda397_ ((WidgetsLabelRow*) self);
}

static void
__lambda398_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 43;
	widgets_label_row_save (self);
}

static void
___lambda398__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda398_ ((WidgetsLabelRow*) self);
}

static void
__lambda399_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 44;
	widgets_label_row_save (self);
}

static void
___lambda399__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda399_ ((WidgetsLabelRow*) self);
}

static void
__lambda400_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 45;
	widgets_label_row_save (self);
}

static void
___lambda400__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda400_ ((WidgetsLabelRow*) self);
}

static void
__lambda401_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 46;
}

static void
___lambda401__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda401_ ((WidgetsLabelRow*) self);
}

static void
__lambda402_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 47;
	widgets_label_row_save (self);
}

static void
___lambda402__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda402_ ((WidgetsLabelRow*) self);
}

static void
__lambda403_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 48;
	widgets_label_row_save (self);
}

static void
___lambda403__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda403_ ((WidgetsLabelRow*) self);
}

static void
__lambda404_ (WidgetsLabelRow* self)
{
	self->priv->color_selected = 49;
	widgets_label_row_save (self);
}

static void
___lambda404__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
	__lambda404_ ((WidgetsLabelRow*) self);
}

static void
widgets_label_row_create_popover (WidgetsLabelRow* self)
{
	GtkToggleButton* _tmp0_;
	GtkPopover* _tmp1_;
	GtkPopover* _tmp2_;
	GtkRadioButton* color_30 = NULL;
	GtkRadioButton* _tmp3_;
	GtkRadioButton* _tmp4_;
	GtkRadioButton* _tmp5_;
	GtkRadioButton* _tmp6_;
	Utils* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GtkRadioButton* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkRadioButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkRadioButton* color_31 = NULL;
	GtkRadioButton* _tmp14_;
	GtkRadioButton* _tmp15_;
	GtkRadioButton* _tmp16_;
	GtkRadioButton* _tmp17_;
	GtkRadioButton* _tmp18_;
	Utils* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkRadioButton* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkRadioButton* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkRadioButton* color_32 = NULL;
	GtkRadioButton* _tmp26_;
	GtkRadioButton* _tmp27_;
	GtkRadioButton* _tmp28_;
	GtkRadioButton* _tmp29_;
	GtkRadioButton* _tmp30_;
	Utils* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GtkRadioButton* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkRadioButton* _tmp36_;
	GtkStyleContext* _tmp37_;
	GtkRadioButton* color_33 = NULL;
	GtkRadioButton* _tmp38_;
	GtkRadioButton* _tmp39_;
	GtkRadioButton* _tmp40_;
	GtkRadioButton* _tmp41_;
	GtkRadioButton* _tmp42_;
	Utils* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	GtkRadioButton* _tmp46_;
	GtkStyleContext* _tmp47_;
	GtkRadioButton* _tmp48_;
	GtkStyleContext* _tmp49_;
	GtkRadioButton* color_34 = NULL;
	GtkRadioButton* _tmp50_;
	GtkRadioButton* _tmp51_;
	GtkRadioButton* _tmp52_;
	GtkRadioButton* _tmp53_;
	GtkRadioButton* _tmp54_;
	Utils* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	GtkRadioButton* _tmp58_;
	GtkStyleContext* _tmp59_;
	GtkRadioButton* _tmp60_;
	GtkStyleContext* _tmp61_;
	GtkRadioButton* color_35 = NULL;
	GtkRadioButton* _tmp62_;
	GtkRadioButton* _tmp63_;
	GtkRadioButton* _tmp64_;
	GtkRadioButton* _tmp65_;
	GtkRadioButton* _tmp66_;
	Utils* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	GtkRadioButton* _tmp70_;
	GtkStyleContext* _tmp71_;
	GtkRadioButton* _tmp72_;
	GtkStyleContext* _tmp73_;
	GtkRadioButton* color_36 = NULL;
	GtkRadioButton* _tmp74_;
	GtkRadioButton* _tmp75_;
	GtkRadioButton* _tmp76_;
	GtkRadioButton* _tmp77_;
	GtkRadioButton* _tmp78_;
	Utils* _tmp79_;
	gchar* _tmp80_;
	gchar* _tmp81_;
	GtkRadioButton* _tmp82_;
	GtkStyleContext* _tmp83_;
	GtkRadioButton* _tmp84_;
	GtkStyleContext* _tmp85_;
	GtkRadioButton* color_37 = NULL;
	GtkRadioButton* _tmp86_;
	GtkRadioButton* _tmp87_;
	GtkRadioButton* _tmp88_;
	GtkRadioButton* _tmp89_;
	GtkRadioButton* _tmp90_;
	Utils* _tmp91_;
	gchar* _tmp92_;
	gchar* _tmp93_;
	GtkRadioButton* _tmp94_;
	GtkStyleContext* _tmp95_;
	GtkRadioButton* _tmp96_;
	GtkStyleContext* _tmp97_;
	GtkRadioButton* color_38 = NULL;
	GtkRadioButton* _tmp98_;
	GtkRadioButton* _tmp99_;
	GtkRadioButton* _tmp100_;
	GtkRadioButton* _tmp101_;
	GtkRadioButton* _tmp102_;
	Utils* _tmp103_;
	gchar* _tmp104_;
	gchar* _tmp105_;
	GtkRadioButton* _tmp106_;
	GtkStyleContext* _tmp107_;
	GtkRadioButton* _tmp108_;
	GtkStyleContext* _tmp109_;
	GtkRadioButton* color_39 = NULL;
	GtkRadioButton* _tmp110_;
	GtkRadioButton* _tmp111_;
	GtkRadioButton* _tmp112_;
	GtkRadioButton* _tmp113_;
	GtkRadioButton* _tmp114_;
	Utils* _tmp115_;
	gchar* _tmp116_;
	gchar* _tmp117_;
	GtkRadioButton* _tmp118_;
	GtkStyleContext* _tmp119_;
	GtkRadioButton* _tmp120_;
	GtkStyleContext* _tmp121_;
	GtkRadioButton* color_40 = NULL;
	GtkRadioButton* _tmp122_;
	GtkRadioButton* _tmp123_;
	GtkRadioButton* _tmp124_;
	GtkRadioButton* _tmp125_;
	GtkRadioButton* _tmp126_;
	Utils* _tmp127_;
	gchar* _tmp128_;
	gchar* _tmp129_;
	GtkRadioButton* _tmp130_;
	GtkStyleContext* _tmp131_;
	GtkRadioButton* _tmp132_;
	GtkStyleContext* _tmp133_;
	GtkRadioButton* color_41 = NULL;
	GtkRadioButton* _tmp134_;
	GtkRadioButton* _tmp135_;
	GtkRadioButton* _tmp136_;
	GtkRadioButton* _tmp137_;
	GtkRadioButton* _tmp138_;
	Utils* _tmp139_;
	gchar* _tmp140_;
	gchar* _tmp141_;
	GtkRadioButton* _tmp142_;
	GtkStyleContext* _tmp143_;
	GtkRadioButton* _tmp144_;
	GtkStyleContext* _tmp145_;
	GtkRadioButton* color_42 = NULL;
	GtkRadioButton* _tmp146_;
	GtkRadioButton* _tmp147_;
	GtkRadioButton* _tmp148_;
	GtkRadioButton* _tmp149_;
	GtkRadioButton* _tmp150_;
	Utils* _tmp151_;
	gchar* _tmp152_;
	gchar* _tmp153_;
	GtkRadioButton* _tmp154_;
	GtkStyleContext* _tmp155_;
	GtkRadioButton* _tmp156_;
	GtkStyleContext* _tmp157_;
	GtkRadioButton* color_43 = NULL;
	GtkRadioButton* _tmp158_;
	GtkRadioButton* _tmp159_;
	GtkRadioButton* _tmp160_;
	GtkRadioButton* _tmp161_;
	GtkRadioButton* _tmp162_;
	Utils* _tmp163_;
	gchar* _tmp164_;
	gchar* _tmp165_;
	GtkRadioButton* _tmp166_;
	GtkStyleContext* _tmp167_;
	GtkRadioButton* _tmp168_;
	GtkStyleContext* _tmp169_;
	GtkRadioButton* color_44 = NULL;
	GtkRadioButton* _tmp170_;
	GtkRadioButton* _tmp171_;
	GtkRadioButton* _tmp172_;
	GtkRadioButton* _tmp173_;
	GtkRadioButton* _tmp174_;
	Utils* _tmp175_;
	gchar* _tmp176_;
	gchar* _tmp177_;
	GtkRadioButton* _tmp178_;
	GtkStyleContext* _tmp179_;
	GtkRadioButton* _tmp180_;
	GtkStyleContext* _tmp181_;
	GtkRadioButton* color_45 = NULL;
	GtkRadioButton* _tmp182_;
	GtkRadioButton* _tmp183_;
	GtkRadioButton* _tmp184_;
	GtkRadioButton* _tmp185_;
	GtkRadioButton* _tmp186_;
	Utils* _tmp187_;
	gchar* _tmp188_;
	gchar* _tmp189_;
	GtkRadioButton* _tmp190_;
	GtkStyleContext* _tmp191_;
	GtkRadioButton* _tmp192_;
	GtkStyleContext* _tmp193_;
	GtkRadioButton* color_46 = NULL;
	GtkRadioButton* _tmp194_;
	GtkRadioButton* _tmp195_;
	GtkRadioButton* _tmp196_;
	GtkRadioButton* _tmp197_;
	GtkRadioButton* _tmp198_;
	Utils* _tmp199_;
	gchar* _tmp200_;
	gchar* _tmp201_;
	GtkRadioButton* _tmp202_;
	GtkStyleContext* _tmp203_;
	GtkRadioButton* _tmp204_;
	GtkStyleContext* _tmp205_;
	GtkRadioButton* color_47 = NULL;
	GtkRadioButton* _tmp206_;
	GtkRadioButton* _tmp207_;
	GtkRadioButton* _tmp208_;
	GtkRadioButton* _tmp209_;
	GtkRadioButton* _tmp210_;
	Utils* _tmp211_;
	gchar* _tmp212_;
	gchar* _tmp213_;
	GtkRadioButton* _tmp214_;
	GtkStyleContext* _tmp215_;
	GtkRadioButton* _tmp216_;
	GtkStyleContext* _tmp217_;
	GtkRadioButton* color_48 = NULL;
	GtkRadioButton* _tmp218_;
	GtkRadioButton* _tmp219_;
	GtkRadioButton* _tmp220_;
	GtkRadioButton* _tmp221_;
	GtkRadioButton* _tmp222_;
	Utils* _tmp223_;
	gchar* _tmp224_;
	gchar* _tmp225_;
	GtkRadioButton* _tmp226_;
	GtkStyleContext* _tmp227_;
	GtkRadioButton* _tmp228_;
	GtkStyleContext* _tmp229_;
	GtkRadioButton* color_49 = NULL;
	GtkRadioButton* _tmp230_;
	GtkRadioButton* _tmp231_;
	GtkRadioButton* _tmp232_;
	GtkRadioButton* _tmp233_;
	GtkRadioButton* _tmp234_;
	Utils* _tmp235_;
	gchar* _tmp236_;
	gchar* _tmp237_;
	GtkRadioButton* _tmp238_;
	GtkStyleContext* _tmp239_;
	GtkRadioButton* _tmp240_;
	GtkStyleContext* _tmp241_;
	GtkGrid* color_box = NULL;
	GtkGrid* _tmp242_;
	GtkGrid* _tmp243_;
	GtkGrid* _tmp244_;
	GtkGrid* _tmp245_;
	GtkGrid* _tmp246_;
	GtkGrid* _tmp247_;
	GtkGrid* _tmp248_;
	GtkGrid* _tmp249_;
	GtkGrid* _tmp250_;
	GtkRadioButton* _tmp251_;
	GtkGrid* _tmp252_;
	GtkRadioButton* _tmp253_;
	GtkGrid* _tmp254_;
	GtkRadioButton* _tmp255_;
	GtkGrid* _tmp256_;
	GtkRadioButton* _tmp257_;
	GtkGrid* _tmp258_;
	GtkRadioButton* _tmp259_;
	GtkGrid* _tmp260_;
	GtkRadioButton* _tmp261_;
	GtkGrid* _tmp262_;
	GtkRadioButton* _tmp263_;
	GtkGrid* _tmp264_;
	GtkRadioButton* _tmp265_;
	GtkGrid* _tmp266_;
	GtkRadioButton* _tmp267_;
	GtkGrid* _tmp268_;
	GtkRadioButton* _tmp269_;
	GtkGrid* _tmp270_;
	GtkRadioButton* _tmp271_;
	GtkGrid* _tmp272_;
	GtkRadioButton* _tmp273_;
	GtkGrid* _tmp274_;
	GtkRadioButton* _tmp275_;
	GtkGrid* _tmp276_;
	GtkRadioButton* _tmp277_;
	GtkGrid* _tmp278_;
	GtkRadioButton* _tmp279_;
	GtkGrid* _tmp280_;
	GtkRadioButton* _tmp281_;
	GtkGrid* _tmp282_;
	GtkRadioButton* _tmp283_;
	GtkGrid* _tmp284_;
	GtkRadioButton* _tmp285_;
	GtkGrid* _tmp286_;
	GtkRadioButton* _tmp287_;
	GtkGrid* _tmp288_;
	GtkRadioButton* _tmp289_;
	GtkGrid* popover_grid = NULL;
	GtkGrid* _tmp290_;
	GtkGrid* _tmp291_;
	GtkGrid* _tmp292_;
	GtkGrid* _tmp293_;
	GtkGrid* _tmp294_;
	GtkGrid* _tmp295_;
	GtkGrid* _tmp296_;
	GtkPopover* _tmp297_;
	GtkGrid* _tmp298_;
	GtkPopover* _tmp299_;
	ObjectsLabel* _tmp300_;
	gint _tmp301_;
	gint _tmp302_;
	GtkRadioButton* _tmp323_;
	GtkRadioButton* _tmp324_;
	GtkRadioButton* _tmp325_;
	GtkRadioButton* _tmp326_;
	GtkRadioButton* _tmp327_;
	GtkRadioButton* _tmp328_;
	GtkRadioButton* _tmp329_;
	GtkRadioButton* _tmp330_;
	GtkRadioButton* _tmp331_;
	GtkRadioButton* _tmp332_;
	GtkRadioButton* _tmp333_;
	GtkRadioButton* _tmp334_;
	GtkRadioButton* _tmp335_;
	GtkRadioButton* _tmp336_;
	GtkRadioButton* _tmp337_;
	GtkRadioButton* _tmp338_;
	GtkRadioButton* _tmp339_;
	GtkRadioButton* _tmp340_;
	GtkRadioButton* _tmp341_;
	GtkRadioButton* _tmp342_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->color_button;
	_tmp1_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) _tmp0_);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp1_;
	_tmp2_ = self->priv->popover;
	gtk_popover_set_position (_tmp2_, GTK_POS_BOTTOM);
	_tmp3_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	g_object_ref_sink (_tmp3_);
	color_30 = _tmp3_;
	_tmp4_ = color_30;
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_START);
	_tmp5_ = color_30;
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_START);
	_tmp6_ = color_30;
	_tmp7_ = planner_utils;
	_tmp8_ = utils_get_color_name (_tmp7_, 30);
	_tmp9_ = _tmp8_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _tmp9_);
	_g_free0 (_tmp9_);
	_tmp10_ = color_30;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_add_class (_tmp11_, "color-30");
	_tmp12_ = color_30;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_add_class (_tmp13_, "color-radio");
	_tmp14_ = color_30;
	_tmp15_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp14_);
	g_object_ref_sink (_tmp15_);
	color_31 = _tmp15_;
	_tmp16_ = color_31;
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
	_tmp17_ = color_31;
	gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_START);
	_tmp18_ = color_31;
	_tmp19_ = planner_utils;
	_tmp20_ = utils_get_color_name (_tmp19_, 31);
	_tmp21_ = _tmp20_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp18_, _tmp21_);
	_g_free0 (_tmp21_);
	_tmp22_ = color_31;
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
	gtk_style_context_add_class (_tmp23_, "color-31");
	_tmp24_ = color_31;
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
	gtk_style_context_add_class (_tmp25_, "color-radio");
	_tmp26_ = color_30;
	_tmp27_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp26_);
	g_object_ref_sink (_tmp27_);
	color_32 = _tmp27_;
	_tmp28_ = color_32;
	gtk_widget_set_valign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
	_tmp29_ = color_32;
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_START);
	_tmp30_ = color_32;
	_tmp31_ = planner_utils;
	_tmp32_ = utils_get_color_name (_tmp31_, 32);
	_tmp33_ = _tmp32_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp30_, _tmp33_);
	_g_free0 (_tmp33_);
	_tmp34_ = color_32;
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
	gtk_style_context_add_class (_tmp35_, "color-32");
	_tmp36_ = color_32;
	_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
	gtk_style_context_add_class (_tmp37_, "color-radio");
	_tmp38_ = color_30;
	_tmp39_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp38_);
	g_object_ref_sink (_tmp39_);
	color_33 = _tmp39_;
	_tmp40_ = color_33;
	gtk_widget_set_valign ((GtkWidget*) _tmp40_, GTK_ALIGN_START);
	_tmp41_ = color_33;
	gtk_widget_set_halign ((GtkWidget*) _tmp41_, GTK_ALIGN_START);
	_tmp42_ = color_33;
	_tmp43_ = planner_utils;
	_tmp44_ = utils_get_color_name (_tmp43_, 33);
	_tmp45_ = _tmp44_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp42_, _tmp45_);
	_g_free0 (_tmp45_);
	_tmp46_ = color_33;
	_tmp47_ = gtk_widget_get_style_context ((GtkWidget*) _tmp46_);
	gtk_style_context_add_class (_tmp47_, "color-33");
	_tmp48_ = color_33;
	_tmp49_ = gtk_widget_get_style_context ((GtkWidget*) _tmp48_);
	gtk_style_context_add_class (_tmp49_, "color-radio");
	_tmp50_ = color_30;
	_tmp51_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp50_);
	g_object_ref_sink (_tmp51_);
	color_34 = _tmp51_;
	_tmp52_ = color_34;
	gtk_widget_set_valign ((GtkWidget*) _tmp52_, GTK_ALIGN_START);
	_tmp53_ = color_34;
	gtk_widget_set_halign ((GtkWidget*) _tmp53_, GTK_ALIGN_START);
	_tmp54_ = color_34;
	_tmp55_ = planner_utils;
	_tmp56_ = utils_get_color_name (_tmp55_, 34);
	_tmp57_ = _tmp56_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp54_, _tmp57_);
	_g_free0 (_tmp57_);
	_tmp58_ = color_34;
	_tmp59_ = gtk_widget_get_style_context ((GtkWidget*) _tmp58_);
	gtk_style_context_add_class (_tmp59_, "color-34");
	_tmp60_ = color_34;
	_tmp61_ = gtk_widget_get_style_context ((GtkWidget*) _tmp60_);
	gtk_style_context_add_class (_tmp61_, "color-radio");
	_tmp62_ = color_30;
	_tmp63_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp62_);
	g_object_ref_sink (_tmp63_);
	color_35 = _tmp63_;
	_tmp64_ = color_35;
	gtk_widget_set_valign ((GtkWidget*) _tmp64_, GTK_ALIGN_START);
	_tmp65_ = color_35;
	gtk_widget_set_halign ((GtkWidget*) _tmp65_, GTK_ALIGN_START);
	_tmp66_ = color_35;
	_tmp67_ = planner_utils;
	_tmp68_ = utils_get_color_name (_tmp67_, 35);
	_tmp69_ = _tmp68_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp66_, _tmp69_);
	_g_free0 (_tmp69_);
	_tmp70_ = color_35;
	_tmp71_ = gtk_widget_get_style_context ((GtkWidget*) _tmp70_);
	gtk_style_context_add_class (_tmp71_, "color-35");
	_tmp72_ = color_35;
	_tmp73_ = gtk_widget_get_style_context ((GtkWidget*) _tmp72_);
	gtk_style_context_add_class (_tmp73_, "color-radio");
	_tmp74_ = color_30;
	_tmp75_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp74_);
	g_object_ref_sink (_tmp75_);
	color_36 = _tmp75_;
	_tmp76_ = color_36;
	gtk_widget_set_valign ((GtkWidget*) _tmp76_, GTK_ALIGN_START);
	_tmp77_ = color_36;
	gtk_widget_set_halign ((GtkWidget*) _tmp77_, GTK_ALIGN_START);
	_tmp78_ = color_36;
	_tmp79_ = planner_utils;
	_tmp80_ = utils_get_color_name (_tmp79_, 36);
	_tmp81_ = _tmp80_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp78_, _tmp81_);
	_g_free0 (_tmp81_);
	_tmp82_ = color_36;
	_tmp83_ = gtk_widget_get_style_context ((GtkWidget*) _tmp82_);
	gtk_style_context_add_class (_tmp83_, "color-36");
	_tmp84_ = color_36;
	_tmp85_ = gtk_widget_get_style_context ((GtkWidget*) _tmp84_);
	gtk_style_context_add_class (_tmp85_, "color-radio");
	_tmp86_ = color_30;
	_tmp87_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp86_);
	g_object_ref_sink (_tmp87_);
	color_37 = _tmp87_;
	_tmp88_ = color_37;
	gtk_widget_set_valign ((GtkWidget*) _tmp88_, GTK_ALIGN_START);
	_tmp89_ = color_37;
	gtk_widget_set_halign ((GtkWidget*) _tmp89_, GTK_ALIGN_START);
	_tmp90_ = color_37;
	_tmp91_ = planner_utils;
	_tmp92_ = utils_get_color_name (_tmp91_, 37);
	_tmp93_ = _tmp92_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp90_, _tmp93_);
	_g_free0 (_tmp93_);
	_tmp94_ = color_37;
	_tmp95_ = gtk_widget_get_style_context ((GtkWidget*) _tmp94_);
	gtk_style_context_add_class (_tmp95_, "color-37");
	_tmp96_ = color_37;
	_tmp97_ = gtk_widget_get_style_context ((GtkWidget*) _tmp96_);
	gtk_style_context_add_class (_tmp97_, "color-radio");
	_tmp98_ = color_30;
	_tmp99_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp98_);
	g_object_ref_sink (_tmp99_);
	color_38 = _tmp99_;
	_tmp100_ = color_38;
	gtk_widget_set_valign ((GtkWidget*) _tmp100_, GTK_ALIGN_START);
	_tmp101_ = color_38;
	gtk_widget_set_halign ((GtkWidget*) _tmp101_, GTK_ALIGN_START);
	_tmp102_ = color_38;
	_tmp103_ = planner_utils;
	_tmp104_ = utils_get_color_name (_tmp103_, 38);
	_tmp105_ = _tmp104_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp102_, _tmp105_);
	_g_free0 (_tmp105_);
	_tmp106_ = color_38;
	_tmp107_ = gtk_widget_get_style_context ((GtkWidget*) _tmp106_);
	gtk_style_context_add_class (_tmp107_, "color-38");
	_tmp108_ = color_38;
	_tmp109_ = gtk_widget_get_style_context ((GtkWidget*) _tmp108_);
	gtk_style_context_add_class (_tmp109_, "color-radio");
	_tmp110_ = color_30;
	_tmp111_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp110_);
	g_object_ref_sink (_tmp111_);
	color_39 = _tmp111_;
	_tmp112_ = color_39;
	gtk_widget_set_valign ((GtkWidget*) _tmp112_, GTK_ALIGN_START);
	_tmp113_ = color_39;
	gtk_widget_set_halign ((GtkWidget*) _tmp113_, GTK_ALIGN_START);
	_tmp114_ = color_39;
	_tmp115_ = planner_utils;
	_tmp116_ = utils_get_color_name (_tmp115_, 39);
	_tmp117_ = _tmp116_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp114_, _tmp117_);
	_g_free0 (_tmp117_);
	_tmp118_ = color_39;
	_tmp119_ = gtk_widget_get_style_context ((GtkWidget*) _tmp118_);
	gtk_style_context_add_class (_tmp119_, "color-39");
	_tmp120_ = color_39;
	_tmp121_ = gtk_widget_get_style_context ((GtkWidget*) _tmp120_);
	gtk_style_context_add_class (_tmp121_, "color-radio");
	_tmp122_ = color_30;
	_tmp123_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp122_);
	g_object_ref_sink (_tmp123_);
	color_40 = _tmp123_;
	_tmp124_ = color_40;
	gtk_widget_set_valign ((GtkWidget*) _tmp124_, GTK_ALIGN_START);
	_tmp125_ = color_40;
	gtk_widget_set_halign ((GtkWidget*) _tmp125_, GTK_ALIGN_START);
	_tmp126_ = color_40;
	_tmp127_ = planner_utils;
	_tmp128_ = utils_get_color_name (_tmp127_, 40);
	_tmp129_ = _tmp128_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp126_, _tmp129_);
	_g_free0 (_tmp129_);
	_tmp130_ = color_40;
	_tmp131_ = gtk_widget_get_style_context ((GtkWidget*) _tmp130_);
	gtk_style_context_add_class (_tmp131_, "color-40");
	_tmp132_ = color_40;
	_tmp133_ = gtk_widget_get_style_context ((GtkWidget*) _tmp132_);
	gtk_style_context_add_class (_tmp133_, "color-radio");
	_tmp134_ = color_30;
	_tmp135_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp134_);
	g_object_ref_sink (_tmp135_);
	color_41 = _tmp135_;
	_tmp136_ = color_41;
	gtk_widget_set_valign ((GtkWidget*) _tmp136_, GTK_ALIGN_START);
	_tmp137_ = color_41;
	gtk_widget_set_halign ((GtkWidget*) _tmp137_, GTK_ALIGN_START);
	_tmp138_ = color_41;
	_tmp139_ = planner_utils;
	_tmp140_ = utils_get_color_name (_tmp139_, 41);
	_tmp141_ = _tmp140_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp138_, _tmp141_);
	_g_free0 (_tmp141_);
	_tmp142_ = color_41;
	_tmp143_ = gtk_widget_get_style_context ((GtkWidget*) _tmp142_);
	gtk_style_context_add_class (_tmp143_, "color-41");
	_tmp144_ = color_41;
	_tmp145_ = gtk_widget_get_style_context ((GtkWidget*) _tmp144_);
	gtk_style_context_add_class (_tmp145_, "color-radio");
	_tmp146_ = color_30;
	_tmp147_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp146_);
	g_object_ref_sink (_tmp147_);
	color_42 = _tmp147_;
	_tmp148_ = color_42;
	gtk_widget_set_valign ((GtkWidget*) _tmp148_, GTK_ALIGN_START);
	_tmp149_ = color_42;
	gtk_widget_set_halign ((GtkWidget*) _tmp149_, GTK_ALIGN_START);
	_tmp150_ = color_42;
	_tmp151_ = planner_utils;
	_tmp152_ = utils_get_color_name (_tmp151_, 42);
	_tmp153_ = _tmp152_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp150_, _tmp153_);
	_g_free0 (_tmp153_);
	_tmp154_ = color_42;
	_tmp155_ = gtk_widget_get_style_context ((GtkWidget*) _tmp154_);
	gtk_style_context_add_class (_tmp155_, "color-42");
	_tmp156_ = color_42;
	_tmp157_ = gtk_widget_get_style_context ((GtkWidget*) _tmp156_);
	gtk_style_context_add_class (_tmp157_, "color-radio");
	_tmp158_ = color_30;
	_tmp159_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp158_);
	g_object_ref_sink (_tmp159_);
	color_43 = _tmp159_;
	_tmp160_ = color_43;
	gtk_widget_set_valign ((GtkWidget*) _tmp160_, GTK_ALIGN_START);
	_tmp161_ = color_43;
	gtk_widget_set_halign ((GtkWidget*) _tmp161_, GTK_ALIGN_START);
	_tmp162_ = color_43;
	_tmp163_ = planner_utils;
	_tmp164_ = utils_get_color_name (_tmp163_, 43);
	_tmp165_ = _tmp164_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp162_, _tmp165_);
	_g_free0 (_tmp165_);
	_tmp166_ = color_43;
	_tmp167_ = gtk_widget_get_style_context ((GtkWidget*) _tmp166_);
	gtk_style_context_add_class (_tmp167_, "color-43");
	_tmp168_ = color_43;
	_tmp169_ = gtk_widget_get_style_context ((GtkWidget*) _tmp168_);
	gtk_style_context_add_class (_tmp169_, "color-radio");
	_tmp170_ = color_30;
	_tmp171_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp170_);
	g_object_ref_sink (_tmp171_);
	color_44 = _tmp171_;
	_tmp172_ = color_44;
	gtk_widget_set_valign ((GtkWidget*) _tmp172_, GTK_ALIGN_START);
	_tmp173_ = color_44;
	gtk_widget_set_halign ((GtkWidget*) _tmp173_, GTK_ALIGN_START);
	_tmp174_ = color_44;
	_tmp175_ = planner_utils;
	_tmp176_ = utils_get_color_name (_tmp175_, 44);
	_tmp177_ = _tmp176_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp174_, _tmp177_);
	_g_free0 (_tmp177_);
	_tmp178_ = color_44;
	_tmp179_ = gtk_widget_get_style_context ((GtkWidget*) _tmp178_);
	gtk_style_context_add_class (_tmp179_, "color-44");
	_tmp180_ = color_44;
	_tmp181_ = gtk_widget_get_style_context ((GtkWidget*) _tmp180_);
	gtk_style_context_add_class (_tmp181_, "color-radio");
	_tmp182_ = color_30;
	_tmp183_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp182_);
	g_object_ref_sink (_tmp183_);
	color_45 = _tmp183_;
	_tmp184_ = color_45;
	gtk_widget_set_valign ((GtkWidget*) _tmp184_, GTK_ALIGN_START);
	_tmp185_ = color_45;
	gtk_widget_set_halign ((GtkWidget*) _tmp185_, GTK_ALIGN_START);
	_tmp186_ = color_45;
	_tmp187_ = planner_utils;
	_tmp188_ = utils_get_color_name (_tmp187_, 45);
	_tmp189_ = _tmp188_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp186_, _tmp189_);
	_g_free0 (_tmp189_);
	_tmp190_ = color_45;
	_tmp191_ = gtk_widget_get_style_context ((GtkWidget*) _tmp190_);
	gtk_style_context_add_class (_tmp191_, "color-45");
	_tmp192_ = color_45;
	_tmp193_ = gtk_widget_get_style_context ((GtkWidget*) _tmp192_);
	gtk_style_context_add_class (_tmp193_, "color-radio");
	_tmp194_ = color_30;
	_tmp195_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp194_);
	g_object_ref_sink (_tmp195_);
	color_46 = _tmp195_;
	_tmp196_ = color_46;
	gtk_widget_set_valign ((GtkWidget*) _tmp196_, GTK_ALIGN_START);
	_tmp197_ = color_46;
	gtk_widget_set_halign ((GtkWidget*) _tmp197_, GTK_ALIGN_START);
	_tmp198_ = color_46;
	_tmp199_ = planner_utils;
	_tmp200_ = utils_get_color_name (_tmp199_, 46);
	_tmp201_ = _tmp200_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp198_, _tmp201_);
	_g_free0 (_tmp201_);
	_tmp202_ = color_46;
	_tmp203_ = gtk_widget_get_style_context ((GtkWidget*) _tmp202_);
	gtk_style_context_add_class (_tmp203_, "color-46");
	_tmp204_ = color_46;
	_tmp205_ = gtk_widget_get_style_context ((GtkWidget*) _tmp204_);
	gtk_style_context_add_class (_tmp205_, "color-radio");
	_tmp206_ = color_30;
	_tmp207_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp206_);
	g_object_ref_sink (_tmp207_);
	color_47 = _tmp207_;
	_tmp208_ = color_47;
	gtk_widget_set_valign ((GtkWidget*) _tmp208_, GTK_ALIGN_START);
	_tmp209_ = color_47;
	gtk_widget_set_halign ((GtkWidget*) _tmp209_, GTK_ALIGN_START);
	_tmp210_ = color_47;
	_tmp211_ = planner_utils;
	_tmp212_ = utils_get_color_name (_tmp211_, 47);
	_tmp213_ = _tmp212_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp210_, _tmp213_);
	_g_free0 (_tmp213_);
	_tmp214_ = color_47;
	_tmp215_ = gtk_widget_get_style_context ((GtkWidget*) _tmp214_);
	gtk_style_context_add_class (_tmp215_, "color-47");
	_tmp216_ = color_47;
	_tmp217_ = gtk_widget_get_style_context ((GtkWidget*) _tmp216_);
	gtk_style_context_add_class (_tmp217_, "color-radio");
	_tmp218_ = color_30;
	_tmp219_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp218_);
	g_object_ref_sink (_tmp219_);
	color_48 = _tmp219_;
	_tmp220_ = color_48;
	gtk_widget_set_valign ((GtkWidget*) _tmp220_, GTK_ALIGN_START);
	_tmp221_ = color_48;
	gtk_widget_set_halign ((GtkWidget*) _tmp221_, GTK_ALIGN_START);
	_tmp222_ = color_48;
	_tmp223_ = planner_utils;
	_tmp224_ = utils_get_color_name (_tmp223_, 48);
	_tmp225_ = _tmp224_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp222_, _tmp225_);
	_g_free0 (_tmp225_);
	_tmp226_ = color_48;
	_tmp227_ = gtk_widget_get_style_context ((GtkWidget*) _tmp226_);
	gtk_style_context_add_class (_tmp227_, "color-48");
	_tmp228_ = color_48;
	_tmp229_ = gtk_widget_get_style_context ((GtkWidget*) _tmp228_);
	gtk_style_context_add_class (_tmp229_, "color-radio");
	_tmp230_ = color_30;
	_tmp231_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp230_);
	g_object_ref_sink (_tmp231_);
	color_49 = _tmp231_;
	_tmp232_ = color_49;
	gtk_widget_set_valign ((GtkWidget*) _tmp232_, GTK_ALIGN_START);
	_tmp233_ = color_49;
	gtk_widget_set_halign ((GtkWidget*) _tmp233_, GTK_ALIGN_START);
	_tmp234_ = color_49;
	_tmp235_ = planner_utils;
	_tmp236_ = utils_get_color_name (_tmp235_, 49);
	_tmp237_ = _tmp236_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp234_, _tmp237_);
	_g_free0 (_tmp237_);
	_tmp238_ = color_49;
	_tmp239_ = gtk_widget_get_style_context ((GtkWidget*) _tmp238_);
	gtk_style_context_add_class (_tmp239_, "color-49");
	_tmp240_ = color_49;
	_tmp241_ = gtk_widget_get_style_context ((GtkWidget*) _tmp240_);
	gtk_style_context_add_class (_tmp241_, "color-radio");
	_tmp242_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp242_);
	color_box = _tmp242_;
	_tmp243_ = color_box;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp243_, TRUE);
	_tmp244_ = color_box;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp244_, 6);
	_tmp245_ = color_box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp245_, 6);
	_tmp246_ = color_box;
	gtk_grid_set_column_homogeneous (_tmp246_, TRUE);
	_tmp247_ = color_box;
	gtk_grid_set_row_homogeneous (_tmp247_, TRUE);
	_tmp248_ = color_box;
	gtk_grid_set_row_spacing (_tmp248_, 9);
	_tmp249_ = color_box;
	gtk_grid_set_column_spacing (_tmp249_, 12);
	_tmp250_ = color_box;
	_tmp251_ = color_30;
	gtk_grid_attach (_tmp250_, (GtkWidget*) _tmp251_, 0, 0, 1, 1);
	_tmp252_ = color_box;
	_tmp253_ = color_31;
	gtk_grid_attach (_tmp252_, (GtkWidget*) _tmp253_, 1, 0, 1, 1);
	_tmp254_ = color_box;
	_tmp255_ = color_32;
	gtk_grid_attach (_tmp254_, (GtkWidget*) _tmp255_, 2, 0, 1, 1);
	_tmp256_ = color_box;
	_tmp257_ = color_33;
	gtk_grid_attach (_tmp256_, (GtkWidget*) _tmp257_, 3, 0, 1, 1);
	_tmp258_ = color_box;
	_tmp259_ = color_34;
	gtk_grid_attach (_tmp258_, (GtkWidget*) _tmp259_, 4, 0, 1, 1);
	_tmp260_ = color_box;
	_tmp261_ = color_35;
	gtk_grid_attach (_tmp260_, (GtkWidget*) _tmp261_, 5, 0, 1, 1);
	_tmp262_ = color_box;
	_tmp263_ = color_36;
	gtk_grid_attach (_tmp262_, (GtkWidget*) _tmp263_, 6, 0, 1, 1);
	_tmp264_ = color_box;
	_tmp265_ = color_37;
	gtk_grid_attach (_tmp264_, (GtkWidget*) _tmp265_, 0, 1, 1, 1);
	_tmp266_ = color_box;
	_tmp267_ = color_38;
	gtk_grid_attach (_tmp266_, (GtkWidget*) _tmp267_, 1, 1, 1, 1);
	_tmp268_ = color_box;
	_tmp269_ = color_39;
	gtk_grid_attach (_tmp268_, (GtkWidget*) _tmp269_, 2, 1, 1, 1);
	_tmp270_ = color_box;
	_tmp271_ = color_40;
	gtk_grid_attach (_tmp270_, (GtkWidget*) _tmp271_, 3, 1, 1, 1);
	_tmp272_ = color_box;
	_tmp273_ = color_41;
	gtk_grid_attach (_tmp272_, (GtkWidget*) _tmp273_, 4, 1, 1, 1);
	_tmp274_ = color_box;
	_tmp275_ = color_42;
	gtk_grid_attach (_tmp274_, (GtkWidget*) _tmp275_, 5, 1, 1, 1);
	_tmp276_ = color_box;
	_tmp277_ = color_43;
	gtk_grid_attach (_tmp276_, (GtkWidget*) _tmp277_, 6, 1, 1, 1);
	_tmp278_ = color_box;
	_tmp279_ = color_44;
	gtk_grid_attach (_tmp278_, (GtkWidget*) _tmp279_, 0, 2, 1, 1);
	_tmp280_ = color_box;
	_tmp281_ = color_45;
	gtk_grid_attach (_tmp280_, (GtkWidget*) _tmp281_, 1, 2, 1, 1);
	_tmp282_ = color_box;
	_tmp283_ = color_46;
	gtk_grid_attach (_tmp282_, (GtkWidget*) _tmp283_, 2, 2, 1, 1);
	_tmp284_ = color_box;
	_tmp285_ = color_47;
	gtk_grid_attach (_tmp284_, (GtkWidget*) _tmp285_, 3, 2, 1, 1);
	_tmp286_ = color_box;
	_tmp287_ = color_48;
	gtk_grid_attach (_tmp286_, (GtkWidget*) _tmp287_, 4, 2, 1, 1);
	_tmp288_ = color_box;
	_tmp289_ = color_49;
	gtk_grid_attach (_tmp288_, (GtkWidget*) _tmp289_, 5, 2, 1, 1);
	_tmp290_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp290_);
	popover_grid = _tmp290_;
	_tmp291_ = popover_grid;
	g_object_set ((GtkWidget*) _tmp291_, "width-request", 235, NULL);
	_tmp292_ = popover_grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp292_, GTK_ORIENTATION_VERTICAL);
	_tmp293_ = popover_grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp293_, 6);
	_tmp294_ = popover_grid;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp294_, 6);
	_tmp295_ = popover_grid;
	_tmp296_ = color_box;
	gtk_container_add ((GtkContainer*) _tmp295_, (GtkWidget*) _tmp296_);
	_tmp297_ = self->priv->popover;
	_tmp298_ = popover_grid;
	gtk_container_add ((GtkContainer*) _tmp297_, (GtkWidget*) _tmp298_);
	_tmp299_ = self->priv->popover;
	g_signal_connect_object (_tmp299_, "closed", (GCallback) ___lambda384__gtk_popover_closed, self, 0);
	_tmp300_ = self->priv->_label;
	_tmp301_ = objects_label_get_color (_tmp300_);
	_tmp302_ = _tmp301_;
	switch (_tmp302_) {
		case 30:
		{
			GtkRadioButton* _tmp303_;
			_tmp303_ = color_30;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp303_, TRUE);
			break;
		}
		case 31:
		{
			GtkRadioButton* _tmp304_;
			_tmp304_ = color_31;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp304_, TRUE);
			break;
		}
		case 32:
		{
			GtkRadioButton* _tmp305_;
			_tmp305_ = color_32;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp305_, TRUE);
			break;
		}
		case 33:
		{
			GtkRadioButton* _tmp306_;
			_tmp306_ = color_33;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp306_, TRUE);
			break;
		}
		case 34:
		{
			GtkRadioButton* _tmp307_;
			_tmp307_ = color_34;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp307_, TRUE);
			break;
		}
		case 35:
		{
			GtkRadioButton* _tmp308_;
			_tmp308_ = color_35;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp308_, TRUE);
			break;
		}
		case 36:
		{
			GtkRadioButton* _tmp309_;
			_tmp309_ = color_36;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp309_, TRUE);
			break;
		}
		case 37:
		{
			GtkRadioButton* _tmp310_;
			_tmp310_ = color_37;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp310_, TRUE);
			break;
		}
		case 38:
		{
			GtkRadioButton* _tmp311_;
			_tmp311_ = color_38;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp311_, TRUE);
			break;
		}
		case 39:
		{
			GtkRadioButton* _tmp312_;
			_tmp312_ = color_39;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp312_, TRUE);
			break;
		}
		case 40:
		{
			GtkRadioButton* _tmp313_;
			_tmp313_ = color_40;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp313_, TRUE);
			break;
		}
		case 41:
		{
			GtkRadioButton* _tmp314_;
			_tmp314_ = color_41;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp314_, TRUE);
			break;
		}
		case 42:
		{
			GtkRadioButton* _tmp315_;
			_tmp315_ = color_42;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp315_, TRUE);
			break;
		}
		case 43:
		{
			GtkRadioButton* _tmp316_;
			_tmp316_ = color_43;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp316_, TRUE);
			break;
		}
		case 44:
		{
			GtkRadioButton* _tmp317_;
			_tmp317_ = color_44;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp317_, TRUE);
			break;
		}
		case 45:
		{
			GtkRadioButton* _tmp318_;
			_tmp318_ = color_45;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp318_, TRUE);
			break;
		}
		case 46:
		{
			GtkRadioButton* _tmp319_;
			_tmp319_ = color_46;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp319_, TRUE);
			break;
		}
		case 47:
		{
			GtkRadioButton* _tmp320_;
			_tmp320_ = color_47;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp320_, TRUE);
			break;
		}
		case 48:
		{
			GtkRadioButton* _tmp321_;
			_tmp321_ = color_48;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp321_, TRUE);
			break;
		}
		case 49:
		{
			GtkRadioButton* _tmp322_;
			_tmp322_ = color_49;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp322_, TRUE);
			break;
		}
		default:
		{
			break;
		}
	}
	_tmp323_ = color_30;
	g_signal_connect_object ((GtkToggleButton*) _tmp323_, "toggled", (GCallback) ___lambda385__gtk_toggle_button_toggled, self, 0);
	_tmp324_ = color_31;
	g_signal_connect_object ((GtkToggleButton*) _tmp324_, "toggled", (GCallback) ___lambda386__gtk_toggle_button_toggled, self, 0);
	_tmp325_ = color_32;
	g_signal_connect_object ((GtkToggleButton*) _tmp325_, "toggled", (GCallback) ___lambda387__gtk_toggle_button_toggled, self, 0);
	_tmp326_ = color_33;
	g_signal_connect_object ((GtkToggleButton*) _tmp326_, "toggled", (GCallback) ___lambda388__gtk_toggle_button_toggled, self, 0);
	_tmp327_ = color_34;
	g_signal_connect_object ((GtkToggleButton*) _tmp327_, "toggled", (GCallback) ___lambda389__gtk_toggle_button_toggled, self, 0);
	_tmp328_ = color_35;
	g_signal_connect_object ((GtkToggleButton*) _tmp328_, "toggled", (GCallback) ___lambda390__gtk_toggle_button_toggled, self, 0);
	_tmp329_ = color_36;
	g_signal_connect_object ((GtkToggleButton*) _tmp329_, "toggled", (GCallback) ___lambda391__gtk_toggle_button_toggled, self, 0);
	_tmp330_ = color_37;
	g_signal_connect_object ((GtkToggleButton*) _tmp330_, "toggled", (GCallback) ___lambda392__gtk_toggle_button_toggled, self, 0);
	_tmp331_ = color_38;
	g_signal_connect_object ((GtkToggleButton*) _tmp331_, "toggled", (GCallback) ___lambda393__gtk_toggle_button_toggled, self, 0);
	_tmp332_ = color_39;
	g_signal_connect_object ((GtkToggleButton*) _tmp332_, "toggled", (GCallback) ___lambda394__gtk_toggle_button_toggled, self, 0);
	_tmp333_ = color_40;
	g_signal_connect_object ((GtkToggleButton*) _tmp333_, "toggled", (GCallback) ___lambda395__gtk_toggle_button_toggled, self, 0);
	_tmp334_ = color_41;
	g_signal_connect_object ((GtkToggleButton*) _tmp334_, "toggled", (GCallback) ___lambda396__gtk_toggle_button_toggled, self, 0);
	_tmp335_ = color_42;
	g_signal_connect_object ((GtkToggleButton*) _tmp335_, "toggled", (GCallback) ___lambda397__gtk_toggle_button_toggled, self, 0);
	_tmp336_ = color_43;
	g_signal_connect_object ((GtkToggleButton*) _tmp336_, "toggled", (GCallback) ___lambda398__gtk_toggle_button_toggled, self, 0);
	_tmp337_ = color_44;
	g_signal_connect_object ((GtkToggleButton*) _tmp337_, "toggled", (GCallback) ___lambda399__gtk_toggle_button_toggled, self, 0);
	_tmp338_ = color_45;
	g_signal_connect_object ((GtkToggleButton*) _tmp338_, "toggled", (GCallback) ___lambda400__gtk_toggle_button_toggled, self, 0);
	_tmp339_ = color_46;
	g_signal_connect_object ((GtkToggleButton*) _tmp339_, "toggled", (GCallback) ___lambda401__gtk_toggle_button_toggled, self, 0);
	_tmp340_ = color_47;
	g_signal_connect_object ((GtkToggleButton*) _tmp340_, "toggled", (GCallback) ___lambda402__gtk_toggle_button_toggled, self, 0);
	_tmp341_ = color_48;
	g_signal_connect_object ((GtkToggleButton*) _tmp341_, "toggled", (GCallback) ___lambda403__gtk_toggle_button_toggled, self, 0);
	_tmp342_ = color_49;
	g_signal_connect_object ((GtkToggleButton*) _tmp342_, "toggled", (GCallback) ___lambda404__gtk_toggle_button_toggled, self, 0);
	_g_object_unref0 (popover_grid);
	_g_object_unref0 (color_box);
	_g_object_unref0 (color_49);
	_g_object_unref0 (color_48);
	_g_object_unref0 (color_47);
	_g_object_unref0 (color_46);
	_g_object_unref0 (color_45);
	_g_object_unref0 (color_44);
	_g_object_unref0 (color_43);
	_g_object_unref0 (color_42);
	_g_object_unref0 (color_41);
	_g_object_unref0 (color_40);
	_g_object_unref0 (color_39);
	_g_object_unref0 (color_38);
	_g_object_unref0 (color_37);
	_g_object_unref0 (color_36);
	_g_object_unref0 (color_35);
	_g_object_unref0 (color_34);
	_g_object_unref0 (color_33);
	_g_object_unref0 (color_32);
	_g_object_unref0 (color_31);
	_g_object_unref0 (color_30);
}

void
widgets_label_row_edit (WidgetsLabelRow* self)
{
	GtkStack* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkEntry* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->name_stack;
	gtk_stack_set_visible_child_name (_tmp0_, "name_entry");
	_tmp1_ = self->priv->name_entry;
	gtk_entry_grab_focus_without_selecting (_tmp1_);
	_tmp2_ = self->priv->name_entry;
	g_object_get (_tmp2_, "cursor-position", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = self->priv->name_entry;
	_tmp6_ = gtk_entry_get_text_length (_tmp5_);
	_tmp7_ = _tmp6_;
	if (((guint) _tmp4_) < _tmp7_) {
		GtkEntry* _tmp8_;
		GtkEntry* _tmp9_;
		guint _tmp10_;
		guint _tmp11_;
		_tmp8_ = self->priv->name_entry;
		_tmp9_ = self->priv->name_entry;
		_tmp10_ = gtk_entry_get_text_length (_tmp9_);
		_tmp11_ = _tmp10_;
		g_signal_emit_by_name (_tmp8_, "move-cursor", GTK_MOVEMENT_BUFFER_ENDS, (gint) ((gint32) _tmp11_), FALSE);
	}
}

ObjectsLabel*
widgets_label_row_get_label (WidgetsLabelRow* self)
{
	ObjectsLabel* result;
	ObjectsLabel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label;
	result = _tmp0_;
	return result;
}

static void
widgets_label_row_set_label (WidgetsLabelRow* self,
                             ObjectsLabel* value)
{
	ObjectsLabel* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_label_row_get_label (self);
	if (old_value != value) {
		ObjectsLabel* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_label);
		self->priv->_label = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_label_row_properties[WIDGETS_LABEL_ROW_LABEL_PROPERTY]);
	}
}

GtkScrolledWindow*
widgets_label_row_get_scrolled (WidgetsLabelRow* self)
{
	GtkScrolledWindow* result;
	GtkScrolledWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_scrolled;
	result = _tmp0_;
	return result;
}

void
widgets_label_row_set_scrolled (WidgetsLabelRow* self,
                                GtkScrolledWindow* value)
{
	GtkScrolledWindow* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_label_row_get_scrolled (self);
	if (old_value != value) {
		GtkScrolledWindow* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_scrolled);
		self->priv->_scrolled = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_label_row_properties[WIDGETS_LABEL_ROW_SCROLLED_PROPERTY]);
	}
}

static Block114Data*
block114_data_ref (Block114Data* _data114_)
{
	g_atomic_int_inc (&_data114_->_ref_count_);
	return _data114_;
}

static void
block114_data_unref (void * _userdata_)
{
	Block114Data* _data114_;
	_data114_ = (Block114Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data114_->_ref_count_)) {
		WidgetsLabelRow* self;
		self = _data114_->self;
		_g_object_unref0 (_data114_->delete_button);
		_g_object_unref0 (self);
		g_slice_free (Block114Data, _data114_);
	}
}

static gboolean
_widgets_label_row___lambda405_ (Block114Data* _data114_,
                                 GdkEventCrossing* event)
{
	WidgetsLabelRow* self;
	GtkRevealer* _tmp0_;
	GtkButton* _tmp1_;
	GtkStyleContext* _tmp2_;
	gboolean result = FALSE;
	self = _data114_->self;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->buttons_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, TRUE);
	_tmp1_ = _data114_->delete_button;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
	gtk_style_context_add_class (_tmp2_, "closed");
	result = TRUE;
	return result;
}

static gboolean
__widgets_label_row___lambda405__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                GdkEventCrossing* event,
                                                                gpointer self)
{
	gboolean result;
	result = _widgets_label_row___lambda405_ (self, event);
	return result;
}

static gboolean
_widgets_label_row___lambda406_ (Block114Data* _data114_,
                                 GdkEventCrossing* event)
{
	WidgetsLabelRow* self;
	GdkNotifyType _tmp0_;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
	self = _data114_->self;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->detail;
	if (_tmp0_ == GDK_NOTIFY_INFERIOR) {
		result = FALSE;
		return result;
	}
	_tmp1_ = self->priv->color_button;
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == FALSE) {
		GtkRevealer* _tmp4_;
		GtkButton* _tmp5_;
		GtkStyleContext* _tmp6_;
		_tmp4_ = self->priv->buttons_revealer;
		gtk_revealer_set_reveal_child (_tmp4_, FALSE);
		_tmp5_ = _data114_->delete_button;
		_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
		gtk_style_context_remove_class (_tmp6_, "closed");
	}
	result = TRUE;
	return result;
}

static gboolean
__widgets_label_row___lambda406__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                GdkEventCrossing* event,
                                                                gpointer self)
{
	gboolean result;
	result = _widgets_label_row___lambda406_ (self, event);
	return result;
}

static void
_widgets_label_row___lambda407_ (WidgetsLabelRow* self)
{
	ServicesDatabase* _tmp0_;
	ObjectsLabel* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	ObjectsLabel* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	_tmp0_ = planner_database;
	_tmp1_ = self->priv->_label;
	_tmp2_ = objects_label_get_id (_tmp1_);
	_tmp3_ = _tmp2_;
	services_database_delete_label (_tmp0_, _tmp3_);
	_tmp4_ = self->priv->_label;
	_tmp5_ = objects_label_get_is_todoist (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == 1) {
		ServicesTodoist* _tmp7_;
		ObjectsLabel* _tmp8_;
		_tmp7_ = planner_todoist;
		_tmp8_ = self->priv->_label;
		services_todoist_delete_label (_tmp7_, _tmp8_);
	}
}

static void
__widgets_label_row___lambda407__gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
	_widgets_label_row___lambda407_ ((WidgetsLabelRow*) self);
}

static void
_widgets_label_row___lambda408_ (WidgetsLabelRow* self)
{
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->color_button;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkPopover* _tmp3_;
		GtkPopover* _tmp4_;
		_tmp3_ = self->priv->popover;
		if (_tmp3_ == NULL) {
			widgets_label_row_create_popover (self);
		}
		_tmp4_ = self->priv->popover;
		gtk_widget_show_all ((GtkWidget*) _tmp4_);
	}
}

static void
__widgets_label_row___lambda408__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                            gpointer self)
{
	_widgets_label_row___lambda408_ ((WidgetsLabelRow*) self);
}

static void
_widgets_label_row___lambda409_ (WidgetsLabelRow* self)
{
	GtkStack* _tmp0_;
	_tmp0_ = self->priv->name_stack;
	gtk_stack_set_visible_child_name (_tmp0_, "name_label");
}

static void
__widgets_label_row___lambda409__gtk_entry_activate (GtkEntry* _sender,
                                                     gpointer self)
{
	_widgets_label_row___lambda409_ ((WidgetsLabelRow*) self);
}

static gboolean
_widgets_label_row___lambda410_ (WidgetsLabelRow* self)
{
	gboolean result = FALSE;
	if (self->priv->entry_menu_opened == FALSE) {
		GtkStack* _tmp0_;
		_tmp0_ = self->priv->name_stack;
		gtk_stack_set_visible_child_name (_tmp0_, "name_label");
		widgets_label_row_save (self);
	}
	result = FALSE;
	return result;
}

static gboolean
__widgets_label_row___lambda410__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                             GdkEventFocus* event,
                                                             gpointer self)
{
	gboolean result;
	result = _widgets_label_row___lambda410_ ((WidgetsLabelRow*) self);
	return result;
}

static void
__lambda412_ (WidgetsLabelRow* self)
{
	self->priv->entry_menu_opened = FALSE;
}

static void
___lambda412__gtk_widget_hide (GtkWidget* _sender,
                               gpointer self)
{
	__lambda412_ ((WidgetsLabelRow*) self);
}

static void
_widgets_label_row___lambda411_ (WidgetsLabelRow* self,
                                 GtkMenu* menu)
{
	g_return_if_fail (menu != NULL);
	self->priv->entry_menu_opened = TRUE;
	g_signal_connect_object ((GtkWidget*) menu, "hide", (GCallback) ___lambda412__gtk_widget_hide, self, 0);
}

static void
__widgets_label_row___lambda411__gtk_entry_populate_popup (GtkEntry* _sender,
                                                           GtkMenu* popup,
                                                           gpointer self)
{
	_widgets_label_row___lambda411_ ((WidgetsLabelRow*) self, popup);
}

static gboolean
___lambda414_ (WidgetsLabelRow* self)
{
	gboolean result = FALSE;
	gtk_widget_destroy ((GtkWidget*) self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda414__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda414_ ((WidgetsLabelRow*) self);
	return result;
}

static void
_widgets_label_row___lambda413_ (WidgetsLabelRow* self,
                                 gint64 id)
{
	ObjectsLabel* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	_tmp0_ = self->priv->_label;
	_tmp1_ = objects_label_get_id (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == id) {
		GtkRevealer* _tmp3_;
		_tmp3_ = self->main_revealer;
		gtk_revealer_set_reveal_child (_tmp3_, FALSE);
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ____lambda414__gsource_func, g_object_ref (self), g_object_unref);
	}
}

static void
__widgets_label_row___lambda413__services_database_label_deleted (ServicesDatabase* _sender,
                                                                  gint64 id,
                                                                  gpointer self)
{
	_widgets_label_row___lambda413_ ((WidgetsLabelRow*) self, id);
}

static GObject *
widgets_label_row_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsLabelRow * self;
	Block114Data* _data114_;
	ObjectsLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkToggleButton* _tmp4_;
	GtkToggleButton* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkToggleButton* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkToggleButton* _tmp9_;
	GtkStyleContext* _tmp10_;
	ObjectsLabel* _tmp11_;
	gint64 _tmp12_;
	gint64 _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GtkImage* color_image = NULL;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	GThemedIcon* _tmp20_;
	GThemedIcon* _tmp21_;
	GtkImage* _tmp22_;
	GtkToggleButton* _tmp23_;
	GtkImage* _tmp24_;
	ObjectsLabel* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkStyleContext* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkImage* source_icon = NULL;
	GtkImage* _tmp35_;
	GtkImage* _tmp36_;
	GtkImage* _tmp37_;
	GThemedIcon* _tmp38_;
	GThemedIcon* _tmp39_;
	GtkBox* name_box = NULL;
	GtkBox* _tmp40_;
	GtkBox* _tmp41_;
	GtkLabel* _tmp42_;
	ObjectsLabel* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	GtkEntry* _tmp48_;
	GtkEntry* _tmp49_;
	ObjectsLabel* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	GtkEntry* _tmp53_;
	GtkEntry* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkEntry* _tmp56_;
	GtkStyleContext* _tmp57_;
	GtkEntry* _tmp58_;
	GtkStyleContext* _tmp59_;
	GtkEntry* _tmp60_;
	GtkStack* _tmp61_;
	GtkStack* _tmp62_;
	GtkStack* _tmp63_;
	GtkStack* _tmp64_;
	GtkBox* _tmp65_;
	GtkStack* _tmp66_;
	GtkEntry* _tmp67_;
	GtkButton* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	GtkButton* _tmp71_;
	GtkStyleContext* _tmp72_;
	GtkButton* _tmp73_;
	GtkStyleContext* _tmp74_;
	GtkRevealer* _tmp75_;
	GtkRevealer* _tmp76_;
	GtkRevealer* _tmp77_;
	GtkButton* _tmp78_;
	GtkBox* box = NULL;
	GtkBox* _tmp79_;
	GtkBox* _tmp80_;
	GtkBox* _tmp81_;
	GtkBox* _tmp82_;
	GtkBox* _tmp83_;
	GtkBox* _tmp84_;
	GtkToggleButton* _tmp85_;
	GtkBox* _tmp86_;
	GtkStack* _tmp87_;
	GtkBox* _tmp88_;
	GtkRevealer* _tmp89_;
	GtkGrid* motion_grid = NULL;
	GtkGrid* _tmp90_;
	GtkGrid* _tmp91_;
	GtkGrid* _tmp92_;
	GtkStyleContext* _tmp93_;
	GtkGrid* _tmp94_;
	GtkRevealer* _tmp95_;
	GtkRevealer* _tmp96_;
	GtkRevealer* _tmp97_;
	GtkGrid* _tmp98_;
	GtkSeparator* _tmp99_;
	GtkSeparator* _tmp100_;
	GtkSeparator* _tmp101_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp102_;
	GtkBox* _tmp103_;
	GtkStyleContext* _tmp104_;
	GtkBox* _tmp105_;
	GtkSeparator* _tmp106_;
	GtkSeparator* _tmp107_;
	GtkBox* _tmp108_;
	GtkBox* _tmp109_;
	GtkBox* _tmp110_;
	GtkSeparator* _tmp111_;
	GtkBox* handle_box = NULL;
	GtkBox* _tmp112_;
	GtkBox* _tmp113_;
	GtkBox* _tmp114_;
	GtkBox* _tmp115_;
	GtkRevealer* _tmp116_;
	GtkEventBox* handle = NULL;
	GtkEventBox* _tmp117_;
	GtkEventBox* _tmp118_;
	GtkEventBox* _tmp119_;
	GtkBox* _tmp120_;
	GtkRevealer* _tmp121_;
	GtkRevealer* _tmp122_;
	GtkRevealer* _tmp123_;
	GtkRevealer* _tmp124_;
	GtkEventBox* _tmp125_;
	GtkRevealer* _tmp126_;
	GtkEventBox* _tmp127_;
	GtkEventBox* _tmp128_;
	GtkButton* _tmp129_;
	GtkToggleButton* _tmp130_;
	GtkEntry* _tmp131_;
	GtkEntry* _tmp132_;
	GtkEntry* _tmp133_;
	ServicesDatabase* _tmp134_;
	parent_class = G_OBJECT_CLASS (widgets_label_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_LABEL_ROW, WidgetsLabelRow);
	_data114_ = g_slice_new0 (Block114Data);
	_data114_->_ref_count_ = 1;
	_data114_->self = g_object_ref (self);
	_tmp0_ = self->priv->_label;
	_tmp1_ = objects_label_get_color (_tmp0_);
	_tmp2_ = _tmp1_;
	self->priv->color_selected = _tmp2_;
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
	_tmp3_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->color_button);
	self->priv->color_button = _tmp3_;
	_tmp4_ = self->priv->color_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
	_tmp5_ = self->priv->color_button;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_add_class (_tmp6_, "flat");
	_tmp7_ = self->priv->color_button;
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
	gtk_style_context_add_class (_tmp8_, "area-row");
	_tmp9_ = self->priv->color_button;
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
	_tmp11_ = self->priv->_label;
	_tmp12_ = objects_label_get_id (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_strdup_printf ("label-%s", _tmp15_);
	_tmp17_ = _tmp16_;
	gtk_style_context_add_class (_tmp10_, _tmp17_);
	_g_free0 (_tmp17_);
	_g_free0 (_tmp15_);
	_tmp18_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp18_);
	color_image = _tmp18_;
	_tmp19_ = color_image;
	_tmp20_ = (GThemedIcon*) g_themed_icon_new ("tag-symbolic");
	_tmp21_ = _tmp20_;
	g_object_set (_tmp19_, "gicon", (GIcon*) _tmp21_, NULL);
	_g_object_unref0 (_tmp21_);
	_tmp22_ = color_image;
	gtk_image_set_pixel_size (_tmp22_, 16);
	_tmp23_ = self->priv->color_button;
	_tmp24_ = color_image;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = self->priv->_label;
	_tmp26_ = objects_label_get_name (_tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = (GtkLabel*) gtk_label_new (_tmp27_);
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->name_label);
	self->priv->name_label = _tmp28_;
	_tmp29_ = self->priv->name_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_START);
	_tmp30_ = self->priv->name_label;
	_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
	gtk_style_context_add_class (_tmp31_, "font-weight-600");
	_tmp32_ = self->priv->name_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp32_, GTK_ALIGN_CENTER);
	_tmp33_ = self->priv->name_label;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp33_, 3);
	_tmp34_ = self->priv->name_label;
	gtk_label_set_ellipsize (_tmp34_, PANGO_ELLIPSIZE_END);
	_tmp35_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp35_);
	source_icon = _tmp35_;
	_tmp36_ = source_icon;
	gtk_image_set_pixel_size (_tmp36_, 16);
	_tmp37_ = source_icon;
	_tmp38_ = (GThemedIcon*) g_themed_icon_new ("planner-online-symbolic");
	_tmp39_ = _tmp38_;
	g_object_set (_tmp37_, "gicon", (GIcon*) _tmp39_, NULL);
	_g_object_unref0 (_tmp39_);
	_tmp40_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	g_object_ref_sink (_tmp40_);
	name_box = _tmp40_;
	_tmp41_ = name_box;
	_tmp42_ = self->priv->name_label;
	gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
	_tmp43_ = self->priv->_label;
	_tmp44_ = objects_label_get_is_todoist (_tmp43_);
	_tmp45_ = _tmp44_;
	if (_tmp45_ == 1) {
		GtkBox* _tmp46_;
		GtkImage* _tmp47_;
		_tmp46_ = name_box;
		_tmp47_ = source_icon;
		gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
	}
	_tmp48_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp48_);
	_g_object_unref0 (self->priv->name_entry);
	self->priv->name_entry = _tmp48_;
	_tmp49_ = self->priv->name_entry;
	_tmp50_ = self->priv->_label;
	_tmp51_ = objects_label_get_name (_tmp50_);
	_tmp52_ = _tmp51_;
	gtk_entry_set_text (_tmp49_, _tmp52_);
	_tmp53_ = self->priv->name_entry;
	gtk_entry_set_placeholder_text (_tmp53_, _ ("Home"));
	_tmp54_ = self->priv->name_entry;
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
	gtk_style_context_add_class (_tmp55_, "flat");
	_tmp56_ = self->priv->name_entry;
	_tmp57_ = gtk_widget_get_style_context ((GtkWidget*) _tmp56_);
	gtk_style_context_add_class (_tmp57_, "check-entry");
	_tmp58_ = self->priv->name_entry;
	_tmp59_ = gtk_widget_get_style_context ((GtkWidget*) _tmp58_);
	gtk_style_context_add_class (_tmp59_, "font-weight-600");
	_tmp60_ = self->priv->name_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp60_, TRUE);
	_tmp61_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp61_);
	_g_object_unref0 (self->priv->name_stack);
	self->priv->name_stack = _tmp61_;
	_tmp62_ = self->priv->name_stack;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp62_, 1);
	_tmp63_ = self->priv->name_stack;
	gtk_stack_set_transition_type (_tmp63_, GTK_STACK_TRANSITION_TYPE_NONE);
	_tmp64_ = self->priv->name_stack;
	_tmp65_ = name_box;
	gtk_stack_add_named (_tmp64_, (GtkWidget*) _tmp65_, "name_label");
	_tmp66_ = self->priv->name_stack;
	_tmp67_ = self->priv->name_entry;
	gtk_stack_add_named (_tmp66_, (GtkWidget*) _tmp67_, "name_entry");
	_tmp68_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp68_);
	_data114_->delete_button = _tmp68_;
	_tmp69_ = _data114_->delete_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp69_, GTK_ALIGN_CENTER);
	_tmp70_ = _data114_->delete_button;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp70_, FALSE);
	_tmp71_ = _data114_->delete_button;
	_tmp72_ = gtk_widget_get_style_context ((GtkWidget*) _tmp71_);
	gtk_style_context_add_class (_tmp72_, "flat");
	_tmp73_ = _data114_->delete_button;
	_tmp74_ = gtk_widget_get_style_context ((GtkWidget*) _tmp73_);
	gtk_style_context_add_class (_tmp74_, "delete-check-button");
	_tmp75_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp75_);
	_g_object_unref0 (self->priv->buttons_revealer);
	self->priv->buttons_revealer = _tmp75_;
	_tmp76_ = self->priv->buttons_revealer;
	gtk_revealer_set_transition_type (_tmp76_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
	_tmp77_ = self->priv->buttons_revealer;
	_tmp78_ = _data114_->delete_button;
	gtk_container_add ((GtkContainer*) _tmp77_, (GtkWidget*) _tmp78_);
	_tmp79_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp79_);
	box = _tmp79_;
	_tmp80_ = box;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp80_, 6);
	_tmp81_ = box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp81_, 3);
	_tmp82_ = box;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp82_, 3);
	_tmp83_ = box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp83_, 6);
	_tmp84_ = box;
	_tmp85_ = self->priv->color_button;
	gtk_box_pack_start (_tmp84_, (GtkWidget*) _tmp85_, FALSE, FALSE, (guint) 0);
	_tmp86_ = box;
	_tmp87_ = self->priv->name_stack;
	gtk_box_pack_start (_tmp86_, (GtkWidget*) _tmp87_, FALSE, TRUE, (guint) 0);
	_tmp88_ = box;
	_tmp89_ = self->priv->buttons_revealer;
	gtk_box_pack_end (_tmp88_, (GtkWidget*) _tmp89_, FALSE, TRUE, (guint) 0);
	_tmp90_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp90_);
	motion_grid = _tmp90_;
	_tmp91_ = motion_grid;
	g_object_set ((GtkWidget*) _tmp91_, "margin", 6, NULL);
	_tmp92_ = motion_grid;
	_tmp93_ = gtk_widget_get_style_context ((GtkWidget*) _tmp92_);
	gtk_style_context_add_class (_tmp93_, "grid-motion");
	_tmp94_ = motion_grid;
	g_object_set ((GtkWidget*) _tmp94_, "height-request", 24, NULL);
	_tmp95_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp95_);
	_g_object_unref0 (self->priv->motion_revealer);
	self->priv->motion_revealer = _tmp95_;
	_tmp96_ = self->priv->motion_revealer;
	gtk_revealer_set_transition_type (_tmp96_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp97_ = self->priv->motion_revealer;
	_tmp98_ = motion_grid;
	gtk_container_add ((GtkContainer*) _tmp97_, (GtkWidget*) _tmp98_);
	_tmp99_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp99_);
	_g_object_unref0 (self->priv->separator);
	self->priv->separator = _tmp99_;
	_tmp100_ = self->priv->separator;
	gtk_widget_set_visible ((GtkWidget*) _tmp100_, FALSE);
	_tmp101_ = self->priv->separator;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp101_, TRUE);
	_tmp102_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp102_);
	main_box = _tmp102_;
	_tmp103_ = main_box;
	_tmp104_ = gtk_widget_get_style_context ((GtkWidget*) _tmp103_);
	gtk_style_context_add_class (_tmp104_, "label-row");
	_tmp105_ = main_box;
	_tmp106_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp106_);
	_tmp107_ = _tmp106_;
	gtk_box_pack_start (_tmp105_, (GtkWidget*) _tmp107_, FALSE, TRUE, (guint) 0);
	_g_object_unref0 (_tmp107_);
	_tmp108_ = main_box;
	_tmp109_ = box;
	gtk_box_pack_start (_tmp108_, (GtkWidget*) _tmp109_, FALSE, FALSE, (guint) 0);
	_tmp110_ = main_box;
	_tmp111_ = self->priv->separator;
	gtk_box_pack_start (_tmp110_, (GtkWidget*) _tmp111_, FALSE, FALSE, (guint) 0);
	_tmp112_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp112_);
	handle_box = _tmp112_;
	_tmp113_ = handle_box;
	_tmp114_ = main_box;
	gtk_box_pack_start (_tmp113_, (GtkWidget*) _tmp114_, FALSE, FALSE, (guint) 0);
	_tmp115_ = handle_box;
	_tmp116_ = self->priv->motion_revealer;
	gtk_box_pack_start (_tmp115_, (GtkWidget*) _tmp116_, FALSE, FALSE, (guint) 0);
	_tmp117_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp117_);
	handle = _tmp117_;
	_tmp118_ = handle;
	gtk_widget_add_events ((GtkWidget*) _tmp118_, (gint) (GDK_ENTER_NOTIFY_MASK | GDK_LEAVE_NOTIFY_MASK));
	_tmp119_ = handle;
	_tmp120_ = handle_box;
	gtk_container_add ((GtkContainer*) _tmp119_, (GtkWidget*) _tmp120_);
	_tmp121_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp121_);
	_g_object_unref0 (self->main_revealer);
	self->main_revealer = _tmp121_;
	_tmp122_ = self->main_revealer;
	gtk_revealer_set_reveal_child (_tmp122_, TRUE);
	_tmp123_ = self->main_revealer;
	gtk_revealer_set_transition_type (_tmp123_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp124_ = self->main_revealer;
	_tmp125_ = handle;
	gtk_container_add ((GtkContainer*) _tmp124_, (GtkWidget*) _tmp125_);
	_tmp126_ = self->main_revealer;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp126_);
	widgets_label_row_build_drag_and_drop (self);
	_tmp127_ = handle;
	g_signal_connect_data ((GtkWidget*) _tmp127_, "enter-notify-event", (GCallback) __widgets_label_row___lambda405__gtk_widget_enter_notify_event, block114_data_ref (_data114_), (GClosureNotify) block114_data_unref, 0);
	_tmp128_ = handle;
	g_signal_connect_data ((GtkWidget*) _tmp128_, "leave-notify-event", (GCallback) __widgets_label_row___lambda406__gtk_widget_leave_notify_event, block114_data_ref (_data114_), (GClosureNotify) block114_data_unref, 0);
	_tmp129_ = _data114_->delete_button;
	g_signal_connect_object (_tmp129_, "clicked", (GCallback) __widgets_label_row___lambda407__gtk_button_clicked, self, 0);
	_tmp130_ = self->priv->color_button;
	g_signal_connect_object (_tmp130_, "toggled", (GCallback) __widgets_label_row___lambda408__gtk_toggle_button_toggled, self, 0);
	_tmp131_ = self->priv->name_entry;
	g_signal_connect_object (_tmp131_, "activate", (GCallback) __widgets_label_row___lambda409__gtk_entry_activate, self, 0);
	_tmp132_ = self->priv->name_entry;
	g_signal_connect_object ((GtkWidget*) _tmp132_, "focus-out-event", (GCallback) __widgets_label_row___lambda410__gtk_widget_focus_out_event, self, 0);
	_tmp133_ = self->priv->name_entry;
	g_signal_connect_object (_tmp133_, "populate-popup", (GCallback) __widgets_label_row___lambda411__gtk_entry_populate_popup, self, 0);
	_tmp134_ = planner_database;
	g_signal_connect_object (_tmp134_, "label-deleted", (GCallback) __widgets_label_row___lambda413__services_database_label_deleted, self, 0);
	_g_object_unref0 (handle);
	_g_object_unref0 (handle_box);
	_g_object_unref0 (main_box);
	_g_object_unref0 (motion_grid);
	_g_object_unref0 (box);
	_g_object_unref0 (name_box);
	_g_object_unref0 (source_icon);
	_g_object_unref0 (color_image);
	block114_data_unref (_data114_);
	_data114_ = NULL;
	return obj;
}

static void
widgets_label_row_class_init (WidgetsLabelRowClass * klass,
                              gpointer klass_data)
{
	widgets_label_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsLabelRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_label_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_label_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_label_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_label_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_LABEL_ROW_LABEL_PROPERTY, widgets_label_row_properties[WIDGETS_LABEL_ROW_LABEL_PROPERTY] = g_param_spec_object ("label", "label", "label", OBJECTS_TYPE_LABEL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_LABEL_ROW_SCROLLED_PROPERTY, widgets_label_row_properties[WIDGETS_LABEL_ROW_SCROLLED_PROPERTY] = g_param_spec_object ("scrolled", "scrolled", "scrolled", gtk_scrolled_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
widgets_label_row_instance_init (WidgetsLabelRow * self,
                                 gpointer klass)
{
	self->priv = widgets_label_row_get_instance_private (self);
	self->priv->popover = NULL;
	self->priv->color_selected = 30;
	self->priv->scroll_up = FALSE;
	self->priv->scrolling = FALSE;
	self->priv->should_scroll = FALSE;
	self->priv->entry_menu_opened = FALSE;
}

static void
widgets_label_row_finalize (GObject * obj)
{
	WidgetsLabelRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_LABEL_ROW, WidgetsLabelRow);
	_g_object_unref0 (self->priv->_label);
	_g_object_unref0 (self->priv->_scrolled);
	_g_object_unref0 (self->priv->name_entry);
	_g_object_unref0 (self->priv->name_label);
	_g_object_unref0 (self->priv->name_stack);
	_g_object_unref0 (self->priv->popover);
	_g_object_unref0 (self->priv->color_button);
	_g_object_unref0 (self->priv->buttons_revealer);
	_g_object_unref0 (self->priv->motion_revealer);
	_g_object_unref0 (self->priv->separator);
	_g_object_unref0 (self->main_revealer);
	_g_object_unref0 (self->vadjustment);
	G_OBJECT_CLASS (widgets_label_row_parent_class)->finalize (obj);
}

static GType
widgets_label_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsLabelRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_label_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsLabelRow), 0, (GInstanceInitFunc) widgets_label_row_instance_init, NULL };
	GType widgets_label_row_type_id;
	widgets_label_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "WidgetsLabelRow", &g_define_type_info, 0);
	WidgetsLabelRow_private_offset = g_type_add_instance_private (widgets_label_row_type_id, sizeof (WidgetsLabelRowPrivate));
	return widgets_label_row_type_id;
}

GType
widgets_label_row_get_type (void)
{
	static volatile gsize widgets_label_row_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_label_row_type_id__volatile)) {
		GType widgets_label_row_type_id;
		widgets_label_row_type_id = widgets_label_row_get_type_once ();
		g_once_init_leave (&widgets_label_row_type_id__volatile, widgets_label_row_type_id);
	}
	return widgets_label_row_type_id__volatile;
}

static void
_vala_widgets_label_row_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	WidgetsLabelRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_LABEL_ROW, WidgetsLabelRow);
	switch (property_id) {
		case WIDGETS_LABEL_ROW_LABEL_PROPERTY:
		g_value_set_object (value, widgets_label_row_get_label (self));
		break;
		case WIDGETS_LABEL_ROW_SCROLLED_PROPERTY:
		g_value_set_object (value, widgets_label_row_get_scrolled (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_label_row_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	WidgetsLabelRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_LABEL_ROW, WidgetsLabelRow);
	switch (property_id) {
		case WIDGETS_LABEL_ROW_LABEL_PROPERTY:
		widgets_label_row_set_label (self, g_value_get_object (value));
		break;
		case WIDGETS_LABEL_ROW_SCROLLED_PROPERTY:
		widgets_label_row_set_scrolled (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

