/* Placeholder.c generated by valac 0.52.4, the Vala compiler
 * generated from Placeholder.vala, do not modify */

/*
* Copyright © 2019 Alain M. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "plannercore.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

enum  {
	WIDGETS_PLACEHOLDER_0_PROPERTY,
	WIDGETS_PLACEHOLDER_ICON_NAME_PROPERTY,
	WIDGETS_PLACEHOLDER_TITLE_PROPERTY,
	WIDGETS_PLACEHOLDER_SUBTITLE_PROPERTY,
	WIDGETS_PLACEHOLDER_NUM_PROPERTIES
};
static GParamSpec* widgets_placeholder_properties[WIDGETS_PLACEHOLDER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _WidgetsPlaceholderPrivate {
	gchar* _icon_name;
	gchar* _title;
	gchar* _subtitle;
};

static gint WidgetsPlaceholder_private_offset;
static gpointer widgets_placeholder_parent_class = NULL;

static GObject * widgets_placeholder_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void widgets_placeholder_finalize (GObject * obj);
static GType widgets_placeholder_get_type_once (void);
static void _vala_widgets_placeholder_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_widgets_placeholder_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
widgets_placeholder_get_instance_private (WidgetsPlaceholder* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsPlaceholder_private_offset);
}

WidgetsPlaceholder*
widgets_placeholder_construct (GType object_type,
                               const gchar* title,
                               const gchar* subtitle,
                               const gchar* icon_name)
{
	WidgetsPlaceholder * self = NULL;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (subtitle != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	self = (WidgetsPlaceholder*) g_object_new (object_type, "title", title, "subtitle", subtitle, "icon-name", icon_name, NULL);
	return self;
}

WidgetsPlaceholder*
widgets_placeholder_new (const gchar* title,
                         const gchar* subtitle,
                         const gchar* icon_name)
{
	return widgets_placeholder_construct (WIDGETS_TYPE_PLACEHOLDER, title, subtitle, icon_name);
}

const gchar*
widgets_placeholder_get_icon_name (WidgetsPlaceholder* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

static void
widgets_placeholder_set_icon_name (WidgetsPlaceholder* self,
                                   const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_placeholder_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_placeholder_properties[WIDGETS_PLACEHOLDER_ICON_NAME_PROPERTY]);
	}
}

const gchar*
widgets_placeholder_get_title (WidgetsPlaceholder* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

static void
widgets_placeholder_set_title (WidgetsPlaceholder* self,
                               const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_placeholder_get_title (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_placeholder_properties[WIDGETS_PLACEHOLDER_TITLE_PROPERTY]);
	}
}

const gchar*
widgets_placeholder_get_subtitle (WidgetsPlaceholder* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_subtitle;
	result = _tmp0_;
	return result;
}

static void
widgets_placeholder_set_subtitle (WidgetsPlaceholder* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_placeholder_get_subtitle (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_subtitle);
		self->priv->_subtitle = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_placeholder_properties[WIDGETS_PLACEHOLDER_SUBTITLE_PROPERTY]);
	}
}

static GObject *
widgets_placeholder_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsPlaceholder * self;
	GtkImage* icon = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	const gchar* _tmp2_;
	GThemedIcon* _tmp3_;
	GThemedIcon* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkLabel* title_label = NULL;
	const gchar* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkLabel* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkLabel* subtitle_label = NULL;
	const gchar* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkStyleContext* _tmp21_;
	GtkBox* box = NULL;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GtkImage* _tmp26_;
	GtkBox* _tmp27_;
	GtkLabel* _tmp28_;
	GtkBox* _tmp29_;
	GtkLabel* _tmp30_;
	GtkBox* _tmp31_;
	parent_class = G_OBJECT_CLASS (widgets_placeholder_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_PLACEHOLDER, WidgetsPlaceholder);
	gtk_revealer_set_transition_type ((GtkRevealer*) self, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
	_tmp0_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp0_);
	icon = _tmp0_;
	_tmp1_ = icon;
	_tmp2_ = self->priv->_icon_name;
	_tmp3_ = (GThemedIcon*) g_themed_icon_new (_tmp2_);
	_tmp4_ = _tmp3_;
	g_object_set (_tmp1_, "gicon", (GIcon*) _tmp4_, NULL);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = icon;
	gtk_image_set_pixel_size (_tmp5_, 48);
	_tmp6_ = icon;
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
	_tmp7_ = icon;
	gtk_widget_set_opacity ((GtkWidget*) _tmp7_, 0.9);
	_tmp8_ = icon;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	gtk_style_context_add_class (_tmp9_, "dim-label");
	_tmp10_ = self->priv->_title;
	_tmp11_ = (GtkLabel*) gtk_label_new (_tmp10_);
	g_object_ref_sink (_tmp11_);
	title_label = _tmp11_;
	_tmp12_ = title_label;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp12_, 9);
	_tmp13_ = title_label;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, "dim-label");
	_tmp15_ = title_label;
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
	gtk_style_context_add_class (_tmp16_, "h3");
	_tmp17_ = self->priv->_subtitle;
	_tmp18_ = (GtkLabel*) gtk_label_new (_tmp17_);
	g_object_ref_sink (_tmp18_);
	subtitle_label = _tmp18_;
	_tmp19_ = subtitle_label;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp19_, 3);
	_tmp20_ = subtitle_label;
	_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
	gtk_style_context_add_class (_tmp21_, "dim-label");
	_tmp22_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp22_);
	box = _tmp22_;
	_tmp23_ = box;
	gtk_widget_set_valign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
	_tmp24_ = box;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp24_, 64);
	_tmp25_ = box;
	_tmp26_ = icon;
	gtk_box_pack_start (_tmp25_, (GtkWidget*) _tmp26_, FALSE, FALSE, (guint) 0);
	_tmp27_ = box;
	_tmp28_ = title_label;
	gtk_box_pack_start (_tmp27_, (GtkWidget*) _tmp28_, FALSE, FALSE, (guint) 0);
	_tmp29_ = box;
	_tmp30_ = subtitle_label;
	gtk_box_pack_start (_tmp29_, (GtkWidget*) _tmp30_, FALSE, FALSE, (guint) 0);
	_tmp31_ = box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp31_);
	_g_object_unref0 (box);
	_g_object_unref0 (subtitle_label);
	_g_object_unref0 (title_label);
	_g_object_unref0 (icon);
	return obj;
}

static void
widgets_placeholder_class_init (WidgetsPlaceholderClass * klass,
                                gpointer klass_data)
{
	widgets_placeholder_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsPlaceholder_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_placeholder_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_placeholder_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_placeholder_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_placeholder_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PLACEHOLDER_ICON_NAME_PROPERTY, widgets_placeholder_properties[WIDGETS_PLACEHOLDER_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PLACEHOLDER_TITLE_PROPERTY, widgets_placeholder_properties[WIDGETS_PLACEHOLDER_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PLACEHOLDER_SUBTITLE_PROPERTY, widgets_placeholder_properties[WIDGETS_PLACEHOLDER_SUBTITLE_PROPERTY] = g_param_spec_string ("subtitle", "subtitle", "subtitle", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
widgets_placeholder_instance_init (WidgetsPlaceholder * self,
                                   gpointer klass)
{
	self->priv = widgets_placeholder_get_instance_private (self);
}

static void
widgets_placeholder_finalize (GObject * obj)
{
	WidgetsPlaceholder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_PLACEHOLDER, WidgetsPlaceholder);
	_g_free0 (self->priv->_icon_name);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_subtitle);
	G_OBJECT_CLASS (widgets_placeholder_parent_class)->finalize (obj);
}

static GType
widgets_placeholder_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsPlaceholderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_placeholder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsPlaceholder), 0, (GInstanceInitFunc) widgets_placeholder_instance_init, NULL };
	GType widgets_placeholder_type_id;
	widgets_placeholder_type_id = g_type_register_static (gtk_revealer_get_type (), "WidgetsPlaceholder", &g_define_type_info, 0);
	WidgetsPlaceholder_private_offset = g_type_add_instance_private (widgets_placeholder_type_id, sizeof (WidgetsPlaceholderPrivate));
	return widgets_placeholder_type_id;
}

GType
widgets_placeholder_get_type (void)
{
	static volatile gsize widgets_placeholder_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_placeholder_type_id__volatile)) {
		GType widgets_placeholder_type_id;
		widgets_placeholder_type_id = widgets_placeholder_get_type_once ();
		g_once_init_leave (&widgets_placeholder_type_id__volatile, widgets_placeholder_type_id);
	}
	return widgets_placeholder_type_id__volatile;
}

static void
_vala_widgets_placeholder_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	WidgetsPlaceholder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_PLACEHOLDER, WidgetsPlaceholder);
	switch (property_id) {
		case WIDGETS_PLACEHOLDER_ICON_NAME_PROPERTY:
		g_value_set_string (value, widgets_placeholder_get_icon_name (self));
		break;
		case WIDGETS_PLACEHOLDER_TITLE_PROPERTY:
		g_value_set_string (value, widgets_placeholder_get_title (self));
		break;
		case WIDGETS_PLACEHOLDER_SUBTITLE_PROPERTY:
		g_value_set_string (value, widgets_placeholder_get_subtitle (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_placeholder_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	WidgetsPlaceholder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_PLACEHOLDER, WidgetsPlaceholder);
	switch (property_id) {
		case WIDGETS_PLACEHOLDER_ICON_NAME_PROPERTY:
		widgets_placeholder_set_icon_name (self, g_value_get_string (value));
		break;
		case WIDGETS_PLACEHOLDER_TITLE_PROPERTY:
		widgets_placeholder_set_title (self, g_value_get_string (value));
		break;
		case WIDGETS_PLACEHOLDER_SUBTITLE_PROPERTY:
		widgets_placeholder_set_subtitle (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

