/* ProjectProgress.c generated by valac 0.52.4, the Vala compiler
 * generated from ProjectProgress.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/* vim: set tabstop=4 softtabstop=4 shiftwidth=4 expandtab : */
/*
 * Custom Gtk.Widget to provide a circular progress bar.
 * It extends/subclasses Gtk.Bin instead of Gtk.DrawingArea.
 *
 * Based on José Miguel Fonte's Vala Circular Progress Bar
 * https://github.com/phastmike/vala-circular-progress-bar
 */

#include "plannercore.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <glib-object.h>
#include <gdk/gdk.h>

enum  {
	WIDGETS_PROJECT_PROGRESS_0_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY,
	WIDGETS_PROJECT_PROGRESS_NUM_PROPERTIES
};
static GParamSpec* widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WidgetsProjectProgressPrivate {
	gint _min_d;
	gchar* _progress_fill_color;
	gdouble _percentage;
};

static gint WidgetsProjectProgress_private_offset;
static gpointer widgets_project_progress_parent_class = NULL;

static void __lambda518_ (WidgetsProjectProgress* self);
static void ___lambda518__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static gint widgets_project_progress_calculate_radius (WidgetsProjectProgress* self);
static gint widgets_project_progress_calculate_diameter (WidgetsProjectProgress* self);
static GtkSizeRequestMode widgets_project_progress_real_get_request_mode (GtkWidget* base);
static void widgets_project_progress_real_get_preferred_width (GtkWidget* base,
                                                        gint* min_w,
                                                        gint* natural_w);
static void widgets_project_progress_real_get_preferred_height (GtkWidget* base,
                                                         gint* min_h,
                                                         gint* natural_h);
static void widgets_project_progress_real_size_allocate (GtkWidget* base,
                                                  GtkAllocation* allocation);
static gboolean widgets_project_progress_real_draw (GtkWidget* base,
                                             cairo_t* cr);
static GObject * widgets_project_progress_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void widgets_project_progress_finalize (GObject * obj);
static GType widgets_project_progress_get_type_once (void);
static void _vala_widgets_project_progress_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_widgets_project_progress_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
widgets_project_progress_get_instance_private (WidgetsProjectProgress* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsProjectProgress_private_offset);
}

static void
__lambda518_ (WidgetsProjectProgress* self)
{
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
___lambda518__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	__lambda518_ ((WidgetsProjectProgress*) self);
}

WidgetsProjectProgress*
widgets_project_progress_construct (GType object_type,
                                    gint min_d)
{
	WidgetsProjectProgress * self = NULL;
	self = (WidgetsProjectProgress*) g_object_new (object_type, "min-d", min_d, NULL);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda518__g_object_notify, self, 0);
	return self;
}

WidgetsProjectProgress*
widgets_project_progress_new (gint min_d)
{
	return widgets_project_progress_construct (WIDGETS_TYPE_PROJECT_PROGRESS, min_d);
}

static gint
widgets_project_progress_calculate_radius (WidgetsProjectProgress* self)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = MIN (gtk_widget_get_allocated_width ((GtkWidget*) self) / 2, gtk_widget_get_allocated_height ((GtkWidget*) self) / 2) - 1;
	return result;
}

static gint
widgets_project_progress_calculate_diameter (WidgetsProjectProgress* self)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = 2 * widgets_project_progress_calculate_radius (self);
	return result;
}

static GtkSizeRequestMode
widgets_project_progress_real_get_request_mode (GtkWidget* base)
{
	WidgetsProjectProgress * self;
	GtkSizeRequestMode result = 0;
	self = (WidgetsProjectProgress*) base;
	result = GTK_SIZE_REQUEST_CONSTANT_SIZE;
	return result;
}

static void
widgets_project_progress_real_get_preferred_width (GtkWidget* base,
                                                   gint* min_w,
                                                   gint* natural_w)
{
	WidgetsProjectProgress * self;
	gint _vala_min_w = 0;
	gint _vala_natural_w = 0;
	gint _tmp0_;
	gint _tmp1_;
	self = (WidgetsProjectProgress*) base;
	_tmp0_ = self->priv->_min_d;
	_vala_min_w = _tmp0_;
	_tmp1_ = self->priv->_min_d;
	_vala_natural_w = MAX (widgets_project_progress_calculate_diameter (self), _tmp1_);
	if (min_w) {
		*min_w = _vala_min_w;
	}
	if (natural_w) {
		*natural_w = _vala_natural_w;
	}
}

static void
widgets_project_progress_real_get_preferred_height (GtkWidget* base,
                                                    gint* min_h,
                                                    gint* natural_h)
{
	WidgetsProjectProgress * self;
	gint _vala_min_h = 0;
	gint _vala_natural_h = 0;
	gint _tmp0_;
	gint _tmp1_;
	self = (WidgetsProjectProgress*) base;
	_tmp0_ = self->priv->_min_d;
	_vala_min_h = _tmp0_;
	_tmp1_ = self->priv->_min_d;
	_vala_natural_h = MAX (widgets_project_progress_calculate_diameter (self), _tmp1_);
	if (min_h) {
		*min_h = _vala_min_h;
	}
	if (natural_h) {
		*natural_h = _vala_natural_h;
	}
}

static void
widgets_project_progress_real_size_allocate (GtkWidget* base,
                                             GtkAllocation* allocation)
{
	WidgetsProjectProgress * self;
	GtkAllocation _tmp0_;
	self = (WidgetsProjectProgress*) base;
	g_return_if_fail (allocation != NULL);
	_tmp0_ = *allocation;
	GTK_WIDGET_CLASS (widgets_project_progress_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin), &_tmp0_);
}

static gboolean
widgets_project_progress_real_draw (GtkWidget* base,
                                    cairo_t* cr)
{
	WidgetsProjectProgress * self;
	GdkRGBA color = {0};
	gint center_x = 0;
	gint center_y = 0;
	gdouble _tmp0_ = 0.0;
	gdouble outer_delta = 0.0;
	gint _tmp1_ = 0;
	gint inner_delta = 0;
	gdouble outer_radius = 0.0;
	gdouble inner_radius = 0.0;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GdkRGBA _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gboolean _tmp9_ = FALSE;
	gboolean result = FALSE;
	self = (WidgetsProjectProgress*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	cairo_save (cr);
	center_x = gtk_widget_get_allocated_width ((GtkWidget*) self) / 2;
	center_y = gtk_widget_get_allocated_height ((GtkWidget*) self) / 2;
	if (self->enable_subprojects) {
		_tmp0_ = self->subproject_offset + self->subproject_line_width;
	} else {
		_tmp0_ = self->line_width;
	}
	outer_delta = _tmp0_;
	if (self->enable_subprojects) {
		_tmp1_ = 1;
	} else {
		_tmp1_ = 2;
	}
	inner_delta = _tmp1_;
	outer_radius = round (center_x - outer_delta);
	inner_radius = round ((outer_radius - self->line_width) - inner_delta);
	memset (&color, 0, sizeof (GdkRGBA));
	_tmp2_ = widgets_project_progress_get_progress_fill_color (self);
	_tmp3_ = _tmp2_;
	gdk_rgba_parse (&color, _tmp3_);
	_tmp4_ = color;
	gdk_cairo_set_source_rgba (cr, &_tmp4_);
	_tmp5_ = widgets_project_progress_get_percentage (self);
	_tmp6_ = _tmp5_;
	if (_tmp6_ > ((gdouble) 0)) {
		gdouble _tmp7_;
		gdouble _tmp8_;
		cairo_move_to (cr, (gdouble) center_x, (gdouble) center_y);
		_tmp7_ = widgets_project_progress_get_percentage (self);
		_tmp8_ = _tmp7_;
		cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, inner_radius, 1.5 * G_PI, (1.5 + (_tmp8_ * 2)) * G_PI);
		cairo_fill (cr);
	}
	cairo_set_line_width (cr, self->line_width);
	cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, outer_radius, (gdouble) 0, G_PI * 2);
	cairo_stroke (cr);
	if (self->has_subprojects) {
		_tmp9_ = self->enable_subprojects;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		GdkRGBA _tmp10_;
		color.alpha = 0.7;
		_tmp10_ = color;
		gdk_cairo_set_source_rgba (cr, &_tmp10_);
		cairo_set_line_width (cr, self->subproject_line_width);
		cairo_arc (cr, (gdouble) (center_x + 2), (gdouble) (center_y + 2), outer_radius, G_PI / 90.0, (90.0 * G_PI) / 180.0);
		cairo_stroke (cr);
	}
	cairo_restore (cr);
	result = GTK_WIDGET_CLASS (widgets_project_progress_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin), cr);
	return result;
}

gint
widgets_project_progress_get_min_d (WidgetsProjectProgress* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_min_d;
	return result;
}

static void
widgets_project_progress_set_min_d (WidgetsProjectProgress* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_project_progress_get_min_d (self);
	if (old_value != value) {
		self->priv->_min_d = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY]);
	}
}

const gchar*
widgets_project_progress_get_progress_fill_color (WidgetsProjectProgress* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_progress_fill_color;
	result = _tmp0_;
	return result;
}

void
widgets_project_progress_set_progress_fill_color (WidgetsProjectProgress* self,
                                                  const gchar* value)
{
	GdkRGBA color = {0};
	g_return_if_fail (self != NULL);
	memset (&color, 0, sizeof (GdkRGBA));
	if (gdk_rgba_parse (&color, value)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_progress_fill_color);
		self->priv->_progress_fill_color = _tmp0_;
	}
	g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY]);
}

gdouble
widgets_project_progress_get_percentage (WidgetsProjectProgress* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_percentage;
	return result;
}

void
widgets_project_progress_set_percentage (WidgetsProjectProgress* self,
                                         gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->_percentage = MIN (MAX (value, (gdouble) 0), (gdouble) 1);
	g_object_notify_by_pspec ((GObject *) self, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY]);
}

static GObject *
widgets_project_progress_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsProjectProgress * self;
	gchar* _tmp0_;
	parent_class = G_OBJECT_CLASS (widgets_project_progress_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgress);
	self->priv->_percentage = (gdouble) 0;
	_tmp0_ = g_strdup ("#4a90d9");
	_g_free0 (self->priv->_progress_fill_color);
	self->priv->_progress_fill_color = _tmp0_;
	return obj;
}

static void
widgets_project_progress_class_init (WidgetsProjectProgressClass * klass,
                                     gpointer klass_data)
{
	widgets_project_progress_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsProjectProgress_private_offset);
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) widgets_project_progress_real_get_request_mode;
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) widgets_project_progress_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) widgets_project_progress_real_get_preferred_height;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) widgets_project_progress_real_size_allocate;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) widgets_project_progress_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_project_progress_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_project_progress_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_project_progress_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_project_progress_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY] = g_param_spec_int ("min-d", "min-d", "min-d", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY] = g_param_spec_string ("progress-fill-color", "Progress fill color", "Progress line color (Check GdkRGBA parse method)", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY, widgets_project_progress_properties[WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY] = g_param_spec_double ("percentage", "Percentage/Value", "The percentage value [0.0 ... 1.0]", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
widgets_project_progress_instance_init (WidgetsProjectProgress * self,
                                        gpointer klass)
{
	self->priv = widgets_project_progress_get_instance_private (self);
	self->subproject_offset = 2;
	self->subproject_line_width = 1.1;
	self->line_width = 1.5;
	self->has_subprojects = FALSE;
	self->enable_subprojects = FALSE;
}

static void
widgets_project_progress_finalize (GObject * obj)
{
	WidgetsProjectProgress * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgress);
	_g_free0 (self->priv->_progress_fill_color);
	G_OBJECT_CLASS (widgets_project_progress_parent_class)->finalize (obj);
}

static GType
widgets_project_progress_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsProjectProgressClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_project_progress_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsProjectProgress), 0, (GInstanceInitFunc) widgets_project_progress_instance_init, NULL };
	GType widgets_project_progress_type_id;
	widgets_project_progress_type_id = g_type_register_static (gtk_bin_get_type (), "WidgetsProjectProgress", &g_define_type_info, 0);
	WidgetsProjectProgress_private_offset = g_type_add_instance_private (widgets_project_progress_type_id, sizeof (WidgetsProjectProgressPrivate));
	return widgets_project_progress_type_id;
}

GType
widgets_project_progress_get_type (void)
{
	static volatile gsize widgets_project_progress_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_project_progress_type_id__volatile)) {
		GType widgets_project_progress_type_id;
		widgets_project_progress_type_id = widgets_project_progress_get_type_once ();
		g_once_init_leave (&widgets_project_progress_type_id__volatile, widgets_project_progress_type_id);
	}
	return widgets_project_progress_type_id__volatile;
}

static void
_vala_widgets_project_progress_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	WidgetsProjectProgress * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgress);
	switch (property_id) {
		case WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY:
		g_value_set_int (value, widgets_project_progress_get_min_d (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY:
		g_value_set_string (value, widgets_project_progress_get_progress_fill_color (self));
		break;
		case WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY:
		g_value_set_double (value, widgets_project_progress_get_percentage (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_project_progress_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	WidgetsProjectProgress * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_PROJECT_PROGRESS, WidgetsProjectProgress);
	switch (property_id) {
		case WIDGETS_PROJECT_PROGRESS_MIN_D_PROPERTY:
		widgets_project_progress_set_min_d (self, g_value_get_int (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_PROGRESS_FILL_COLOR_PROPERTY:
		widgets_project_progress_set_progress_fill_color (self, g_value_get_string (value));
		break;
		case WIDGETS_PROJECT_PROGRESS_PERCENTAGE_PROPERTY:
		widgets_project_progress_set_percentage (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

