/* ScheduleButton.c generated by valac 0.52.4, the Vala compiler
 * generated from ScheduleButton.vala, do not modify */

/*
* Copyright © 2019 Alain M. (https://github.com/alainm23/planner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "plannercore.h"
#include <gtk/gtk.h>
#include <granite.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>

enum  {
	WIDGETS_SCHEDULE_BUTTON_0_PROPERTY,
	WIDGETS_SCHEDULE_BUTTON_ITEM_PROPERTY,
	WIDGETS_SCHEDULE_BUTTON_DUEDATE_PROPERTY,
	WIDGETS_SCHEDULE_BUTTON_CHRONO_PROPERTY,
	WIDGETS_SCHEDULE_BUTTON_NUM_PROPERTIES
};
static GParamSpec* widgets_schedule_button_properties[WIDGETS_SCHEDULE_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block154Data Block154Data;
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
enum  {
	WIDGETS_SCHEDULE_BUTTON_POPOVER_OPENED_SIGNAL,
	WIDGETS_SCHEDULE_BUTTON_NUM_SIGNALS
};
static guint widgets_schedule_button_signals[WIDGETS_SCHEDULE_BUTTON_NUM_SIGNALS] = {0};
enum  {
	WIDGETS_SCHEDULE_ROW_0_PROPERTY,
	WIDGETS_SCHEDULE_ROW_WITH_PREVIEW_PROPERTY,
	WIDGETS_SCHEDULE_ROW_ICON_PROPERTY,
	WIDGETS_SCHEDULE_ROW_TEXT_PROPERTY,
	WIDGETS_SCHEDULE_ROW_SELECTED_PROPERTY,
	WIDGETS_SCHEDULE_ROW_DATE_LABEL_PROPERTY,
	WIDGETS_SCHEDULE_ROW_NUM_PROPERTIES
};
static GParamSpec* widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_NUM_PROPERTIES];
enum  {
	WIDGETS_SCHEDULE_ROW_CLICKED_SIGNAL,
	WIDGETS_SCHEDULE_ROW_NUM_SIGNALS
};
static guint widgets_schedule_row_signals[WIDGETS_SCHEDULE_ROW_NUM_SIGNALS] = {0};
enum  {
	WIDGETS_TIME_ALTERNATIVE_BUTTON_0_PROPERTY,
	WIDGETS_TIME_ALTERNATIVE_BUTTON_TEXT_PROPERTY,
	WIDGETS_TIME_ALTERNATIVE_BUTTON_KEY_PROPERTY,
	WIDGETS_TIME_ALTERNATIVE_BUTTON_TIME_PROPERTY,
	WIDGETS_TIME_ALTERNATIVE_BUTTON_NUM_PROPERTIES
};
static GParamSpec* widgets_time_alternative_button_properties[WIDGETS_TIME_ALTERNATIVE_BUTTON_NUM_PROPERTIES];

struct _WidgetsScheduleButtonPrivate {
	ObjectsItem* _item;
	ObjectsDuedate* _duedate;
	ServicesChronoChrono* _chrono;
	GtkImage* due_image;
	GtkLabel* due_label;
	GtkLabel* time_label;
	GtkImage* repeat_image;
	GtkRevealer* time_revealer;
	GtkRevealer* repeat_revealer;
	GtkButton* clear_button;
	GtkPopover* popover;
	GtkSearchEntry* search_entry;
	WidgetsCalendarCalendar* calendar;
	GraniteWidgetsTimePicker* time_picker;
	WidgetsScheduleRow* parse_row;
	WidgetsScheduleRow* today_row;
	WidgetsScheduleRow* tomorrow_row;
	WidgetsScheduleRow* calendar_row;
	WidgetsScheduleRow* time_row;
	WidgetsScheduleRow* repeat_row;
	GtkStack* stack;
	GtkStack* clear_back_stack;
	GtkRevealer* no_time_revealer;
	GtkRevealer* no_repeat_revealer;
	GtkLabel* repeat_label;
	GtkComboBoxText* repeat_combobox;
	GtkSpinButton* repeat_spin_button;
};

struct _Block154Data {
	int _ref_count_;
	WidgetsScheduleButton* self;
	WidgetsTimeAlternativeButton* morning_button;
	WidgetsTimeAlternativeButton* afternoon_button;
	WidgetsTimeAlternativeButton* evening_button;
};

struct _WidgetsScheduleRowPrivate {
	gboolean _with_preview;
};

struct _WidgetsTimeAlternativeButtonPrivate {
	gchar* _text;
	gchar* _key;
	GDateTime* _time;
	GtkLabel* title_label;
	GtkLabel* time_label;
};

static gint WidgetsScheduleButton_private_offset;
static gpointer widgets_schedule_button_parent_class = NULL;
static gint WidgetsScheduleRow_private_offset;
static gpointer widgets_schedule_row_parent_class = NULL;
static gint WidgetsTimeAlternativeButton_private_offset;
static gpointer widgets_time_alternative_button_parent_class = NULL;

static void widgets_schedule_button_create_popover (WidgetsScheduleButton* self);
static GtkWidget* widgets_schedule_button_get_home_widget (WidgetsScheduleButton* self);
static GtkWidget* widgets_schedule_button_get_pick_date_widget (WidgetsScheduleButton* self);
static GtkWidget* widgets_schedule_button_get_pick_time_widget (WidgetsScheduleButton* self);
static GtkWidget* widgets_schedule_button_get_pick_repeat_widget (WidgetsScheduleButton* self);
static void __lambda115_ (WidgetsScheduleButton* self);
static void ___lambda115__gtk_popover_closed (GtkPopover* _sender,
                                       gpointer self);
static void __lambda116_ (WidgetsScheduleButton* self);
static void ___lambda116__gtk_widget_show (GtkWidget* _sender,
                                    gpointer self);
static void __lambda117_ (WidgetsScheduleButton* self);
static void ___lambda117__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda118_ (WidgetsScheduleButton* self);
static void widgets_schedule_button_update_popover (WidgetsScheduleButton* self,
                                             ObjectsDuedate* duedate);
static void widgets_schedule_button_update_button (WidgetsScheduleButton* self,
                                            ObjectsDuedate* duedate);
static void ___lambda118__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda119_ (WidgetsScheduleButton* self);
static void widgets_schedule_button_check_clear_button (WidgetsScheduleButton* self);
static void ___lambda119__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda95_ (WidgetsScheduleButton* self);
static void widgets_schedule_button_set_date (WidgetsScheduleButton* self,
                                       GDateTime* date);
static void ___lambda95__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                                gpointer self);
static void __lambda96_ (WidgetsScheduleButton* self);
static void ___lambda96__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                                gpointer self);
static void __lambda97_ (WidgetsScheduleButton* self);
static void ___lambda97__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                                gpointer self);
static void __lambda98_ (WidgetsScheduleButton* self);
static void ___lambda98__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                                gpointer self);
static void __lambda99_ (WidgetsScheduleButton* self);
static void widgets_schedule_button_check_repeat_widget (WidgetsScheduleButton* self);
static void ___lambda99__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                                gpointer self);
static void __lambda100_ (WidgetsScheduleButton* self);
static void ___lambda100__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                    gpointer self);
static void __lambda101_ (WidgetsScheduleButton* self);
static void widgets_schedule_button_set_parse_item (WidgetsScheduleButton* self,
                                             const gchar* text);
static void ___lambda101__gtk_entry_activate (GtkEntry* _sender,
                                       gpointer self);
static void __lambda102_ (WidgetsScheduleButton* self);
static void ___lambda102__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                                 gpointer self);
static void __lambda103_ (WidgetsScheduleButton* self,
                   GDateTime* date);
static void ___lambda103__widgets_calendar_calendar_selection_changed (WidgetsCalendarCalendar* _sender,
                                                                GDateTime* date,
                                                                gpointer self);
static Block154Data* block154_data_ref (Block154Data* _data154_);
static void block154_data_unref (void * _userdata_);
static void __lambda105_ (WidgetsScheduleButton* self);
static void widgets_schedule_button_set_time (WidgetsScheduleButton* self,
                                       GDateTime* time);
static void ___lambda105__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda106_ (WidgetsScheduleButton* self);
static void ___lambda106__gtk_entry_activate (GtkEntry* _sender,
                                       gpointer self);
static void __lambda107_ (Block154Data* _data154_);
static void ___lambda107__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda108_ (Block154Data* _data154_);
static void ___lambda108__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda109_ (Block154Data* _data154_);
static void ___lambda109__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda110_ (WidgetsScheduleButton* self);
static void ___lambda110__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda111_ (WidgetsScheduleButton* self);
static void widgets_schedule_button_update_repeat_label (WidgetsScheduleButton* self);
static void ___lambda111__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                  gpointer self);
static void __lambda112_ (WidgetsScheduleButton* self);
static void ___lambda112__gtk_combo_box_changed (GtkComboBox* _sender,
                                          gpointer self);
static void __lambda113_ (WidgetsScheduleButton* self);
static void widgets_schedule_button_set_repeat (WidgetsScheduleButton* self);
static void ___lambda113__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda114_ (WidgetsScheduleButton* self);
static void ___lambda114__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static gchar* widgets_schedule_button_get_repeat_text (WidgetsScheduleButton* self);
static GObject * widgets_schedule_button_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _widgets_schedule_button___lambda120_ (WidgetsScheduleButton* self);
static void __widgets_schedule_button___lambda120__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _widgets_schedule_button___lambda121_ (WidgetsScheduleButton* self,
                                            const gchar* key);
static void __widgets_schedule_button___lambda121__g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self);
static void _widgets_schedule_button___lambda122_ (WidgetsScheduleButton* self);
static void __widgets_schedule_button___lambda122__utils_clock_format_changed (Utils* _sender,
                                                                        gpointer self);
static void widgets_schedule_button_finalize (GObject * obj);
static GType widgets_schedule_button_get_type_once (void);
static void _vala_widgets_schedule_button_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_widgets_schedule_button_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static GObject * widgets_schedule_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _widgets_schedule_row___lambda94_ (WidgetsScheduleRow* self);
static void __widgets_schedule_row___lambda94__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void widgets_schedule_row_finalize (GObject * obj);
static GType widgets_schedule_row_get_type_once (void);
static void _vala_widgets_schedule_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_widgets_schedule_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void widgets_time_alternative_button_update_label (WidgetsTimeAlternativeButton* self);
static GObject * widgets_time_alternative_button_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static void _widgets_time_alternative_button___lambda104_ (WidgetsTimeAlternativeButton* self,
                                                    const gchar* schema);
static void __widgets_time_alternative_button___lambda104__g_settings_changed (GSettings* _sender,
                                                                        const gchar* key,
                                                                        gpointer self);
static void widgets_time_alternative_button_finalize (GObject * obj);
static GType widgets_time_alternative_button_get_type_once (void);
static void _vala_widgets_time_alternative_button_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_widgets_time_alternative_button_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);

static inline gpointer
widgets_schedule_button_get_instance_private (WidgetsScheduleButton* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsScheduleButton_private_offset);
}

WidgetsScheduleButton*
widgets_schedule_button_construct (GType object_type,
                                   ObjectsItem* item)
{
	WidgetsScheduleButton * self = NULL;
	g_return_val_if_fail (item != NULL, NULL);
	self = (WidgetsScheduleButton*) g_object_new (object_type, "item", item, NULL);
	return self;
}

WidgetsScheduleButton*
widgets_schedule_button_new (ObjectsItem* item)
{
	return widgets_schedule_button_construct (WIDGETS_TYPE_SCHEDULE_BUTTON, item);
}

WidgetsScheduleButton*
widgets_schedule_button_construct_new_item (GType object_type)
{
	WidgetsScheduleButton * self = NULL;
	ObjectsItem* item = NULL;
	ObjectsItem* _tmp0_;
	_tmp0_ = objects_item_new ();
	item = _tmp0_;
	objects_item_set_id (item, (gint64) 0);
	self = (WidgetsScheduleButton*) g_object_new (object_type, "item", item, NULL);
	_g_object_unref0 (item);
	return self;
}

WidgetsScheduleButton*
widgets_schedule_button_new_new_item (void)
{
	return widgets_schedule_button_construct_new_item (WIDGETS_TYPE_SCHEDULE_BUTTON);
}

static void
__lambda115_ (WidgetsScheduleButton* self)
{
	g_signal_emit (self, widgets_schedule_button_signals[WIDGETS_SCHEDULE_BUTTON_POPOVER_OPENED_SIGNAL], 0, FALSE);
	gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
	widgets_schedule_button_save_item (self);
}

static void
___lambda115__gtk_popover_closed (GtkPopover* _sender,
                                  gpointer self)
{
	__lambda115_ ((WidgetsScheduleButton*) self);
}

static void
__lambda116_ (WidgetsScheduleButton* self)
{
	g_signal_emit (self, widgets_schedule_button_signals[WIDGETS_SCHEDULE_BUTTON_POPOVER_OPENED_SIGNAL], 0, TRUE);
}

static void
___lambda116__gtk_widget_show (GtkWidget* _sender,
                               gpointer self)
{
	__lambda116_ ((WidgetsScheduleButton*) self);
}

static void
__lambda117_ (WidgetsScheduleButton* self)
{
	GtkPopover* _tmp0_;
	_tmp0_ = self->priv->popover;
	gtk_popover_popdown (_tmp0_);
}

static void
___lambda117__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda117_ ((WidgetsScheduleButton*) self);
}

static void
__lambda118_ (WidgetsScheduleButton* self)
{
	GtkSearchEntry* _tmp0_;
	ObjectsDuedate* _tmp1_;
	ObjectsDuedate* _tmp2_;
	ObjectsDuedate* _tmp3_;
	GtkPopover* _tmp4_;
	_tmp0_ = self->priv->search_entry;
	gtk_entry_set_text ((GtkEntry*) _tmp0_, "");
	_tmp1_ = self->priv->_duedate;
	objects_duedate_set_datetime (_tmp1_, NULL);
	_tmp2_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp2_);
	_tmp3_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp3_);
	_tmp4_ = self->priv->popover;
	gtk_popover_popdown (_tmp4_);
}

static void
___lambda118__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda118_ ((WidgetsScheduleButton*) self);
}

static void
__lambda119_ (WidgetsScheduleButton* self)
{
	GtkStack* _tmp0_;
	_tmp0_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp0_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda119__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda119_ ((WidgetsScheduleButton*) self);
}

static void
widgets_schedule_button_create_popover (WidgetsScheduleButton* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	GtkPopover* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkButton* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkButton* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkButton* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* back_button = NULL;
	GtkButton* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkStyleContext* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkStack* _tmp19_;
	GtkStack* _tmp20_;
	GtkStack* _tmp21_;
	GtkStack* _tmp22_;
	GtkButton* _tmp23_;
	GtkStack* _tmp24_;
	GtkButton* done_button = NULL;
	GtkButton* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkStyleContext* _tmp28_;
	GtkLabel* title_label = NULL;
	GtkLabel* _tmp29_;
	GtkStyleContext* _tmp30_;
	GtkBox* header_box = NULL;
	GtkBox* _tmp31_;
	GtkStack* _tmp32_;
	GtkStack* _tmp33_;
	GtkStack* _tmp34_;
	GtkStack* _tmp35_;
	GtkStack* _tmp36_;
	GtkWidget* _tmp37_;
	GtkWidget* _tmp38_;
	GtkStack* _tmp39_;
	GtkWidget* _tmp40_;
	GtkWidget* _tmp41_;
	GtkStack* _tmp42_;
	GtkWidget* _tmp43_;
	GtkWidget* _tmp44_;
	GtkStack* _tmp45_;
	GtkWidget* _tmp46_;
	GtkWidget* _tmp47_;
	GtkGrid* popover_grid = NULL;
	GtkGrid* _tmp48_;
	GtkStack* _tmp49_;
	GtkPopover* _tmp50_;
	GtkPopover* _tmp51_;
	GtkPopover* _tmp52_;
	GtkButton* _tmp53_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp0_;
	_tmp1_ = self->priv->popover;
	gtk_popover_set_position (_tmp1_, GTK_POS_BOTTOM);
	_tmp2_ = self->priv->popover;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, "popover-background");
	_tmp4_ = (GtkButton*) gtk_button_new_with_label (_ ("Clear"));
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->clear_button);
	self->priv->clear_button = _tmp4_;
	_tmp5_ = self->priv->clear_button;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_add_class (_tmp6_, "flat");
	_tmp7_ = self->priv->clear_button;
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
	gtk_style_context_add_class (_tmp8_, "font-weight-600");
	_tmp9_ = self->priv->clear_button;
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
	gtk_style_context_add_class (_tmp10_, "label-danger");
	_tmp11_ = self->priv->clear_button;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	gtk_style_context_add_class (_tmp12_, "no-padding-left");
	_tmp13_ = self->priv->clear_button;
	gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_START);
	_tmp14_ = self->priv->clear_button;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp14_, FALSE);
	_tmp15_ = (GtkButton*) gtk_button_new_from_icon_name ("arrow-back-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp15_);
	back_button = _tmp15_;
	gtk_button_set_always_show_image (back_button, TRUE);
	gtk_widget_set_can_focus ((GtkWidget*) back_button, FALSE);
	gtk_button_set_label (back_button, _ ("Back"));
	gtk_widget_set_halign ((GtkWidget*) back_button, GTK_ALIGN_START);
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) back_button);
	gtk_style_context_add_class (_tmp16_, "back-b");
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) back_button);
	gtk_style_context_add_class (_tmp17_, "flat");
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) back_button);
	gtk_style_context_add_class (_tmp18_, "font-weight-600");
	_tmp19_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->clear_back_stack);
	self->priv->clear_back_stack = _tmp19_;
	_tmp20_ = self->priv->clear_back_stack;
	g_object_set ((GtkWidget*) _tmp20_, "expand", TRUE, NULL);
	_tmp21_ = self->priv->clear_back_stack;
	gtk_stack_set_transition_type (_tmp21_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	_tmp22_ = self->priv->clear_back_stack;
	_tmp23_ = self->priv->clear_button;
	gtk_stack_add_named (_tmp22_, (GtkWidget*) _tmp23_, "clear");
	_tmp24_ = self->priv->clear_back_stack;
	gtk_stack_add_named (_tmp24_, (GtkWidget*) back_button, "back");
	_tmp25_ = (GtkButton*) gtk_button_new_with_label (_ ("Done"));
	g_object_ref_sink (_tmp25_);
	done_button = _tmp25_;
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) done_button);
	gtk_style_context_add_class (_tmp26_, "flat");
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) done_button);
	gtk_style_context_add_class (_tmp27_, "font-weight-600");
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) done_button);
	gtk_style_context_add_class (_tmp28_, "no-padding-right");
	gtk_widget_set_can_focus ((GtkWidget*) done_button, FALSE);
	_tmp29_ = (GtkLabel*) gtk_label_new (_ ("Schedule"));
	g_object_ref_sink (_tmp29_);
	title_label = _tmp29_;
	_tmp30_ = gtk_widget_get_style_context ((GtkWidget*) title_label);
	gtk_style_context_add_class (_tmp30_, "font-bold");
	_tmp31_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp31_);
	header_box = _tmp31_;
	gtk_widget_set_margin_start ((GtkWidget*) header_box, 3);
	gtk_widget_set_margin_end ((GtkWidget*) header_box, 3);
	gtk_widget_set_hexpand ((GtkWidget*) header_box, TRUE);
	_tmp32_ = self->priv->clear_back_stack;
	gtk_box_pack_start (header_box, (GtkWidget*) _tmp32_, FALSE, FALSE, (guint) 0);
	gtk_box_set_center_widget (header_box, (GtkWidget*) title_label);
	gtk_box_pack_end (header_box, (GtkWidget*) done_button, FALSE, FALSE, (guint) 0);
	_tmp33_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->stack);
	self->priv->stack = _tmp33_;
	_tmp34_ = self->priv->stack;
	g_object_set ((GtkWidget*) _tmp34_, "expand", TRUE, NULL);
	_tmp35_ = self->priv->stack;
	gtk_stack_set_transition_type (_tmp35_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
	_tmp36_ = self->priv->stack;
	_tmp37_ = widgets_schedule_button_get_home_widget (self);
	_tmp38_ = _tmp37_;
	gtk_stack_add_named (_tmp36_, _tmp38_, "home");
	_g_object_unref0 (_tmp38_);
	_tmp39_ = self->priv->stack;
	_tmp40_ = widgets_schedule_button_get_pick_date_widget (self);
	_tmp41_ = _tmp40_;
	gtk_stack_add_named (_tmp39_, _tmp41_, "pick-date");
	_g_object_unref0 (_tmp41_);
	_tmp42_ = self->priv->stack;
	_tmp43_ = widgets_schedule_button_get_pick_time_widget (self);
	_tmp44_ = _tmp43_;
	gtk_stack_add_named (_tmp42_, _tmp44_, "pick-time");
	_g_object_unref0 (_tmp44_);
	_tmp45_ = self->priv->stack;
	_tmp46_ = widgets_schedule_button_get_pick_repeat_widget (self);
	_tmp47_ = _tmp46_;
	gtk_stack_add_named (_tmp45_, _tmp47_, "pick-repeat");
	_g_object_unref0 (_tmp47_);
	_tmp48_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp48_);
	popover_grid = _tmp48_;
	gtk_widget_set_margin_top ((GtkWidget*) popover_grid, 6);
	gtk_widget_set_margin_bottom ((GtkWidget*) popover_grid, 6);
	g_object_set ((GtkWidget*) popover_grid, "width-request", 235, NULL);
	gtk_orientable_set_orientation ((GtkOrientable*) popover_grid, GTK_ORIENTATION_VERTICAL);
	gtk_container_add ((GtkContainer*) popover_grid, (GtkWidget*) header_box);
	_tmp49_ = self->priv->stack;
	gtk_container_add ((GtkContainer*) popover_grid, (GtkWidget*) _tmp49_);
	gtk_widget_show_all ((GtkWidget*) popover_grid);
	_tmp50_ = self->priv->popover;
	gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) popover_grid);
	_tmp51_ = self->priv->popover;
	g_signal_connect_object (_tmp51_, "closed", (GCallback) ___lambda115__gtk_popover_closed, self, 0);
	_tmp52_ = self->priv->popover;
	g_signal_connect_object ((GtkWidget*) _tmp52_, "show", (GCallback) ___lambda116__gtk_widget_show, self, 0);
	g_signal_connect_object (done_button, "clicked", (GCallback) ___lambda117__gtk_button_clicked, self, 0);
	_tmp53_ = self->priv->clear_button;
	g_signal_connect_object (_tmp53_, "clicked", (GCallback) ___lambda118__gtk_button_clicked, self, 0);
	g_signal_connect_object (back_button, "clicked", (GCallback) ___lambda119__gtk_button_clicked, self, 0);
	_g_object_unref0 (popover_grid);
	_g_object_unref0 (header_box);
	_g_object_unref0 (title_label);
	_g_object_unref0 (done_button);
	_g_object_unref0 (back_button);
}

static void
__lambda95_ (WidgetsScheduleButton* self)
{
	Utils* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	_tmp0_ = planner_utils;
	_tmp1_ = g_date_time_new_now_local ();
	_tmp2_ = _tmp1_;
	_tmp3_ = utils_get_format_date (_tmp0_, _tmp2_);
	_tmp4_ = _tmp3_;
	widgets_schedule_button_set_date (self, _tmp4_);
	_g_date_time_unref0 (_tmp4_);
	_g_date_time_unref0 (_tmp2_);
}

static void
___lambda95__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                           gpointer self)
{
	__lambda95_ ((WidgetsScheduleButton*) self);
}

static void
__lambda96_ (WidgetsScheduleButton* self)
{
	Utils* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	_tmp0_ = planner_utils;
	_tmp1_ = g_date_time_new_now_local ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_date_time_add_days (_tmp2_, 1);
	_tmp4_ = _tmp3_;
	_tmp5_ = utils_get_format_date (_tmp0_, _tmp4_);
	_tmp6_ = _tmp5_;
	widgets_schedule_button_set_date (self, _tmp6_);
	_g_date_time_unref0 (_tmp6_);
	_g_date_time_unref0 (_tmp4_);
	_g_date_time_unref0 (_tmp2_);
}

static void
___lambda96__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                           gpointer self)
{
	__lambda96_ ((WidgetsScheduleButton*) self);
}

static void
__lambda97_ (WidgetsScheduleButton* self)
{
	GtkStack* _tmp0_;
	_tmp0_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp0_, "pick-date");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda97__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                           gpointer self)
{
	__lambda97_ ((WidgetsScheduleButton*) self);
}

static void
__lambda98_ (WidgetsScheduleButton* self)
{
	GtkStack* _tmp0_;
	GtkRevealer* _tmp1_;
	GraniteWidgetsTimePicker* _tmp2_;
	ObjectsDuedate* _tmp3_;
	_tmp0_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp0_, "pick-time");
	widgets_schedule_button_check_clear_button (self);
	_tmp1_ = self->priv->no_time_revealer;
	gtk_revealer_set_reveal_child (_tmp1_, FALSE);
	_tmp2_ = self->priv->time_picker;
	gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->_duedate;
	if (objects_duedate_is_valid (_tmp3_)) {
		Utils* _tmp4_;
		ObjectsDuedate* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp7_;
		_tmp4_ = planner_utils;
		_tmp5_ = self->priv->_duedate;
		_tmp6_ = objects_duedate_get_datetime (_tmp5_);
		_tmp7_ = _tmp6_;
		if (utils_has_time (_tmp4_, _tmp7_)) {
			GtkRevealer* _tmp8_;
			_tmp8_ = self->priv->no_time_revealer;
			gtk_revealer_set_reveal_child (_tmp8_, TRUE);
		}
	}
}

static void
___lambda98__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                           gpointer self)
{
	__lambda98_ ((WidgetsScheduleButton*) self);
}

static void
__lambda99_ (WidgetsScheduleButton* self)
{
	GtkStack* _tmp0_;
	_tmp0_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp0_, "pick-repeat");
	widgets_schedule_button_check_clear_button (self);
	widgets_schedule_button_check_repeat_widget (self);
}

static void
___lambda99__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                           gpointer self)
{
	__lambda99_ ((WidgetsScheduleButton*) self);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
__lambda100_ (WidgetsScheduleButton* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	_tmp0_ = self->priv->search_entry;
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = string_strip (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strcmp0 (_tmp4_, "") != 0;
	_g_free0 (_tmp4_);
	if (_tmp5_) {
		ObjectsDuedate* duedate = NULL;
		ServicesChronoChrono* _tmp6_;
		GtkSearchEntry* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		ObjectsDuedate* _tmp14_;
		ObjectsDuedate* _tmp15_;
		ObjectsDuedate* _tmp16_;
		_tmp6_ = self->priv->_chrono;
		_tmp7_ = self->priv->search_entry;
		_tmp8_ = gtk_entry_get_text ((GtkEntry*) _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_utf8_strdown (_tmp9_, (gssize) -1);
		_tmp11_ = _tmp10_;
		_tmp12_ = string_strip (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = services_chrono_chrono_parse (_tmp6_, _tmp13_, "en");
		_tmp15_ = _tmp14_;
		_g_free0 (_tmp13_);
		_g_free0 (_tmp11_);
		duedate = _tmp15_;
		_tmp16_ = duedate;
		if (_tmp16_ != NULL) {
			WidgetsScheduleRow* _tmp17_;
			WidgetsScheduleRow* _tmp18_;
			WidgetsScheduleRow* _tmp19_;
			WidgetsScheduleRow* _tmp20_;
			WidgetsScheduleRow* _tmp21_;
			WidgetsScheduleRow* _tmp22_;
			ObjectsDuedate* _tmp23_;
			gboolean _tmp24_;
			gboolean _tmp25_;
			_tmp17_ = self->priv->parse_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp17_, TRUE);
			_tmp18_ = self->priv->today_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp18_, FALSE);
			_tmp19_ = self->priv->tomorrow_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp19_, FALSE);
			_tmp20_ = self->priv->calendar_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp20_, FALSE);
			_tmp21_ = self->priv->time_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp21_, FALSE);
			_tmp22_ = self->priv->repeat_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp22_, FALSE);
			_tmp23_ = duedate;
			_tmp24_ = objects_duedate_get_is_recurring (_tmp23_);
			_tmp25_ = _tmp24_;
			if (_tmp25_) {
				WidgetsScheduleRow* _tmp26_;
				ObjectsDuedate* _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				WidgetsScheduleRow* _tmp30_;
				_tmp26_ = self->priv->parse_row;
				_tmp27_ = duedate;
				_tmp28_ = objects_duedate_get_text (_tmp27_);
				_tmp29_ = _tmp28_;
				widgets_schedule_row_set_text (_tmp26_, _tmp29_);
				_tmp30_ = self->priv->parse_row;
				widgets_schedule_row_set_icon (_tmp30_, "media-playlist-repeat-symbolic");
			} else {
				WidgetsScheduleRow* _tmp31_;
				ObjectsDuedate* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				WidgetsScheduleRow* _tmp35_;
				ObjectsDuedate* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				_tmp31_ = self->priv->parse_row;
				_tmp32_ = duedate;
				_tmp33_ = objects_duedate_get_relative_date_format (_tmp32_);
				_tmp34_ = _tmp33_;
				widgets_schedule_row_set_text (_tmp31_, _tmp34_);
				_g_free0 (_tmp34_);
				_tmp35_ = self->priv->parse_row;
				_tmp36_ = duedate;
				_tmp37_ = objects_duedate_get_icon (_tmp36_);
				_tmp38_ = _tmp37_;
				widgets_schedule_row_set_icon (_tmp35_, _tmp38_);
				_g_free0 (_tmp38_);
			}
		} else {
			WidgetsScheduleRow* _tmp39_;
			WidgetsScheduleRow* _tmp40_;
			WidgetsScheduleRow* _tmp41_;
			WidgetsScheduleRow* _tmp42_;
			WidgetsScheduleRow* _tmp43_;
			WidgetsScheduleRow* _tmp44_;
			_tmp39_ = self->priv->parse_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp39_, FALSE);
			_tmp40_ = self->priv->today_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp40_, TRUE);
			_tmp41_ = self->priv->tomorrow_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp41_, TRUE);
			_tmp42_ = self->priv->calendar_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp42_, TRUE);
			_tmp43_ = self->priv->time_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp43_, TRUE);
			_tmp44_ = self->priv->repeat_row;
			gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp44_, TRUE);
		}
		_g_object_unref0 (duedate);
	} else {
		WidgetsScheduleRow* _tmp45_;
		WidgetsScheduleRow* _tmp46_;
		WidgetsScheduleRow* _tmp47_;
		WidgetsScheduleRow* _tmp48_;
		WidgetsScheduleRow* _tmp49_;
		WidgetsScheduleRow* _tmp50_;
		_tmp45_ = self->priv->parse_row;
		gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp45_, FALSE);
		_tmp46_ = self->priv->today_row;
		gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp46_, TRUE);
		_tmp47_ = self->priv->tomorrow_row;
		gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp47_, TRUE);
		_tmp48_ = self->priv->calendar_row;
		gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp48_, TRUE);
		_tmp49_ = self->priv->time_row;
		gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp49_, TRUE);
		_tmp50_ = self->priv->repeat_row;
		gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp50_, TRUE);
	}
}

static void
___lambda100__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                               gpointer self)
{
	__lambda100_ ((WidgetsScheduleButton*) self);
}

static void
__lambda101_ (WidgetsScheduleButton* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->search_entry;
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
	_tmp2_ = _tmp1_;
	widgets_schedule_button_set_parse_item (self, _tmp2_);
}

static void
___lambda101__gtk_entry_activate (GtkEntry* _sender,
                                  gpointer self)
{
	__lambda101_ ((WidgetsScheduleButton*) self);
}

static void
__lambda102_ (WidgetsScheduleButton* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->search_entry;
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
	_tmp2_ = _tmp1_;
	widgets_schedule_button_set_parse_item (self, _tmp2_);
}

static void
___lambda102__widgets_schedule_row_clicked (WidgetsScheduleRow* _sender,
                                            gpointer self)
{
	__lambda102_ ((WidgetsScheduleButton*) self);
}

static GtkWidget*
widgets_schedule_button_get_home_widget (WidgetsScheduleButton* self)
{
	GtkSearchEntry* _tmp0_;
	GtkSearchEntry* _tmp1_;
	GtkSearchEntry* _tmp2_;
	GtkSearchEntry* _tmp3_;
	GtkSearchEntry* _tmp4_;
	GtkSearchEntry* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkSearchEntry* _tmp7_;
	GtkStyleContext* _tmp8_;
	WidgetsScheduleRow* _tmp9_;
	WidgetsScheduleRow* _tmp10_;
	WidgetsScheduleRow* _tmp11_;
	WidgetsScheduleRow* _tmp12_;
	GtkImage* _tmp13_;
	GtkStyleContext* _tmp14_;
	WidgetsScheduleRow* _tmp15_;
	WidgetsScheduleRow* _tmp16_;
	WidgetsScheduleRow* _tmp17_;
	WidgetsScheduleRow* _tmp18_;
	GtkImage* _tmp19_;
	WidgetsScheduleRow* _tmp20_;
	GtkLabel* _tmp21_;
	WidgetsScheduleRow* _tmp22_;
	GtkImage* _tmp23_;
	WidgetsScheduleRow* _tmp24_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp25_;
	GtkSearchEntry* _tmp26_;
	WidgetsScheduleRow* _tmp27_;
	WidgetsScheduleRow* _tmp28_;
	WidgetsScheduleRow* _tmp29_;
	WidgetsScheduleRow* _tmp30_;
	WidgetsScheduleRow* _tmp31_;
	WidgetsScheduleRow* _tmp32_;
	WidgetsScheduleRow* _tmp33_;
	WidgetsScheduleRow* _tmp34_;
	WidgetsScheduleRow* _tmp35_;
	WidgetsScheduleRow* _tmp36_;
	WidgetsScheduleRow* _tmp37_;
	GtkSearchEntry* _tmp38_;
	GtkSearchEntry* _tmp39_;
	WidgetsScheduleRow* _tmp40_;
	GtkWidget* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (GtkSearchEntry*) gtk_search_entry_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->search_entry);
	self->priv->search_entry = _tmp0_;
	_tmp1_ = self->priv->search_entry;
	g_object_set ((GtkWidget*) _tmp1_, "margin", 6, NULL);
	_tmp2_ = self->priv->search_entry;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, 12);
	_tmp3_ = self->priv->search_entry;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp3_, 12);
	_tmp4_ = self->priv->search_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp4_, TRUE);
	_tmp5_ = self->priv->search_entry;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_add_class (_tmp6_, "border-radius-4");
	_tmp7_ = self->priv->search_entry;
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
	gtk_style_context_add_class (_tmp8_, "popover-entry");
	_tmp9_ = widgets_schedule_row_new (_ ("Today"), "help-about-symbolic", FALSE);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->parse_row);
	self->priv->parse_row = _tmp9_;
	_tmp10_ = self->priv->parse_row;
	gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp10_, FALSE);
	_tmp11_ = widgets_schedule_row_new (_ ("Today"), "help-about-symbolic", FALSE);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->today_row);
	self->priv->today_row = _tmp11_;
	_tmp12_ = self->priv->today_row;
	_tmp13_ = _tmp12_->item_image;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, "today");
	_tmp15_ = widgets_schedule_row_new (_ ("Tomorrow"), "go-jump-symbolic", FALSE);
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->tomorrow_row);
	self->priv->tomorrow_row = _tmp15_;
	_tmp16_ = widgets_schedule_row_new (_ ("Pick Date"), "office-calendar-symbolic", TRUE);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->calendar_row);
	self->priv->calendar_row = _tmp16_;
	_tmp17_ = widgets_schedule_row_new (_ ("Pick Time"), "appointment-new-symbolic", TRUE);
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->time_row);
	self->priv->time_row = _tmp17_;
	_tmp18_ = self->priv->time_row;
	_tmp19_ = _tmp18_->item_image;
	gtk_image_set_pixel_size (_tmp19_, 14);
	_tmp20_ = self->priv->time_row;
	_tmp21_ = _tmp20_->item_label;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp21_, 1);
	_tmp22_ = self->priv->time_row;
	_tmp23_ = _tmp22_->item_image;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp23_, 1);
	_tmp24_ = widgets_schedule_row_new (_ ("Repeat"), "emblem-synchronizing-symbolic", TRUE);
	g_object_ref_sink (_tmp24_);
	_g_object_unref0 (self->priv->repeat_row);
	self->priv->repeat_row = _tmp24_;
	_tmp25_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp25_);
	grid = _tmp25_;
	gtk_orientable_set_orientation ((GtkOrientable*) grid, GTK_ORIENTATION_VERTICAL);
	_tmp26_ = self->priv->search_entry;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp26_);
	_tmp27_ = self->priv->parse_row;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp27_);
	_tmp28_ = self->priv->today_row;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp28_);
	_tmp29_ = self->priv->tomorrow_row;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp29_);
	_tmp30_ = self->priv->calendar_row;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp30_);
	_tmp31_ = self->priv->time_row;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp31_);
	_tmp32_ = self->priv->repeat_row;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp32_);
	_tmp33_ = self->priv->today_row;
	g_signal_connect_object (_tmp33_, "clicked", (GCallback) ___lambda95__widgets_schedule_row_clicked, self, 0);
	_tmp34_ = self->priv->tomorrow_row;
	g_signal_connect_object (_tmp34_, "clicked", (GCallback) ___lambda96__widgets_schedule_row_clicked, self, 0);
	_tmp35_ = self->priv->calendar_row;
	g_signal_connect_object (_tmp35_, "clicked", (GCallback) ___lambda97__widgets_schedule_row_clicked, self, 0);
	_tmp36_ = self->priv->time_row;
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) ___lambda98__widgets_schedule_row_clicked, self, 0);
	_tmp37_ = self->priv->repeat_row;
	g_signal_connect_object (_tmp37_, "clicked", (GCallback) ___lambda99__widgets_schedule_row_clicked, self, 0);
	_tmp38_ = self->priv->search_entry;
	g_signal_connect_object (_tmp38_, "search-changed", (GCallback) ___lambda100__gtk_search_entry_search_changed, self, 0);
	_tmp39_ = self->priv->search_entry;
	g_signal_connect_object ((GtkEntry*) _tmp39_, "activate", (GCallback) ___lambda101__gtk_entry_activate, self, 0);
	_tmp40_ = self->priv->parse_row;
	g_signal_connect_object (_tmp40_, "clicked", (GCallback) ___lambda102__widgets_schedule_row_clicked, self, 0);
	result = (GtkWidget*) grid;
	return result;
}

static void
widgets_schedule_button_set_parse_item (WidgetsScheduleButton* self,
                                        const gchar* text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	GtkSearchEntry* _tmp37_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = string_strip (text);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strcmp0 (_tmp1_, "") != 0;
	_g_free0 (_tmp1_);
	if (_tmp2_) {
		ObjectsDuedate* duedate_parse = NULL;
		ServicesChronoChrono* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		ObjectsDuedate* _tmp8_;
		ObjectsDuedate* _tmp9_;
		ObjectsDuedate* _tmp10_;
		_tmp3_ = self->priv->_chrono;
		_tmp4_ = g_utf8_strdown (text, (gssize) -1);
		_tmp5_ = _tmp4_;
		_tmp6_ = string_strip (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = services_chrono_chrono_parse (_tmp3_, _tmp7_, "en");
		_tmp9_ = _tmp8_;
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
		duedate_parse = _tmp9_;
		_tmp10_ = duedate_parse;
		if (_tmp10_ != NULL) {
			ObjectsDuedate* _tmp11_;
			ObjectsDuedate* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* _tmp14_;
			ObjectsDuedate* _tmp15_;
			ObjectsDuedate* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			ObjectsDuedate* _tmp19_;
			ObjectsDuedate* _tmp20_;
			gboolean _tmp21_;
			gboolean _tmp22_;
			ObjectsDuedate* _tmp23_;
			ObjectsDuedate* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			ObjectsDuedate* _tmp27_;
			gboolean _tmp28_;
			gboolean _tmp29_;
			ObjectsDuedate* _tmp34_;
			ObjectsDuedate* _tmp35_;
			GtkPopover* _tmp36_;
			_tmp11_ = self->priv->_duedate;
			_tmp12_ = duedate_parse;
			_tmp13_ = objects_duedate_get_datetime (_tmp12_);
			_tmp14_ = _tmp13_;
			objects_duedate_set_datetime (_tmp11_, _tmp14_);
			_tmp15_ = self->priv->_duedate;
			_tmp16_ = duedate_parse;
			_tmp17_ = objects_duedate_get_lang (_tmp16_);
			_tmp18_ = _tmp17_;
			objects_duedate_set_lang (_tmp15_, _tmp18_);
			_tmp19_ = self->priv->_duedate;
			_tmp20_ = duedate_parse;
			_tmp21_ = objects_duedate_get_is_recurring (_tmp20_);
			_tmp22_ = _tmp21_;
			objects_duedate_set_is_recurring (_tmp19_, _tmp22_);
			_tmp23_ = self->priv->_duedate;
			_tmp24_ = duedate_parse;
			_tmp25_ = objects_duedate_get_text (_tmp24_);
			_tmp26_ = _tmp25_;
			objects_duedate_set_text (_tmp23_, _tmp26_);
			_tmp27_ = self->priv->_duedate;
			_tmp28_ = objects_duedate_get_is_recurring (_tmp27_);
			_tmp29_ = _tmp28_;
			if (_tmp29_) {
				GtkLabel* _tmp30_;
				ObjectsDuedate* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				_tmp30_ = self->priv->repeat_label;
				_tmp31_ = self->priv->_duedate;
				_tmp32_ = objects_duedate_get_text (_tmp31_);
				_tmp33_ = _tmp32_;
				gtk_label_set_label (_tmp30_, _tmp33_);
			}
			_tmp34_ = self->priv->_duedate;
			widgets_schedule_button_update_button (self, _tmp34_);
			_tmp35_ = self->priv->_duedate;
			widgets_schedule_button_update_popover (self, _tmp35_);
			_tmp36_ = self->priv->popover;
			gtk_popover_popdown (_tmp36_);
		}
		_g_object_unref0 (duedate_parse);
	}
	_tmp37_ = self->priv->search_entry;
	gtk_entry_set_text ((GtkEntry*) _tmp37_, "");
}

static void
__lambda103_ (WidgetsScheduleButton* self,
              GDateTime* date)
{
	Utils* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GtkStack* _tmp3_;
	g_return_if_fail (date != NULL);
	_tmp0_ = planner_utils;
	_tmp1_ = utils_get_format_date (_tmp0_, date);
	_tmp2_ = _tmp1_;
	widgets_schedule_button_set_date (self, _tmp2_);
	_g_date_time_unref0 (_tmp2_);
	_tmp3_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp3_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda103__widgets_calendar_calendar_selection_changed (WidgetsCalendarCalendar* _sender,
                                                           GDateTime* date,
                                                           gpointer self)
{
	__lambda103_ ((WidgetsScheduleButton*) self, date);
}

static GtkWidget*
widgets_schedule_button_get_pick_date_widget (WidgetsScheduleButton* self)
{
	WidgetsCalendarCalendar* _tmp0_;
	WidgetsCalendarCalendar* _tmp1_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp2_;
	WidgetsCalendarCalendar* _tmp3_;
	WidgetsCalendarCalendar* _tmp4_;
	GtkWidget* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = widgets_calendar_calendar_new (TRUE);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->calendar);
	self->priv->calendar = _tmp0_;
	_tmp1_ = self->priv->calendar;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp2_);
	grid = _tmp2_;
	gtk_orientable_set_orientation ((GtkOrientable*) grid, GTK_ORIENTATION_VERTICAL);
	_tmp3_ = self->priv->calendar;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp3_);
	_tmp4_ = self->priv->calendar;
	g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) ___lambda103__widgets_calendar_calendar_selection_changed, self, 0);
	result = (GtkWidget*) grid;
	return result;
}

static Block154Data*
block154_data_ref (Block154Data* _data154_)
{
	g_atomic_int_inc (&_data154_->_ref_count_);
	return _data154_;
}

static void
block154_data_unref (void * _userdata_)
{
	Block154Data* _data154_;
	_data154_ = (Block154Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data154_->_ref_count_)) {
		WidgetsScheduleButton* self;
		self = _data154_->self;
		_g_object_unref0 (_data154_->evening_button);
		_g_object_unref0 (_data154_->afternoon_button);
		_g_object_unref0 (_data154_->morning_button);
		_g_object_unref0 (self);
		g_slice_free (Block154Data, _data154_);
	}
}

static void
__lambda105_ (WidgetsScheduleButton* self)
{
	GraniteWidgetsTimePicker* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GtkStack* _tmp3_;
	_tmp0_ = self->priv->time_picker;
	_tmp1_ = granite_widgets_time_picker_get_time (_tmp0_);
	_tmp2_ = _tmp1_;
	widgets_schedule_button_set_time (self, _tmp2_);
	_tmp3_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp3_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda105__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda105_ ((WidgetsScheduleButton*) self);
}

static void
__lambda106_ (WidgetsScheduleButton* self)
{
	GraniteWidgetsTimePicker* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GtkStack* _tmp3_;
	_tmp0_ = self->priv->time_picker;
	_tmp1_ = granite_widgets_time_picker_get_time (_tmp0_);
	_tmp2_ = _tmp1_;
	widgets_schedule_button_set_time (self, _tmp2_);
	_tmp3_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp3_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda106__gtk_entry_activate (GtkEntry* _sender,
                                  gpointer self)
{
	__lambda106_ ((WidgetsScheduleButton*) self);
}

static void
__lambda107_ (Block154Data* _data154_)
{
	WidgetsScheduleButton* self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GtkStack* _tmp2_;
	self = _data154_->self;
	_tmp0_ = widgets_time_alternative_button_get_time (_data154_->morning_button);
	_tmp1_ = _tmp0_;
	widgets_schedule_button_set_time (self, _tmp1_);
	_tmp2_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp2_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda107__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda107_ (self);
}

static void
__lambda108_ (Block154Data* _data154_)
{
	WidgetsScheduleButton* self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GtkStack* _tmp2_;
	self = _data154_->self;
	_tmp0_ = widgets_time_alternative_button_get_time (_data154_->afternoon_button);
	_tmp1_ = _tmp0_;
	widgets_schedule_button_set_time (self, _tmp1_);
	_tmp2_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp2_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda108__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda108_ (self);
}

static void
__lambda109_ (Block154Data* _data154_)
{
	WidgetsScheduleButton* self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GtkStack* _tmp2_;
	self = _data154_->self;
	_tmp0_ = widgets_time_alternative_button_get_time (_data154_->evening_button);
	_tmp1_ = _tmp0_;
	widgets_schedule_button_set_time (self, _tmp1_);
	_tmp2_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp2_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda109__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda109_ (self);
}

static void
__lambda110_ (WidgetsScheduleButton* self)
{
	ObjectsDuedate* _tmp0_;
	ObjectsDuedate* _tmp1_;
	ObjectsDuedate* _tmp2_;
	GtkStack* _tmp3_;
	_tmp0_ = self->priv->_duedate;
	objects_duedate_no_time (_tmp0_);
	_tmp1_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp1_);
	_tmp2_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp2_);
	_tmp3_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp3_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda110__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda110_ ((WidgetsScheduleButton*) self);
}

static GtkWidget*
widgets_schedule_button_get_pick_time_widget (WidgetsScheduleButton* self)
{
	Block154Data* _data154_;
	GraniteWidgetsTimePicker* _tmp0_;
	GraniteWidgetsTimePicker* _tmp1_;
	GraniteWidgetsTimePicker* _tmp2_;
	GraniteWidgetsTimePicker* _tmp3_;
	GraniteWidgetsTimePicker* _tmp4_;
	GtkStyleContext* _tmp5_;
	GraniteWidgetsTimePicker* _tmp6_;
	GtkStyleContext* _tmp7_;
	WidgetsTimeAlternativeButton* _tmp8_;
	WidgetsTimeAlternativeButton* _tmp9_;
	WidgetsTimeAlternativeButton* _tmp10_;
	GtkGrid* times_grid = NULL;
	GtkGrid* _tmp11_;
	GtkButton* set_time_button = NULL;
	GtkButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkButton* no_time_button = NULL;
	GtkButton* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkRevealer* _tmp18_;
	GtkRevealer* _tmp19_;
	GtkRevealer* _tmp20_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp21_;
	GraniteWidgetsTimePicker* _tmp22_;
	GtkRevealer* _tmp23_;
	GraniteWidgetsTimePicker* _tmp24_;
	GtkWidget* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_data154_ = g_slice_new0 (Block154Data);
	_data154_->_ref_count_ = 1;
	_data154_->self = g_object_ref (self);
	_tmp0_ = granite_widgets_time_picker_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->time_picker);
	self->priv->time_picker = _tmp0_;
	_tmp1_ = self->priv->time_picker;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = self->priv->time_picker;
	g_object_set ((GtkWidget*) _tmp2_, "margin", 12, NULL);
	_tmp3_ = self->priv->time_picker;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp3_, 24);
	_tmp4_ = self->priv->time_picker;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, "border-radius-4");
	_tmp6_ = self->priv->time_picker;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "popover-entry");
	_tmp8_ = widgets_time_alternative_button_new (_ ("Morning"), "morning-time");
	g_object_ref_sink (_tmp8_);
	_data154_->morning_button = _tmp8_;
	_tmp9_ = widgets_time_alternative_button_new (_ ("Afternoon"), "afternoon-time");
	g_object_ref_sink (_tmp9_);
	_data154_->afternoon_button = _tmp9_;
	_tmp10_ = widgets_time_alternative_button_new (_ ("Evening"), "evening-time");
	g_object_ref_sink (_tmp10_);
	_data154_->evening_button = _tmp10_;
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp11_);
	times_grid = _tmp11_;
	gtk_grid_set_column_homogeneous (times_grid, TRUE);
	gtk_container_add ((GtkContainer*) times_grid, (GtkWidget*) _data154_->morning_button);
	gtk_container_add ((GtkContainer*) times_grid, (GtkWidget*) _data154_->afternoon_button);
	gtk_container_add ((GtkContainer*) times_grid, (GtkWidget*) _data154_->evening_button);
	_tmp12_ = (GtkButton*) gtk_button_new_with_label (_ ("Set Time"));
	g_object_ref_sink (_tmp12_);
	set_time_button = _tmp12_;
	gtk_widget_set_margin_top ((GtkWidget*) set_time_button, 12);
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) set_time_button);
	gtk_style_context_add_class (_tmp13_, "suggested-action");
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) set_time_button);
	gtk_style_context_add_class (_tmp14_, "border-radius-50");
	gtk_widget_set_halign ((GtkWidget*) set_time_button, GTK_ALIGN_CENTER);
	_tmp15_ = (GtkButton*) gtk_button_new_with_label (_ ("No Time"));
	g_object_ref_sink (_tmp15_);
	no_time_button = _tmp15_;
	gtk_widget_set_margin_top ((GtkWidget*) no_time_button, 6);
	gtk_widget_set_can_focus ((GtkWidget*) no_time_button, FALSE);
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) no_time_button);
	gtk_style_context_add_class (_tmp16_, "flat");
	gtk_widget_set_halign ((GtkWidget*) no_time_button, GTK_ALIGN_CENTER);
	_tmp17_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->no_time_revealer);
	self->priv->no_time_revealer = _tmp17_;
	_tmp18_ = self->priv->no_time_revealer;
	gtk_revealer_set_transition_type (_tmp18_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	_tmp19_ = self->priv->no_time_revealer;
	gtk_revealer_set_reveal_child (_tmp19_, TRUE);
	_tmp20_ = self->priv->no_time_revealer;
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) no_time_button);
	_tmp21_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp21_);
	grid = _tmp21_;
	gtk_orientable_set_orientation ((GtkOrientable*) grid, GTK_ORIENTATION_VERTICAL);
	_tmp22_ = self->priv->time_picker;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp22_);
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) times_grid);
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) set_time_button);
	_tmp23_ = self->priv->no_time_revealer;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp23_);
	g_signal_connect_object (set_time_button, "clicked", (GCallback) ___lambda105__gtk_button_clicked, self, 0);
	_tmp24_ = self->priv->time_picker;
	g_signal_connect_object ((GtkEntry*) _tmp24_, "activate", (GCallback) ___lambda106__gtk_entry_activate, self, 0);
	g_signal_connect_data ((GtkButton*) _data154_->morning_button, "clicked", (GCallback) ___lambda107__gtk_button_clicked, block154_data_ref (_data154_), (GClosureNotify) block154_data_unref, 0);
	g_signal_connect_data ((GtkButton*) _data154_->afternoon_button, "clicked", (GCallback) ___lambda108__gtk_button_clicked, block154_data_ref (_data154_), (GClosureNotify) block154_data_unref, 0);
	g_signal_connect_data ((GtkButton*) _data154_->evening_button, "clicked", (GCallback) ___lambda109__gtk_button_clicked, block154_data_ref (_data154_), (GClosureNotify) block154_data_unref, 0);
	g_signal_connect_object (no_time_button, "clicked", (GCallback) ___lambda110__gtk_button_clicked, self, 0);
	result = (GtkWidget*) grid;
	_g_object_unref0 (no_time_button);
	_g_object_unref0 (set_time_button);
	_g_object_unref0 (times_grid);
	block154_data_unref (_data154_);
	_data154_ = NULL;
	return result;
}

static void
__lambda111_ (WidgetsScheduleButton* self)
{
	widgets_schedule_button_update_repeat_label (self);
}

static void
___lambda111__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                             gpointer self)
{
	__lambda111_ ((WidgetsScheduleButton*) self);
}

static void
__lambda112_ (WidgetsScheduleButton* self)
{
	widgets_schedule_button_update_repeat_label (self);
}

static void
___lambda112__gtk_combo_box_changed (GtkComboBox* _sender,
                                     gpointer self)
{
	__lambda112_ ((WidgetsScheduleButton*) self);
}

static void
__lambda113_ (WidgetsScheduleButton* self)
{
	GtkStack* _tmp0_;
	widgets_schedule_button_set_repeat (self);
	_tmp0_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp0_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda113__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda113_ ((WidgetsScheduleButton*) self);
}

static void
__lambda114_ (WidgetsScheduleButton* self)
{
	ObjectsDuedate* _tmp0_;
	ObjectsDuedate* _tmp1_;
	ObjectsDuedate* _tmp2_;
	ObjectsDuedate* _tmp3_;
	ObjectsDuedate* _tmp4_;
	GtkStack* _tmp5_;
	_tmp0_ = self->priv->_duedate;
	objects_duedate_set_is_recurring (_tmp0_, FALSE);
	_tmp1_ = self->priv->_duedate;
	objects_duedate_set_text (_tmp1_, "");
	_tmp2_ = self->priv->_duedate;
	objects_duedate_set_lang (_tmp2_, "");
	_tmp3_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp3_);
	_tmp4_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp4_);
	_tmp5_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp5_, "home");
	widgets_schedule_button_check_clear_button (self);
}

static void
___lambda114__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	__lambda114_ ((WidgetsScheduleButton*) self);
}

static GtkWidget*
widgets_schedule_button_get_pick_repeat_widget (WidgetsScheduleButton* self)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkSpinButton* _tmp5_;
	GtkSpinButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkComboBoxText* _tmp8_;
	GtkComboBoxText* _tmp9_;
	GtkComboBoxText* _tmp10_;
	GtkComboBoxText* _tmp11_;
	GtkComboBoxText* _tmp12_;
	GtkComboBoxText* _tmp13_;
	GtkGrid* repeat_grid = NULL;
	GtkGrid* _tmp14_;
	GtkSpinButton* _tmp15_;
	GtkComboBoxText* _tmp16_;
	GtkButton* set_repeat_button = NULL;
	GtkButton* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkButton* no_repeat_button = NULL;
	GtkButton* _tmp20_;
	GtkStyleContext* _tmp21_;
	GtkRevealer* _tmp22_;
	GtkRevealer* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkRevealer* _tmp25_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkRevealer* _tmp28_;
	GtkSpinButton* _tmp29_;
	GtkComboBoxText* _tmp30_;
	GtkWidget* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->repeat_label);
	self->priv->repeat_label = _tmp0_;
	_tmp1_ = self->priv->repeat_label;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, 12);
	_tmp2_ = self->priv->repeat_label;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp2_, 6);
	_tmp3_ = self->priv->repeat_label;
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
	gtk_style_context_add_class (_tmp4_, "repeat-label");
	_tmp5_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) 100, (gdouble) 1);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->repeat_spin_button);
	self->priv->repeat_spin_button = _tmp5_;
	_tmp6_ = self->priv->repeat_spin_button;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "popover-spinbutton");
	_tmp8_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->repeat_combobox);
	self->priv->repeat_combobox = _tmp8_;
	_tmp9_ = self->priv->repeat_combobox;
	gtk_combo_box_text_append_text (_tmp9_, _ ("Day"));
	_tmp10_ = self->priv->repeat_combobox;
	gtk_combo_box_text_append_text (_tmp10_, _ ("Week"));
	_tmp11_ = self->priv->repeat_combobox;
	gtk_combo_box_text_append_text (_tmp11_, _ ("Month"));
	_tmp12_ = self->priv->repeat_combobox;
	gtk_combo_box_text_append_text (_tmp12_, _ ("Year"));
	_tmp13_ = self->priv->repeat_combobox;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp13_, 0);
	_tmp14_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp14_);
	repeat_grid = _tmp14_;
	gtk_grid_set_column_spacing (repeat_grid, 6);
	gtk_widget_set_hexpand ((GtkWidget*) repeat_grid, TRUE);
	gtk_widget_set_halign ((GtkWidget*) repeat_grid, GTK_ALIGN_CENTER);
	_tmp15_ = self->priv->repeat_spin_button;
	gtk_container_add ((GtkContainer*) repeat_grid, (GtkWidget*) _tmp15_);
	_tmp16_ = self->priv->repeat_combobox;
	gtk_container_add ((GtkContainer*) repeat_grid, (GtkWidget*) _tmp16_);
	_tmp17_ = (GtkButton*) gtk_button_new_with_label (_ ("Set Repeat"));
	g_object_ref_sink (_tmp17_);
	set_repeat_button = _tmp17_;
	gtk_widget_set_margin_top ((GtkWidget*) set_repeat_button, 12);
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) set_repeat_button);
	gtk_style_context_add_class (_tmp18_, "suggested-action");
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) set_repeat_button);
	gtk_style_context_add_class (_tmp19_, "border-radius-50");
	gtk_widget_set_halign ((GtkWidget*) set_repeat_button, GTK_ALIGN_CENTER);
	_tmp20_ = (GtkButton*) gtk_button_new_with_label (_ ("No Repeat"));
	g_object_ref_sink (_tmp20_);
	no_repeat_button = _tmp20_;
	gtk_widget_set_margin_top ((GtkWidget*) no_repeat_button, 6);
	gtk_widget_set_can_focus ((GtkWidget*) no_repeat_button, FALSE);
	_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) no_repeat_button);
	gtk_style_context_add_class (_tmp21_, "flat");
	gtk_widget_set_halign ((GtkWidget*) no_repeat_button, GTK_ALIGN_CENTER);
	_tmp22_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->no_repeat_revealer);
	self->priv->no_repeat_revealer = _tmp22_;
	_tmp23_ = self->priv->no_repeat_revealer;
	gtk_revealer_set_transition_type (_tmp23_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	_tmp24_ = self->priv->no_repeat_revealer;
	gtk_revealer_set_reveal_child (_tmp24_, TRUE);
	_tmp25_ = self->priv->no_repeat_revealer;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) no_repeat_button);
	_tmp26_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp26_);
	grid = _tmp26_;
	gtk_orientable_set_orientation ((GtkOrientable*) grid, GTK_ORIENTATION_VERTICAL);
	_tmp27_ = self->priv->repeat_label;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp27_);
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) repeat_grid);
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) set_repeat_button);
	_tmp28_ = self->priv->no_repeat_revealer;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp28_);
	_tmp29_ = self->priv->repeat_spin_button;
	g_signal_connect_object (_tmp29_, "value-changed", (GCallback) ___lambda111__gtk_spin_button_value_changed, self, 0);
	_tmp30_ = self->priv->repeat_combobox;
	g_signal_connect_object ((GtkComboBox*) _tmp30_, "changed", (GCallback) ___lambda112__gtk_combo_box_changed, self, 0);
	g_signal_connect_object (set_repeat_button, "clicked", (GCallback) ___lambda113__gtk_button_clicked, self, 0);
	g_signal_connect_object (no_repeat_button, "clicked", (GCallback) ___lambda114__gtk_button_clicked, self, 0);
	result = (GtkWidget*) grid;
	_g_object_unref0 (no_repeat_button);
	_g_object_unref0 (set_repeat_button);
	_g_object_unref0 (repeat_grid);
	return result;
}

static void
widgets_schedule_button_update_repeat_label (WidgetsScheduleButton* self)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	GtkSpinButton* _tmp1_;
	GtkLabel* _tmp34_;
	GtkSpinButton* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("");
	text = _tmp0_;
	_tmp1_ = self->priv->repeat_spin_button;
	if (gtk_spin_button_get_value_as_int (_tmp1_) <= 1) {
		GtkComboBoxText* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = self->priv->repeat_combobox;
		_tmp3_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp2_);
		_tmp4_ = _tmp3_;
		if (_tmp4_ == 0) {
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("day");
			_g_free0 (text);
			text = _tmp5_;
		} else {
			GtkComboBoxText* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			_tmp6_ = self->priv->repeat_combobox;
			_tmp7_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp6_);
			_tmp8_ = _tmp7_;
			if (_tmp8_ == 1) {
				gchar* _tmp9_;
				_tmp9_ = g_strdup ("week");
				_g_free0 (text);
				text = _tmp9_;
			} else {
				GtkComboBoxText* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				_tmp10_ = self->priv->repeat_combobox;
				_tmp11_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp10_);
				_tmp12_ = _tmp11_;
				if (_tmp12_ == 2) {
					gchar* _tmp13_;
					_tmp13_ = g_strdup ("month");
					_g_free0 (text);
					text = _tmp13_;
				} else {
					GtkComboBoxText* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
					_tmp14_ = self->priv->repeat_combobox;
					_tmp15_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp14_);
					_tmp16_ = _tmp15_;
					if (_tmp16_ == 3) {
						gchar* _tmp17_;
						_tmp17_ = g_strdup ("year");
						_g_free0 (text);
						text = _tmp17_;
					}
				}
			}
		}
	} else {
		GtkComboBoxText* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		_tmp18_ = self->priv->repeat_combobox;
		_tmp19_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp18_);
		_tmp20_ = _tmp19_;
		if (_tmp20_ == 0) {
			gchar* _tmp21_;
			_tmp21_ = g_strdup ("days");
			_g_free0 (text);
			text = _tmp21_;
		} else {
			GtkComboBoxText* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			_tmp22_ = self->priv->repeat_combobox;
			_tmp23_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp22_);
			_tmp24_ = _tmp23_;
			if (_tmp24_ == 1) {
				gchar* _tmp25_;
				_tmp25_ = g_strdup ("weeks");
				_g_free0 (text);
				text = _tmp25_;
			} else {
				GtkComboBoxText* _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				_tmp26_ = self->priv->repeat_combobox;
				_tmp27_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp26_);
				_tmp28_ = _tmp27_;
				if (_tmp28_ == 2) {
					gchar* _tmp29_;
					_tmp29_ = g_strdup ("months");
					_g_free0 (text);
					text = _tmp29_;
				} else {
					GtkComboBoxText* _tmp30_;
					gint _tmp31_;
					gint _tmp32_;
					_tmp30_ = self->priv->repeat_combobox;
					_tmp31_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp30_);
					_tmp32_ = _tmp31_;
					if (_tmp32_ == 3) {
						gchar* _tmp33_;
						_tmp33_ = g_strdup ("years");
						_g_free0 (text);
						text = _tmp33_;
					}
				}
			}
		}
	}
	_tmp34_ = self->priv->repeat_label;
	_tmp35_ = self->priv->repeat_spin_button;
	_tmp36_ = text;
	_tmp37_ = g_strdup_printf ("%s %i %s", _ ("Repeats every"), gtk_spin_button_get_value_as_int (_tmp35_), _tmp36_);
	_tmp38_ = _tmp37_;
	gtk_label_set_label (_tmp34_, _tmp38_);
	_g_free0 (_tmp38_);
	_g_free0 (text);
}

static void
widgets_schedule_button_set_date (WidgetsScheduleButton* self,
                                  GDateTime* date)
{
	Utils* _tmp0_;
	ObjectsDuedate* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	ObjectsDuedate* _tmp6_;
	ObjectsDuedate* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (date != NULL);
	_tmp0_ = planner_utils;
	_tmp1_ = self->priv->_duedate;
	_tmp2_ = objects_duedate_get_datetime (_tmp1_);
	_tmp3_ = _tmp2_;
	if (utils_has_time (_tmp0_, _tmp3_)) {
		ObjectsDuedate* _tmp4_;
		_tmp4_ = self->priv->_duedate;
		objects_duedate_update_date (_tmp4_, date);
	} else {
		ObjectsDuedate* _tmp5_;
		_tmp5_ = self->priv->_duedate;
		objects_duedate_set_datetime (_tmp5_, date);
	}
	_tmp6_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp6_);
	_tmp7_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp7_);
}

static void
widgets_schedule_button_set_time (WidgetsScheduleButton* self,
                                  GDateTime* time)
{
	ObjectsDuedate* _tmp0_;
	ObjectsDuedate* _tmp3_;
	ObjectsDuedate* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (time != NULL);
	_tmp0_ = self->priv->_duedate;
	if (objects_duedate_is_valid (_tmp0_)) {
		ObjectsDuedate* _tmp1_;
		_tmp1_ = self->priv->_duedate;
		objects_duedate_set_time (_tmp1_, time);
	} else {
		ObjectsDuedate* _tmp2_;
		_tmp2_ = self->priv->_duedate;
		objects_duedate_set_datetime (_tmp2_, time);
	}
	_tmp3_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp3_);
	_tmp4_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp4_);
}

static void
widgets_schedule_button_set_repeat (WidgetsScheduleButton* self)
{
	ObjectsDuedate* _tmp0_;
	ObjectsDuedate* _tmp7_;
	ObjectsDuedate* _tmp8_;
	ObjectsDuedate* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	ObjectsDuedate* _tmp12_;
	ObjectsDuedate* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_duedate;
	if (!objects_duedate_is_valid (_tmp0_)) {
		ObjectsDuedate* _tmp1_;
		Utils* _tmp2_;
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		_tmp1_ = self->priv->_duedate;
		_tmp2_ = planner_utils;
		_tmp3_ = g_date_time_new_now_local ();
		_tmp4_ = _tmp3_;
		_tmp5_ = utils_get_format_date (_tmp2_, _tmp4_);
		_tmp6_ = _tmp5_;
		objects_duedate_set_datetime (_tmp1_, _tmp6_);
		_g_date_time_unref0 (_tmp6_);
		_g_date_time_unref0 (_tmp4_);
	}
	_tmp7_ = self->priv->_duedate;
	objects_duedate_set_is_recurring (_tmp7_, TRUE);
	_tmp8_ = self->priv->_duedate;
	objects_duedate_set_lang (_tmp8_, "en");
	_tmp9_ = self->priv->_duedate;
	_tmp10_ = widgets_schedule_button_get_repeat_text (self);
	_tmp11_ = _tmp10_;
	objects_duedate_set_text (_tmp9_, _tmp11_);
	_g_free0 (_tmp11_);
	_tmp12_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp12_);
	_tmp13_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp13_);
}

static gchar*
widgets_schedule_button_get_repeat_text (WidgetsScheduleButton* self)
{
	gchar* returned = NULL;
	gchar* _tmp0_;
	gchar* text = NULL;
	gchar* _tmp1_;
	GtkSpinButton* _tmp2_;
	GtkSpinButton* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	returned = _tmp0_;
	_tmp1_ = g_strdup ("");
	text = _tmp1_;
	_tmp2_ = self->priv->repeat_spin_button;
	if (gtk_spin_button_get_value_as_int (_tmp2_) <= 1) {
		GtkComboBoxText* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		_tmp3_ = self->priv->repeat_combobox;
		_tmp4_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_ == 0) {
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("day");
			_g_free0 (text);
			text = _tmp6_;
		} else {
			GtkComboBoxText* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			_tmp7_ = self->priv->repeat_combobox;
			_tmp8_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp7_);
			_tmp9_ = _tmp8_;
			if (_tmp9_ == 1) {
				gchar* _tmp10_;
				_tmp10_ = g_strdup ("week");
				_g_free0 (text);
				text = _tmp10_;
			} else {
				GtkComboBoxText* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				_tmp11_ = self->priv->repeat_combobox;
				_tmp12_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp11_);
				_tmp13_ = _tmp12_;
				if (_tmp13_ == 2) {
					gchar* _tmp14_;
					_tmp14_ = g_strdup ("month");
					_g_free0 (text);
					text = _tmp14_;
				} else {
					GtkComboBoxText* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
					_tmp15_ = self->priv->repeat_combobox;
					_tmp16_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp15_);
					_tmp17_ = _tmp16_;
					if (_tmp17_ == 3) {
						gchar* _tmp18_;
						_tmp18_ = g_strdup ("year");
						_g_free0 (text);
						text = _tmp18_;
					}
				}
			}
		}
	} else {
		GtkComboBoxText* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		_tmp19_ = self->priv->repeat_combobox;
		_tmp20_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp19_);
		_tmp21_ = _tmp20_;
		if (_tmp21_ == 0) {
			gchar* _tmp22_;
			_tmp22_ = g_strdup ("days");
			_g_free0 (text);
			text = _tmp22_;
		} else {
			GtkComboBoxText* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			_tmp23_ = self->priv->repeat_combobox;
			_tmp24_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp23_);
			_tmp25_ = _tmp24_;
			if (_tmp25_ == 1) {
				gchar* _tmp26_;
				_tmp26_ = g_strdup ("weeks");
				_g_free0 (text);
				text = _tmp26_;
			} else {
				GtkComboBoxText* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				_tmp27_ = self->priv->repeat_combobox;
				_tmp28_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp27_);
				_tmp29_ = _tmp28_;
				if (_tmp29_ == 2) {
					gchar* _tmp30_;
					_tmp30_ = g_strdup ("months");
					_g_free0 (text);
					text = _tmp30_;
				} else {
					GtkComboBoxText* _tmp31_;
					gint _tmp32_;
					gint _tmp33_;
					_tmp31_ = self->priv->repeat_combobox;
					_tmp32_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp31_);
					_tmp33_ = _tmp32_;
					if (_tmp33_ == 3) {
						gchar* _tmp34_;
						_tmp34_ = g_strdup ("years");
						_g_free0 (text);
						text = _tmp34_;
					}
				}
			}
		}
	}
	_tmp35_ = self->priv->repeat_spin_button;
	_tmp36_ = text;
	_tmp37_ = g_strdup_printf ("%s %i %s", "Every", gtk_spin_button_get_value_as_int (_tmp35_), _tmp36_);
	_g_free0 (returned);
	returned = _tmp37_;
	result = returned;
	_g_free0 (text);
	return result;
}

static void
widgets_schedule_button_check_clear_button (WidgetsScheduleButton* self)
{
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, "home") == 0) {
		GtkStack* _tmp3_;
		_tmp3_ = self->priv->clear_back_stack;
		gtk_stack_set_visible_child_name (_tmp3_, "clear");
	} else {
		GtkStack* _tmp4_;
		_tmp4_ = self->priv->clear_back_stack;
		gtk_stack_set_visible_child_name (_tmp4_, "back");
	}
}

static void
widgets_schedule_button_update_popover (WidgetsScheduleButton* self,
                                        ObjectsDuedate* duedate)
{
	WidgetsScheduleRow* _tmp0_;
	WidgetsScheduleRow* _tmp1_;
	WidgetsScheduleRow* _tmp2_;
	WidgetsScheduleRow* _tmp3_;
	WidgetsScheduleRow* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (duedate != NULL);
	_tmp0_ = self->priv->today_row;
	widgets_schedule_row_set_selected (_tmp0_, FALSE);
	_tmp1_ = self->priv->tomorrow_row;
	widgets_schedule_row_set_selected (_tmp1_, FALSE);
	_tmp2_ = self->priv->calendar_row;
	widgets_schedule_row_set_date_label (_tmp2_, "");
	_tmp3_ = self->priv->time_row;
	widgets_schedule_row_set_date_label (_tmp3_, "");
	_tmp4_ = self->priv->repeat_row;
	widgets_schedule_row_set_date_label (_tmp4_, "");
	if (objects_duedate_is_valid (duedate)) {
		Utils* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp7_;
		Utils* _tmp19_;
		GDateTime* _tmp20_;
		GDateTime* _tmp21_;
		gboolean _tmp30_;
		gboolean _tmp31_;
		_tmp5_ = planner_utils;
		_tmp6_ = objects_duedate_get_datetime (duedate);
		_tmp7_ = _tmp6_;
		if (utils_is_today (_tmp5_, _tmp7_)) {
			WidgetsScheduleRow* _tmp8_;
			_tmp8_ = self->priv->today_row;
			widgets_schedule_row_set_selected (_tmp8_, TRUE);
		} else {
			Utils* _tmp9_;
			GDateTime* _tmp10_;
			GDateTime* _tmp11_;
			_tmp9_ = planner_utils;
			_tmp10_ = objects_duedate_get_datetime (duedate);
			_tmp11_ = _tmp10_;
			if (utils_is_tomorrow (_tmp9_, _tmp11_)) {
				WidgetsScheduleRow* _tmp12_;
				_tmp12_ = self->priv->tomorrow_row;
				widgets_schedule_row_set_selected (_tmp12_, TRUE);
			} else {
				WidgetsScheduleRow* _tmp13_;
				Utils* _tmp14_;
				GDateTime* _tmp15_;
				GDateTime* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				_tmp13_ = self->priv->calendar_row;
				_tmp14_ = planner_utils;
				_tmp15_ = objects_duedate_get_datetime (duedate);
				_tmp16_ = _tmp15_;
				_tmp17_ = utils_get_relative_date_from_date (_tmp14_, _tmp16_);
				_tmp18_ = _tmp17_;
				widgets_schedule_row_set_date_label (_tmp13_, _tmp18_);
				_g_free0 (_tmp18_);
			}
		}
		_tmp19_ = planner_utils;
		_tmp20_ = objects_duedate_get_datetime (duedate);
		_tmp21_ = _tmp20_;
		if (utils_has_time (_tmp19_, _tmp21_)) {
			WidgetsScheduleRow* _tmp22_;
			GDateTime* _tmp23_;
			GDateTime* _tmp24_;
			Utils* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			_tmp22_ = self->priv->time_row;
			_tmp23_ = objects_duedate_get_datetime (duedate);
			_tmp24_ = _tmp23_;
			_tmp25_ = planner_utils;
			_tmp26_ = utils_get_default_time_format (_tmp25_);
			_tmp27_ = _tmp26_;
			_tmp28_ = g_date_time_format (_tmp24_, _tmp27_);
			_tmp29_ = _tmp28_;
			widgets_schedule_row_set_date_label (_tmp22_, _tmp29_);
			_g_free0 (_tmp29_);
			_g_free0 (_tmp27_);
		}
		_tmp30_ = objects_duedate_get_is_recurring (duedate);
		_tmp31_ = _tmp30_;
		if (_tmp31_) {
			WidgetsScheduleRow* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			_tmp32_ = self->priv->repeat_row;
			_tmp33_ = objects_duedate_get_text (duedate);
			_tmp34_ = _tmp33_;
			widgets_schedule_row_set_date_label (_tmp32_, _tmp34_);
		}
	}
}

static void
widgets_schedule_button_update_button (WidgetsScheduleButton* self,
                                       ObjectsDuedate* duedate)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GSettings* _tmp2_;
	GtkImage* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkImage* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkImage* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkRevealer* _tmp15_;
	GtkRevealer* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (duedate != NULL);
	_tmp0_ = self->priv->due_label;
	gtk_label_set_label (_tmp0_, _ ("Schedule"));
	_tmp1_ = self->priv->time_label;
	gtk_label_set_label (_tmp1_, "");
	_tmp2_ = planner_settings;
	if (g_settings_get_enum (_tmp2_, "appearance") == 0) {
		GtkImage* _tmp3_;
		GThemedIcon* _tmp4_;
		GThemedIcon* _tmp5_;
		_tmp3_ = self->priv->due_image;
		_tmp4_ = (GThemedIcon*) g_themed_icon_new ("calendar-outline-light");
		_tmp5_ = _tmp4_;
		g_object_set (_tmp3_, "gicon", (GIcon*) _tmp5_, NULL);
		_g_object_unref0 (_tmp5_);
	} else {
		GtkImage* _tmp6_;
		GThemedIcon* _tmp7_;
		GThemedIcon* _tmp8_;
		_tmp6_ = self->priv->due_image;
		_tmp7_ = (GThemedIcon*) g_themed_icon_new ("calendar-outline-dark");
		_tmp8_ = _tmp7_;
		g_object_set (_tmp6_, "gicon", (GIcon*) _tmp8_, NULL);
		_g_object_unref0 (_tmp8_);
	}
	_tmp9_ = self->priv->due_image;
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
	gtk_style_context_remove_class (_tmp10_, "overdue-label");
	_tmp11_ = self->priv->due_image;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	gtk_style_context_remove_class (_tmp12_, "today");
	_tmp13_ = self->priv->due_image;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_remove_class (_tmp14_, "upcoming");
	_tmp15_ = self->priv->repeat_revealer;
	gtk_revealer_set_reveal_child (_tmp15_, FALSE);
	_tmp16_ = self->priv->time_revealer;
	gtk_revealer_set_reveal_child (_tmp16_, FALSE);
	if (objects_duedate_is_valid (duedate)) {
		GtkLabel* _tmp17_;
		Utils* _tmp18_;
		GDateTime* _tmp19_;
		GDateTime* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		Utils* _tmp23_;
		GDateTime* _tmp24_;
		GDateTime* _tmp25_;
		Utils* _tmp35_;
		GDateTime* _tmp36_;
		GDateTime* _tmp37_;
		gboolean _tmp60_;
		gboolean _tmp61_;
		_tmp17_ = self->priv->due_label;
		_tmp18_ = planner_utils;
		_tmp19_ = objects_duedate_get_datetime (duedate);
		_tmp20_ = _tmp19_;
		_tmp21_ = utils_get_relative_date_from_date (_tmp18_, _tmp20_);
		_tmp22_ = _tmp21_;
		gtk_label_set_label (_tmp17_, _tmp22_);
		_g_free0 (_tmp22_);
		_tmp23_ = planner_utils;
		_tmp24_ = objects_duedate_get_datetime (duedate);
		_tmp25_ = _tmp24_;
		if (utils_has_time (_tmp23_, _tmp25_)) {
			GtkLabel* _tmp26_;
			GDateTime* _tmp27_;
			GDateTime* _tmp28_;
			Utils* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			GtkRevealer* _tmp34_;
			_tmp26_ = self->priv->time_label;
			_tmp27_ = objects_duedate_get_datetime (duedate);
			_tmp28_ = _tmp27_;
			_tmp29_ = planner_utils;
			_tmp30_ = utils_get_default_time_format (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp32_ = g_date_time_format (_tmp28_, _tmp31_);
			_tmp33_ = _tmp32_;
			gtk_label_set_label (_tmp26_, _tmp33_);
			_g_free0 (_tmp33_);
			_g_free0 (_tmp31_);
			_tmp34_ = self->priv->time_revealer;
			gtk_revealer_set_reveal_child (_tmp34_, TRUE);
		}
		_tmp35_ = planner_utils;
		_tmp36_ = objects_duedate_get_datetime (duedate);
		_tmp37_ = _tmp36_;
		if (utils_is_today (_tmp35_, _tmp37_)) {
			GtkImage* _tmp38_;
			GThemedIcon* _tmp39_;
			GThemedIcon* _tmp40_;
			GtkImage* _tmp41_;
			GtkStyleContext* _tmp42_;
			_tmp38_ = self->priv->due_image;
			_tmp39_ = (GThemedIcon*) g_themed_icon_new ("help-about-symbolic");
			_tmp40_ = _tmp39_;
			g_object_set (_tmp38_, "gicon", (GIcon*) _tmp40_, NULL);
			_g_object_unref0 (_tmp40_);
			_tmp41_ = self->priv->due_image;
			_tmp42_ = gtk_widget_get_style_context ((GtkWidget*) _tmp41_);
			gtk_style_context_add_class (_tmp42_, "today");
		} else {
			Utils* _tmp43_;
			GDateTime* _tmp44_;
			GDateTime* _tmp45_;
			_tmp43_ = planner_utils;
			_tmp44_ = objects_duedate_get_datetime (duedate);
			_tmp45_ = _tmp44_;
			if (utils_is_overdue (_tmp43_, _tmp45_)) {
				GtkImage* _tmp46_;
				GThemedIcon* _tmp47_;
				GThemedIcon* _tmp48_;
				GtkImage* _tmp49_;
				GtkStyleContext* _tmp50_;
				_tmp46_ = self->priv->due_image;
				_tmp47_ = (GThemedIcon*) g_themed_icon_new ("calendar-overdue");
				_tmp48_ = _tmp47_;
				g_object_set (_tmp46_, "gicon", (GIcon*) _tmp48_, NULL);
				_g_object_unref0 (_tmp48_);
				_tmp49_ = self->priv->due_image;
				_tmp50_ = gtk_widget_get_style_context ((GtkWidget*) _tmp49_);
				gtk_style_context_add_class (_tmp50_, "overdue-label");
			} else {
				GSettings* _tmp51_;
				GtkImage* _tmp58_;
				GtkStyleContext* _tmp59_;
				_tmp51_ = planner_settings;
				if (g_settings_get_enum (_tmp51_, "appearance") == 0) {
					GtkImage* _tmp52_;
					GThemedIcon* _tmp53_;
					GThemedIcon* _tmp54_;
					_tmp52_ = self->priv->due_image;
					_tmp53_ = (GThemedIcon*) g_themed_icon_new ("calendar-outline-light");
					_tmp54_ = _tmp53_;
					g_object_set (_tmp52_, "gicon", (GIcon*) _tmp54_, NULL);
					_g_object_unref0 (_tmp54_);
				} else {
					GtkImage* _tmp55_;
					GThemedIcon* _tmp56_;
					GThemedIcon* _tmp57_;
					_tmp55_ = self->priv->due_image;
					_tmp56_ = (GThemedIcon*) g_themed_icon_new ("calendar-outline-dark");
					_tmp57_ = _tmp56_;
					g_object_set (_tmp55_, "gicon", (GIcon*) _tmp57_, NULL);
					_g_object_unref0 (_tmp57_);
				}
				_tmp58_ = self->priv->due_image;
				_tmp59_ = gtk_widget_get_style_context ((GtkWidget*) _tmp58_);
				gtk_style_context_add_class (_tmp59_, "upcoming");
			}
		}
		_tmp60_ = objects_duedate_get_is_recurring (duedate);
		_tmp61_ = _tmp60_;
		if (_tmp61_) {
			GtkRevealer* _tmp62_;
			_tmp62_ = self->priv->repeat_revealer;
			gtk_revealer_set_reveal_child (_tmp62_, TRUE);
		}
	}
}

void
widgets_schedule_button_update_duedate (WidgetsScheduleButton* self,
                                        ObjectsItem* item)
{
	ObjectsDuedate* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GTimeZone* _tmp3_;
	GTimeZone* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	ObjectsDuedate* _tmp16_;
	ObjectsDuedate* _tmp17_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->_duedate;
	_tmp1_ = objects_item_get_due_date (item);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_time_zone_new_local ();
	_tmp4_ = _tmp3_;
	_tmp5_ = g_date_time_new_from_iso8601 (_tmp2_, _tmp4_);
	_tmp6_ = _tmp5_;
	objects_duedate_set_datetime (_tmp0_, _tmp6_);
	_g_date_time_unref0 (_tmp6_);
	_g_time_zone_unref0 (_tmp4_);
	_tmp7_ = objects_item_get_due_is_recurring (item);
	_tmp8_ = _tmp7_;
	if (_tmp8_ == 1) {
		ObjectsDuedate* _tmp9_;
		ObjectsDuedate* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		ObjectsDuedate* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		_tmp9_ = self->priv->_duedate;
		objects_duedate_set_is_recurring (_tmp9_, TRUE);
		_tmp10_ = self->priv->_duedate;
		_tmp11_ = objects_item_get_due_lang (item);
		_tmp12_ = _tmp11_;
		objects_duedate_set_lang (_tmp10_, _tmp12_);
		_tmp13_ = self->priv->_duedate;
		_tmp14_ = objects_item_get_due_string (item);
		_tmp15_ = _tmp14_;
		objects_duedate_set_text (_tmp13_, _tmp15_);
	}
	_tmp16_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp16_);
	_tmp17_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp17_);
}

void
widgets_schedule_button_set_new_item_due_date (WidgetsScheduleButton* self,
                                               const gchar* due_date)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (due_date != NULL);
	if (g_strcmp0 (due_date, "") != 0) {
		ObjectsDuedate* _tmp0_;
		Utils* _tmp1_;
		GDateTime* _tmp2_;
		GDateTime* _tmp3_;
		ObjectsDuedate* _tmp4_;
		_tmp0_ = self->priv->_duedate;
		_tmp1_ = planner_utils;
		_tmp2_ = utils_get_format_date_from_string (_tmp1_, due_date);
		_tmp3_ = _tmp2_;
		objects_duedate_set_datetime (_tmp0_, _tmp3_);
		_g_date_time_unref0 (_tmp3_);
		_tmp4_ = self->priv->_duedate;
		widgets_schedule_button_update_button (self, _tmp4_);
	}
}

gchar*
widgets_schedule_button_get_due_date (WidgetsScheduleButton* self)
{
	gchar* returned = NULL;
	gchar* _tmp0_;
	ObjectsDuedate* _tmp1_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	returned = _tmp0_;
	_tmp1_ = self->priv->_duedate;
	if (objects_duedate_is_valid (_tmp1_)) {
		ObjectsDuedate* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = self->priv->_duedate;
		_tmp3_ = objects_duedate_get_due_date (_tmp2_);
		_g_free0 (returned);
		returned = _tmp3_;
	}
	result = returned;
	return result;
}

void
widgets_schedule_button_save_item (WidgetsScheduleButton* self)
{
	ObjectsItem* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_item;
	_tmp1_ = objects_item_get_id (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != ((gint64) 0)) {
		gboolean new_date = FALSE;
		ObjectsDuedate* _tmp3_;
		ServicesDatabase* _tmp28_;
		ObjectsItem* _tmp29_;
		ObjectsItem* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		new_date = FALSE;
		_tmp3_ = self->priv->_duedate;
		if (objects_duedate_is_valid (_tmp3_)) {
			ObjectsItem* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			ObjectsItem* _tmp7_;
			ObjectsDuedate* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			ObjectsItem* _tmp11_;
			ObjectsDuedate* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			ObjectsItem* _tmp15_;
			ObjectsDuedate* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			ObjectsDuedate* _tmp19_;
			gboolean _tmp20_;
			gboolean _tmp21_;
			_tmp4_ = self->priv->_item;
			_tmp5_ = objects_item_get_due_date (_tmp4_);
			_tmp6_ = _tmp5_;
			if (g_strcmp0 (_tmp6_, "") == 0) {
				new_date = TRUE;
			}
			_tmp7_ = self->priv->_item;
			_tmp8_ = self->priv->_duedate;
			_tmp9_ = objects_duedate_get_due_date (_tmp8_);
			_tmp10_ = _tmp9_;
			objects_item_set_due_date (_tmp7_, _tmp10_);
			_g_free0 (_tmp10_);
			_tmp11_ = self->priv->_item;
			_tmp12_ = self->priv->_duedate;
			_tmp13_ = objects_duedate_get_text (_tmp12_);
			_tmp14_ = _tmp13_;
			objects_item_set_due_string (_tmp11_, _tmp14_);
			_tmp15_ = self->priv->_item;
			_tmp16_ = self->priv->_duedate;
			_tmp17_ = objects_duedate_get_lang (_tmp16_);
			_tmp18_ = _tmp17_;
			objects_item_set_due_lang (_tmp15_, _tmp18_);
			_tmp19_ = self->priv->_duedate;
			_tmp20_ = objects_duedate_get_is_recurring (_tmp19_);
			_tmp21_ = _tmp20_;
			if (_tmp21_) {
				ObjectsItem* _tmp22_;
				_tmp22_ = self->priv->_item;
				objects_item_set_due_is_recurring (_tmp22_, 1);
			} else {
				ObjectsItem* _tmp23_;
				_tmp23_ = self->priv->_item;
				objects_item_set_due_is_recurring (_tmp23_, 0);
			}
		} else {
			ObjectsItem* _tmp24_;
			ObjectsItem* _tmp25_;
			ObjectsItem* _tmp26_;
			ObjectsItem* _tmp27_;
			_tmp24_ = self->priv->_item;
			objects_item_set_due_date (_tmp24_, "");
			_tmp25_ = self->priv->_item;
			objects_item_set_due_is_recurring (_tmp25_, 0);
			_tmp26_ = self->priv->_item;
			objects_item_set_due_string (_tmp26_, "");
			_tmp27_ = self->priv->_item;
			objects_item_set_due_lang (_tmp27_, "");
		}
		_tmp28_ = planner_database;
		_tmp29_ = self->priv->_item;
		services_database_set_due_item (_tmp28_, _tmp29_, new_date, -1);
		_tmp30_ = self->priv->_item;
		_tmp31_ = objects_item_get_is_todoist (_tmp30_);
		_tmp32_ = _tmp31_;
		if (_tmp32_ == 1) {
			ServicesTodoist* _tmp33_;
			ObjectsItem* _tmp34_;
			_tmp33_ = planner_todoist;
			_tmp34_ = self->priv->_item;
			services_todoist_update_item (_tmp33_, _tmp34_);
		}
	}
}

void
widgets_schedule_button_clear (WidgetsScheduleButton* self)
{
	ObjectsDuedate* _tmp0_;
	ObjectsDuedate* _tmp1_;
	ObjectsDuedate* _tmp2_;
	ObjectsDuedate* _tmp3_;
	ObjectsDuedate* _tmp4_;
	ObjectsDuedate* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_duedate;
	objects_duedate_set_datetime (_tmp0_, NULL);
	_tmp1_ = self->priv->_duedate;
	objects_duedate_set_is_recurring (_tmp1_, FALSE);
	_tmp2_ = self->priv->_duedate;
	objects_duedate_set_lang (_tmp2_, "");
	_tmp3_ = self->priv->_duedate;
	objects_duedate_set_text (_tmp3_, "");
	_tmp4_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp4_);
	_tmp5_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp5_);
}

gboolean
widgets_schedule_button_has_datetime (WidgetsScheduleButton* self)
{
	ObjectsDuedate* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_duedate;
	result = objects_duedate_is_valid (_tmp0_);
	return result;
}

void
widgets_schedule_button_set_datetime (WidgetsScheduleButton* self,
                                      GDateTime* datetime)
{
	ObjectsDuedate* _tmp0_;
	ObjectsDuedate* _tmp1_;
	ObjectsDuedate* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (datetime != NULL);
	_tmp0_ = self->priv->_duedate;
	objects_duedate_set_datetime (_tmp0_, datetime);
	_tmp1_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp1_);
	_tmp2_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp2_);
}

static void
widgets_schedule_button_check_repeat_widget (WidgetsScheduleButton* self)
{
	ObjectsDuedate* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_duedate;
	_tmp1_ = objects_duedate_get_is_recurring (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkLabel* _tmp3_;
		ObjectsDuedate* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		GtkRevealer* _tmp7_;
		_tmp3_ = self->priv->repeat_label;
		_tmp4_ = self->priv->_duedate;
		_tmp5_ = objects_duedate_get_text (_tmp4_);
		_tmp6_ = _tmp5_;
		gtk_label_set_label (_tmp3_, _tmp6_);
		_tmp7_ = self->priv->no_repeat_revealer;
		gtk_revealer_set_reveal_child (_tmp7_, TRUE);
	} else {
		GtkRevealer* _tmp8_;
		_tmp8_ = self->priv->no_repeat_revealer;
		gtk_revealer_set_reveal_child (_tmp8_, FALSE);
	}
}

ObjectsItem*
widgets_schedule_button_get_item (WidgetsScheduleButton* self)
{
	ObjectsItem* result;
	ObjectsItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_item;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
widgets_schedule_button_set_item (WidgetsScheduleButton* self,
                                  ObjectsItem* value)
{
	ObjectsItem* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_schedule_button_get_item (self);
	if (old_value != value) {
		ObjectsItem* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_item);
		self->priv->_item = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_schedule_button_properties[WIDGETS_SCHEDULE_BUTTON_ITEM_PROPERTY]);
	}
}

ObjectsDuedate*
widgets_schedule_button_get_duedate (WidgetsScheduleButton* self)
{
	ObjectsDuedate* result;
	ObjectsDuedate* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_duedate;
	result = _tmp0_;
	return result;
}

void
widgets_schedule_button_set_duedate (WidgetsScheduleButton* self,
                                     ObjectsDuedate* value)
{
	ObjectsDuedate* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_schedule_button_get_duedate (self);
	if (old_value != value) {
		ObjectsDuedate* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_duedate);
		self->priv->_duedate = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_schedule_button_properties[WIDGETS_SCHEDULE_BUTTON_DUEDATE_PROPERTY]);
	}
}

ServicesChronoChrono*
widgets_schedule_button_get_chrono (WidgetsScheduleButton* self)
{
	ServicesChronoChrono* result;
	ServicesChronoChrono* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_chrono;
	result = _tmp0_;
	return result;
}

void
widgets_schedule_button_set_chrono (WidgetsScheduleButton* self,
                                    ServicesChronoChrono* value)
{
	ServicesChronoChrono* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_schedule_button_get_chrono (self);
	if (old_value != value) {
		ServicesChronoChrono* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_chrono);
		self->priv->_chrono = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_schedule_button_properties[WIDGETS_SCHEDULE_BUTTON_CHRONO_PROPERTY]);
	}
}

static void
_widgets_schedule_button___lambda120_ (WidgetsScheduleButton* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GtkPopover* _tmp2_;
		ObjectsDuedate* _tmp3_;
		GtkPopover* _tmp4_;
		_tmp2_ = self->priv->popover;
		if (_tmp2_ == NULL) {
			widgets_schedule_button_create_popover (self);
		}
		_tmp3_ = self->priv->_duedate;
		widgets_schedule_button_update_popover (self, _tmp3_);
		_tmp4_ = self->priv->popover;
		gtk_popover_popup (_tmp4_);
	}
}

static void
__widgets_schedule_button___lambda120__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_widgets_schedule_button___lambda120_ ((WidgetsScheduleButton*) self);
}

static void
_widgets_schedule_button___lambda121_ (WidgetsScheduleButton* self,
                                       const gchar* key)
{
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "appearance") == 0) {
		ObjectsDuedate* _tmp0_;
		_tmp0_ = self->priv->_duedate;
		widgets_schedule_button_update_button (self, _tmp0_);
	}
}

static void
__widgets_schedule_button___lambda121__g_settings_changed (GSettings* _sender,
                                                           const gchar* key,
                                                           gpointer self)
{
	_widgets_schedule_button___lambda121_ ((WidgetsScheduleButton*) self, key);
}

static void
_widgets_schedule_button___lambda122_ (WidgetsScheduleButton* self)
{
	ObjectsDuedate* _tmp0_;
	ObjectsDuedate* _tmp1_;
	_tmp0_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp0_);
	_tmp1_ = self->priv->_duedate;
	widgets_schedule_button_update_popover (self, _tmp1_);
}

static void
__widgets_schedule_button___lambda122__utils_clock_format_changed (Utils* _sender,
                                                                   gpointer self)
{
	_widgets_schedule_button___lambda122_ ((WidgetsScheduleButton*) self);
}

static GObject *
widgets_schedule_button_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsScheduleButton * self;
	ServicesChronoChrono* _tmp0_;
	ServicesChronoChrono* _tmp1_;
	ObjectsDuedate* _tmp2_;
	ObjectsDuedate* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkLabel* _tmp14_;
	GtkRevealer* _tmp15_;
	GtkRevealer* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkLabel* _tmp18_;
	GtkRevealer* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	GtkImage* _tmp23_;
	GtkImage* _tmp24_;
	GThemedIcon* _tmp25_;
	GThemedIcon* _tmp26_;
	GtkRevealer* _tmp27_;
	GtkRevealer* _tmp28_;
	GtkRevealer* _tmp29_;
	GtkImage* _tmp30_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp31_;
	GtkGrid* _tmp32_;
	GtkGrid* _tmp33_;
	GtkGrid* _tmp34_;
	GtkImage* _tmp35_;
	GtkGrid* _tmp36_;
	GtkLabel* _tmp37_;
	GtkGrid* _tmp38_;
	GtkRevealer* _tmp39_;
	GtkGrid* _tmp40_;
	GtkRevealer* _tmp41_;
	GtkGrid* _tmp42_;
	ObjectsItem* _tmp43_;
	gint64 _tmp44_;
	gint64 _tmp45_;
	ObjectsDuedate* _tmp66_;
	GSettings* _tmp67_;
	Utils* _tmp68_;
	parent_class = G_OBJECT_CLASS (widgets_schedule_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SCHEDULE_BUTTON, WidgetsScheduleButton);
	_tmp0_ = services_chrono_chrono_get_instance ();
	_tmp1_ = _tmp0_;
	widgets_schedule_button_set_chrono (self, _tmp1_);
	_tmp2_ = objects_duedate_new ();
	_tmp3_ = _tmp2_;
	widgets_schedule_button_set_duedate (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Schedule"));
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp4_, "flat");
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp5_, "item-action-button");
	_tmp6_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->due_image);
	self->priv->due_image = _tmp6_;
	_tmp7_ = self->priv->due_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
	_tmp8_ = self->priv->due_image;
	gtk_image_set_pixel_size (_tmp8_, 16);
	_tmp9_ = (GtkLabel*) gtk_label_new (_ ("Schedule"));
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->due_label);
	self->priv->due_label = _tmp9_;
	_tmp10_ = self->priv->due_label;
	gtk_label_set_use_markup (_tmp10_, TRUE);
	_tmp11_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->time_label);
	self->priv->time_label = _tmp11_;
	_tmp12_ = self->priv->time_label;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_add_class (_tmp13_, "no-padding");
	_tmp14_ = self->priv->time_label;
	gtk_label_set_use_markup (_tmp14_, TRUE);
	_tmp15_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->time_revealer);
	self->priv->time_revealer = _tmp15_;
	_tmp16_ = self->priv->time_revealer;
	gtk_revealer_set_transition_type (_tmp16_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
	_tmp17_ = self->priv->time_revealer;
	_tmp18_ = self->priv->time_label;
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = self->priv->time_revealer;
	gtk_revealer_set_reveal_child (_tmp19_, FALSE);
	_tmp20_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->repeat_image);
	self->priv->repeat_image = _tmp20_;
	_tmp21_ = self->priv->repeat_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp21_, GTK_ALIGN_CENTER);
	_tmp22_ = self->priv->repeat_image;
	gtk_image_set_pixel_size (_tmp22_, 10);
	_tmp23_ = self->priv->repeat_image;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp23_, 6);
	_tmp24_ = self->priv->repeat_image;
	_tmp25_ = (GThemedIcon*) g_themed_icon_new ("media-playlist-repeat-symbolic");
	_tmp26_ = _tmp25_;
	g_object_set (_tmp24_, "gicon", (GIcon*) _tmp26_, NULL);
	_g_object_unref0 (_tmp26_);
	_tmp27_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->repeat_revealer);
	self->priv->repeat_revealer = _tmp27_;
	_tmp28_ = self->priv->repeat_revealer;
	gtk_revealer_set_transition_type (_tmp28_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
	_tmp29_ = self->priv->repeat_revealer;
	_tmp30_ = self->priv->repeat_image;
	gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
	_tmp31_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp31_);
	main_grid = _tmp31_;
	_tmp32_ = main_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp32_, GTK_ALIGN_CENTER);
	_tmp33_ = main_grid;
	gtk_widget_set_valign ((GtkWidget*) _tmp33_, GTK_ALIGN_CENTER);
	_tmp34_ = main_grid;
	_tmp35_ = self->priv->due_image;
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
	_tmp36_ = main_grid;
	_tmp37_ = self->priv->due_label;
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
	_tmp38_ = main_grid;
	_tmp39_ = self->priv->time_revealer;
	gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
	_tmp40_ = main_grid;
	_tmp41_ = self->priv->repeat_revealer;
	gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp41_);
	_tmp42_ = main_grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp42_);
	_tmp43_ = self->priv->_item;
	_tmp44_ = objects_item_get_id (_tmp43_);
	_tmp45_ = _tmp44_;
	if (_tmp45_ != ((gint64) 0)) {
		ObjectsDuedate* _tmp46_;
		ObjectsItem* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		GTimeZone* _tmp50_;
		GTimeZone* _tmp51_;
		GDateTime* _tmp52_;
		GDateTime* _tmp53_;
		ObjectsItem* _tmp54_;
		gint _tmp55_;
		gint _tmp56_;
		_tmp46_ = self->priv->_duedate;
		_tmp47_ = self->priv->_item;
		_tmp48_ = objects_item_get_due_date (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp50_ = g_time_zone_new_local ();
		_tmp51_ = _tmp50_;
		_tmp52_ = g_date_time_new_from_iso8601 (_tmp49_, _tmp51_);
		_tmp53_ = _tmp52_;
		objects_duedate_set_datetime (_tmp46_, _tmp53_);
		_g_date_time_unref0 (_tmp53_);
		_g_time_zone_unref0 (_tmp51_);
		_tmp54_ = self->priv->_item;
		_tmp55_ = objects_item_get_due_is_recurring (_tmp54_);
		_tmp56_ = _tmp55_;
		if (_tmp56_ == 1) {
			ObjectsDuedate* _tmp57_;
			ObjectsDuedate* _tmp58_;
			ObjectsItem* _tmp59_;
			const gchar* _tmp60_;
			const gchar* _tmp61_;
			ObjectsDuedate* _tmp62_;
			ObjectsItem* _tmp63_;
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			_tmp57_ = self->priv->_duedate;
			objects_duedate_set_is_recurring (_tmp57_, TRUE);
			_tmp58_ = self->priv->_duedate;
			_tmp59_ = self->priv->_item;
			_tmp60_ = objects_item_get_due_lang (_tmp59_);
			_tmp61_ = _tmp60_;
			objects_duedate_set_lang (_tmp58_, _tmp61_);
			_tmp62_ = self->priv->_duedate;
			_tmp63_ = self->priv->_item;
			_tmp64_ = objects_item_get_due_string (_tmp63_);
			_tmp65_ = _tmp64_;
			objects_duedate_set_text (_tmp62_, _tmp65_);
		}
	}
	g_signal_connect_object ((GtkToggleButton*) self, "toggled", (GCallback) __widgets_schedule_button___lambda120__gtk_toggle_button_toggled, self, 0);
	_tmp66_ = self->priv->_duedate;
	widgets_schedule_button_update_button (self, _tmp66_);
	_tmp67_ = planner_settings;
	g_signal_connect_object (_tmp67_, "changed", (GCallback) __widgets_schedule_button___lambda121__g_settings_changed, self, 0);
	_tmp68_ = planner_utils;
	g_signal_connect_object (_tmp68_, "clock-format-changed", (GCallback) __widgets_schedule_button___lambda122__utils_clock_format_changed, self, 0);
	_g_object_unref0 (main_grid);
	return obj;
}

static void
widgets_schedule_button_class_init (WidgetsScheduleButtonClass * klass,
                                    gpointer klass_data)
{
	widgets_schedule_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsScheduleButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_schedule_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_schedule_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_schedule_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_schedule_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCHEDULE_BUTTON_ITEM_PROPERTY, widgets_schedule_button_properties[WIDGETS_SCHEDULE_BUTTON_ITEM_PROPERTY] = g_param_spec_object ("item", "item", "item", OBJECTS_TYPE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCHEDULE_BUTTON_DUEDATE_PROPERTY, widgets_schedule_button_properties[WIDGETS_SCHEDULE_BUTTON_DUEDATE_PROPERTY] = g_param_spec_object ("duedate", "duedate", "duedate", OBJECTS_TYPE_DUEDATE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCHEDULE_BUTTON_CHRONO_PROPERTY, widgets_schedule_button_properties[WIDGETS_SCHEDULE_BUTTON_CHRONO_PROPERTY] = g_param_spec_object ("chrono", "chrono", "chrono", SERVICES_CHRONO_TYPE_CHRONO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	widgets_schedule_button_signals[WIDGETS_SCHEDULE_BUTTON_POPOVER_OPENED_SIGNAL] = g_signal_new ("popover-opened", WIDGETS_TYPE_SCHEDULE_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
widgets_schedule_button_instance_init (WidgetsScheduleButton * self,
                                       gpointer klass)
{
	self->priv = widgets_schedule_button_get_instance_private (self);
	self->priv->popover = NULL;
}

static void
widgets_schedule_button_finalize (GObject * obj)
{
	WidgetsScheduleButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SCHEDULE_BUTTON, WidgetsScheduleButton);
	_g_object_unref0 (self->priv->_item);
	_g_object_unref0 (self->priv->_duedate);
	_g_object_unref0 (self->priv->_chrono);
	_g_object_unref0 (self->priv->due_image);
	_g_object_unref0 (self->priv->due_label);
	_g_object_unref0 (self->priv->time_label);
	_g_object_unref0 (self->priv->repeat_image);
	_g_object_unref0 (self->priv->time_revealer);
	_g_object_unref0 (self->priv->repeat_revealer);
	_g_object_unref0 (self->priv->clear_button);
	_g_object_unref0 (self->priv->popover);
	_g_object_unref0 (self->priv->search_entry);
	_g_object_unref0 (self->priv->calendar);
	_g_object_unref0 (self->priv->time_picker);
	_g_object_unref0 (self->priv->parse_row);
	_g_object_unref0 (self->priv->today_row);
	_g_object_unref0 (self->priv->tomorrow_row);
	_g_object_unref0 (self->priv->calendar_row);
	_g_object_unref0 (self->priv->time_row);
	_g_object_unref0 (self->priv->repeat_row);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->clear_back_stack);
	_g_object_unref0 (self->priv->no_time_revealer);
	_g_object_unref0 (self->priv->no_repeat_revealer);
	_g_object_unref0 (self->priv->repeat_label);
	_g_object_unref0 (self->priv->repeat_combobox);
	_g_object_unref0 (self->priv->repeat_spin_button);
	G_OBJECT_CLASS (widgets_schedule_button_parent_class)->finalize (obj);
}

static GType
widgets_schedule_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsScheduleButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_schedule_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsScheduleButton), 0, (GInstanceInitFunc) widgets_schedule_button_instance_init, NULL };
	GType widgets_schedule_button_type_id;
	widgets_schedule_button_type_id = g_type_register_static (gtk_toggle_button_get_type (), "WidgetsScheduleButton", &g_define_type_info, 0);
	WidgetsScheduleButton_private_offset = g_type_add_instance_private (widgets_schedule_button_type_id, sizeof (WidgetsScheduleButtonPrivate));
	return widgets_schedule_button_type_id;
}

GType
widgets_schedule_button_get_type (void)
{
	static volatile gsize widgets_schedule_button_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_schedule_button_type_id__volatile)) {
		GType widgets_schedule_button_type_id;
		widgets_schedule_button_type_id = widgets_schedule_button_get_type_once ();
		g_once_init_leave (&widgets_schedule_button_type_id__volatile, widgets_schedule_button_type_id);
	}
	return widgets_schedule_button_type_id__volatile;
}

static void
_vala_widgets_schedule_button_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	WidgetsScheduleButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SCHEDULE_BUTTON, WidgetsScheduleButton);
	switch (property_id) {
		case WIDGETS_SCHEDULE_BUTTON_ITEM_PROPERTY:
		g_value_set_object (value, widgets_schedule_button_get_item (self));
		break;
		case WIDGETS_SCHEDULE_BUTTON_DUEDATE_PROPERTY:
		g_value_set_object (value, widgets_schedule_button_get_duedate (self));
		break;
		case WIDGETS_SCHEDULE_BUTTON_CHRONO_PROPERTY:
		g_value_set_object (value, widgets_schedule_button_get_chrono (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_schedule_button_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	WidgetsScheduleButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SCHEDULE_BUTTON, WidgetsScheduleButton);
	switch (property_id) {
		case WIDGETS_SCHEDULE_BUTTON_ITEM_PROPERTY:
		widgets_schedule_button_set_item (self, g_value_get_object (value));
		break;
		case WIDGETS_SCHEDULE_BUTTON_DUEDATE_PROPERTY:
		widgets_schedule_button_set_duedate (self, g_value_get_object (value));
		break;
		case WIDGETS_SCHEDULE_BUTTON_CHRONO_PROPERTY:
		widgets_schedule_button_set_chrono (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
widgets_schedule_row_get_instance_private (WidgetsScheduleRow* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsScheduleRow_private_offset);
}

WidgetsScheduleRow*
widgets_schedule_row_construct (GType object_type,
                                const gchar* text,
                                const gchar* icon,
                                gboolean with_preview)
{
	WidgetsScheduleRow * self = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	self = (WidgetsScheduleRow*) g_object_new (object_type, "text", text, "icon", icon, "with-preview", with_preview, NULL);
	return self;
}

WidgetsScheduleRow*
widgets_schedule_row_new (const gchar* text,
                          const gchar* icon,
                          gboolean with_preview)
{
	return widgets_schedule_row_construct (WIDGETS_TYPE_SCHEDULE_ROW, text, icon, with_preview);
}

gboolean
widgets_schedule_row_get_with_preview (WidgetsScheduleRow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_with_preview;
	return result;
}

static void
widgets_schedule_row_set_with_preview (WidgetsScheduleRow* self,
                                       gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_schedule_row_get_with_preview (self);
	if (old_value != value) {
		self->priv->_with_preview = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_WITH_PREVIEW_PROPERTY]);
	}
}

void
widgets_schedule_row_set_icon (WidgetsScheduleRow* self,
                               const gchar* value)
{
	GtkImage* _tmp0_;
	GThemedIcon* _tmp1_;
	GThemedIcon* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->item_image;
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (value);
	_tmp2_ = _tmp1_;
	g_object_set (_tmp0_, "gicon", (GIcon*) _tmp2_, NULL);
	_g_object_unref0 (_tmp2_);
	g_object_notify_by_pspec ((GObject *) self, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_ICON_PROPERTY]);
}

void
widgets_schedule_row_set_text (WidgetsScheduleRow* self,
                               const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->item_label;
	gtk_label_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_TEXT_PROPERTY]);
}

void
widgets_schedule_row_set_selected (WidgetsScheduleRow* self,
                                   gboolean value)
{
	GtkRevealer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->selected_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_SELECTED_PROPERTY]);
}

void
widgets_schedule_row_set_date_label (WidgetsScheduleRow* self,
                                     const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->preview_label;
	gtk_label_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_DATE_LABEL_PROPERTY]);
}

static void
_widgets_schedule_row___lambda94_ (WidgetsScheduleRow* self)
{
	g_signal_emit (self, widgets_schedule_row_signals[WIDGETS_SCHEDULE_ROW_CLICKED_SIGNAL], 0);
}

static void
__widgets_schedule_row___lambda94__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	_widgets_schedule_row___lambda94_ ((WidgetsScheduleRow*) self);
}

static GObject *
widgets_schedule_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsScheduleRow * self;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkLabel* _tmp4_;
	GtkImage* selected_image = NULL;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GThemedIcon* _tmp10_;
	GThemedIcon* _tmp11_;
	GtkImage* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkRevealer* _tmp14_;
	GtkRevealer* _tmp15_;
	GtkRevealer* _tmp16_;
	GtkImage* _tmp17_;
	GtkImage* forward_image = NULL;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	GThemedIcon* _tmp23_;
	GThemedIcon* _tmp24_;
	GtkImage* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkStyleContext* _tmp29_;
	GtkLabel* _tmp30_;
	GtkStyleContext* _tmp31_;
	GtkBox* box = NULL;
	GtkBox* _tmp32_;
	GtkBox* _tmp33_;
	GtkBox* _tmp34_;
	GtkBox* _tmp35_;
	GtkBox* _tmp36_;
	GtkImage* _tmp37_;
	GtkBox* _tmp38_;
	GtkLabel* _tmp39_;
	gboolean _tmp40_;
	GtkButton* button = NULL;
	GtkButton* _tmp47_;
	GtkButton* _tmp48_;
	GtkStyleContext* _tmp49_;
	GtkButton* _tmp50_;
	GtkStyleContext* _tmp51_;
	GtkButton* _tmp52_;
	GtkStyleContext* _tmp53_;
	GtkButton* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkButton* _tmp56_;
	GtkButton* _tmp57_;
	GtkBox* _tmp58_;
	GtkButton* _tmp59_;
	GtkButton* _tmp60_;
	parent_class = G_OBJECT_CLASS (widgets_schedule_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SCHEDULE_ROW, WidgetsScheduleRow);
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, TRUE);
	_tmp0_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->item_image);
	self->item_image = _tmp0_;
	_tmp1_ = self->item_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
	_tmp2_ = self->item_image;
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
	_tmp3_ = self->item_image;
	gtk_image_set_pixel_size (_tmp3_, 16);
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->item_label);
	self->item_label = _tmp4_;
	_tmp5_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp5_);
	selected_image = _tmp5_;
	_tmp6_ = selected_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
	_tmp7_ = selected_image;
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
	_tmp8_ = selected_image;
	gtk_image_set_pixel_size (_tmp8_, 16);
	_tmp9_ = selected_image;
	_tmp10_ = (GThemedIcon*) g_themed_icon_new ("object-select-symbolic");
	_tmp11_ = _tmp10_;
	g_object_set (_tmp9_, "gicon", (GIcon*) _tmp11_, NULL);
	_g_object_unref0 (_tmp11_);
	_tmp12_ = selected_image;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_add_class (_tmp13_, "inbox");
	_tmp14_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->selected_revealer);
	self->selected_revealer = _tmp14_;
	_tmp15_ = self->selected_revealer;
	gtk_revealer_set_transition_type (_tmp15_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	_tmp16_ = self->selected_revealer;
	_tmp17_ = selected_image;
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp18_);
	forward_image = _tmp18_;
	_tmp19_ = forward_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp19_, GTK_ALIGN_CENTER);
	_tmp20_ = forward_image;
	gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_CENTER);
	_tmp21_ = forward_image;
	gtk_image_set_pixel_size (_tmp21_, 16);
	_tmp22_ = forward_image;
	_tmp23_ = (GThemedIcon*) g_themed_icon_new ("chevron-forward-symbolic");
	_tmp24_ = _tmp23_;
	g_object_set (_tmp22_, "gicon", (GIcon*) _tmp24_, NULL);
	_g_object_unref0 (_tmp24_);
	_tmp25_ = forward_image;
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
	gtk_style_context_add_class (_tmp26_, "inbox");
	_tmp27_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->preview_label);
	self->preview_label = _tmp27_;
	_tmp28_ = self->preview_label;
	_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) _tmp28_);
	gtk_style_context_add_class (_tmp29_, "inbox");
	_tmp30_ = self->preview_label;
	_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
	gtk_style_context_add_class (_tmp31_, "font-weight-600");
	_tmp32_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
	g_object_ref_sink (_tmp32_);
	box = _tmp32_;
	_tmp33_ = box;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp33_, 3);
	_tmp34_ = box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp34_, 3);
	_tmp35_ = box;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp35_, TRUE);
	_tmp36_ = box;
	_tmp37_ = self->item_image;
	gtk_box_pack_start (_tmp36_, (GtkWidget*) _tmp37_, FALSE, FALSE, (guint) 0);
	_tmp38_ = box;
	_tmp39_ = self->item_label;
	gtk_box_pack_start (_tmp38_, (GtkWidget*) _tmp39_, FALSE, TRUE, (guint) 0);
	_tmp40_ = self->priv->_with_preview;
	if (_tmp40_) {
		GtkBox* _tmp41_;
		GtkImage* _tmp42_;
		GtkBox* _tmp43_;
		GtkLabel* _tmp44_;
		_tmp41_ = box;
		_tmp42_ = forward_image;
		gtk_box_pack_end (_tmp41_, (GtkWidget*) _tmp42_, FALSE, FALSE, (guint) 0);
		_tmp43_ = box;
		_tmp44_ = self->preview_label;
		gtk_box_pack_end (_tmp43_, (GtkWidget*) _tmp44_, FALSE, FALSE, (guint) 0);
	} else {
		GtkBox* _tmp45_;
		GtkRevealer* _tmp46_;
		_tmp45_ = box;
		_tmp46_ = self->selected_revealer;
		gtk_box_pack_end (_tmp45_, (GtkWidget*) _tmp46_, FALSE, FALSE, (guint) 0);
	}
	_tmp47_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp47_);
	button = _tmp47_;
	_tmp48_ = button;
	_tmp49_ = gtk_widget_get_style_context ((GtkWidget*) _tmp48_);
	gtk_style_context_remove_class (_tmp49_, "button");
	_tmp50_ = button;
	_tmp51_ = gtk_widget_get_style_context ((GtkWidget*) _tmp50_);
	gtk_style_context_add_class (_tmp51_, "flat");
	_tmp52_ = button;
	_tmp53_ = gtk_widget_get_style_context ((GtkWidget*) _tmp52_);
	gtk_style_context_add_class (_tmp53_, "menuitem");
	_tmp54_ = button;
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
	gtk_style_context_add_class (_tmp55_, "no-border");
	_tmp56_ = button;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp56_, FALSE);
	_tmp57_ = button;
	_tmp58_ = box;
	gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
	_tmp59_ = button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp59_);
	_tmp60_ = button;
	g_signal_connect_object (_tmp60_, "clicked", (GCallback) __widgets_schedule_row___lambda94__gtk_button_clicked, self, 0);
	_g_object_unref0 (button);
	_g_object_unref0 (box);
	_g_object_unref0 (forward_image);
	_g_object_unref0 (selected_image);
	return obj;
}

static void
widgets_schedule_row_class_init (WidgetsScheduleRowClass * klass,
                                 gpointer klass_data)
{
	widgets_schedule_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsScheduleRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_schedule_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_schedule_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_schedule_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_schedule_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCHEDULE_ROW_WITH_PREVIEW_PROPERTY, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_WITH_PREVIEW_PROPERTY] = g_param_spec_boolean ("with-preview", "with-preview", "with-preview", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCHEDULE_ROW_ICON_PROPERTY, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCHEDULE_ROW_TEXT_PROPERTY, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCHEDULE_ROW_SELECTED_PROPERTY, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCHEDULE_ROW_DATE_LABEL_PROPERTY, widgets_schedule_row_properties[WIDGETS_SCHEDULE_ROW_DATE_LABEL_PROPERTY] = g_param_spec_string ("date-label", "date-label", "date-label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	widgets_schedule_row_signals[WIDGETS_SCHEDULE_ROW_CLICKED_SIGNAL] = g_signal_new ("clicked", WIDGETS_TYPE_SCHEDULE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
widgets_schedule_row_instance_init (WidgetsScheduleRow * self,
                                    gpointer klass)
{
	self->priv = widgets_schedule_row_get_instance_private (self);
}

static void
widgets_schedule_row_finalize (GObject * obj)
{
	WidgetsScheduleRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SCHEDULE_ROW, WidgetsScheduleRow);
	_g_object_unref0 (self->item_label);
	_g_object_unref0 (self->selected_revealer);
	_g_object_unref0 (self->item_image);
	_g_object_unref0 (self->preview_label);
	G_OBJECT_CLASS (widgets_schedule_row_parent_class)->finalize (obj);
}

static GType
widgets_schedule_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsScheduleRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_schedule_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsScheduleRow), 0, (GInstanceInitFunc) widgets_schedule_row_instance_init, NULL };
	GType widgets_schedule_row_type_id;
	widgets_schedule_row_type_id = g_type_register_static (gtk_revealer_get_type (), "WidgetsScheduleRow", &g_define_type_info, 0);
	WidgetsScheduleRow_private_offset = g_type_add_instance_private (widgets_schedule_row_type_id, sizeof (WidgetsScheduleRowPrivate));
	return widgets_schedule_row_type_id;
}

GType
widgets_schedule_row_get_type (void)
{
	static volatile gsize widgets_schedule_row_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_schedule_row_type_id__volatile)) {
		GType widgets_schedule_row_type_id;
		widgets_schedule_row_type_id = widgets_schedule_row_get_type_once ();
		g_once_init_leave (&widgets_schedule_row_type_id__volatile, widgets_schedule_row_type_id);
	}
	return widgets_schedule_row_type_id__volatile;
}

static void
_vala_widgets_schedule_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	WidgetsScheduleRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SCHEDULE_ROW, WidgetsScheduleRow);
	switch (property_id) {
		case WIDGETS_SCHEDULE_ROW_WITH_PREVIEW_PROPERTY:
		g_value_set_boolean (value, widgets_schedule_row_get_with_preview (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_schedule_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	WidgetsScheduleRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SCHEDULE_ROW, WidgetsScheduleRow);
	switch (property_id) {
		case WIDGETS_SCHEDULE_ROW_WITH_PREVIEW_PROPERTY:
		widgets_schedule_row_set_with_preview (self, g_value_get_boolean (value));
		break;
		case WIDGETS_SCHEDULE_ROW_ICON_PROPERTY:
		widgets_schedule_row_set_icon (self, g_value_get_string (value));
		break;
		case WIDGETS_SCHEDULE_ROW_TEXT_PROPERTY:
		widgets_schedule_row_set_text (self, g_value_get_string (value));
		break;
		case WIDGETS_SCHEDULE_ROW_SELECTED_PROPERTY:
		widgets_schedule_row_set_selected (self, g_value_get_boolean (value));
		break;
		case WIDGETS_SCHEDULE_ROW_DATE_LABEL_PROPERTY:
		widgets_schedule_row_set_date_label (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
widgets_time_alternative_button_get_instance_private (WidgetsTimeAlternativeButton* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsTimeAlternativeButton_private_offset);
}

WidgetsTimeAlternativeButton*
widgets_time_alternative_button_construct (GType object_type,
                                           const gchar* text,
                                           const gchar* key)
{
	WidgetsTimeAlternativeButton * self = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	self = (WidgetsTimeAlternativeButton*) g_object_new (object_type, "text", text, "key", key, NULL);
	return self;
}

WidgetsTimeAlternativeButton*
widgets_time_alternative_button_new (const gchar* text,
                                     const gchar* key)
{
	return widgets_time_alternative_button_construct (WIDGETS_TYPE_TIME_ALTERNATIVE_BUTTON, text, key);
}

static void
widgets_time_alternative_button_update_label (WidgetsTimeAlternativeButton* self)
{
	gint hour = 0;
	gint minute = 0;
	GSettings* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	Utils* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GtkLabel* _tmp7_;
	GDateTime* _tmp8_;
	Utils* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = planner_settings;
	_tmp1_ = self->priv->_key;
	g_settings_get (_tmp0_, _tmp1_, "(ii)", &_tmp2_, &_tmp3_);
	hour = _tmp2_;
	minute = _tmp3_;
	_tmp4_ = planner_utils;
	_tmp5_ = utils_get_time_by_hour_minute (_tmp4_, hour, minute);
	_tmp6_ = _tmp5_;
	widgets_time_alternative_button_set_time (self, _tmp6_);
	_g_date_time_unref0 (_tmp6_);
	_tmp7_ = self->priv->time_label;
	_tmp8_ = self->priv->_time;
	_tmp9_ = planner_utils;
	_tmp10_ = utils_get_default_time_format (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_date_time_format (_tmp8_, _tmp11_);
	_tmp13_ = _tmp12_;
	gtk_label_set_label (_tmp7_, _tmp13_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
}

const gchar*
widgets_time_alternative_button_get_text (WidgetsTimeAlternativeButton* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_text;
	result = _tmp0_;
	return result;
}

static void
widgets_time_alternative_button_set_text (WidgetsTimeAlternativeButton* self,
                                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_time_alternative_button_get_text (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_text);
		self->priv->_text = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_time_alternative_button_properties[WIDGETS_TIME_ALTERNATIVE_BUTTON_TEXT_PROPERTY]);
	}
}

const gchar*
widgets_time_alternative_button_get_key (WidgetsTimeAlternativeButton* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_key;
	result = _tmp0_;
	return result;
}

static void
widgets_time_alternative_button_set_key (WidgetsTimeAlternativeButton* self,
                                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_time_alternative_button_get_key (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_key);
		self->priv->_key = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_time_alternative_button_properties[WIDGETS_TIME_ALTERNATIVE_BUTTON_KEY_PROPERTY]);
	}
}

GDateTime*
widgets_time_alternative_button_get_time (WidgetsTimeAlternativeButton* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_time;
	result = _tmp0_;
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

void
widgets_time_alternative_button_set_time (WidgetsTimeAlternativeButton* self,
                                          GDateTime* value)
{
	GDateTime* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_time_alternative_button_get_time (self);
	if (old_value != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_time);
		self->priv->_time = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_time_alternative_button_properties[WIDGETS_TIME_ALTERNATIVE_BUTTON_TIME_PROPERTY]);
	}
}

static void
_widgets_time_alternative_button___lambda104_ (WidgetsTimeAlternativeButton* self,
                                               const gchar* schema)
{
	const gchar* _tmp0_;
	g_return_if_fail (schema != NULL);
	_tmp0_ = self->priv->_key;
	if (g_strcmp0 (schema, _tmp0_) == 0) {
		widgets_time_alternative_button_update_label (self);
	}
}

static void
__widgets_time_alternative_button___lambda104__g_settings_changed (GSettings* _sender,
                                                                   const gchar* key,
                                                                   gpointer self)
{
	_widgets_time_alternative_button___lambda104_ ((WidgetsTimeAlternativeButton*) self, key);
}

static GObject *
widgets_time_alternative_button_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsTimeAlternativeButton * self;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	const gchar* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkGrid* _tmp15_;
	GtkLabel* _tmp16_;
	GtkGrid* _tmp17_;
	GtkLabel* _tmp18_;
	GtkGrid* _tmp19_;
	GSettings* _tmp20_;
	parent_class = G_OBJECT_CLASS (widgets_time_alternative_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_TIME_ALTERNATIVE_BUTTON, WidgetsTimeAlternativeButton);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_remove_class (_tmp0_, "button");
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp1_, "flat");
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp2_, "menuitem");
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp3_, "no-border");
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp4_, "time-alternative");
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
	_tmp5_ = self->priv->_text;
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->title_label);
	self->priv->title_label = _tmp6_;
	_tmp7_ = self->priv->title_label;
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
	gtk_style_context_add_class (_tmp8_, "font-bold");
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->time_label);
	self->priv->time_label = _tmp9_;
	_tmp10_ = self->priv->time_label;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_add_class (_tmp11_, "small-label");
	_tmp12_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp12_);
	grid = _tmp12_;
	_tmp13_ = grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
	_tmp14_ = grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp14_, GTK_ORIENTATION_VERTICAL);
	_tmp15_ = grid;
	_tmp16_ = self->priv->title_label;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = grid;
	_tmp18_ = self->priv->time_label;
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp19_);
	widgets_time_alternative_button_update_label (self);
	_tmp20_ = planner_settings;
	g_signal_connect_object (_tmp20_, "changed", (GCallback) __widgets_time_alternative_button___lambda104__g_settings_changed, self, 0);
	_g_object_unref0 (grid);
	return obj;
}

static void
widgets_time_alternative_button_class_init (WidgetsTimeAlternativeButtonClass * klass,
                                            gpointer klass_data)
{
	widgets_time_alternative_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsTimeAlternativeButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_time_alternative_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_time_alternative_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_time_alternative_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_time_alternative_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_TIME_ALTERNATIVE_BUTTON_TEXT_PROPERTY, widgets_time_alternative_button_properties[WIDGETS_TIME_ALTERNATIVE_BUTTON_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_TIME_ALTERNATIVE_BUTTON_KEY_PROPERTY, widgets_time_alternative_button_properties[WIDGETS_TIME_ALTERNATIVE_BUTTON_KEY_PROPERTY] = g_param_spec_string ("key", "key", "key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_TIME_ALTERNATIVE_BUTTON_TIME_PROPERTY, widgets_time_alternative_button_properties[WIDGETS_TIME_ALTERNATIVE_BUTTON_TIME_PROPERTY] = g_param_spec_boxed ("time", "time", "time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
widgets_time_alternative_button_instance_init (WidgetsTimeAlternativeButton * self,
                                               gpointer klass)
{
	self->priv = widgets_time_alternative_button_get_instance_private (self);
}

static void
widgets_time_alternative_button_finalize (GObject * obj)
{
	WidgetsTimeAlternativeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_TIME_ALTERNATIVE_BUTTON, WidgetsTimeAlternativeButton);
	_g_free0 (self->priv->_text);
	_g_free0 (self->priv->_key);
	_g_date_time_unref0 (self->priv->_time);
	_g_object_unref0 (self->priv->title_label);
	_g_object_unref0 (self->priv->time_label);
	G_OBJECT_CLASS (widgets_time_alternative_button_parent_class)->finalize (obj);
}

static GType
widgets_time_alternative_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsTimeAlternativeButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_time_alternative_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsTimeAlternativeButton), 0, (GInstanceInitFunc) widgets_time_alternative_button_instance_init, NULL };
	GType widgets_time_alternative_button_type_id;
	widgets_time_alternative_button_type_id = g_type_register_static (gtk_button_get_type (), "WidgetsTimeAlternativeButton", &g_define_type_info, 0);
	WidgetsTimeAlternativeButton_private_offset = g_type_add_instance_private (widgets_time_alternative_button_type_id, sizeof (WidgetsTimeAlternativeButtonPrivate));
	return widgets_time_alternative_button_type_id;
}

GType
widgets_time_alternative_button_get_type (void)
{
	static volatile gsize widgets_time_alternative_button_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_time_alternative_button_type_id__volatile)) {
		GType widgets_time_alternative_button_type_id;
		widgets_time_alternative_button_type_id = widgets_time_alternative_button_get_type_once ();
		g_once_init_leave (&widgets_time_alternative_button_type_id__volatile, widgets_time_alternative_button_type_id);
	}
	return widgets_time_alternative_button_type_id__volatile;
}

static void
_vala_widgets_time_alternative_button_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	WidgetsTimeAlternativeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_TIME_ALTERNATIVE_BUTTON, WidgetsTimeAlternativeButton);
	switch (property_id) {
		case WIDGETS_TIME_ALTERNATIVE_BUTTON_TEXT_PROPERTY:
		g_value_set_string (value, widgets_time_alternative_button_get_text (self));
		break;
		case WIDGETS_TIME_ALTERNATIVE_BUTTON_KEY_PROPERTY:
		g_value_set_string (value, widgets_time_alternative_button_get_key (self));
		break;
		case WIDGETS_TIME_ALTERNATIVE_BUTTON_TIME_PROPERTY:
		g_value_set_boxed (value, widgets_time_alternative_button_get_time (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_time_alternative_button_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	WidgetsTimeAlternativeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_TIME_ALTERNATIVE_BUTTON, WidgetsTimeAlternativeButton);
	switch (property_id) {
		case WIDGETS_TIME_ALTERNATIVE_BUTTON_TEXT_PROPERTY:
		widgets_time_alternative_button_set_text (self, g_value_get_string (value));
		break;
		case WIDGETS_TIME_ALTERNATIVE_BUTTON_KEY_PROPERTY:
		widgets_time_alternative_button_set_key (self, g_value_get_string (value));
		break;
		case WIDGETS_TIME_ALTERNATIVE_BUTTON_TIME_PROPERTY:
		widgets_time_alternative_button_set_time (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

